var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "sas/dm/commons/controller/base/MasterControllerBase", "sas/dm/commons/util/SharedProperties", "sas/dm/commons/util/binding/BindingUtils", "sas/dm/businessdata/components/termsview/TermsViewMode", "../model/TypeAttribute"], function (require, exports, MasterControllerBase, CommonSharedProperties, BindingUtils, TermsViewMode, TypeAttribute) {
    "use strict";
    var TermTypeController = (function (_super) {
        __extends(TermTypeController, _super);
        function TermTypeController() {
            return _super.call(this) || this;
        }
        Object.defineProperty(TermTypeController.prototype, "globalController", {
            get: function () {
                return this._globalController;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TermTypeController.prototype, "termType", {
            get: function () {
                return this._termType;
            },
            set: function (value) {
                this._termType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TermTypeController.prototype, "termsViewMode", {
            get: function () {
                return this._termsViewMode;
            },
            set: function (value) {
                this._termsViewMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TermTypeController.prototype, "editMode", {
            get: function () {
                return this._editMode;
            },
            set: function (value) {
                this._editMode = value;
            },
            enumerable: true,
            configurable: true
        });
        TermTypeController.prototype.save = function (successHandler, errorHandler) {
            if (this.termType.attributes) {
                this.termType.attributes.map(function (attr) {
                    if (attr.renderer == TypeAttribute.RENDERER_SINGLE_SELECT_LIST || attr.renderer == TypeAttribute.RENDERER_MULTI_SELECT_LIST) {
                        if (attr.values) {
                            for (var i = 0; i < attr.values.length; i++) {
                                attr.values[i].sortOrder = i;
                            }
                        }
                    }
                });
            }
            if (this.termType.id == "0") {
                this.globalController.createTermType(this.termType, successHandler, errorHandler);
            }
            else {
                this.globalController.updateTermType(this.termType, successHandler, errorHandler);
            }
        };
        TermTypeController.prototype.setMasterContext = function (context) {
            var _this = this;
            _super.prototype.setMasterContext.call(this, context);
            var controllers = context.getObject(CommonSharedProperties.CONTEXT_KEY_CONTROLLER, true);
            this._globalController = controllers[controllers.length - 1];
            this.unbind();
            this._termsViewModeWatcher = BindingUtils.handlePropertyChange(this._globalController, "termsViewMode", function (newTermsViewMode, oldTermsViewMode) {
                _this.termsViewMode = newTermsViewMode;
                _this.editMode = !(_this.termsViewMode == TermsViewMode.SNAPSHOTVIEW);
            }, true);
        };
        TermTypeController.prototype.unbind = function () {
            BindingUtils.unbind(this._termsViewModeWatcher);
        };
        return TermTypeController;
    }(MasterControllerBase));
    return TermTypeController;
});
