sap.ui.require.preload({
	"sap/f/Avatar.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./library\",\"sap/ui/core/Control\",\"sap/ui/core/IconPool\",\"./AvatarRenderer\",\"jquery.sap.keycodes\"],function(t,e,i,a,s){\"use strict\";var r=e.AvatarType,o=e.AvatarImageFitType,n=e.AvatarSize,p=e.AvatarShape,l=i.extend(\"sap.f.Avatar\",{metadata:{library:\"sap.f\",properties:{src:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:null},initials:{type:\"string\",group:\"Data\",defaultValue:null},displayShape:{type:\"sap.f.AvatarShape\",group:\"Appearance\",defaultValue:p.Circle},displaySize:{type:\"sap.f.AvatarSize\",group:\"Appearance\",defaultValue:n.S},customDisplaySize:{type:\"sap.ui.core.CSSSize\",group:\"Appearance\",defaultValue:\"3rem\"},customFontSize:{type:\"sap.ui.core.CSSSize\",group:\"Appearance\",defaultValue:\"1.125rem\"},imageFitType:{type:\"sap.f.AvatarImageFitType\",group:\"Appearance\",defaultValue:o.Cover}},aggregations:{detailBox:{type:\"sap.m.LightBox\",multiple:!1,bindable:\"bindable\"}},events:{press:{}},designtime:\"sap/f/designtime/Avatar.designtime\"}});return l.DEFAULT_CIRCLE_PLACEHOLDER=\"sap-icon://person-placeholder\",l.DEFAULT_SQUARE_PLACEHOLDER=\"sap-icon://product\",l.prototype.init=function(){this._sActualType=null,this._bIsDefaultIcon=!0},l.prototype.exit=function(){this._icon&&this._icon.destroy(),this._fnLightBoxOpen&&(this._fnLightBoxOpen=null)},l.prototype.setDetailBox=function(t){var e=this.getDetailBox();if(t){if(t===e)return this;e&&this.detachPress(this._fnLightBoxOpen,e),this._fnLightBoxOpen=t.open,this.attachPress(this._fnLightBoxOpen,t)}else this._fnLightBoxOpen&&(this.detachPress(this._fnLightBoxOpen,e),this._fnLightBoxOpen=null);return this.setAggregation(\"detailBox\",t)},l.prototype.clone=function(){var t=i.prototype.clone.apply(this,arguments),e=t.getDetailBox();return e&&(t.detachPress(this._fnLightBoxOpen,this.getDetailBox()),t._fnLightBoxOpen=e.open,t.attachPress(t._fnLightBoxOpen,e)),t},l.prototype.attachPress=function(){return Array.prototype.unshift.apply(arguments,[\"press\"]),i.prototype.attachEvent.apply(this,arguments),this.hasListeners(\"press\")&&(this.$().attr(\"tabindex\",\"0\"),this.$().attr(\"role\",\"button\")),this},l.prototype.detachPress=function(){return Array.prototype.unshift.apply(arguments,[\"press\"]),i.prototype.detachEvent.apply(this,arguments),this.hasListeners(\"press\")||(this.$().removeAttr(\"tabindex\"),this.$().removeAttr(\"role\")),this},l.prototype.ontap=function(){this.firePress({})},l.prototype.onkeyup=function(e){e.which!==t.sap.KeyCodes.SPACE&&e.which!==t.sap.KeyCodes.ENTER||(this.firePress({}),e.stopPropagation())},l.prototype._areInitialsValid=function(e){return!!/^[a-zA-Z]{1,2}$/.test(e)||(t.sap.log.warning(\"Initials should consist of only 1 or 2 latin letters\",this),this._sActualType=r.Icon,this._bIsDefaultIcon=!0,!1)},l.prototype._validateSrc=function(t){return a.isIconURI(t)?(this._sActualType=r.Icon,this._bIsDefaultIcon=!1):this._sActualType=r.Image,this},l.prototype._getActualDisplayType=function(){var e=this.getSrc(),i=this.getInitials();return e?this._validateSrc(e):i&&this._areInitialsValid(i)?this._sActualType=r.Initials:(t.sap.log.warning(\"No src and initials were provided\",this),this._sActualType=r.Icon,this._bIsDefaultIcon=!0),this._sActualType},l.prototype._getDefaultIconPath=function(t){var e=null;return t===p.Circle?e=l.DEFAULT_CIRCLE_PLACEHOLDER:t===p.Square&&(e=l.DEFAULT_SQUARE_PLACEHOLDER),e},l.prototype._getIcon=function(){var t=this.getSrc(),e=this.getDisplayShape();return this._bIsDefaultIcon&&(t=this._getDefaultIconPath(e)),this._icon?this._icon.getSrc()!==t&&this._icon.setSrc(t):this._icon=a.createControlByURI({alt:\"Image placeholder\",src:t}),this._icon},l.prototype._getEscapedSrc=function(){var t=this.getSrc();return t?t.replace(/'/g,\"\\\\'\"):\"\"},l.prototype.getAccessibilityInfo=function(){var t=this.hasListeners(\"press\");return t?{role:t?\"button\":\"img\",type:sap.ui.getCore().getLibraryResourceBundle(\"sap.f\").getText(t?\"ACC_CTR_TYPE_BUTTON\":\"ACC_CTR_TYPE_IMAGE\"),focusable:t}:null},l});",
	"sap/f/AvatarRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/f/library\",\"jquery.sap.global\"],function(a,t){\"use strict\";var e=a.AvatarSize,s=a.AvatarType,i={};return i.render=function(a,i){var r=i.getInitials(),l=i._getActualDisplayType(),d=i.getDisplaySize(),n=i.getDisplayShape(),p=i.getImageFitType(),o=i.getCustomDisplaySize(),g=i.getCustomFontSize(),c=i._getEscapedSrc(),u=i.getTooltip_AsString();a.write(\"<span\"),a.writeControlData(i),a.addClass(\"sapFAvatar\"),a.addClass(\"sapFAvatar\"+d),a.addClass(\"sapFAvatar\"+l),a.addClass(\"sapFAvatar\"+n),i.hasListeners(\"press\")&&(a.addClass(\"sapMPointer\"),a.addClass(\"sapFAvatarFocusable\"),a.writeAccessibilityState(i,{role:\"button\"}),a.writeAttribute(\"tabIndex\",0)),l===s.Image&&(a.addClass(\"sapFAvatar\"+l+p),a.addStyle(\"background-image\",\"url('\"+t.sap.encodeHTML(c)+\"')\")),d===e.Custom&&(a.addStyle(\"width\",o),a.addStyle(\"height\",o),a.addStyle(\"font-size\",g)),u&&a.writeAttributeEscaped(\"title\",u),a.writeClasses(),a.writeStyles(),a.write(\">\"),l===s.Icon?a.renderControl(i._getIcon()):l===s.Initials&&(a.write(\"<span\"),a.addClass(\"sapFAvatarInitialsHolder\"),a.writeClasses(),a.write(\">\"),a.writeEscaped(r),a.write(\"</span>\")),i._fnLightBoxOpen&&a.write('<span class=\"sapFAvatarMagnifyingGlass\"></span>'),a.write(\"</span>\")},i},!0);",
	"sap/f/library.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/base/DataType\",\"sap/ui/Global\",\"sap/ui/core/library\",\"sap/m/library\"],function(e){\"use strict\";sap.ui.getCore().initLibrary({name:\"sap.f\",version:\"904001.3.0.20231215124400_f0htmcm94p\",dependencies:[\"sap.ui.core\",\"sap.m\"],designtime:\"sap/f/designtime/library.designtime\",types:[\"sap.f.LayoutType\",\"sap.f.DynamicPageTitleArea\",\"sap.f.DynamicPageTitleShrinkRatio\"],controls:[\"sap.f.Avatar\",\"sap.f.DynamicPage\",\"sap.f.DynamicPageHeader\",\"sap.f.DynamicPageTitle\",\"sap.f.FlexibleColumnLayout\",\"sap.f.semantic.SemanticPage\"],elements:[\"sap.f.semantic.AddAction\",\"sap.f.semantic.CloseAction\",\"sap.f.semantic.CopyAction\",\"sap.f.semantic.DeleteAction\",\"sap.f.semantic.DiscussInJamAction\",\"sap.f.semantic.EditAction\",\"sap.f.semantic.ExitFullScreenAction\",\"sap.f.semantic.FavoriteAction\",\"sap.f.semantic.FlagAction\",\"sap.f.semantic.FooterMainAction\",\"sap.f.semantic.FullScreenAction\",\"sap.f.semantic.MessagesIndicator\",\"sap.f.semantic.NegativeAction\",\"sap.f.semantic.PositiveAction\",\"sap.f.semantic.PrintAction\",\"sap.f.semantic.SemanticButton\",\"sap.f.semantic.SemanticControl\",\"sap.f.semantic.SemanticToggleButton\",\"sap.f.semantic.SendEmailAction\",\"sap.f.semantic.SendMessageAction\",\"sap.f.semantic.ShareInJamAction\",\"sap.f.semantic.TitleMainAction\"],extensions:{flChangeHandlers:{\"sap.f.DynamicPageHeader\":{hideControl:\"default\",unhideControl:\"default\",moveControls:\"default\"},\"sap.f.DynamicPageTitle\":\"sap/f/flexibility/DynamicPageTitle\",\"sap.f.semantic.SemanticPage\":{moveControls:\"default\"}},\"sap.ui.support\":{internalRules:!0}}});var a=sap.f;return a.DynamicPageTitleArea={Begin:\"Begin\",Middle:\"Middle\"},a.DynamicPageTitleShrinkRatio=e.createType(\"sap.f.DynamicPageTitleShrinkRatio\",{isValid:function(e){return/^(([0-9]\\d*)(\\.\\d)?:([0-9]\\d*)(\\.\\d)?:([0-9]\\d*)(\\.\\d)?)$/.test(e)}},e.getType(\"string\")),a.LayoutType={OneColumn:\"OneColumn\",TwoColumnsBeginExpanded:\"TwoColumnsBeginExpanded\",TwoColumnsMidExpanded:\"TwoColumnsMidExpanded\",MidColumnFullScreen:\"MidColumnFullScreen\",ThreeColumnsMidExpanded:\"ThreeColumnsMidExpanded\",ThreeColumnsEndExpanded:\"ThreeColumnsEndExpanded\",ThreeColumnsMidExpandedEndHidden:\"ThreeColumnsMidExpandedEndHidden\",ThreeColumnsBeginExpandedEndHidden:\"ThreeColumnsBeginExpandedEndHidden\",EndColumnFullScreen:\"EndColumnFullScreen\"},sap.ui.lazyRequire(\"sap.f.routing.Router\"),sap.ui.lazyRequire(\"sap.f.routing.Target\"),sap.ui.lazyRequire(\"sap.f.routing.TargetHandler\"),sap.ui.lazyRequire(\"sap.f.routing.Targets\"),a.AvatarShape={Circle:\"Circle\",Square:\"Square\"},a.AvatarSize={XS:\"XS\",S:\"S\",M:\"M\",L:\"L\",XL:\"XL\",Custom:\"Custom\"},a.AvatarType={Icon:\"Icon\",Image:\"Image\",Initials:\"Initials\"},a.AvatarImageFitType={Cover:\"Cover\",Contain:\"Contain\"},a});",
	"sap/f/routing/async/Target.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{_place:function(t){var n=this._super._place.apply(this,arguments),i=t&&t.routeConfig||{},a=this;return this._oTargetHandler._chainNavigation(function(){return n.then(function(n){return a._oTargetHandler.addNavigation({navigationIdentifier:a._oOptions.name,transition:a._oOptions.transition,transitionParameters:a._oOptions.transitionParameters,eventData:t,targetControl:n.control,view:n.view,layout:i.layout}),n})})}}},!0);",
	"sap/f/routing/async/Targets.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";return{display:function(){var t,i;return this._oLastDisplayedTarget=null,this._super.display.apply(this,arguments).then(function(e){return this._oLastDisplayedTarget&&(t=this._getViewLevel(this._oLastDisplayedTarget),i=this._oLastDisplayedTarget._oOptions.name),this._oTargetHandler.navigate({viewLevel:t,navigationIdentifier:i}),e}.bind(this))},_displaySingleTarget:function(t){var i=this.getTarget(t);return this._super._displaySingleTarget.apply(this,arguments).then(function(t){return i&&(this._oLastDisplayedTarget=i),t}.bind(this))}}},!0);",
	"sap/f/routing/Router.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/routing/Router\",\"./TargetHandler\",\"./Targets\"],function(t,e,r){\"use strict\";return t.extend(\"sap.f.routing.Router\",{constructor:function(){this._oTargetHandler=new e,t.prototype.constructor.apply(this,arguments)},destroy:function(){t.prototype.destroy.apply(this,arguments),this._oTargetHandler.destroy(),this._oTargetHandler=null},getTargetHandler:function(){return this._oTargetHandler},_createTargets:function(t,e){return new r({views:this._oViews,config:t,targets:e,targetHandler:this._oTargetHandler})},fireRouteMatched:function(e){var r,a=this.getRoute(e.name);return a._oTarget&&(r=a._oTarget._oOptions,this._oTargetHandler.addNavigation({navigationIdentifier:e.name,transition:r.transition,transitionParameters:r.transitionParameters,eventData:e.arguments,targetControl:e.targetControl,view:e.view,layout:a._oConfig.layout})),t.prototype.fireRouteMatched.apply(this,arguments)},fireRoutePatternMatched:function(e){var r,a=e.name;return this._oTargets&&this._oTargets._oLastDisplayedTarget&&(r=this._oTargets._getViewLevel(this._oTargets._oLastDisplayedTarget)),this._oTargetHandler.navigate({navigationIdentifier:a,viewLevel:r,askHistory:!0}),t.prototype.fireRoutePatternMatched.apply(this,arguments)}})});",
	"sap/f/routing/Target.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/routing/Target\",\"sap/f/FlexibleColumnLayout\",\"./async/Target\"],function(t,o,e){\"use strict\";return t.extend(\"sap.f.routing.Target\",{constructor:function(o,n,a,r){this._oTargetHandler=r,t.prototype.constructor.apply(this,arguments);var i=e;this._super={};for(var s in i)this._super[s]=this[s],this[s]=i[s]},_beforePlacingViewIntoContainer:function(e){var n=e.container,a=e.data&&e.data.routeConfig;n instanceof o&&a&&a.layout&&n.setLayout(a.layout),t.prototype._beforePlacingViewIntoContainer.apply(this,arguments)}})});",
	"sap/f/routing/TargetHandler.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/m/InstanceManager\",\"sap/f/FlexibleColumnLayout\",\"sap/ui/base/Object\",\"sap/ui/core/routing/History\"],function(t,e,i,o,a){\"use strict\";var n=o.extend(\"sap.f.routing.TargetHandler\",{constructor:function(t){this._aQueue=[],this._oNavigationOrderPromise=Promise.resolve(),this._bCloseDialogs=void 0===t||!!t}});return n.prototype.setCloseDialogs=function(t){return this._bCloseDialogs=!!t,this},n.prototype.getCloseDialogs=function(){return this._bCloseDialogs},n.prototype.addNavigation=function(t){this._aQueue.push(t)},n.prototype.navigate=function(t){for(var e,i=this._createResultingNavigations(t.navigationIdentifier),o=!1,a=this._getDirection(t);i.length;)e=this._applyNavigationResult(i.shift().oParams,a),o=o||e;o&&this._closeDialogs()},n.prototype._chainNavigation=function(t){return this._oNavigationOrderPromise=this._oNavigationOrderPromise.then(t),this._oNavigationOrderPromise},n.prototype._getDirection=function(t){var e=t.viewLevel,i=a.getInstance(),o=!1;return\"Backwards\"===t.direction?o=!0:isNaN(e)||isNaN(this._iCurrentViewLevel)||e===this._iCurrentViewLevel?t.askHistory&&(o=\"Backwards\"===i.getDirection()):o=e<this._iCurrentViewLevel,this._iCurrentViewLevel=e,o},n.prototype._createResultingNavigations=function(t){for(var e,i,o,a,n,r=[];this._aQueue.length;){for(i=this._aQueue.shift(),o=i.targetControl,a={oContainer:o,oParams:i},e=0;e<r.length;e++)n=r[e],n.oContainer;r.push(a)}return r},n.prototype._applyNavigationResult=function(e,o){var a,n=e.targetControl,r=e.eventData,s=e.transition||\"\",g=e.transitionParameters,l=e.view.getId(),u=n instanceof i,p=!1;return u&&(a=[n.getCurrentBeginColumnPage(),n.getCurrentMidColumnPage(),n.getCurrentEndColumnPage()],p=a.some(function(t){return t&&t.getId()===l})),p?(t.sap.log.info(\"navigation to view with id: \"+l+\" is skipped since it already is displayed by its targetControl\",\"sap.f.routing.TargetHandler\"),!1):(t.sap.log.info(\"navigation to view with id: \"+l+\" the targetControl is \"+n.getId()+\" backwards is \"+o),o?n._safeBackToPage(l,s,r,g):n.to(l,s,r,g),!0)},n.prototype._closeDialogs=function(){this._bCloseDialogs&&(e.hasOpenPopover()&&e.closeAllPopovers(),e.hasOpenDialog()&&e.closeAllDialogs(),e.hasOpenLightBox()&&e.closeAllLightBoxes())},n});",
	"sap/f/routing/Targets.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"sap/ui/core/routing/Targets\",\"./TargetHandler\",\"./Target\",\"./async/Targets\"],function(t,e,r,n){\"use strict\";return t.extend(\"sap.f.routing.Targets\",{constructor:function(r){r.config._async=!0,r.targetHandler?this._oTargetHandler=r.targetHandler:(this._oTargetHandler=new e,this._bHasOwnTargetHandler=!0),t.prototype.constructor.apply(this,arguments);var a=n;this._super={};for(var s in a)this._super[s]=this[s],this[s]=a[s]},destroy:function(){t.prototype.destroy.apply(this,arguments),this._bHasOwnTargetHandler&&this._oTargetHandler.destroy(),this._oTargetHandler=null},getTargetHandler:function(){return this._oTargetHandler},_constructTarget:function(t,e){return new r(t,this._oViews,e,this._oTargetHandler)},_getViewLevel:function(t){var e;do{if(void 0!==(e=t._oOptions.viewLevel))return e;t=t._oParent}while(t);return e}})});",
	"sap/f/designtime/Avatar.create.fragment.xml": "<core:FragmentDefinition\n\t\txmlns=\"sap.f\"\n\t\txmlns:core=\"sap.ui.core\"><Avatar /></core:FragmentDefinition>",
	"sap/f/designtime/DynamicPage.create.fragment.xml": "<core:FragmentDefinition\n        xmlns=\"sap.f\"\n        xmlns:m=\"sap.m\"\n        xmlns:core=\"sap.ui.core\"><DynamicPage showFooter=\"true\"><title><DynamicPageTitle><heading><m:Title text=\"Header Title\"/></heading></DynamicPageTitle></title><header><DynamicPageHeader pinnable=\"true\"><content><m:Text text=\"Header Content\"/></content></DynamicPageHeader></header><content><m:Text text=\"Dynamic Page Content\"/></content><footer><m:OverflowToolbar><m:ToolbarSpacer/><m:Button text=\"Button\"/></m:OverflowToolbar></footer></DynamicPage></core:FragmentDefinition>",
	"sap/f/designtime/SemanticPage.create.fragment.xml": "<core:FragmentDefinition\n\t\txmlns=\"sap.f.semantic\"\n\t\txmlns:m=\"sap.m\"\n\t\txmlns:core=\"sap.ui.core\"><SemanticPage showFooter=\"true\"><titleHeading><m:Title text=\"Semantic Page Title\" /></titleHeading><headerContent><m:Text text=\"Semantic Page Header Content\"/></headerContent><titleMainAction><TitleMainAction text=\"Main Action\"/></titleMainAction><titleCustomTextActions><m:Button text=\"Custom Text Button\"/></titleCustomTextActions><titleCustomIconActions><m:OverflowToolbarButton icon=\"sap-icon://cart\" text=\"Custom Icon Button\" /></titleCustomIconActions><content><m:Text text=\"Semantic Page Header Content\"/></content><footerCustomActions><m:Button text=\"Button 1\" /></footerCustomActions></SemanticPage></core:FragmentDefinition>",
	"sap/f/manifest.json": "{\"_version\":\"1.9.0\",\"sap.app\":{\"_version\":\"1.2.0\",\"id\":\"sap.f\",\"type\":\"library\",\"applicationVersion\":{\"version\":\"9.4.0-0\"},\"title\":\"The OpenUI5-based library, sap.f.\"},\"sap.ui5\":{\"_version\":\"1.1.0\",\"dependencies\":{\"libs\":{\"sap.ui.core\":{},\"sap.m\":{}}},\"library\":{\"i18n\":\"messagebundle.properties\"}}}"
}, "sap/f/library-preload");