sap.ui.require.preload({
	"sap/ui/ux3/ActionBar.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/delegate/ItemNavigation\",\"./library\",\"./ActionBarRenderer\"],function(t,e,o,i,n){\"use strict\";var s=e.extend(\"sap.ui.ux3.ActionBar\",{metadata:{library:\"sap.ui.ux3\",properties:{followState:{type:\"sap.ui.ux3.FollowActionState\",group:\"Misc\",defaultValue:sap.ui.ux3.FollowActionState.Default},flagState:{type:\"boolean\",group:\"Misc\",defaultValue:null},favoriteState:{type:\"boolean\",group:\"Misc\",defaultValue:null},updateState:{type:\"boolean\",group:\"Misc\",defaultValue:null},thingIconURI:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},alwaysShowMoreMenu:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showUpdate:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showFollow:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showFlag:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showFavorite:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showOpen:{type:\"boolean\",group:\"Misc\",defaultValue:!0},dividerWidth:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:null}},aggregations:{businessActions:{type:\"sap.ui.ux3.ThingAction\",multiple:!0,singularName:\"businessAction\"},_businessActionButtons:{type:\"sap.ui.commons.Button\",multiple:!0,singularName:\"_businessActionButton\",visibility:\"hidden\"},_socialActions:{type:\"sap.ui.ux3.ThingAction\",multiple:!0,singularName:\"_socialAction\",visibility:\"hidden\"}},events:{actionSelected:{parameters:{id:{type:\"string\"},action:{type:\"sap.ui.ux3.ThingAction\"},newState:{type:\"string\"}}},feedSubmit:{parameters:{text:{type:\"string\"}}}}}});return s.prototype.init=function(){this.mActionMap={},this.mActionKeys=sap.ui.ux3.ActionBarSocialActions,this.oRb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Update),!0),this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Follow),!0),this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Flag),!0),this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Favorite),!0),this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Open),!0),this._oItemNavigation||(this._oItemNavigation=new o,this.addDelegate(this._oItemNavigation))},s.prototype.exit=function(){this.closePopups(),this._oUpdatePopup&&(this._oUpdatePopup.destroy(),this._oUpdatePopup=null),this._oMoreMenuButton&&(this._oMoreMenuButton.destroy(),this._oMoreMenuButton=null),this._oMoreMenu&&(this._oMoreMenu.destroy(),this._oMoreMenu=null),this._oHoldItem&&this._oHoldItem.destroy(),this._oUnFollowItem&&this._oUnFollowItem.destroy(),this._oUnHoldItem&&this._oUnHoldItem.destroy(),this._sResizeListenerId&&(sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId),this._sResizeListenerId=null),this.mActionKeys=null,this.mActionKeys=null,this.oRb=null,this.destroyAggregation(\"_socialActions\"),this.destroyAggregation(\"_businessActionButtons\"),this._oItemNavigation&&(this.removeDelegate(this._oItemNavigation),this._oItemNavigation.destroy(),delete this._oItemNavigation)},s.prototype.isActive=function(){return null!=this.getDomRef()},s.prototype._getLocalizedText=function(t,e){var o;if(this.oRb&&(o=this.oRb.getText(t)),o&&e)for(var i=0;i<e.length;i++)o=o.replace(\"{\"+i+\"}\",e[i]);return o||t},s.prototype._getSocialAction=function(e){var o=this.mActionMap[e];if(!o)switch(o=new sap.ui.ux3.ThingAction({id:this.getId()+\"-\"+e}),e){case this.mActionKeys.Update:o.name=this.mActionKeys.Update,o.tooltipKey=\"ACTIONBAR_UPDATE_ACTION_TOOLTIP\",o.cssClass=\"sapUiUx3ActionBarUpdateAction\",o.fnInit=function(e){e._oUpdatePopup=new sap.ui.ux3.ToolPopup({id:e.getId()+\"-UpdateActionPopup\"}).addStyleClass(\"sapUiUx3ActionBarUpdatePopup\"),e._oUpdatePopup._ensurePopup().setAutoClose(!0),e._feeder=new sap.ui.ux3.Feeder({id:e.getId()+\"-Feeder\",type:sap.ui.ux3.FeederType.Comment,thumbnailSrc:e.getThingIconURI(),text:\"\",submit:t.proxy(function(t){var e=t.getParameter(\"text\");this.fireFeedSubmit({text:e}),this._oUpdatePopup.close()},e)}),e._feeder.addStyleClass(\"sapUiUx3ActionBarFeeder\"),e._oUpdatePopup.addContent(e._feeder)},o.fnActionSelected=function(e,i){if(i._setUpdateState(!i.getUpdateState()),i._oUpdatePopup.isOpen())i._oUpdatePopup.close();else{var n,s,a;i._oUpdatePopup.setPosition(sap.ui.core.Popup.Dock.BeginBottom,sap.ui.core.Popup.Dock.BeginTop,e.getSource().getDomRef(),\"-8 -13\",\"none\"),i._oUpdatePopup.open(),n=t(i._oUpdatePopup.getDomRef()),s=t(window).height(),a=t(i.getDomRef()).offset().top,n.css(\"top\",\"auto\").css(\"bottom\",s-a+7+\"px\"),t.sap.delayedCall(1e3,this,function(){t.sap.focus(i._feeder.getFocusDomRef())})}i._updateSocialActionDomRef(o)},o.fnExit=function(t){t._oUpdatePopup&&(t._oUpdatePopup.destroy(),t._oUpdatePopup=null)},o.fnCalculateState=function(t){var e=null;return t.getUpdateState()&&(e=\"Selected\"),e};break;case this.mActionKeys.Follow:var i=o;o.name=this.mActionKeys.Follow,o.tooltipKey=\"ACTIONBAR_FOLLOW_ACTION_TOOLTIP_FOLLOW\",o.cssClass=\"sapUiUx3ActionBarFollowAction\",o.isMenu=function(t){return t.getFollowState()!=sap.ui.ux3.FollowActionState.Default},o.fnActionSelected=function(t,e){if(e.getFollowState()==sap.ui.ux3.FollowActionState.Default)e._setFollowState(sap.ui.ux3.FollowActionState.Follow),e.fireActionSelected({id:i.name,state:\"followState\",action:i}),this._fnPrepareFollowMenu(t,e);else{var o=sap.ui.core.Popup.Dock;e._oMenu.open(!1,i.getFocusDomRef(),o.BeginBottom,o.BeginTop,i.getDomRef())}},o.fnCalculateState=function(t){return t.getFollowState()},o._fnPrepareFollowMenu=function(e,i){var n=sap.ui.resource(\"sap.ui.ux3\",\"themes/\"+sap.ui.getCore().getConfiguration().getTheme());i.mActionMap[i.mActionKeys.Follow]&&(i._oUnFollowItem||(i._oUnFollowItem=new sap.ui.commons.MenuItem({id:i.getId()+\"-unfollowState\",text:i._getLocalizedText(\"TI_FOLLOW_ACTION_MENU_TXT_UNFOLLOW\"),icon:n+\"/img/menu_unlisten.png\"})),i._oHoldItem||(i._oHoldItem=new sap.ui.commons.MenuItem({id:i.getId()+\"-holdState\",text:i._getLocalizedText(\"TI_FOLLOW_ACTION_MENU_TXT_HOLD\"),icon:n+\"/img/menu_hold.png\"})),i._oUnHoldItem||(i._oUnHoldItem=new sap.ui.commons.MenuItem({id:i.getId()+\"-unholdState\",text:i._getLocalizedText(\"TI_FOLLOW_ACTION_MENU_TXT_UNHOLD\"),icon:n+\"/img/menu_follow.png\"})),i._oMenu||(i._oMenu=new sap.ui.commons.Menu({id:i.getId()+\"-followActionMenu\"}),i._oMenu.attachItemSelect(t.proxy(function(t){this._fnFollowMenuSelected(t,i)},this)),i._oMenu.addItem(i._oHoldItem),i._oMenu.addItem(i._oUnHoldItem),i._oMenu.addItem(i._oUnFollowItem)),i.getFollowState()==sap.ui.ux3.FollowActionState.Default?(i.mActionMap[i.mActionKeys.Follow].setTooltip(i._getLocalizedText(\"TI_FOLLOW_ACTION_TOOLTIP_FOLLOW\")),i._oHoldItem.setVisible(!1),i._oUnFollowItem.setVisible(!1),i._oUnHoldItem.setVisible(!1)):i.getFollowState()==sap.ui.ux3.FollowActionState.Follow?(i.mActionMap[i.mActionKeys.Follow].setTooltip(i._getLocalizedText(\"TI_FOLLOW_ACTION_TOOLTIP_STOPPAUSE_FOLLOW\")),i._oHoldItem.setVisible(!0),i._oUnFollowItem.setVisible(!0),i._oUnHoldItem.setVisible(!1)):i.getFollowState()==sap.ui.ux3.FollowActionState.Hold&&(i.mActionMap[i.mActionKeys.Follow].setTooltip(i._getLocalizedText(\"TI_FOLLOW_ACTION_TOOLTIP_STOPCONTINUE_FOLLOW\")),i._oHoldItem.setVisible(!1),i._oUnFollowItem.setVisible(!0),i._oUnHoldItem.setVisible(!0)),i._updateSocialActionDomRef(o))},o._fnFollowMenuSelected=function(t,e){if(e.mActionMap[e.mActionKeys.Follow]){var o=t.getParameters().item.getId();o==e.getId()+\"-followState\"?e._setFollowState(sap.ui.ux3.FollowActionState.Follow):o==e.getId()+\"-unfollowState\"?e._setFollowState(sap.ui.ux3.FollowActionState.Default):o==e.getId()+\"-holdState\"?e._setFollowState(sap.ui.ux3.FollowActionState.Hold):e._setFollowState(sap.ui.ux3.FollowActionState.Follow),e.fireActionSelected({id:i.name,state:o,action:i}),this._fnPrepareFollowMenu(t,e)}};break;case this.mActionKeys.Favorite:var n=o;o.name=this.mActionKeys.Favorite,o.tooltipKey=\"ACTIONBAR_FAVORITE_ACTION_TOOLTIP\",o.cssClass=\"sapUiUx3ActionBarFavoriteAction\",o.fnActionSelected=function(t,e){1==e.getFavoriteState()?e._setFavoriteState(!1):e._setFavoriteState(!0),e.fireActionSelected({id:n.name,state:e.getFavoriteState(),action:n}),e._updateSocialActionDomRef(o)},o.fnCalculateState=function(t){var e=null;return t.getFavoriteState()&&(e=\"Selected\"),e};break;case this.mActionKeys.Flag:var s=o;o.name=this.mActionKeys.Flag,o.tooltipKey=\"ACTIONBAR_FLAG_ACTION_TOOLTIP\",o.cssClass=\"sapUiUx3ActionBarFlagAction\",o.fnActionSelected=function(t,e){e._setFlagState(!e.getFlagState()),e.fireActionSelected({id:s.name,state:e.getFlagState(),action:s}),e._updateSocialActionDomRef(o)},o.fnCalculateState=function(t){var e=null;return t.getFlagState()&&(e=\"Selected\"),e};break;case this.mActionKeys.Open:o.name=this.mActionKeys.Open,o.tooltipKey=\"ACTIONBAR_OPEN_THING_ACTION_TOOLTIP\",o.cssClass=\"sapUiUx3ActionBarOpenThingAction\";break;default:return void t.sap.log.warning('Function \"sap.ui.ux3.ActionBar.prototype._getSocialAction\" was called with unknown action key \"'+e+'\".\\n\\tNo action will not be rendered.')}return o},s.prototype._updateSocialActionDomRef=function(t){var e=t.$();e&&(e.attr(\"class\",t.cssClass),t.fnCalculateState&&(e.addClass(\"sapUiUx3ActionBarAction\"),e.addClass(t.fnCalculateState(this))),t.name!=this.mActionKeys.Update&&t.name!=this.mActionKeys.Flag&&t.name!=this.mActionKeys.Favorite||e.attr(\"aria-pressed\",\"Selected\"==t.fnCalculateState(this)?\"true\":\"false\"),t.isMenu&&e.attr(\"aria-haspopup\",t.isMenu(this)?\"true\":\"false\"))},s.prototype._rerenderSocialActions=function(){var t=this.$(\"socialActions\");if(t.length>0){var e=sap.ui.getCore().createRenderManager();sap.ui.ux3.ActionBarRenderer.renderSocialActions(e,this),e.flush(t[0]),e.destroy()}},s.prototype._rerenderBusinessAction=function(t){var e=t.$();if(e.length>0){var o=sap.ui.getCore().createRenderManager();o.renderControl(t),o.flush(e[0].parentNode),o.destroy()}},s.prototype._rerenderBusinessActions=function(){if(!this.getAlwaysShowMoreMenu()){var t=this.$(\"businessActions\");if(t&&t.length>0){var e=sap.ui.getCore().createRenderManager();sap.ui.ux3.ActionBarRenderer.renderBusinessActionButtons(e,this),e.flush(t[0]),e.destroy()}}this._onresize()},s.prototype.setFollowState=function(t){if(this.setProperty(\"followState\",t),!this._oMenu){this._getSocialAction(this.mActionKeys.Follow)._fnPrepareFollowMenu(null,this)}return this},s.prototype.setShowUpdate=function(t){return this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Update),t),this.setProperty(\"showUpdate\",t,!0),this},s.prototype.setShowFollow=function(t){return this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Follow),t),this.setProperty(\"showFollow\",t,!0),this},s.prototype.setShowFlag=function(t){return this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Flag),t),this.setProperty(\"showFlag\",t,!0),this},s.prototype.setShowFavorite=function(t){return this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Favorite),t),this.setProperty(\"showFavorite\",t,!0),this},s.prototype.setShowOpen=function(t){return this._setShowSocialAction(this._getSocialAction(this.mActionKeys.Open),t),this.setProperty(\"showOpen\",t,!0),this},s.prototype._setFollowState=function(t){return this.setProperty(\"followState\",t,!0),this},s.prototype._setFlagState=function(t){return this.setProperty(\"flagState\",t,!0),this},s.prototype._setUpdateState=function(t){return this.setProperty(\"updateState\",t,!0),this},s.prototype._setFavoriteState=function(t){return this.setProperty(\"favoriteState\",t,!0),this},s.prototype.setThingIconURI=function(e){this.setProperty(\"thingIconURI\",e,!0);var o=this.mActionMap[this.mActionKeys.Update];return o&&this._feeder?this._feeder.setThumbnailSrc(e):t.sap.log.warning('Function \"sap.ui.ux3.ActionBar.setThingIconURI\": failed to set new icon \"'+e+'\".\\n\\tReason: either updateAction '+o+\" or feeder \"+this._feeder+\" is not defined.\"),this},s.prototype.setDividerWidth=function(t){return this._iSocActListWidth=null,this.setProperty(\"dividerWidth\",t),this},s.prototype.setAlwaysShowMoreMenu=function(t){var e=this.getProperty(\"alwaysShowMoreMenu\"),o=this.getAggregation(\"businessActions\",[]);if(this.setProperty(\"alwaysShowMoreMenu\",t,!0),e!=t&&o){if(t){for(var i=this._getBusinessActionButtons(),n=0;n<i.length;n++)i[n].oMenuItem&&(i[n].oMenuItem.setVisible(!0),i[n].oMenuItem=null);this.destroyAggregation(\"_businessActionButtons\")}else for(var s=0;s<o.length;s++){var a=o[s];this._createButtonForAction(a,this._oMoreMenu._getMenuItemForAction(a))}this._styleMoreMenuButton()}return this._bCallOnresize=!0,this._rerenderBusinessActions(),this},s.prototype.closePopups=function(){this._oUpdatePopup&&this._oUpdatePopup.close(),this._oMoreMenu&&this._oMoreMenu.close(),this._oMenu&&this._oMenu.close()},s.prototype._removeSocialAction=function(t){var e=null;return t.name&&this.mActionMap[t.name]&&(this.mActionMap[t.name].fnExit&&this.mActionMap[t.name].fnExit(this),e=this.removeAggregation(\"_socialActions\",this.mActionMap[t.name],!0),this.mActionMap[t.name].destroy(),delete this.mActionMap[t.name],this._rerenderSocialActions(),this._iSocActListWidth=null),e},s.prototype._removeAllSocialActions=function(){for(var t in this.mActionMap)this.mActionMap[t]&&this.mActionMap[t].fnExit&&this.mActionMap[t].fnExit(this);this.mActionMap={};var e=this.removeAllAggregation(\"_socialActions\",!0);return this._iSocActListWidth=null,this._rerenderSocialActions(),e},s.prototype._addSocialAction=function(t,e){var o=null;return this.mActionMap[t.name]||(o=this._prepareSocialAction(t,e),t.fnInit&&t.fnInit(this),this._iSocActListWidth=null),o&&this._rerenderSocialActions(),o},s.prototype._prepareSocialAction=function(e,o){return e.attachSelect(t.proxy(function(t){e.fnActionSelected?e.fnActionSelected(t,this):this.fireActionSelected({id:e.name,action:e})},this)),e.setTooltip(this._getLocalizedText(e.tooltipKey)),this.mActionMap[e.name]=e,o?this.insertAggregation(\"_socialActions\",e,o,!0):this.addAggregation(\"_socialActions\",e,!0),e},s.prototype._setShowSocialAction=function(t,e){return e?this._addSocialAction(t):this._removeSocialAction(t)},s.prototype.addBusinessAction=function(t){return this._addBusinessAction(t)},s.prototype.insertBusinessAction=function(t,e){return this._addBusinessAction(t,e)},s.prototype.removeBusinessAction=function(t){return this._removeBusinessAction(t,!0)},s.prototype._removeBusinessAction=function(t,e){if(\"string\"==typeof t){for(var o,i=t,n=0;n<this.getBusinessActions().length;n++){var s=this.getBusinessActions()[n];if(s.getId()===i){o=s;break}}t=o}if(this._oMoreMenu){var a=this._oMoreMenu._getMenuItemForAction(t);a&&(this._oMoreMenu.removeItem(a),a.destroy()),0==this._oMoreMenu.getItems().length&&(this._oMoreMenuButton.destroy(),this._oMoreMenuButton=null,this._oMoreMenu.destroy(),this._oMoreMenu=null)}if(!this.getAlwaysShowMoreMenu()){var r=this._getButtonForAction(t);r&&(this.removeAggregation(\"_businessActionButtons\",r,!0),r.destroy())}var u=this.removeAggregation(\"businessActions\",t,!0);return e&&this._rerenderBusinessActions(),u},s.prototype.removeAllBusinessActions=function(){var t=this.getAggregation(\"businessActions\",[]);if(t)for(var e=0;e<t.length;e++)this._removeBusinessAction(t[e],!1);return this._rerenderBusinessActions(),this.removeAllAggregation(\"businessActions\",!0)},s.prototype.destroyBusinessActions=function(){var t=this.getAggregation(\"businessActions\",[]);if(t)for(var e=0;e<t.length;e++){var o=this._removeBusinessAction(t[e],!1);o instanceof sap.ui.core.Element&&o.destroy(!0)}return this._rerenderBusinessActions(),this.destroyAggregation(\"businessActions\",!0)},s.prototype._getBusinessActionButtons=function(){return this.getAggregation(\"_businessActionButtons\",[])},s.prototype._addBusinessAction=function(e,o){var i;if(i=o||0==o?this.insertAggregation(\"businessActions\",e,o,!0):this.addAggregation(\"businessActions\",e,!0),!this._oMoreMenuButton){this._oMoreMenuButton=new sap.ui.commons.MenuButton(this.getId()+\"-MoreMenuButton\"),this._oMoreMenuButton.setText(this._getLocalizedText(\"ACTIONBAR_BUTTON_MORE_TEXT\")),this._oMoreMenuButton.setTooltip(this._getLocalizedText(\"ACTIONBAR_BUTTON_MORE_TOOLTIP\"));var n=sap.ui.core.Popup.Dock;this._oMoreMenuButton.setDockButton(n.EndTop),this._oMoreMenuButton.setDockMenu(n.EndBottom),this._styleMoreMenuButton(),this._oMoreMenu=new sap.ui.commons.Menu(this.getId()+\"-MoreMenu\",{ariaDescription:this._getLocalizedText(\"ACTIONBAR_BUTTON_MORE_TOOLTIP\")}),this._oMoreMenu._getMenuItemForAction=function(t){for(var e=0;e<this.getItems().length;e++){var o=this.getItems()[e];if(o.action==t)return o}return null},this._oMoreMenuButton.setMenu(this._oMoreMenu)}var s=this._oMoreMenu.getId()+\"-MenuItem-\"+e.getId(),a=new sap.ui.commons.MenuItem(s,{text:e.getText(),enabled:e.getEnabled()});return a.action=e,a.attachSelect(t.proxy(function(t){this.fireActionSelected({id:e.getId(),action:e})},this)),o?this._oMoreMenu.insertItem(a,o):this._oMoreMenu.addItem(a),this._createButtonForAction(e,a,o),this._rerenderBusinessActions(),i},s.prototype._getMoreMenuButton=function(){return this._oMoreMenuButton},s.prototype._onresize=function(t){var e=this.$();if(e){var o=this.getActionBarMinWidth()+\"px\";e.css(\"minWidth\")!=o&&e.css(\"minWidth\",o)}if(!this.getAlwaysShowMoreMenu()&&this._oMoreMenuButton){var i=!1;if(this._getBusinessActionButtons().length>1){for(var n=this._oMoreMenuButton.$().outerWidth(),s=e.outerWidth()-this._getSocialActionListMinWidth()-n,a=this._getBusinessActionButtons(),r=0,u=0;u<a.length;u++){var l=a[u].$().parent();r+=l.outerWidth(),u==a.length-1&&(r-=n),r>=s?l.length>0&&(l.css(\"display\",\"none\"),a[u].oMenuItem&&a[u].oMenuItem.setVisible(!0),i=!0):l.length>0&&(l.css(\"display\",\"\"),sap.ui.Device.browser.internet_explorer&&this._rerenderBusinessAction(a[u]),a[u].oMenuItem&&a[u].oMenuItem.setVisible(!1))}i|=this.getAggregation(\"businessActions\").length>a.length}var c=this._oMoreMenuButton.$().parent();c.length>0&&(i?c.css(\"display\",\"\"):c.css(\"display\",\"none\")),!i&&this._oMoreMenu&&this._oMoreMenu.close()}this._setItemNavigation()},s.prototype.onBeforeRendering=function(){sap.ui.core.ResizeHandler.deregister(this._sResizeListenerId),this._sResizeListenerId=null},s.prototype.onAfterRendering=function(){this._sResizeListenerId=sap.ui.core.ResizeHandler.register(this.getDomRef(),t.proxy(this._onresize,this)),this._bCallOnresize&&this._onresize(),this._setItemNavigation()},s.prototype._getSocialActionListMinWidth=function(){if(!this._iSocActListWidth)if(this.getDividerWidth())this._iSocActListWidth=parseInt(this.getDividerWidth(),10);else{var t=this.getAggregation(\"_socialActions\",[]),e=t.length;this._iSocActListWidth=24*e+12}return this._iSocActListWidth},s.prototype.getActionBarMinWidth=function(){var t=this._getSocialActionListMinWidth(),e=this._oMoreMenuButton;if(this.getAlwaysShowMoreMenu()||1!=this._getBusinessActionButtons().length||(e=this._getBusinessActionButtons()[0]),e){var o=e.$().parent();o&&(t+=o.outerWidth()-3)}return t},s.prototype._getButtonForAction=function(t){for(var e=0;e<this._getBusinessActionButtons().length;e++){var o=this._getBusinessActionButtons()[e];if(o.action==t)return o}return null},s.prototype._createButtonForAction=function(e,o,i){if(!this.getAlwaysShowMoreMenu()&&!e.showInMoreMenu){var n=new sap.ui.commons.Button({id:this.getId()+\"-\"+e.getId()+\"Button\",text:e.getText(),tooltip:e.getTooltip(),enabled:e.getEnabled()});return n.attachPress(t.proxy(function(t){this.fireActionSelected({id:e.getId(),action:e})},this)),n.oMenuItem=o,n.action=e,i?this.insertAggregation(\"_businessActionButtons\",n,i,!0):this.addAggregation(\"_businessActionButtons\",n,!0),n}return null},s.prototype._styleMoreMenuButton=function(){this._oMoreMenuButton&&(this.getAlwaysShowMoreMenu()?(this._oMoreMenuButton.setLite(!0),this._oMoreMenuButton.addStyleClass(\"sapUiUx3ActionBarLiteMoreButton\")):(this._oMoreMenuButton.setLite(!1),this._oMoreMenuButton.removeStyleClass(\"sapUiUx3ActionBarLiteMoreButton\")))},s.prototype._setItemNavigation=function(){if(this.getDomRef()){this._oItemNavigation.setRootDomRef(t(this.getDomRef()).get(0));for(var e=[],o=this.getAggregation(\"_socialActions\",[]),i=0;i<o.length;i++)e.push(o[i].getDomRef());o=this.getAggregation(\"_businessActionButtons\",[]);for(var i=0;i<o.length;i++)e.push(o[i].getDomRef());this._oMoreMenuButton&&this._oMoreMenuButton.getDomRef()&&e.push(this._oMoreMenuButton.getDomRef()),this._oItemNavigation.setItemDomRefs(e)}},s.prototype.invalidate=function(t){if(t instanceof sap.ui.ux3.ThingAction){var o=sap.ui.getCore().byId(this.getId()+\"-\"+t.getId()+\"Button\"),i=this._oMoreMenu&&this._oMoreMenu._getMenuItemForAction(t);o&&(o.setTooltip(t.getTooltip()),o.setText(t.getText()),o.setEnabled(t.getEnabled())),i&&(i.setTooltip(t.getTooltip()),i.setText(t.getText()),i.setEnabled(t.getEnabled())),o||i||e.prototype.invalidate.apply(this,arguments)}e.prototype.invalidate.apply(this,arguments)},s},!0);",
	"sap/ui/ux3/ActionBarRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){var i=t;i.write(\"<div\"),i.writeControlData(e),i.addClass(\"sapUiUx3ActionBar\"),i.writeClasses(),sap.ui.getCore().getConfiguration().getAccessibility()&&i.writeAttribute(\"role\",\"toolbar\"),i.write(\">\"),i.write(\"<ul\"),i.writeAttribute(\"id\",e.getId()+\"-socialActions\"),i.addClass(\"sapUiUx3ActionBarSocialActions\"),i.writeClasses(),i.addStyle(\"min-width\",e._getSocialActionListMinWidth()+\"px\"),i.writeStyles(),i.write(\">\"),this.renderSocialActions(i,e),i.write(\"</ul>\"),i.write(\"<ul  id='\"+e.getId()+\"-businessActions' class='sapUiUx3ActionBarBusinessActions'>\"),this.renderBusinessActionButtons(i,e),i.write(\"</ul>\"),i.write(\"</div>\")},e.renderBusinessActionButtons=function(t,e){var i=e._getBusinessActionButtons(),r=e._getMoreMenuButton();if(i&&i.length>0){for(var a=0;a<i.length;a++){var s=i[a];t.write(\"<li\"),t.addClass(\"sapUiUx3ActionBarItemRight\"),t.writeClasses(),t.write(\">\"),t.renderControl(s),t.write(\"</li>\")}this._renderMoreMenuButton(t,r)}else r&&this._renderMoreMenuButton(t,r)},e._renderMoreMenuButton=function(t,e){e&&(t.write(\"<li\"),t.addClass(\"sapUiUx3ActionBarItemRight\"),t.addClass(\"sapUiUx3ActionBarMoreButton\"),t.writeClasses(),t.write(\">\"),t.renderControl(e),t.write(\"</li>\"))},e.renderSocialActions=function(t,e){var i=e.mActionMap,r=e.mActionKeys;i[r.Update]&&this._renderSocialActionListItem(t,e,i[r.Update]),i[r.Follow]&&this._renderSocialActionListItem(t,e,i[r.Follow]),i[r.Flag]&&this._renderSocialActionListItem(t,e,i[r.Flag]),i[r.Favorite]&&this._renderSocialActionListItem(t,e,i[r.Favorite]),i[r.Open]&&this._renderSocialActionListItem(t,e,i[r.Open]);for(var a in i)a in sap.ui.ux3.ActionBarSocialActions||this._renderSocialActionListItem(t,e,i[a])},e._renderSocialActionListItem=function(t,e,i){i&&!i.hide&&(t.write(\"<li\"),t.addClass(\"sapUiUx3ActionBarItem\"),t.writeClasses(),t.write(\">\"),this._renderSocialAction(t,e,i),t.write(\"</li>\"))},e._renderSocialAction=function(t,e,i){i.isMenu&&i.isMenu(e)?t.write('<a role=\"button\" aria-disabled=\"false\" aria-haspopup=\"true\"'):t.write('<a  role=\"button\" aria-disabled=\"false\" aria-haspopup=\"false\"'),i.name!=e.mActionKeys.Flag&&i.name!=e.mActionKeys.Favorite||t.writeAttribute(\"aria-pressed\",\"Selected\"==i.fnCalculateState(e)?\"true\":\"false\"),t.writeAttribute(\"tabindex\",\"0\"),t.writeElementData(i),t.addClass(i.cssClass),i.fnCalculateState&&t.addClass(i.fnCalculateState(e)),t.addClass(\"sapUiUx3ActionBarAction\"),t.writeClasses(),i.getTooltip()&&t.writeAttributeEscaped(\"title\",i.getTooltip()),i.text&&t.writeAttributeEscaped(\"text\",e.getLocalizedText(i.getText())),t.write(\"></a>\")},e},!0);",
	"sap/ui/ux3/Collection.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"sap/ui/model/SelectionModel\",\"./library\"],function(e,t,i,o){\"use strict\";var l=t.extend(\"sap.ui.ux3.Collection\",{metadata:{library:\"sap.ui.ux3\",properties:{title:{type:\"string\",group:\"Appearance\",defaultValue:null},editable:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},multiSelection:{type:\"boolean\",group:\"Accessibility\",defaultValue:!1}},aggregations:{items:{type:\"sap.ui.core.Item\",multiple:!0,singularName:\"item\"}},associations:{selectedItems:{type:\"sap.ui.core.Item\",multiple:!0,singularName:\"selectedItem\"}},events:{selectionChanged:{},propertyChanged:{}}}});return l.prototype.init=function(){this.oCollectionSelection=new i(i.SINGLE_SELECTION)},l.prototype.setMultiSelection=function(e){return e?this.oCollectionSelection.setSelectionMode(i.MULTI_SELECTION):(this.oCollectionSelection.setSelectionMode(i.SINGLE_SELECTION),this.removeAllSelectedItems()),this.setProperty(\"multiSelection\",e)},l.prototype.setEditable=function(e){this.setProperty(\"editable\",e,!0),this.firePropertyChanged()},l.prototype.setTitle=function(e){this.setProperty(\"title\",e),this.fireEvent(\"_titleChanged\",{newTitle:this.getProperty(\"title\")})},l.prototype.addSelectedItem=function(t){var o;if(o=\"object\"==typeof t?t:sap.ui.getCore().byId(t),e.inArray(o.getId(),this.getSelectedItems())>=0)return this;var l=this.indexOfItem(o);return l>-1&&(this.oCollectionSelection.getSelectionMode()==i.SINGLE_SELECTION&&(this.removeAllAssociation(\"selectedItems\",!0),this.oCollectionSelection.clearSelection()),this.oCollectionSelection.addSelectionInterval(l,l)),this.addAssociation(\"selectedItems\",t,!0),this.fireSelectionChanged(),this},l.prototype.removeSelectedItem=function(e){if(!(this.getSelectedItems().length<=1)){var t,i=this.removeAssociation(\"selectedItems\",e,!0);return t=\"object\"==typeof e?this.indexOfItem(e):this.indexOfItem(sap.ui.getCore().byId(e)),t>-1&&this.oCollectionSelection.removeSelectionInterval(t,t),this.fireSelectionChanged(),i}},l.prototype.removeAllSelectedItems=function(){var e=this.removeAllAssociation(\"selectedItems\",!0);return this.oCollectionSelection.clearSelection(),this.getItems().length>0?this.addSelectedItem(this.getItems()[0]):this.fireSelectionChanged(),e},l},!0);",
	"sap/ui/ux3/CollectionInspector.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/delegate/ItemNavigation\",\"./library\",\"./CollectionInspectorRenderer\"],function(t,e,o,i,n){\"use strict\";var s=e.extend(\"sap.ui.ux3.CollectionInspector\",{metadata:{library:\"sap.ui.ux3\",properties:{sidebarVisible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},fitParent:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},aggregations:{collections:{type:\"sap.ui.ux3.Collection\",multiple:!0,singularName:\"collection\"},content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"}},associations:{selectedCollection:{type:\"sap.ui.ux3.Collection\",multiple:!1}},events:{collectionSelected:{},itemSelectionChanged:{},editCollection:{}}}});return s.prototype.init=function(){var t=this;this._oItemNavigation||(this._oItemNavigation=new o,this._oItemNavigation.setCycling(!1),this.addDelegate(this._oItemNavigation));var e=new sap.ui.commons.ToggleButton(this.getId()+\"-toggleButton\");e.setParent(this),e.setTooltip(\"This button opens and closes the sidebar\"),e.attachPress(function(){e.getPressed()?t.openSidebar():t.closeSidebar()}),this._oToggleButton=e;var i=new sap.ui.commons.SegmentedButton(this.getId()+\"-selector\");i.attachSelect(function(e){var o=this.indexOfButton(sap.ui.getCore().byId(this.getSelectedButton())),i=t.getCollections()[o];t.setSelectedCollection(i),t.fireCollectionSelected({collection:i}),t.openSidebar()}),this._oCollectionSelector=i;var n=new sap.ui.commons.Button;n.addStyleClass(\"sapUiUx3EditCollectionButton\"),n.setText(\"Collection\"),n.setTooltip(\"This button opens an edit dialog for the current collection\"),n.attachPress(function(){t.fireEditCollection()}),this._oEditButton=n},s.prototype.exit=function(){this._oToggleButton.destroy(),this._oToggleButton=null,this._oEditButton.destroy(),this._oEditButton=null,this._oCollectionSelector.destroy(),this._oCollectionSelector=null,this._oItemNavigation&&(this.removeDelegate(this._oItemNavigation),this._oItemNavigation.destroy(),delete this._oItemNavigation)},s.prototype.onBeforeRendering=function(){this._oToggleButton.setPressed(this.getSidebarVisible())},s.prototype.onAfterRendering=function(){if(this.getSelectedCollection()){var t=sap.ui.getCore().byId(this.getSelectedCollection());0==t.getSelectedItems().length&&t.getItems().length>0&&t.addSelectedItem(t.getItems()[0])}else this.getCollections().length>0&&this.setSelectedCollection(this.getCollections()[0]);this.setElementsHeight(),this.updateItemNavigation(),this.refreshSelectionHighlighting()},s.prototype.onclick=function(e){var o=e.target;if(t(o).hasClass(\"sapUiUx3CICollectionListItem\")){var i=sap.ui.getCore().byId(this.getSelectedCollection());t.inArray(o.id,i.getSelectedItems())>=0?i.removeSelectedItem(o.id):i.addSelectedItem(o.id),this.refreshSelectionHighlighting(),this.fireItemSelectionChanged({selectedItems:i.getSelectedItems()})}},s.prototype.getToggleButton=function(){return this._oToggleButton},s.prototype.getCollectionSelector=function(){return this._oCollectionSelector},s.prototype.rerenderSidebar=function(){var t=sap.ui.getCore().byId(this.getSelectedCollection());t&&t.getEditable()?this._oEditButton.setVisible(!0):this._oEditButton.setVisible(!1);var e=this.$(\"sidebar\");if(e.length>0){var o=sap.ui.getCore().createRenderManager();this.getRenderer().renderSidebar(o,this),o.flush(e[0]),o.destroy()}t&&t.getEditable()?this.$(\"sidebar\").addClass(\"sapUiUx3CIWithEditButton\"):this.$(\"sidebar\").removeClass(\"sapUiUx3CIWithEditButton\"),this.updateItemNavigation(),this.refreshSelectionHighlighting()},s.prototype.updateItemNavigation=function(){var e=[],o=this.$(\"sidebar\").find(\"li\");t.each(o,function(t,o){e.push(o)}),this._oItemNavigation.setItemDomRefs(e),this._oItemNavigation.setRootDomRef(this.$(\"sidebar ul\")[0])},s.prototype.rerenderContent=function(){var t=this.$(\"content\");if(t.length>0){var e=sap.ui.getCore().createRenderManager();this.getRenderer().renderContent(e,this),e.flush(t[0]),e.destroy()}this.setElementsHeight()},s.prototype.setElementsHeight=function(){if(!this.getFitParent()){var t=this.$(\"sidebar\"),e=this.$(\"content\"),o=e.outerHeight(!0),i=e.outerHeight(!0)-e.height(),n=t.outerHeight(!0)-t.height();t.height(Math.max(200,o)-n),e.height(Math.max(200,o)-i)}},s.prototype.openSidebar=function(){var t=this.$(),e=this.$(\"sidebar\"),o=this.$(\"content\");e.stop(!0,!0).animate({width:150},300,function(){e.css(\"width\",\"\")}),o.stop(!0,!0).animate({left:150},300,function(){o.css(\"left\",\"\")}),t.removeClass(\"sapUiUx3CISidebarClosed\"),t.addClass(\"sapUiUx3CISidebarOpened\"),this._oToggleButton.setPressed(!0)},s.prototype.closeSidebar=function(){var t=this.$(),e=this.$(\"sidebar\"),o=this.$(\"content\");e.stop(!0,!0).animate({width:0},300,function(){e.css(\"width\",\"\")}),o.stop(!0,!0).animate({left:0},300,function(){o.css(\"left\",\"\")}),t.removeClass(\"sapUiUx3CISidebarOpened\"),t.addClass(\"sapUiUx3CISidebarClosed\"),this._oToggleButton.setPressed(!1)},s.prototype.insertCollection=function(t,e){var o=new sap.ui.commons.Button;o.setText(t.getTitle()),t.attachEvent(\"_titleChanged\",function(t){o.setText(t.getParameter(\"newTitle\"))});var i=this;return t.attachSelectionChanged(function(){i.refreshSelectionHighlighting()}),t.attachPropertyChanged(function(){i.rerenderSidebar()}),this._oCollectionSelector.insertButton(o,e),this.insertAggregation(\"collections\",t,e)},s.prototype.addCollection=function(t){var e=new sap.ui.commons.Button;e.setText(t.getTitle()),t.attachEvent(\"_titleChanged\",function(t){e.setText(t.getParameter(\"newTitle\"))});var o=this;return t.attachSelectionChanged(function(){o.refreshSelectionHighlighting()}),t.attachPropertyChanged(function(){o.rerenderSidebar()}),this._oCollectionSelector.addButton(e),this.addAggregation(\"collections\",t)},s.prototype.removeCollection=function(t){var e;e=\"object\"==typeof t?this.indexOfCollection(t):this.indexOfCollection(sap.ui.getCore().byId(t));var o=this._oCollectionSelector.getButtons()[e];this._oCollectionSelector.removeButton(o);var i=this.removeAggregation(\"collections\",t);return i&&this.getSelectedCollection()==i.getId()&&this.setSelectedCollection(null),i},s.prototype.removeAllCollections=function(){return this._oCollectionSelector.removeAllButtons(),this.setSelectedCollection(null),this.removeAllAggregation(\"collections\")},s.prototype.destroyCollections=function(){return this._oCollectionSelector.destroyButtons(),this.setSelectedCollection(null),this.destroyAggregation(\"collections\")},s.prototype.setSelectedCollection=function(t){if(this.setAssociation(\"selectedCollection\",t,!0),t){this._oCollectionSelector.setSelectedButton(this._oCollectionSelector.getButtons()[this.indexOfCollection(t)]);var e=sap.ui.getCore().byId(this.getSelectedCollection());0==e.getSelectedItems().length&&e.getItems().length>0&&e.addSelectedItem(e.getItems()[0])}else this._oEditButton.setVisible(!1);this.rerenderSidebar(),this.refreshSelectionHighlighting()},s.prototype.insertContent=function(t,e){this.insertAggregation(\"content\",t,e,!0),this.rerenderContent()},s.prototype.addContent=function(t){this.addAggregation(\"content\",t,!0),this.rerenderContent()},s.prototype.removeContent=function(t){this.removeAggregation(\"content\",t,!0),this.rerenderContent()},s.prototype.removeAllContent=function(){this.removeAllAggregation(\"content\",!0),this.rerenderContent()},s.prototype.destroyContent=function(){this.destroyAggregation(\"content\",!0),this.rerenderContent()},s.prototype.onfocusout=function(e){var o=t(e.target);o.hasClass(\"sapUiUx3CICollectionListItem\")&&o.removeClass(\"sapUiUx3CISidebarFoc\")},s.prototype.onfocusin=function(e){var o=t(e.target);o.hasClass(\"sapUiUx3CICollectionListItem\")&&o.addClass(\"sapUiUx3CISidebarFoc\")},s.prototype.onsapenter=function(e){t(e.target).hasClass(\"sapUiUx3CISidebarFoc\")&&this.onclick(e),e.stopPropagation()},s.prototype.onsapspace=function(e){t(e.target).hasClass(\"sapUiUx3CISidebarFoc\")&&this.onclick(e),e.stopPropagation()},s.prototype.refreshSelectionHighlighting=function(){var e,o=this.$(\"sidebar\").find(\".sapUiUx3CICollectionListItem\");e=this.getSelectedCollection()?sap.ui.getCore().byId(this.getSelectedCollection()).getSelectedItems():[],t.each(o,function(o,i){t.inArray(i.id,e)>=0?(t(i).addClass(\"sapUiUx3CICollectionListItemSelected\"),t(i).attr(\"aria-selected\",!0)):(t(i).removeClass(\"sapUiUx3CICollectionListItemSelected\"),t(i).attr(\"aria-selected\",!1))})},s.prototype.getEditButton=function(){return this._oEditButton},s},!0);",
	"sap/ui/ux3/CollectionInspectorRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){var i=e;i.write(\"<div\"),i.addClass(\"sapUiUx3CI\"),t.getSidebarVisible()?i.addClass(\"sapUiUx3CISidebarOpened\"):i.addClass(\"sapUiUx3CISidebarClosed\"),t.getFitParent()&&i.addClass(\"sapUiUx3CIFitParent\"),i.writeClasses(),i.writeControlData(t),i.write(\">\"),i.write(\"<div\"),i.addClass(\"sapUiUx3CIToolBar\"),i.writeClasses(),i.write(\">\"),this.renderToggleButton(i,t),this.renderCollectionSelector(i,t),i.write(\"</div>\"),i.write(\"<div\"),i.addClass(\"sapUiUx3CISidebar\"),i.writeClasses(),i.writeAttribute(\"id\",t.getId()+\"-sidebar\"),i.write(\">\"),this.renderSidebar(i,t),i.write(\"</div>\"),i.write(\"<div\"),i.addClass(\"sapUiUx3CIContent\"),i.writeAttribute(\"id\",t.getId()+\"-content\"),i.writeClasses(),i.write(\">\"),this.renderContent(i,t),i.write(\"</div>\"),i.write(\"<div\"),i.addClass(\"sapUiUx3CIClear\"),i.writeClasses(),i.write(\">\"),i.write(\"</div>\"),i.write(\"</div>\")},t.renderToggleButton=function(e,t){t.getToggleButton()&&(e.write(\"<div\"),e.writeAttribute(\"id\",t.getId()+\"-togglebutton\"),e.addClass(\"sapUiUx3CIToggleButton\"),e.writeClasses(),e.write(\">\"),e.renderControl(t.getToggleButton()),e.write(\"</div>\"))},t.renderCollectionSelector=function(e,t){t.getCollectionSelector()&&(e.write(\"<div\"),e.addClass(\"sapUiUx3CICollectionSelector\"),e.writeClasses(),e.write(\">\"),e.renderControl(t.getCollectionSelector()),e.write(\"</div>\"))},t.renderSidebar=function(t,i){t.write(\"<div\"),t.addClass(\"sapUiUx3CICollectionListContainer\"),t.writeClasses(),t.write(\">\"),t.write('<ul tabindex=\"-1\"'),t.addClass(\"sapUiUx3CICollectionList\"),t.writeClasses();var r=sap.ui.getCore().byId(i.getSelectedCollection());if(i.getSelectedCollection()&&t.writeAccessibilityState(r,{role:\"listbox\",multiselectable:r.getMultiSelection()}),t.write(\">\"),i.getSelectedCollection()){var s=r.getItems().length;e.each(r.getItems(),function(i,l){t.write('<li tabindex=\"-1\"'),t.writeElementData(l),t.writeAttributeEscaped(\"title\",l.getText()),t.addClass(\"sapUiUx3CICollectionListItem\"),t.writeClasses(),t.writeAccessibilityState(l,{role:\"option\",selected:e.inArray(l.getId(),r.getSelectedItems())>=0,setsize:s,posinset:i}),t.write(\">\"),t.writeEscaped(l.getText()),t.write(\"</li>\")})}t.write(\"</ul></div>\"),t.renderControl(i.getEditButton())},t.renderContent=function(t,i){e.each(i.getContent(),function(e,i){t.renderControl(i)})},t},!0);",
	"sap/ui/ux3/DataSet.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/ResizeHandler\",\"./library\",\"./DataSetRenderer\"],function(e,t,i,o,r){\"use strict\";var s=t.extend(\"sap.ui.ux3.DataSet\",{metadata:{library:\"sap.ui.ux3\",properties:{showToolbar:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showFilter:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showSearchField:{type:\"boolean\",group:\"Misc\",defaultValue:!0},multiSelect:{type:\"boolean\",group:\"Behavior\",defaultValue:!1}},aggregations:{items:{type:\"sap.ui.ux3.DataSetItem\",multiple:!0,singularName:\"item\",bindable:\"bindable\"},views:{type:\"sap.ui.ux3.DataSetView\",multiple:!0,singularName:\"view\"},filter:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"filter\"},_viewSwitches:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"_viewSwitch\",visibility:\"hidden\"},_toolbar:{type:\"sap.ui.commons.Toolbar\",multiple:!1,visibility:\"hidden\"}},associations:{selectedView:{type:\"sap.ui.ux3.DataSetView\",multiple:!1}},events:{selectionChanged:{parameters:{oldLeadSelectedIndex:{type:\"int\"},newLeadSelectedIndex:{type:\"int\"}}},search:{parameters:{query:{type:\"string\"}}}}}});return s.prototype.init=function(){var t,i=this;e.sap.require(\"sap.ui.model.SelectionModel\"),this.selectionModel=new sap.ui.model.SelectionModel(sap.ui.model.SelectionModel.SINGLE_SELECTION),this._oSegBut=new sap.ui.commons.SegmentedButton,this._oSegBut.attachSelect(function(e){i.press(e)},i),this._oSegBut.show=!1,this._oSearchField=new sap.ui.commons.SearchField(this.getId()+\"-searchValue\"),this._oSearchField.setShowListExpander(!1),this._oSearchField.setEnableListSuggest(!1),this._oSearchField.setEnableFilterMode(!0),this._oSearchField.setEnableClear(!0),this._oSearchField.show=!1,i=this,this._oSearchField.attachSearch(function(e){i.fireSearch(e.getParameters())}),this.selectionModel.attachSelectionChanged(function(t){var o,r,s=t.getParameters();s&&(r=s.leadIndex,o=s.oldIndex),i.fireSelectionChanged({oldLeadSelectedIndex:o,newLeadSelectedIndex:r}),e.sap.log.debug(\"Selection Change fired\")}),t=new sap.ui.commons.Toolbar,this._setToolbar(t),this._iShiftStart=null},s.prototype.exit=function(){this._oSegBut.destroy(),this._oSearchField.destroy(),this.destroyAggregation(\"_toolbar\")},s.prototype._prepareToolbar=function(){var e=this.getViews().length,t=this._getToolbar();e>1&&0==this._oSegBut.show?(t.insertItem(this._oSegBut,0),this._oSegBut.show=!0):e<=1&&this._oSegBut.show&&(t.removeItem(this._oSegBut),this._oSegBut.show=!1),this.getShowSearchField()&&0==this._oSearchField.show?(t.insertRightItem(this._oSearchField,t.getRightItems().length),this._oSearchField.show=!0):this.getShowSearchField()||1!=this._oSearchField.show||(t.removeRightItem(this._oSearchField),this._oSearchField.show=!1)},s.prototype.press=function(e,t){var i=e.getParameters().selectedButtonId,o=i.substring(i.lastIndexOf(\"-\")+1);sap.ui.getCore().byId(this.getSelectedView()).exitView(this.getItems()),this.setSelectedView(o)},s.prototype.filter=function(){this.fireFilter({filterValue:this.getFilterValue()})},s.prototype.sort=function(){this.fireSort()},s.prototype.addSelectionInterval=function(e,t){return this.selectionModel.addSelectionInterval(e,t),this},s.prototype.setSelectionInterval=function(e,t){return this.selectionModel.setSelectionInterval(e,t),this},s.prototype.removeSelectionInterval=function(e,t){return this.selectionModel.removeSelectionInterval(e,t),this},s.prototype.getSelectedIndex=function(){return this.selectionModel.getLeadSelectedIndex()},s.prototype.getSelectedIndices=function(){return this.selectionModel.getSelectedIndices()||[]},s.prototype.clearSelection=function(){return this.selectionModel.clearSelection(),this},s.prototype.selectItem=function(t){var i=t.getParameters(),o=t.getParameters().itemId,r=sap.ui.getCore().byId(o),s=this.getItems(),n=e.inArray(r,s),a=this.getLeadSelection();this.getMultiSelect()?(i.ctrl&&(this.isSelectedIndex(n)?this.removeSelectionInterval(n,n):this.addSelectionInterval(n,n),this._iShiftStart>=0&&(this._iShiftStart=n)),i.shift&&(this._iShiftStart||0===this._iShiftStart||(this._iShiftStart=a),this._iShiftStart>=0&&i.ctrl?this.addSelectionInterval(this._iShiftStart,n):this._iShiftStart>=0&!i.ctrl?this.setSelectionInterval(this._iShiftStart,n):(this.setLeadSelection(n),this._iShiftStart=n)),i.shift||i.ctrl||(a==n&&n!=this._iShiftStart?this.setLeadSelection(-1):this.setLeadSelection(n),this._iShiftStart=null)):(a!=n||i.shift?this.setLeadSelection(n):this.setLeadSelection(-1),this._iShiftStart=null)},s.prototype.prepareRendering=function(){var e;0!=this.getViews().length&&(this._prepareToolbar(),this._bDirty&&(e=sap.ui.getCore().byId(this.getSelectedView()),e.exitView&&e.exitView(this.getItems()),e.initView&&e.initView(this.getItems()),this._bDirty=!1))},s.prototype.getLeadSelection=function(){return this.selectionModel.getLeadSelectedIndex()},s.prototype.setLeadSelection=function(e){this.selectionModel.setLeadSelectedIndex(e)},s.prototype.isSelectedIndex=function(e){return this.selectionModel.isSelectedIndex(e)},s.prototype.getSelectedItemId=function(e){return this.getItems()[e].getId()},s.prototype.createViewSwitch=function(e,t){var i;return i=e.getIcon()?new sap.ui.commons.Button({id:this.getId()+\"-view-\"+e.getId(),lite:!0,icon:e.getIcon(),iconHovered:e.getIconHovered(),iconSelected:e.getIconSelected()}):e.getName()?new sap.ui.commons.Button({id:this.getId()+\"-view-\"+e.getId(),text:e.getName(),lite:!0}):new sap.ui.commons.Button({id:this.getId()+\"-view-\"+e.getId(),text:e.getId(),lite:!0}),i._viewIndex=t,i},s.prototype._rerenderToolbar=function(){var e=this.$(\"toolbar\");if(this._prepareToolbar(),e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.DataSetRenderer.renderToolbar(t,this),t.flush(e[0]),t.destroy()}},s.prototype._rerenderFilter=function(){var e=this.$(\"filter\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.DataSetRenderer.renderFilterArea(t,this),t.flush(e[0]),this.getShowFilter()?e.removeClass(\"noPadding\"):e.addClass(\"noPadding\"),t.destroy()}},s.prototype.setMultiSelect=function(e){return this.clearSelection(),e?(this.setProperty(\"multiSelect\",!0),this.selectionModel&&this.selectionModel.setSelectionMode(sap.ui.model.SelectionModel.MULTI_SELECTION)):(this.setProperty(\"multiSelect\",!1),this.selectionModel&&this.selectionModel.setSelectionMode(sap.ui.model.SelectionModel.SINGLE_SELECTION)),this},s.prototype.removeItem=function(e){var t=this.removeAggregation(\"items\",e,!0);return t&&(t.detachSelected(this.selectItem,this),t.destroyAggregation(\"_template\",!0),this._bDirty=!0),t},s.prototype.removeAllItems=function(){var t,i=this.getItems();return e.each(i,function(e,t){t.destroyAggregation(\"_template\",!0),t.detachSelected(this.selectItem,this)}),t=this.removeAllAggregation(\"items\"),this._bDirty=!0,t},s.prototype.destroyItems=function(){var e=this.destroyAggregation(\"items\");return this._bDirty=!0,e},s.prototype.addItem=function(e){return this.addAggregation(\"items\",e,!0),e.attachSelected(this.selectItem,this),this._bDirty=!0,this},s.prototype.insertItem=function(e,t){return this.insertAggregation(\"items\",e,t,!0),e.attachSelected(this.selectItem,this),this._bDirty=!0,this},s.prototype.setFilterValue=function(e){return this.setProperty(\"filterValue\",e,!0),this},s.prototype.getFilterValue=function(){return this.getProperty(\"filterValue\")},s.prototype.insertView=function(e,t){var i=this.createViewSwitch(e,t,!0);return this.getSelectedView()||this.setSelectedView(e),this.insertAggregation(\"views\",e,t),this._oSegBut.insertButton(i,t),this._rerenderToolbar(),this},s.prototype.addView=function(e){var t=this.getViews().length,i=this.createViewSwitch(e,t);return this.getSelectedView()||this.setSelectedView(e),this.addAggregation(\"views\",e,!0),this._oSegBut.addButton(i),this._rerenderToolbar(),this},s.prototype.removeView=function(e){var t=this.removeAggregation(\"views\",e,!0);return t&&(this.getSelectedView()==t.getId()?(this.setSelectedView(this.getViews()[0]),this._bDirty=!0,t.invalidate()):this._rerenderToolbar(),this._oSegBut.removeButton(this.getId()+\"-view-\"+t.getId()).destroy()),t},s.prototype.destroyViews=function(){return this._oSegBut.destroyButtons(),this.destroyAggregation(\"views\"),this},s.prototype.removeAllViews=function(){var e=this.removeAllAggregation(\"views\");return this._oSegBut.destroyButtons(),e},s.prototype.setEnableSorting=function(e){return this.setProperty(\"enableSorting\",e,!0),this._rerenderToolbar(),this},s.prototype.setEnableFiltering=function(e){return this.setProperty(\"enableFiltering\",e,!0),this._rerenderToolbar(),this},s.prototype.setSelectedView=function(e){var t=this.getSelectedView();return this.setAssociation(\"selectedView\",e),t!=this.getSelectedView()&&(this._bDirty=!0),this.getId()+\"-view-\"+this.getSelectedView()!==this._oSegBut.getSelectedButton()&&this._oSegBut.setSelectedButton(this.getId()+\"-view-\"+this.getSelectedView()),this},s.prototype.addToolbarItem=function(e){this._getToolbar().addItem(e),this._rerenderToolbar()},s.prototype.removeToolbarItem=function(e){this._getToolbar().removeItem(e),this._rerenderToolbar()},s.prototype.setShowToolbar=function(e){this.setProperty(\"showToolbar\",e,!0),this._rerenderToolbar()},s.prototype.setShowFilter=function(e){this.setProperty(\"showFilter\",e,!0),this._rerenderFilter()},s.prototype.setShowSearchField=function(e){this.setProperty(\"showSearchField\",e,!0),this._rerenderToolbar()},s.prototype._setToolbar=function(e){this.setAggregation(\"_toolbar\",e,!0),this._rerenderToolbar()},s.prototype._getToolbar=function(){return this.getAggregation(\"_toolbar\")},s.prototype.refreshItems=function(){var e=this.getBinding(\"items\"),t=sap.ui.getCore().byId(this.getSelectedView());if(e.bUseExtendedChangeDetection=!0,t&&t.getItemCount&&t.getItemCount()){var i=Math.max(t.getItemCount(),this.getItems().length);i?e.getContexts(0,i):e.getContexts()}else e.getContexts()},s.prototype.updateItems=function(t){var i,o,r,s,n=this.mBindingInfos.items,a=this.getMetadata().getAggregation(\"items\"),l=sap.ui.getCore().byId(this.getSelectedView()),h=n.binding,d=n.factory,c=this,g=[];if(h.bUseExtendedChangeDetection=!0,l&&l.getItemCount&&l.getItemCount()){var u=Math.max(l.getItemCount(),this.getItems().length);g=u?h.getContexts(0,u):h.getContexts()}else g=h.getContexts();if(g.diff&&t){for(var p=g.diff,S=0;S<p.length;S++)o=this.getItems(),s=p[S].index,\"delete\"===p[S].type?(r=o[s],p[S].item=r,this.removeItem(r)):\"insert\"===g.diff[S].type&&(r=d(\"\",g[s]),r.setBindingContext(g[s],n.model),p[S].item=r,this.insertItem(r,s));l&&l.updateView&&l.updateView(p)}else this[a._sDestructor](),e.each(g,function(e,t){var o=c.getId()+\"-\"+e;i=d(o,t),i.setBindingContext(t,n.model),c[a._sMutator](i)});o=this.getItems();for(var S=0,m=g.length;S<m;S++)o[S].setBindingContext(g[S],n.model)},s},!0);",
	"sap/ui/ux3/DataSetItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\"],function(e,t,i){\"use strict\";var a=t.extend(\"sap.ui.ux3.DataSetItem\",{metadata:{library:\"sap.ui.ux3\",properties:{iconSrc:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},title:{type:\"string\",group:\"Misc\",defaultValue:\"Title\"},checkable:{type:\"boolean\",group:\"Misc\",defaultValue:!0},subtitle:{type:\"string\",group:\"Misc\",defaultValue:\"Subtitle\"}},aggregations:{_template:{type:\"sap.ui.core.Control\",multiple:!1,visibility:\"hidden\"}},events:{selected:{parameters:{itemId:{type:\"string\"}}}}}});return a.prototype.onclick=function(e){e.stopPropagation();var t=e.shiftKey,i=!(!e.metaKey&&!e.ctrlKey);this.fireSelected({itemId:this.getId(),shift:t,ctrl:i})},a.prototype.ondblclick=function(e){this.onclick(e)},a},!0);",
	"sap/ui/ux3/DataSetRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var r={};return r.render=function(e,r){var t=e,i=null;r.prepareRendering(),t.write(\"<div\"),t.writeControlData(r),t.addClass(\"sapUiUx3DS\"),t.writeClasses(),t.writeStyles(),t.write(\">\"),t.write(\"<div id='\"+r.getId()+\"-toolbar'\"),t.addClass(\"sapUiUx3DSToolbar\"),r.getShowToolbar()||t.addClass(\"noPadding\"),t.writeClasses(),t.write(\">\"),this.renderToolbar(t,r),t.write(\"</div>\"),t.write(\"<div id='\"+r.getId()+\"-filter'\"),t.addClass(\"sapUiUx3DSFilterArea\"),r.getShowFilter()||t.addClass(\"noPadding\"),t.writeClasses(),t.write(\">\"),this.renderFilterArea(t,r),t.write(\"</div>\"),t.write(\"<div\"),t.writeAttribute(\"id\",r.getId()+\"-items\"),t.addClass(\"sapUiUx3DSItems\"),t.writeClasses(),t.write(\">\"),i=sap.ui.getCore().byId(r.getSelectedView()),t.renderControl(i),t.write(\"</div>\"),t.write(\"</div>\")},r.renderToolbar=function(e,r){var t=e;r.getShowToolbar()&&t.renderControl(r._getToolbar())},r.renderFilterArea=function(r,t){var i=r,a=t.getFilter();t.getShowFilter()&&e.each(a,function(e,r){i.renderControl(r)})},r},!0);",
	"sap/ui/ux3/DataSetSimpleView.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/ResizeHandler\",\"./library\",\"./DataSetSimpleViewRenderer\",\"jquery.sap.script\"],function(e,t,i,s,n){\"use strict\";var o=t.extend(\"sap.ui.ux3.DataSetSimpleView\",{metadata:{interfaces:[\"sap.ui.ux3.DataSetView\"],library:\"sap.ui.ux3\",properties:{floating:{type:\"boolean\",group:\"Misc\",defaultValue:!0},name:{type:\"string\",group:\"Misc\",defaultValue:\"Name of this View\"},icon:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},iconHovered:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},iconSelected:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},responsive:{type:\"boolean\",group:\"Misc\",defaultValue:!1},itemMinWidth:{type:\"int\",group:\"Misc\",defaultValue:0},initialItemCount:{type:\"int\",group:\"Appearance\",defaultValue:0},reloadItemCount:{type:\"int\",group:\"Appearance\",defaultValue:0},scrollArea:{type:\"any\",group:\"Appearance\",defaultValue:null},height:{type:\"sap.ui.core.CSSSize\",group:\"Appearance\",defaultValue:null}},aggregations:{template:{type:\"sap.ui.core.Control\",multiple:!1}}}});return o.prototype.init=function(){this._oDataSet=this.getParent(),this.items=[],this._bRendered=!1,this.getInitialItemCount()>0&&this.getReloadItemCount()<=0&&this.setReloadItemCount(this.getInitialItemCount()),this._bUsePagination=!1},o.prototype.exit=function(){this.sResizeListenerId&&(i.deregister(this.sResizeListenerId),this.sResizeListenerId=null)},o.prototype.handleSelection=function(t){var i=this.getParent(),s=i.getItems();i.getSelectedIndices().length>1&&this._clearTextSelection(),e.each(s,function(e,t){i.isSelectedIndex(e)?t.$().addClass(\"sapUiUx3DSSVSelected\"):t.$().removeClass(\"sapUiUx3DSSVSelected\")})},o.prototype._clearTextSelection=function(){if(window.getSelection)window.getSelection().empty?window.getSelection().empty():window.getSelection().removeAllRanges&&window.getSelection().removeAllRanges();else if(document.selection&&document.selection.empty)try{document.selection.empty()}catch(e){}},o.prototype.isItemSelected=function(t){var i=e.inArray(t,this.items);return-1!=i&&this.getParent().isSelectedIndex(i)},o.prototype.initView=function(e){this.getParent().attachSelectionChanged(this.handleSelection,this),this.items=this.items.concat(e);for(var t=0;t<e.length;t++){var i=this.getTemplate().clone();e[t].setAggregation(\"_template\",i,!0)}},o.prototype.updateView=function(e){var t;if(this.getDomRef()){var i=sap.ui.getCore().createRenderManager(),s=this.items.length;for(t=0;t<e.length;t++){var n=e[t].item,o=e[t].index;if(\"insert\"===e[t].type){var r=this.getTemplate().clone();if(n.setAggregation(\"_template\",r,!0),t==e.length-1&&0==s){var a={onAfterRendering:function(){this.calculateItemCounts(),this.getParent().updateItems(sap.ui.model.ChangeReason.Change),r.removeDelegate(a)}};r.addDelegate(a,!1,this)}this.getRenderer().renderItem(i,this,n),i.flush(this.$()[0],!1,o),this.items.splice(o,0,n)}else this.items.splice(o,1),n.$().remove(),n.destroy()}e.length>0&&this.getFloating()&&this.getResponsive()&&this._computeWidths(!0),i.destroy()}else for(t=0;t<e.length;t++)\"delete\"===e[t].type&&e[t].item.destroy()},o.prototype.exitView=function(e){this.getParent().detachSelectionChanged(this.handleSelection,this);for(var t=0;t<e.length;t++)e[t].destroyAggregation(\"_template\",!0);this.items=[]},o.prototype.initScrollArea=function(){var t=this.getScrollArea(),i=this,s=function(e){i.getParent().updateItems(sap.ui.model.ChangeReason.Change)};\"string\"==typeof t&&(t=e.sap.byId(t)),t?t.is(\"html\")&&(t=e(document)):t=this.$(),this._bUsePagination?t.on(\"scroll\",s):t.off(\"scroll\",s)},o.prototype.checkScrollItems=function(){if(this._bRendered){var t,i,s,n,o=this.getParent().mBindingInfos.items,r=this.getScrollArea(),a=o.binding,l=this.getParent(),h=0;if(l.getItems().length===a.getLength())return h;if(\"string\"==typeof r&&(r=e.sap.byId(r)),r||(r=this.$()),!r||0==r.length)return h;if(i=r[0],s=i.clientHeight,n=i.scrollHeight,r.is(\"html\")&&(r=e(document)),(t=s==n?s+this._iScrollTrigger:s+this._iScrollTrigger+r.scrollTop())>0){var g=Math.floor(t/this._iRowHeight)*this._iItemsPerRow,p=l.getItems().length;g=Math.ceil(g/this._iItemsPerRow)*this._iItemsPerRow,h=g-p}return h}},o.prototype.getItemCount=function(){if(this._bUsePagination){var e=this.getParent().getItems().length,t=this.checkScrollItems();return e+=0==e?this.getInitialItemCount():t}return null},o.prototype.setInitialItemCount=function(e){this.setProperty(\"initialItemCount\",e),this._bUsePagination=0!=e},o.prototype.onBeforeRendering=function(){this.sResizeListenerId&&(i.deregister(this.sResizeListenerId),this.sResizeListenerId=null)},o.prototype.onAfterRendering=function(){this._bRendered=!0,this.initScrollArea(),(this.getFloating()&&this.getResponsive()||this._bUsePagination)&&(this._height=-1,this._itemsPerRow=-1,this.onresize(),this.sResizeListenerId=i.register(this.getDomRef(),e.proxy(this.onresize,this)))},o.prototype.onThemeChanged=function(){this._bRendered&&(this.calculateItemCounts(),this.getParent().updateItems(sap.ui.model.ChangeReason.Change))},o.prototype.onresize=function(){if(!this.getDomRef())return void(this.sResizeListenerId&&(i.deregister(this.sResizeListenerId),this.sResizeListenerId=null));this.getFloating()&&this.getResponsive()&&this._computeWidths(),this._bUsePagination&&this.items.length>0&&(this.calculateItemCounts(),this.getParent().updateItems(sap.ui.model.ChangeReason.Change))},o.prototype.setTemplate=function(e){this.setAggregation(\"template\",e,!0),this.getParent()&&this.getParent().updateItems()},o.prototype.calculateItemCounts=function(){if(this.getDomRef()&&sap.ui.getCore().isThemeApplied()){var e=this.$(),t=e.children().first();this._iItemsPerRow=Math.floor(e.outerWidth(!0)/t.outerWidth(!0)),this._iNewRows=Math.ceil(this.getReloadItemCount()/this._iItemsPerRow),this._iNewItems=this._iItemsPerRow*this._iNewRows,this._iRowHeight=t.outerHeight(!0),this._iScrollTrigger=this._iNewRows*this._iRowHeight}},o.prototype._computeWidths=function(e){var t=this.$(),i=Math.floor(t.width()/this.getItemMinWidth()),s=Math.floor(100/i);if(t.width()*s/100<this.getItemMinWidth()&&(i--,s=Math.floor(100/i)),e||this._height!=t.height()||this._itemsPerRow!=i){for(var n,o,r=-1,a=this.getParent().getItems(),l=0;l<a.length;l++){(-1==r||r+1>i)&&(r=0,n=100-i*s);var o=s;n>0&&(o++,n--),a[l].$().css(\"width\",o+\"%\"),r++}this._height=t.height(),this._itemsPerRow=i}},o.prototype.setScrollArea=function(t,i){\"string\"==typeof t||t instanceof e||e.sap.log.error(\"You can only pass a string (ID of scroll area DOM) or a jQuery object as scrollarea\"),this.setProperty(\"scrollArea\",t,i)},o},!0);",
	"sap/ui/ux3/DataSetSimpleViewRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){var i=e;if(i.write(\"<div\"),i.writeControlData(t),i.addClass(\"sapUiUx3DSSV\"),t.getFloating()?t.getResponsive()?i.addClass(\"sapUiUx3DSSVResponsive\"):i.addClass(\"sapUiUx3DSSVFloating\"):i.addClass(\"sapUiUx3DSSVSingleRow\"),t.getHeight()&&(i.addStyle(\"height\",t.getHeight()),i.addClass(\"sapUiUx3DSSVSA\")),i.writeClasses(),i.writeStyles(),i.write(\">\"),t.items)for(var s=0;s<t.items.length;s++)this.renderItem(i,t,t.items[s]);i.write(\"</div>\")},t.renderItem=function(e,t,i){e.write(\"<div\"),e.addClass(\"sapUiUx3DSSVItem\"),t.getFloating()&&(e.addClass(\"sapUiUx3DSSVFlow\"),t.getItemMinWidth()>0&&e.writeAttribute(\"style\",\"min-width:\"+t.getItemMinWidth()+\"px\")),t.isItemSelected(i)&&e.addClass(\"sapUiUx3DSSVSelected\"),e.writeClasses(),e.writeElementData(i),e.write(\">\"),e.renderControl(i.getAggregation(\"_template\")),e.write(\"</div>\")},t},!0);",
	"sap/ui/ux3/Exact.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/Button\",\"sap/ui/commons/Menu\",\"sap/ui/commons/SearchField\",\"sap/ui/commons/TextView\",\"sap/ui/core/Control\",\"./ExactArea\",\"./ExactAttribute\",\"./ExactBrowser\",\"./library\",\"./ExactRenderer\"],function(t,e,r,i,s,a,u,n,o,l,c){\"use strict\";var h=a.extend(\"sap.ui.ux3.Exact\",{metadata:{library:\"sap.ui.ux3\",properties:{resultText:{type:\"string\",group:\"Misc\",defaultValue:null}},defaultAggregation:\"attributes\",aggregations:{settingsMenu:{type:\"sap.ui.commons.Menu\",multiple:!1,forwarding:{idSuffix:\"-browser\",aggregation:\"optionsMenu\"}},attributes:{type:\"sap.ui.ux3.ExactAttribute\",multiple:!0,singularName:\"attribute\",forwarding:{idSuffix:\"-browser\",aggregation:\"attributes\"}},controls:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"control\",visibility:\"hidden\"}},events:{search:{parameters:{query:{type:\"string\"}}},refineSearch:{parameters:{query:{type:\"string\"},changedAttribute:{type:\"sap.ui.ux3.ExactAttribute\"},allSelectedAttributes:{type:\"object\"}}}}}});return function(){h.prototype.init=function(){var r=this;this._searchArea=new u(this.getId()+\"-searchArea\",{toolbarVisible:!1}),this._searchArea.addStyleClass(\"sapUiUx3ExactSearchArea\"),this.addAggregation(\"controls\",this._searchArea),this._search_input=new i(this.getId()+\"-searchTF\",{enableListSuggest:!1}),this._search_input.attachSearch(function(e){t(r,e)}),this._search_input.addStyleClass(\"sapUiUx3ExactSearchText\"),this._searchArea.addContent(this._search_input),this._browser=new o(this.getId()+\"-browser\",{title:\"Attributes\"}),this._browser.addStyleClass(\"sapUiUx3ExactBrowseArea\"),this.addAggregation(\"controls\",this._browser),this._browser.attachAttributeSelected(function(t){e(r,t)}),this._resultArea=new u(this.getId()+\"-resultArea\"),this.addAggregation(\"controls\",this._resultArea),this._resultText=new s(this.getId()+\"-resultAreaTitle\",{design:sap.ui.commons.TextViewDesign.Bold}),this._resultText.addStyleClass(\"sapUiUx3ExactViewTitle\"),this.addAggregation(\"controls\",this._resultText),this._bDetailsVisible=!1},h.prototype.getResultText=function(){return this._resultText.getText()},h.prototype.setResultText=function(t){return this._resultText.setText(t),this},h.prototype.getResultArea=function(){return this._resultArea},h.prototype.getSearchField=function(){return this._search_input};var t=function(t,e){t._sSearchQuery=e.getParameter(\"query\"),t.fireSearch({query:t._sSearchQuery}),t._bDetailsVisible=!0,t.invalidate()},e=function(t,e){t.fireRefineSearch({query:t._sSearchQuery,changedAttribute:e.getParameter(\"attribute\"),allSelectedAttributes:e.getParameter(\"allAttributes\")})}}(),h},!0);",
	"sap/ui/ux3/ExactArea.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/Toolbar\",\"sap/ui/core/Control\",\"./library\",\"./ExactAreaRenderer\"],function(e,a,t,o,r){\"use strict\";var n=t.extend(\"sap.ui.ux3.ExactArea\",{metadata:{library:\"sap.ui.ux3\",properties:{toolbarVisible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},defaultAggregation:\"content\",aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"},toolbarItems:{type:\"sap.ui.commons.ToolbarItem\",multiple:!0,singularName:\"toolbarItem\"}}}});return function(){sap.ui.core.Element.extend(\"sap.ui.ux3.ExactAreaToolbarTitle\",{metadata:{interfaces:[\"sap.ui.commons.ToolbarItem\"],properties:{text:{name:\"text\",type:\"string\",group:\"Appearance\",defaultValue:\"\"}}}})}(),n},!0);",
	"sap/ui/ux3/ExactAreaRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var a={};return a.render=function(a,r){var i=a;if(i.write(\"<div\"),i.writeControlData(r),i.addClass(\"sapUiUx3ExactArea\"),i.writeClasses(),i.write(\">\"),r.getToolbarVisible()){i.write('<div id=\"'+r.getId()+'-tb\" class=\"sapUiTb sapUiTbDesignFlat sapUiTbStandalone\" role=\"toolbar\">'),i.write('<div class=\"sapUiTbCont\"><div class=\"sapUiTbInner\">');for(var t=r.getToolbarItems(),s=0;s<t.length;s++){var o=t[s];o instanceof sap.ui.commons.ToolbarSeparator?sap.ui.commons.ToolbarRenderer.renderSeparator(i,o):o instanceof sap.ui.ux3.ExactAreaToolbarTitle?i.write('<div class=\"sapUiUx3ExactAreaTbTitle\">'+e.sap.encodeHTML(o.getText())+\"</div>\"):i.renderControl(o)}i.write(\"</div></div></div>\")}i.write('<div id=\"'+r.getId()+'-ct\" class=\"sapUiUx3ExactAreaCont\">');for(var n=r.getContent(),s=0;s<n.length;s++)i.renderControl(n[s]);i.write(\"</div>\"),i.write(\"</div>\")},a},!0);",
	"sap/ui/ux3/ExactAttribute.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\"],function(t,e,i){\"use strict\";var r=e.extend(\"sap.ui.ux3.ExactAttribute\",{metadata:{library:\"sap.ui.ux3\",properties:{text:{type:\"string\",group:\"Misc\",defaultValue:null},selected:{type:\"boolean\",group:\"Misc\",defaultValue:null},width:{type:\"int\",group:\"Misc\",defaultValue:168},listOrder:{type:\"sap.ui.ux3.ExactOrder\",defaultValue:sap.ui.ux3.ExactOrder.Select},showSubAttributesIndicator:{type:\"boolean\",group:\"Misc\",defaultValue:!0},additionalData:{type:\"object\",group:\"Misc\",defaultValue:null},supplyActive:{type:\"boolean\",group:\"Misc\",defaultValue:!0},autoActivateSupply:{type:\"boolean\",group:\"Misc\",defaultValue:!1}},defaultAggregation:\"attributes\",aggregations:{attributes:{type:\"sap.ui.ux3.ExactAttribute\",multiple:!0,singularName:\"attribute\"}},events:{supplyAttributes:{parameters:{attribute:{type:\"sap.ui.ux3.ExactAttribute\"}}}}}});return function(){r._MINWIDTH=70,r._MAXWIDTH=500,r.prototype.init=function(){this._getAttributesCallCount=0},r.prototype.scrollTo=function(t){if(!(t instanceof r))return void(this._scrollToAttributeId=void 0);var e=this.getChangeListener();if(e&&(e=sap.ui.getCore().byId(e.id))&&e._lb){var i=this.indexOfAttribute(t);return i>=0&&e._lb.scrollToIndex(i,!0),void(this._scrollToAttributeId=void 0)}this._scrollToAttributeId=t.getId()},r.prototype.setText=function(t){return this.setProperty(\"text\",t,!0),this._handleChange(this,\"text\"),this},r.prototype.setWidth=function(t){return this._setWidth(t),this._handleChange(this,\"width\"),this},r.prototype.setTooltip=function(t){return e.prototype.setTooltip.apply(this,arguments),this._handleChange(this,\"tooltip\",!0),this},r.prototype.setSelected=function(t){return this.setProperty(\"selected\",t,!0),this.getSelected()||this._clearSelection(),this._handleChange(this,\"selected\"),this},r.prototype.setSupplyActive=function(t){return this.setProperty(\"supplyActive\",t,!0),this},r.prototype.setAutoActivateSupply=function(t){return this.setProperty(\"autoActivateSupply\",t,!0),this},r.prototype.setAdditionalData=function(t){return this.setProperty(\"additionalData\",t,!0),this},r.prototype.setListOrder=function(t){return this.setProperty(\"listOrder\",t,!0),this._handleChange(this,\"order\"),this},r.prototype.getAttributes=function(){return this._getAttributesCallCount++,this._getAttributesCallCount>1&&this.setSupplyActive(!1),this.hasListeners(\"supplyAttributes\")&&this.getSupplyActive()&&(this._bSuppressChange=!0,this._bChangedHappenedDuringSuppress=!1,this.fireSupplyAttributes({attribute:this}),this.setSupplyActive(!1),this._bSuppressChange=void 0,this._bChangedHappenedDuringSuppress&&this._handleChange(this,\"attributes\"),this._bChangedHappenedDuringSuppress=void 0),this._getAttributesCallCount--,this.getAttributesInternal()},r.prototype.insertAttribute=function(t,e){return this.insertAggregation(\"attributes\",t,e,!0),this._handleChange(this,\"attributes\"),this.setSupplyActive(!1),this},r.prototype.addAttribute=function(t){return this.addAggregation(\"attributes\",t,!0),this._handleChange(this,\"attributes\"),this.setSupplyActive(!1),this},r.prototype.removeAttribute=function(t){var e=this.removeAggregation(\"attributes\",t,!0);return e&&(e.setChangeListener(null),this._handleChange(this,\"attributes\")),e},r.prototype.removeAllAttributes=function(){for(var t=this.getAttributesInternal(),e=0;e<t.length;e++)t[e].setChangeListener(null);var i=this.removeAllAggregation(\"attributes\",!0);return t.length>0&&this._handleChange(this,\"attributes\"),i},r.prototype.destroyAttributes=function(){for(var t=this.getAttributesInternal(),e=0;e<t.length;e++)t[e].setChangeListener(null);return this.destroyAggregation(\"attributes\",!0),t.length>0&&this._handleChange(this,\"attributes\"),this},r.prototype.getShowSubAttributesIndicator_Computed=function(){return this.hasListeners(\"supplyAttributes\")&&this.getSupplyActive()?this.getShowSubAttributesIndicator():this.getAttributesInternal().length>0},r.prototype.attachSupplyAttributes=function(t,e,i){return this.attachEvent(\"supplyAttributes\",t,e,i),this.getSelected()&&this.getAttributesInternal(!0),this},r.prototype._setProperty_Orig=r.prototype.setProperty,r.prototype.setProperty=function(t,e,i){return this._setProperty_Orig(t,e,i),\"selected\"==t&&(e?this.getAttributesInternal(!0):this.getAutoActivateSupply()&&this.setSupplyActive(!0)),this},r.prototype.setChangeListener=function(t){this._oChangeListener=t},r.prototype.getChangeListener=function(t){return this._oChangeListener},r.prototype.getAttributesInternal=function(t){return t?this.getAttributes():this.getAggregation(\"attributes\",[])},r.prototype._handleChange=function(t,e){if(this._bSuppressChange)return void(this._bChangedHappenedDuringSuppress=!0);this.getChangeListener()?this.getChangeListener()._notifyOnChange(e,t):this.getParent()&&this.getParent()._handleChange&&this.getParent()._handleChange(t,e)},r.prototype._clearSelection=function(){this.setProperty(\"selected\",!1,!0);for(var t=this.getAttributesInternal(),e=0;e<t.length;e++)t[e]._clearSelection()},r.prototype._setWidth=function(t){t=Math.round(r._checkWidth(t)),this.setProperty(\"width\",t,!0)},r._checkWidth=function(t){return t=Math.max(t,r._MINWIDTH),t=Math.min(t,r._MAXWIDTH)}}(),r},!0);",
	"sap/ui/ux3/ExactBrowser.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/Button\",\"sap/ui/commons/Menu\",\"sap/ui/core/Control\",\"./ExactAttribute\",\"./ExactList\",\"./library\",\"./ExactBrowserRenderer\"],function(t,e,i,o,s,r,a,u){\"use strict\";var n=o.extend(\"sap.ui.ux3.ExactBrowser\",{metadata:{library:\"sap.ui.ux3\",properties:{title:{type:\"string\",group:\"Misc\",defaultValue:null},headerTitle:{type:\"string\",group:\"Misc\",defaultValue:null},topListOrder:{type:\"sap.ui.ux3.ExactOrder\",defaultValue:sap.ui.ux3.ExactOrder.Select},enableListClose:{type:\"boolean\",group:\"Misc\",defaultValue:!1},listHeight:{type:\"int\",group:\"Appearance\",defaultValue:290},showHeader:{type:\"boolean\",group:\"Misc\",defaultValue:!1},showTopList:{type:\"boolean\",group:\"Misc\",defaultValue:!0},enableReset:{type:\"boolean\",group:\"Misc\",defaultValue:!0},enableSave:{type:\"boolean\",group:\"Misc\",defaultValue:!1},topListWidth:{type:\"int\",group:\"Misc\",defaultValue:168}},defaultAggregation:\"attributes\",aggregations:{attributes:{type:\"sap.ui.ux3.ExactAttribute\",multiple:!0,singularName:\"attribute\",forwarding:{idSuffix:\"-rootAttribute\",aggregation:\"attributes\"}},optionsMenu:{type:\"sap.ui.commons.Menu\",multiple:!1},controls:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"control\",visibility:\"hidden\"},rootAttribute:{type:\"sap.ui.core.Element\",multiple:!1,visibility:\"hidden\"}},associations:{followUpControl:{type:\"sap.ui.core.Control\",multiple:!1}},events:{attributeSelected:{parameters:{attribute:{type:\"sap.ui.ux3.ExactAttribute\"},allAttributes:{type:\"object\"}}},save:{}}}});return function(){n.prototype.init=function(){var t=this;this.data(\"sap-ui-fastnavgroup\",\"true\",!0),this._rb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this._attributeRoot=new s(this.getId()+\"-rootAttribute\"),this.setAggregation(\"rootAttribute\",this._attributeRoot),this._rootList=new r(this.getId()+\"-rootlist\"),this._rootList.setData(this._attributeRoot),this.addAggregation(\"controls\",this._rootList),this._resetButton=new e(this.getId()+\"-RstBtn\",{text:this._rb.getText(\"EXACT_BRWSR_RESET\"),lite:!0}),this._resetButton.addStyleClass(\"sapUiUx3ExactBrwsrReset\"),this.addAggregation(\"controls\",this._resetButton),this._resetButton.attachPress(function(){t.reset()}),this._saveButton=new e(this.getId()+\"-SvBtn\",{text:this._rb.getText(\"EXACT_BRWSR_SAVE\"),lite:!0}),this._saveButton.addStyleClass(\"sapUiUx3ExactBrwsrSave\"),this.addAggregation(\"controls\",this._saveButton),this._saveButton.attachPress(function(){t.fireSave()}),this._rootList.attachAttributeSelected(function(e){t.fireAttributeSelected({attribute:e.getParameter(\"attribute\"),allAttributes:e.getParameter(\"allAttributes\")})}),this._rootList.attachEvent(\"_headerPress\",function(e){var i=t.getOptionsMenu();if(i){var o=e.getParameter(\"domRef\");i.open(e.getParameter(\"keyboard\"),o,sap.ui.core.Popup.Dock.BeginTop,sap.ui.core.Popup.Dock.BeginBottom,o)}})},n.prototype.exit=function(){this._rootList.destroy(),this._attributeRoot.destroy(),this._rootList=null,this._attributeRoot=null,this._resetButton=null,this._saveButton=null,this._saveDialog=null,this._saveTextField=null,this._rb=null},n.prototype.onThemeChanged=function(t){this.getDomRef()&&this.invalidate()},n.prototype.getTitle=function(){return this._rootList.getTopTitle()},n.prototype.setTitle=function(t){return this._rootList.setTopTitle(t),this},n.prototype.setTopListOrder=function(t){return this.setProperty(\"topListOrder\",t,!0),this._attributeRoot.setListOrder(t),this},n.prototype.getTopListWidth=function(){return this._attributeRoot.getWidth()},n.prototype.setTopListWidth=function(t){return this._attributeRoot.setWidth(t),this},n.prototype.getHeaderTitle=function(){var t=this.getProperty(\"headerTitle\");return t||this._rb.getText(\"EXACT_BRWSR_TITLE\")},n.prototype.getEnableListClose=function(){return this._rootList.getShowClose()},n.prototype.setEnableListClose=function(t){return this._rootList.setShowClose(t),this},n.prototype.getListHeight=function(){return this._rootList.getTopHeight()},n.prototype.setListHeight=function(t){return this._rootList.setTopHeight(t),this},n.prototype.reset=function(){this._rootList._closeAll()},n.prototype.hasOptionsMenu=function(){return!!this.getOptionsMenu()}}(),n},!0);",
	"sap/ui/ux3/ExactBrowserRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(e,r){var i=e;i.write(\"<div\"),i.writeControlData(r),i.addClass(\"sapUiUx3ExactBrwsr\"),i.writeClasses(),i.writeAttribute(\"role\",\"region\"),r.getShowHeader()&&i.writeAttribute(\"aria-labelledby\",r.getId()+\"-hdtitle\"),r.getFollowUpControl()&&i.writeAttribute(\"aria-controls\",r.getFollowUpControl());var o=r.getTooltip_AsString();o&&i.writeAttributeEscaped(\"title\",o),i.write(\">\"),r.getShowHeader()&&(i.write('<div class=\"sapUiUx3ExactBrwsrHd\"><h2 id=\"'+r.getId()+'-hdtitle\">'),i.write(t.sap.encodeHTML(r.getHeaderTitle())),i.write('</h2><div class=\"sapUiUx3ExactBrwsrHdTool\" role=\"toolbar\">'),r.getEnableSave()&&i.renderControl(r._saveButton),r.getEnableReset()&&i.renderControl(r._resetButton),i.write(\"</div></div>\")),i.renderControl(r._rootList),i.write(\"</div>\")},e},!0);",
	"sap/ui/ux3/ExactList.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/ListBox\",\"sap/ui/core/Control\",\"sap/ui/core/Popup\",\"sap/ui/core/theming/Parameters\",\"./library\",\"./ExactListRenderer\",\"jquery.sap.dom\"],function(t,e,i,s,o,a,r){\"use strict\";var n=i.extend(\"sap.ui.ux3.ExactList\",{metadata:{library:\"sap.ui.ux3\",properties:{showClose:{type:\"boolean\",group:\"Misc\",defaultValue:!1},topTitle:{type:\"string\",group:\"Misc\",defaultValue:null},topHeight:{type:\"int\",group:\"Appearance\",defaultValue:290}},aggregations:{subLists:{type:\"sap.ui.ux3.ExactList\",multiple:!0,singularName:\"subList\"},controls:{type:\"sap.ui.commons.ListBox\",multiple:!0,singularName:\"control\",visibility:\"hidden\"}},associations:{data:{type:\"sap.ui.ux3.ExactAttribute\",multiple:!1}},events:{attributeSelected:{parameters:{attribute:{type:\"sap.ui.ux3.ExactAttribute\"},allAttributes:{type:\"object\"}}}}}});return function(){e.extend(\"sap.ui.ux3.ExactList.LB\",{init:function(){e.prototype.init.apply(this,arguments),this.setAllowMultiSelect(!0),this.setDisplayIcons(!0),this.addStyleClass(\"sapUiUx3ExactLstLb\")},invalidate:function(){e.prototype.invalidate.apply(this,arguments),!this.bInvalidated&&this.getParent()&&this.getParent().invalidate(),this.bInvalidated=!0},_handleUserActivation:function(t){t.metaKey=!0,e.prototype._handleUserActivation.apply(this,[t])},onclick:function(t){e.prototype.onclick.apply(this,arguments),this.getParent().onclick(t)},onAfterRendering:function(){e.prototype.onAfterRendering.apply(this,arguments),this.bInvalidated=!1;for(var i=this.getParent(),s=this.getItems(),o=i._isTop(),a=!1,r=0;r<s.length;r++){var n=s[r],l=sap.ui.getCore().byId(n.getKey()),p=n.$();a=!1,!o&&l&&l.getShowSubAttributesIndicator_Computed()?a=!0:(p.addClass(\"sapUiUx3ExactLstNoIco\"),a=o),a&&!o&&p.attr(\"aria-label\",i._rb.getText(p.hasClass(\"sapUiLbxISel\")?\"EXACT_LST_LIST_ITEM_SEL_ARIA_LABEL\":\"EXACT_LST_LIST_ITEM_ARIA_LABEL\",[n.getText()]))}var h=i._bRTL?\"left\":\"right\";t(\".sapUiLbxITxt\",this.getDomRef()).css(\"margin-\"+h,20+t.sap.scrollbarSize().width+\"px\"),t(\".sapUiLbxIIco\",this.getDomRef()).css(h,5+t.sap.scrollbarSize().width+\"px\"),t(this.getDomRef()).attr(\"tabindex\",\"-1\");var u;u=o?i.getTopTitle():i._rb.getText(\"EXACT_LST_LIST_ARIA_LABEL\",[i._iLevel,i._getAtt().getText()]),t(this.getFocusDomRef()).attr(\"aria-label\",u).attr(\"aria-expanded\",\"true\"),this.oItemNavigation.iActiveTabIndex=-1,this.oItemNavigation.setSelectedIndex(-1),this.oItemNavigation.onsapnext=function(e){e.keyCode==t.sap.KeyCodes.ARROW_DOWN&&sap.ui.core.delegate.ItemNavigation.prototype.onsapnext.apply(this,arguments)},this.oItemNavigation.onsapprevious=function(e){e.keyCode==t.sap.KeyCodes.ARROW_UP&&sap.ui.core.delegate.ItemNavigation.prototype.onsapprevious.apply(this,arguments)}},renderer:\"sap.ui.commons.ListBoxRenderer\"}),n.prototype.init=function(){var e=this;this._iLevel=0,this._bCollapsed=!1,this._bIsFirstRendering=!0,this._rb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this._lb=new n.LB(this.getId()+\"-lb\",{select:function(t){x(e);var i=t.getParameter(\"selectedItem\").getKey(),s=sap.ui.getCore().byId(i),o=t.getParameter(\"selectedIndex\");if(e._lb.isIndexSelected(o)){s.setProperty(\"selected\",!0,!0);var a=T(e,s);if(a){var r=h(e,s);r<0?e.addSubList(a):e.insertSubList(a,r)}}else I(e,s,o);S(e)._selectionChanged(s)}}),this.addAggregation(\"controls\",this._lb),this._closeHandle=t.proxy(this.onForceVerticalClose,this)},n.prototype.exit=function(){this.bIsDestroyed||(E(this),this._lb.removeAllItems(),this._lb=null,this._closeHandle=null,this._scrollCheckHandle=null,this._rb={getText:function(){return\"\"}},this._oTopList=null,this._dirtyListsCleanupTimer&&(t.sap.clearDelayedCall(this._dirtyListsCleanupTimer),this._dirtyListsCleanupTimer=null,this._dirtyLists=null))},n.prototype.getFocusDomRef=function(){return this._isTop()&&this.$().hasClass(\"sapUiUx3ExactLstTopHidden\")?this.getDomRef(\"foc\"):this._bCollapsed?this.getDomRef(\"head\"):this._lb.getFocusDomRef()},n.prototype.onBeforeRendering=function(){this._oTopList=null,this._bIsFirstRendering&&(this._bRTL=sap.ui.getCore().getConfiguration().getRTL(),this._isTop()?this._bIsFirstRendering=!1:(this._bCollapsed=!0,this._oCollapseStyles={cntnt:\"margin-\"+(this._bRTL?\"right\":\"left\")+\":\"+o.get(\"sapUiUx3ExactLstCollapseWidth\")+\";border-top-width:0px;\",lst:\"width:0px;\"}))},n.prototype.onAfterRendering=function(){var e=this,i=this._isTop();this._iCurrentWidth||(this._iCurrentWidth=this._getAtt().getWidth()),i&&(this._iScrollWidthDiff=-1,this.onCheckScrollbar(),this.$(\"lst\").css(\"bottom\",t.sap.scrollbarSize().height+\"px\"),this.$(\"cntnt\").bind(\"scroll\",function(t){t.target.id===e.getId()+\"-cntnt\"&&0!=t.target.scrollTop&&(t.target.scrollTop=0)})),this._bCollapsed||_(this,this._iCurrentWidth),x(this),this._bIsFirstRendering?(this._bIsFirstRendering=!1,v(this,!1,null,!0)):(u(this),L(this)),this._bRefreshList&&(this._bRefreshList=!1,setTimeout(function(){e._lb.invalidate()},0))},n.prototype.onfocusin=function(t){t.target===this.getDomRef()&&this.getFocusDomRef().focus();var e=this.$(\"head\");if(this._isTop()&&(e.attr(\"tabindex\",\"-1\"),this.$(\"foc\").attr(\"tabindex\",\"-1\"),l(this)||t.target!==e[0]||this.getFocusDomRef().focus(),this.$().hasClass(\"sapUiUx3ExactLstTopHidden\")&&t.target===this.getDomRef(\"foc\"))){var i=this.getSubLists();i.length>0&&i[0].getFocusDomRef().focus()}t.__exactHandled||(e.addClass(\"sapUiUx3ExactLstHeadFocus\"),t.__exactHandled=!0)},n.prototype.onfocusout=function(t){var e=this.$(\"head\");this._isTop()&&(e.attr(\"tabindex\",\"0\"),this.$(\"foc\").attr(\"tabindex\",\"0\")),e.removeClass(\"sapUiUx3ExactLstHeadFocus\")},n.prototype.onclick=function(e){var i=this._lb.getScrollTop();if(t(e.target).attr(\"id\")==this.getId()+\"-exp\")C(this),this.focus(),e.stopPropagation();else if(t(e.target).attr(\"id\")==this.getId()+\"-close\")m(this);else if(t(e.target).attr(\"id\")==this.getId()+\"-hide\")v(this,!this._bCollapsed,e);else{if(this._isTop()&&l(this)&&t.sap.containsOrEquals(this.$(\"head\")[0],e.target))return void r(this,e,!1);t.sap.containsOrEquals(this.$(\"cntnt\")[0],e.target)||this.focus()}this._lb.setScrollTop(i)},n.prototype.onkeydown=function(e){function s(e,i){t(i).hasClass(\"sapUiUx3ExactLstFoc\")||(i&&i.focus(),e.preventDefault(),e.stopPropagation())}switch(e.keyCode){case t.sap.KeyCodes.ENTER:case t.sap.KeyCodes.SPACE:this._isTop()&&l(this)&&t.sap.containsOrEquals(this.$(\"head\")[0],e.target)&&r(this,e,!0);break;case t.sap.KeyCodes.DELETE:!this._isTop()&&this.getShowClose()&&(m(this),s(e,this.getParent().getFocusDomRef()));break;case t.sap.KeyCodes.NUMPAD_MINUS:e.shiftKey?this._bCollapsed||(_(this,this._iCurrentWidth-10),s(e)):this._bCollapsed||v(this,!0,e);break;case t.sap.KeyCodes.NUMPAD_PLUS:e.shiftKey?this._bCollapsed||(_(this,this._iCurrentWidth+10),s(e)):this._bCollapsed&&v(this,!1,e);break;case t.sap.KeyCodes.TAB:if(0==this._iLevel){var o=l(this);if(!e.shiftKey&&o&&t.sap.containsOrEquals(this.$(\"head\")[0],e.target))s(e,this.getFocusDomRef());else if(t.sap.containsOrEquals(this.getFocusDomRef(),e.target))if(e.shiftKey&&o)s(e,this.$(\"head\")[0]);else if(!e.shiftKey){var n=a(this);n&&s(e,n.getFocusDomRef())}return}if(1==this._iLevel){var n=null;n=e.shiftKey?t.sap.containsOrEquals(this.$(\"cntnt\")[0],e.target)?this:i(this):a(this),n&&s(e,n.getFocusDomRef()),e.stopPropagation()}break;case t.sap.KeyCodes.ARROW_LEFT:case t.sap.KeyCodes.ARROW_RIGHT:var n=null;this._iLevel>=1&&(n=this._bRTL&&e.keyCode===t.sap.KeyCodes.ARROW_LEFT||!this._bRTL&&e.keyCode===t.sap.KeyCodes.ARROW_RIGHT?a(this,!0):i(this,!0),n&&s(e,n.getFocusDomRef()),e.stopPropagation())}},n.prototype.onmousedown=function(e){if(e.target.id===this.getId()+\"-rsz\"){t(document.body).append('<div id=\"'+this.getId()+'-ghost\" class=\"sapUiUx3ExactLstRSzGhost\" style =\" z-index:'+s.getNextZIndex()+'\" ></div>'),t(document.body).bind(\"selectstart.\"+this.getId(),c);(sap.ui.Device.browser.internet_explorer?t(document.body):this.$(\"ghost\")).bind(\"mouseup.\"+this.getId(),t.proxy(f,this)).bind(\"mousemove.\"+this.getId(),t.proxy(g,this)),this._iStartDragX=e.pageX,this._iStartWidth=this.$(\"lst\").width(),this.$(\"rsz\").addClass(\"sapUiUx3ExactLstRSzDrag\")}},n.prototype.onForceVerticalClose=function(e){if(\"mousedown\"==e.type||\"click\"==e.type||\"dblclick\"==e.type||\"focusin\"==e.type||\"focusout\"==e.type||\"keydown\"==e.type||\"keypress\"==e.type||\"keyup\"==e.type||\"mousedown\"==e.type||\"mouseup\"==e.type){var i=this.$(\"lst\");t.sap.containsOrEquals(i[0],e.target)&&\"BODY\"!=e.target.tagName||i.hasClass(\"sapUiUx3ExactLstExpanded\")&&this._oPopup.close(!0)}},n.prototype.onCheckScrollbar=function(e){this._scrollCheckTimer=null;var i=this.$(\"cntnt\"),s=i[0];if(s){var o=s.scrollWidth-s.clientWidth;this._iScrollWidthDiff!=o&&(this._iScrollWidthDiff=o,o<=0?i.css({\"overflow-x\":\"hidden\",bottom:t.sap.scrollbarSize().height+\"px\"}):i.css({\"overflow-x\":\"scroll\",bottom:\"0px\"})),this._scrollCheckTimer=t.sap.delayedCall(300,this,this.onCheckScrollbar)}},n.prototype.insertSubList=function(t,e){return this.insertAggregation(\"subLists\",t,e),t&&b(t,this._iLevel+1),this},n.prototype.addSubList=function(t){return this.addAggregation(\"subLists\",t),t&&b(t,this._iLevel+1),this},n.prototype.setData=function(e){if(null!=e&&\"string\"!=typeof e&&(e=e.getId()),e){if(this.setAssociation(\"data\",e),e=this._getAtt(),this._lb.removeAllItems(),!e)return this;for(var i=e.getAttributesInternal(!0),s=[],o=[],a=0;a<i.length;a++){var r=A(i[a]);if(this._lb.addItem(r),i[a].getSelected()){var n=T(this,i[a]);n&&o.push(n),s.push(r.getKey())}}this._lb.setSelectedKeys(s);for(var l=this.getSubLists(),a=0;a<l.length;a++){var p=t.inArray(l[a],o);p>=0?e.getListOrder()!=sap.ui.ux3.ExactOrder.Fixed&&o.splice(p,1):(l[a]._lb.removeAllItems(),l[a].destroy())}e.getListOrder()===sap.ui.ux3.ExactOrder.Fixed&&this.removeAllSubLists();for(var a=0;a<o.length;a++)this.addSubList(o[a]);var h=this;e.setChangeListener({id:h.getId(),_notifyOnChange:function(e,i){if(\"width\"===e)return void(h._getAtt()===i&&h.getDomRef()&&_(h,i.getWidth()));var s=S(h);s._dirtyLists||(s._dirtyLists={}),s._dirtyLists[h.getId()]||(s._dirtyLists[h.getId()]=h),s._dirtyListsCleanupTimer||(s._dirtyListsCleanupTimer=t.sap.delayedCall(0,s,function(){this._dirtyListsCleanupTimer=null,t.each(this._dirtyLists,function(t,e){e._lb&&e.getParent()&&(e._isTop()?e.setData(e.getData()):e.getParent().setData(e.getParent().getData()))}),this._dirtyLists=null},[]))}})}return this},n.prototype.setShowClose=function(t){return this._isTop()&&this.setProperty(\"showClose\",t),this},n.prototype.getShowClose=function(){return S(this).getProperty(\"showClose\")},n.prototype.getTopTitle=function(){var t=this.getProperty(\"topTitle\");return t||this._rb.getText(\"EXACT_BRWSR_LST_TITLE\")},n.prototype._getAtt=function(){return sap.ui.getCore().byId(this.getData())},n.prototype._isTop=function(){return!(this.getParent()instanceof n)},n.prototype._selectionChanged=function(t){if(this._isTop()){t=sap.ui.getCore().byId(t.getId());for(var e=function(t,i){if(t.getSelected()){i.push(t);for(var s=t.getAttributesInternal(),o=0;o<s.length;o++)e(s[o],i)}},i=[],s=this._getAtt().getAttributesInternal(),o=0;o<s.length;o++)e(s[o],i);this.fireAttributeSelected({attribute:t,allAttributes:i})}},n.prototype._closeAll=function(){if(this._isTop()){var t=this,e=function(){t._getAtt()._clearSelection(),t._lb.clearSelection(),t.fireAttributeSelected({attribute:void 0,allAttributes:[]})},i=this.getSubLists();if(i.length>0)for(var s=0;s<i.length;s++)m(i[s],!0,s==i.length-1?e:null);else e()}};var i=function(t,e){function i(t){var e=t.getParent(),i=e.getSubLists(),s=e.indexOfSubList(t)-1;return s>=0?i[s]:null}function s(t){var e=t.getSubLists();return e.length>0?s(e[e.length-1]):t}if(0==t._iLevel)return null;if(1==t._iLevel){if(e)return null;var o=i(t);return o||t.getParent()}if(t._iLevel>1){var o=i(t);if(o)return s(o);var a=t.getParent();if(a._iLevel>=1)return a}return null},a=function(t,e){function i(t){var e=t.getParent(),i=e.getSubLists(),s=e.indexOfSubList(t)+1;return s<i.length?i[s]:null}function s(t){var e=t.getSubLists();return e.length>0?e[0]:null}function o(t){var s=i(t);if(s)return s;var a=t.getParent();return a._iLevel>(e?1:0)?o(a):null}if(0==t._iLevel)return s(t);if(1==t._iLevel)return e?s(t):i(t);if(t._iLevel>1){var a=s(t);return a||o(t)}return null},r=function(t,e,i){t.fireEvent(\"_headerPress\",{kexboard:i,domRef:t.$(\"head\")}),e.stopPropagation()},l=function(t){return!p(t)&&t.$().hasClass(\"sapUiUx3ExactLstTopActive\")},p=function(t){return t.$().hasClass(\"sapUiUx3ExactLstTopHidden\")},h=function(t,e){if(t._getAtt().getListOrder()!=sap.ui.ux3.ExactOrder.Fixed)return-1;for(var i=t._getAtt().getAttributes(),s=0,o=0;o<i.length&&i[o]!==e;o++)i[o].getChangeListener()&&s++;return s},u=function(e){if(y(e)&&(e.$(\"lst\").addClass(\"sapUiUx3ExactLstLstExp\"),!e._oPopup)){var i=function(t){e._handleEvent(t)};e._oPopup=new s,sap.ui.Device.browser.firefox||(e._oPopup._fixPositioning=function(e,i){if(s.prototype._fixPositioning.apply(this,arguments),i){var o=this._$(),a=t(e.of),r=0;e.offset&&(r=parseInt(e.offset.split(\" \")[0],10)),o.css(\"right\",t(window).width()-a.outerWidth()-a.offset().left+r+\"px\")}}),e._oPopup.open=function(){var a=e.$(\"lst\");d(a,!1,-1,function(i){a.addClass(\"sapUiUx3ExactLstExpanded\"),e.$(\"exp\").html(sap.ui.ux3.ExactListRenderer.getExpanderSymbol(!0,!1)),e.__sOldHeight=a.css(\"height\"),a.css(\"height\",e.__sOldHeight);var r=e.$(\"head\"),n=t(e._lb.getDomRef()),l=n[0].scrollHeight+e.$(\"exp\").height()+n.outerHeight()-n.height()+1,p=t(window).height()-parseInt(n.offset().top,10)+t(window).scrollTop()-r.outerHeight(),h=Math.min(l,p);e._oPopup.setContent(a[0]);var u=o.get()[\"sapUiUx3ExactLst\"+(e._isTop()?\"Root\":\"\")+\"ExpandOffset\"]||\"0 0\";return s.prototype.open.apply(e._oPopup,[0,s.Dock.BeginTop,s.Dock.BeginBottom,r[0],u,\"none none\"]),e._bPopupOpened=!0,h},function(s){a.addClass(\"sapUiUx3ExactLstExpandedBL\"),y(e),e.getFocusDomRef().focus(),t.sap.bindAnyEvent(e._closeHandle),s.bind(t.sap.ControlEvents.join(\" \"),i)})},e._oPopup.close=function(o){var a=e.$(\"lst\");a.removeClass(\"sapUiUx3ExactLstExpandedBL\"),d(a,!1,e.__sOldHeight,function(s){t.sap.unbindAnyEvent(e._closeHandle),s.unbind(t.sap.ControlEvents.join(\" \"),i),a.removeClass(\"sapUiUx3ExactLstExpanded\"),e.$(\"exp\").html(sap.ui.ux3.ExactListRenderer.getExpanderSymbol(!1,!1))},function(i){i.detach(),a.removeClass(\"sapUiShd\"),i.attr(\"style\",\"width:\"+e._iCurrentWidth+\"px;\"),t(e.getDomRef()).prepend(i),e._oPopup.setContent(null),e._bPopupOpened=void 0,e.__sOldHeight=null,e._isTop()&&i.css(\"bottom\",t.sap.scrollbarSize().height+\"px\"),y(e),s.prototype.close.apply(e._oPopup,[0]),o||e.getFocusDomRef().focus()})}}},d=function(e,i,s,o,a){if(o){var r=o(e);void 0!=r&&(s=r)}var n=a?function(){a(e)}:function(){};if(t.fx.off)i?e.width(s):e.height(s),n();else{var l=i?{width:s}:{height:s};e.stop(!0,!0).animate(l,200,\"linear\",n)}},c=function(t){return t.preventDefault(),t.stopPropagation(),!1},g=function(t){var e=t.pageX,i=this._bRTL?this._iStartDragX-e:e-this._iStartDragX;_(this,this._iStartWidth+i)},f=function(e){t(document.body).unbind(\"selectstart.\"+this.getId()).unbind(\"mouseup.\"+this.getId()).unbind(\"mousemove.\"+this.getId()),this.$(\"ghost\").remove(),this.$(\"rsz\").removeClass(\"sapUiUx3ExactLstRSzDrag\"),this._iStartWidth=void 0,this._iStartDragX=void 0,this.focus()},_=function(t,e){e=sap.ui.ux3.ExactAttribute._checkWidth(e);var i=t._bRTL?\"right\":\"left\";t._iCurrentWidth=e,t._getAtt()._setWidth(t._iCurrentWidth),t.$(\"lst\").css(\"width\",e+\"px\"),t.$(\"rsz\").css(i,e-4+\"px\"),t._isTop()?p(t)||(t.$(\"head\").css(\"width\",e+\"px\"),t.$(\"cntnt\").css(i,e+8+\"px\"),t.$(\"scroll\").css(i,e+8+\"px\")):t.$().hasClass(\"sapUiUx3ExactLstCollapsed\")||t.$(\"cntnt\").css(\"margin-\"+i,e+\"px\")},x=function(e){var i=e._getAtt();i&&!e._isTop()&&e.$(\"head-txt\").html(t.sap.encodeHTML(i.getText())+'<span class=\"sapUiUx3ExactLstHeadInfo\">&nbsp;('+e._lb.getSelectedIndices().length+\"/\"+e._lb.getItems().length+\")</span>\")},b=function(t,e){t._iLevel=e;for(var i=t.getSubLists(),s=0;s<i.length;s++)b(i[s],e+1)},y=function(e){if(e._lb){var i=t(e._lb.getDomRef());if(e.$(\"lst\").removeClass(\"sapUiUx3ExactLstScroll\"),i.length>0&&i.outerHeight()<i[0].scrollHeight)return e.$(\"lst\").addClass(\"sapUiUx3ExactLstScroll\"),!0}return!1},v=function(e,i,s,a){if(s&&(s.preventDefault(),s.stopPropagation()),!e._isTop()){if(e._bCollapsed!=i){var r=!!s,n={};n[\"margin-\"+(e._bRTL?\"right\":\"left\")]=e._bCollapsed?e._iCurrentWidth+\"px\":o.get(\"sapUiUx3ExactLstCollapseWidth\"),n[\"border-top-width\"]=e._bCollapsed?o.get(\"sapUiUx3ExactLstContentTop\"):\"0px\";var l=e.$(\"cntnt\");if(t.fx.off)for(var p in n)l.css(p,n[p]);else l.stop(!0,!0).animate(n,200,\"linear\");if(e._bCollapsed)d(e.$(\"lst\"),!0,e._iCurrentWidth+\"px\",function(){t(e.getDomRef()).removeClass(\"sapUiUx3ExactLstCollapsed\"),e.$(\"head\").css(\"overflow\",\"hidden\")},function(t){e.$(\"hide\").html(sap.ui.ux3.ExactListRenderer.getExpanderSymbol(!0,!0)).attr(\"title\",e._rb.getText(\"EXACT_LST_LIST_COLLAPSE\")),r&&e.focus();var i=e.$(\"head\");e.$(\"head-txt\").removeAttr(\"style\"),i.removeAttr(\"style\"),t.removeAttr(\"style\"),u(e),_(e,e._iCurrentWidth),L(e),i.removeAttr(\"role\"),i.removeAttr(\"aria-label\"),i.removeAttr(\"aria-expanded\");var s=e._getAtt();s&&s._scrollToAttributeId&&s.scrollTo(sap.ui.getCore().byId(s._scrollToAttributeId))}),e._oCollapseStyles=void 0;else{e._oCollapseStyles={},d(e.$(\"lst\"),!0,0,null,function(){t(e.getDomRef()).addClass(\"sapUiUx3ExactLstCollapsed\"),e.$(\"hide\").html(sap.ui.ux3.ExactListRenderer.getExpanderSymbol(!1,!0)).attr(\"title\",e._rb.getText(\"EXACT_LST_LIST_EXPAND\")),r&&e.focus(),L(e);var i=e.$(\"head\");i.attr(\"role\",\"region\"),i.attr(\"aria-label\",e._rb.getText(\"EXACT_LST_LIST_COLL_ARIA_LABEL\",[e._iLevel,e._getAtt().getText()])),i.attr(\"aria-expanded\",\"false\")});var h=[];for(var p in n)h.push(p,\":\",n[p],\";\");e._oCollapseStyles.cntnt=h.join(\"\"),e._oCollapseStyles.lst=\"width:0px;\"}e._bCollapsed=!e._bCollapsed}if(!a){var c=e.getParent();!e._isTop()&&c&&c._isTop&&!c._isTop()&&v(c,i)}}},L=function(t){if(t._bCollapsed){var e=t.$(\"cntnt\").height()-50;t.$(\"head-txt\").css(\"width\",e+\"px\")}for(var i=t.getSubLists(),s=0;s<i.length;s++)L(i[s])},C=function(t){t.$(\"lst\").hasClass(\"sapUiUx3ExactLstExpanded\")?t._oPopup.close():t._oPopup.open()},m=function(e,i,s){var o=function(t){if(!i){var o=e._getAtt(),a=o.getParent().indexOfAttribute(o);I(e.getParent(),o,a,!0),x(e.getParent()),S(e)._selectionChanged(o)}e.destroy(),s&&s()},a=e.getDomRef();a?d(t(a),!0,0,function(t){t.css(\"overflow\",\"hidden\")},o):o()},T=function(t,e){if(e.getSelected()){if(e.getAttributesInternal(!0).length>0){var i;return i=e.getChangeListener()?sap.ui.getCore().byId(e.getChangeListener().id):new n,i.setData(e),i}}return null},I=function(t,e,i,s){if(t._lb.removeSelectedIndex(i),e._clearSelection(),!s)for(var o=t.getSubLists(),a=0;a<o.length;a++)o[a].getData()===e.getId()&&m(o[a],!0)},E=function(t){var e=t._getAtt();e&&e.getChangeListener()&&e.getChangeListener().id===t.getId()&&e.setChangeListener(null)},S=function(t){return t._isTop()?t:(t._oTopList||(t._oTopList=S(t.getParent())),t._oTopList)},A=function(t){var e;return t.__oItem?(e=t.__oItem,e.getText()!=t.getText()&&e.setText(t.getText()),e.getKey()!=t.getId()&&e.setKey(t.getId())):(e=new sap.ui.core.ListItem({text:t.getText(),key:t.getId()}),t.exit=function(){sap.ui.ux3.ExactAttribute.prototype.exit&&sap.ui.ux3.ExactAttribute.prototype.exit.apply(t,[]),this.__oItem.destroy(),this.__oItem=null},t.__oItem=e),e}}(),n},!0);",
	"sap/ui/ux3/ExactListRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){var s=t,a=e.getSubLists(),i=e._getAtt();if(i){var l=e._isTop();s.write(\"<div\"),s.writeControlData(e),s.addClass(\"sapUiUx3ExactLst\");var r=!1,d=!1;if(l){var p=e.getParent();p&&(p.hasOptionsMenu&&(r=p.hasOptionsMenu())&&s.addClass(\"sapUiUx3ExactLstTopActive\"),p.getShowTopList&&!p.getShowTopList()&&(s.addClass(\"sapUiUx3ExactLstTopHidden\"),d=!0)),s.addClass(\"sapUiUx3ExactLstTop\"),s.addStyle(\"height\",e.getTopHeight()+\"px\")}e._bCollapsed&&s.addClass(\"sapUiUx3ExactLstCollapsed\"),s.addClass(\"sapUiUx3ExactLstLvl_\"+e._iLevel),s.writeClasses(),s.writeStyles(),s.write(\">\"),d&&s.write('<div id=\"'+e.getId()+'-foc\" class=\"sapUiUx3ExactLstFoc\" tabindex=\"0\"></div>'),e._bPopupOpened?e._bRefreshList=!0:(s.write('<div id=\"'+e.getId()+'-lst\" class=\"sapUiUx3ExactLstLst\"'),e._bCollapsed&&e._oCollapseStyles&&e._oCollapseStyles.lst&&s.write(' style=\"'+e._oCollapseStyles.lst+'\"'),s.write(\">\"),s.renderControl(e._lb),s.write('<a id=\"'+e.getId()+'-exp\" class=\"sapUiUx3ExactLstExp\">'+this.getExpanderSymbol(!1,!1)+\"</a>\"),s.write(\"</div>\")),s.write('<div id=\"'+e.getId()+'-cntnt\" '),s.write('class=\"sapUiUx3ExactLstCntnt'),0==a.length&&s.write(\" sapUiUx3ExactLstCntntEmpty\"),s.write('\"'),e._bCollapsed&&e._oCollapseStyles&&e._oCollapseStyles.cntnt&&s.write(' style=\"'+e._oCollapseStyles.cntnt+'\"'),s.write(\">\");for(var o=0;o<a.length;o++)s.renderControl(a[o]);s.write(\"</div>\"),s.write('<header id=\"'+e.getId()+'-head\" class=\"sapUiUx3ExactLstHead\"'),l&&r&&s.write(' role=\"button\" aria-haspopup=\"true\"'),!l&&e._bCollapsed&&i&&(s.writeAttribute(\"role\",\"region\"),s.writeAttribute(\"aria-expanded\",\"false\"),s.writeAttributeEscaped(\"aria-label\",e._rb.getText(\"EXACT_LST_LIST_COLL_ARIA_LABEL\",[e._iLevel,i.getText()]))),s.write(' tabindex=\"'+(l?\"0\":\"-1\")+'\">'),l?(s.write('<h3 id=\"'+e.getId()+'-head-txt\" class=\"sapUiUx3ExactLstHeadTopTxt\"><span class=\"sapUiUx3ExactLstHeadTopTxtTxt\">'),e.getTopTitle()&&s.writeEscaped(e.getTopTitle()),s.write(\"</span>\"),r&&s.write('<span class=\"sapUiUx3ExactLstHeadTopIco\"></span>'),s.write(\"</h3>\")):(s.write('<h3 id=\"'+e.getId()+'-head-txt\" class=\"sapUiUx3ExactLstHeadTxt\"'),i&&i.getTooltip_AsString()?s.writeAttributeEscaped(\"title\",i.getTooltip_AsString()):i&&i.getText()&&s.writeAttributeEscaped(\"title\",i.getText()),e._bCollapsed&&e._oCollapseStyles&&e._oCollapseStyles[\"head-txt\"]&&s.write(' style=\"'+e._oCollapseStyles[\"head-txt\"]+'\"'),s.write(\">\"),i&&s.writeEscaped(i.getText()),s.write(\"</h3>\"),s.write('<div id=\"'+e.getId()+'-head-action\" class=\"sapUiUx3ExactLstHeadAct'+(e.getShowClose()?\"\":\" sapUiUx3ExactLstHeadActNoClose\")+'\">'),s.write('<a id=\"'+e.getId()+'-hide\" class=\"sapUiUx3ExactLstHide\" role=\"presentation\"'),s.writeAttributeEscaped(\"title\",e._rb.getText(e._bCollapsed?\"EXACT_LST_LIST_EXPAND\":\"EXACT_LST_LIST_COLLAPSE\")),s.write(\">\",this.getExpanderSymbol(!e._bCollapsed,!0),\"</a>\"),s.write('<a id=\"'+e.getId()+'-close\" role=\"presentation\" class=\"sapUiUx3ExactLstClose\"'),s.writeAttributeEscaped(\"title\",e._rb.getText(\"EXACT_LST_LIST_CLOSE\")),s.write(\">X</a>\"),s.write(\"</div>\")),s.write(\"</header>\"),s.write('<div id=\"'+e.getId()+'-rsz\" class=\"sapUiUx3ExactLstRSz\"></div>'),s.write(\"</div>\")}},e.getExpanderSymbol=function(t,e){return e?sap.ui.getCore().getConfiguration().getRTL()?t?\"&#9654;\":\"&#9664;\":t?\"&#9664;\":\"&#9654;\":t?\"&#9650;\":\"&#9660;\"},e},!0);",
	"sap/ui/ux3/ExactRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(r){\"use strict\";var e={};return e.render=function(r,e){var t=r;t.write(\"<div\"),t.writeControlData(e),t.addClass(\"sapUiUx3Exact\"),t.writeClasses();var i=e.getTooltip_AsString();i&&t.writeAttributeEscaped(\"title\",i),t.write(\">\"),t.renderControl(e._searchArea),e._bDetailsVisible&&(t.renderControl(e._browser),t.renderControl(e._resultText),t.renderControl(e._resultArea)),t.write(\"</div>\")},e},!0);",
	"sap/ui/ux3/FacetFilter.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"./library\",\"./FacetFilterRenderer\"],function(e,t,i,a){\"use strict\";var u=t.extend(\"sap.ui.ux3.FacetFilter\",{metadata:{library:\"sap.ui.ux3\",properties:{visibleItemCountMode:{type:\"sap.ui.ux3.VisibleItemCountMode\",group:\"Appearance\",defaultValue:sap.ui.ux3.VisibleItemCountMode.Fixed}},aggregations:{lists:{type:\"sap.ui.ux3.FacetFilterList\",multiple:!0,singularName:\"list\"}}}});return u.prototype.init=function(){this.data(\"sap-ui-fastnavgroup\",\"true\",!0)},u},!0);",
	"sap/ui/ux3/FacetFilterList.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/ListBox\",\"sap/ui/core/Control\",\"./library\",\"./FacetFilterListRenderer\"],function(t,e,s,i,o){\"use strict\";var l=s.extend(\"sap.ui.ux3.FacetFilterList\",{metadata:{library:\"sap.ui.ux3\",properties:{title:{type:\"string\",group:\"Misc\",defaultValue:null},multiSelect:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},displaySecondaryValues:{type:\"boolean\",group:\"Misc\",defaultValue:!1},selectedKeys:{type:\"string[]\",group:\"Misc\",defaultValue:null},showCounter:{type:\"boolean\",group:\"Behavior\",defaultValue:!0}},aggregations:{items:{type:\"sap.ui.core.ListItem\",multiple:!0,singularName:\"item\"},controls:{type:\"sap.ui.commons.ListBox\",multiple:!0,singularName:\"control\",visibility:\"hidden\"}},events:{select:{parameters:{id:{type:\"string\"},selectedIndices:{type:\"int[]\"},selectedItems:{type:\"sap.ui.core.ListItem[]\"},all:{type:\"boolean\"}}}}}});return function(){l.prototype.init=function(){this._oResBundle=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this._oListBox=new e(this.getId()+\"-lb\"),this._oListBox.setScrollTop(0),this._oListBox.setValueTextAlign(\"Begin\"),this._oListBox.setDisplaySecondaryValues(this.getDisplaySecondaryValues()),this._oListBox.setDisplayIcons(!1),this._oListBox.setEditable(!0),this._oListBox.setEnabled(!0),this._oListBox.setVisible(!0),this._oListBox.setAllowMultiSelect(this.getMultiSelect()),this._oListBox.addAriaLabelledBy(this.getId()+\"-head-txt\");var t=this;this._oListBox.attachSelect(function(e){t.onSelect(t,e)}),this.addAggregation(\"controls\",this._oListBox),this._oItemAll=new sap.ui.core.ListItem({text:this._oResBundle.getText(\"FACETFILTER_ALL\",[0]),key:\"sapUiFacetFilter_ALL\"}),this._oListBox.addItem(this._oItemAll)},l.prototype.setMultiSelect=function(t){this._oListBox.setAllowMultiSelect(t),this.setProperty(\"multiSelect\",t,!0)},l.prototype.setDisplaySecondaryValues=function(t){this._oListBox.setDisplaySecondaryValues(t),this.setProperty(\"displaySecondaryValues\",t,!0)},l.prototype.addItem=function(e){this._oListBox.addItem(e),e.getKey()&&\"\"!=t.trim(e.getKey())||e.setKey(\"generatedkey\"+this.indexOfItem(e)),this.updateText4All()},l.prototype.insertItem=function(e,s){this._oListBox.insertItem(e,s+1),e.getKey()&&\"\"!=t.trim(e.getKey())||e.setKey(\"generatedkey\"+this.indexOfItem(e)),this.updateText4All()},l.prototype.removeItem=function(t){this._oListBox.removeItem(t),this.updateText4All()},l.prototype.removeAllItems=function(){this._oListBox.removeAllItems(),this._oListBox.addItem(this._oItemAll),this.updateText4All()},l.prototype.destroyItems=function(){this._oListBox.removeItem(this._oItemAll),this._oListBox.destroyItems(),this._oListBox.addItem(this._oItemAll),this.updateText4All()},l.prototype.indexOfItem=function(t){var e=this._oListBox.indexOfItem(t);return e>-1&&(e-=1),e},l.prototype.getItems=function(){for(var t=this._oListBox.getItems(),e=[],s=1;s<t.length;s++)e.push(t[s]);return e},l.prototype.setSelectedKeys=function(t){this.setProperty(\"selectedKeys\",t),this.invalidate()},l.prototype.setShowCounter=function(t){this.setProperty(\"showCounter\",t),this.updateText4All()},l.prototype.updateText4All=function(){this.getShowCounter()?this._oItemAll.setText(this._oResBundle.getText(\"FACETFILTER_ALL\",[this._oListBox.getItems().length-1])):this._oItemAll.setText(this._oResBundle.getText(\"FACETFILTER_NO_COUNT\"))},l.prototype.onBeforeRendering=function(){this.bFullHeight||this._oListBox.setVisibleItems(5);var t=this.getSelectedKeys();t&&t.length>0?(this._oListBox.setSelectedKeys(t),this._bAllOnly=!1):(this._oListBox.setSelectedKeys([\"sapUiFacetFilter_ALL\"]),this._bAllOnly=!0)},l.prototype.updateItems=function(){this.updateAggregation(\"items\");var t=this._oListBox.getSelectedKeys();0==t.length&&(t=[\"sapUiFacetFilter_ALL\"],this._bAllOnly=!0,this._oListBox.setSelectedKeys(t))},l.prototype.onSelect=function(e,s){var i=this._oListBox.getSelectedKeys();0==i.length&&(i=[\"sapUiFacetFilter_ALL\"],this._bAllOnly=!0,this._oListBox.setSelectedKeys(i));var o=t.inArray(\"sapUiFacetFilter_ALL\",i);o>-1?1==i.length?this._bAllOnly=!0:(this._bAllOnly?(i.splice(o,1),this._bAllOnly=!1):(i=[\"sapUiFacetFilter_ALL\"],this._bAllOnly=!0),this._oListBox.setSelectedKeys(i)):this._bAllOnly=!1,this.setProperty(\"selectedKeys\",i,!0);var l=[],n=[],r=this._oListBox.getSelectedItems();if(!this._bAllOnly)for(var a=0;a<r.length;a++)r[a]!=this._oItemAll&&(l.push(this.indexOfItem(r[a])),n.push(r[a]));this.fireSelect({id:e.getId(),all:this._bAllOnly,selectedIndices:l,selectedItems:n})}}(),l},!0);",
	"sap/ui/ux3/FacetFilterListRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){var i=t;i.write(\"<div \"),i.writeControlData(e),i.addClass(\"sapUiUx3FFLst\"),i.writeClasses(),i.writeAttribute(\"style\",\"width:\"+e.sWidth),i.write(\">\"),i.write('<header id=\"'+e.getId()+'-head\"  class=\"sapUiUx3FFLstHead\"'),e.getTooltip_AsString()&&i.writeAttributeEscaped(\"title\",e.getTooltip_AsString()),i.write(\">\"),i.write('<h3 id=\"'+e.getId()+'-head-txt\"  class=\"sapUiUx3FFLstHeadTxt\">'),e.getTitle()&&i.writeEscaped(e.getTitle()),i.write(\"</h3>\"),i.write(\"</header>\"),i.renderControl(e._oListBox),i.write(\"</div>\")},e},!0);",
	"sap/ui/ux3/FacetFilterRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(t){\"use strict\";var e={};return e.render=function(t,e){var i=t,r=e.getVisibleItemCountMode()===sap.ui.ux3.VisibleItemCountMode.Auto;i.write(\"<div\"),i.writeControlData(e),i.addClass(\"sapUiUx3FacetFilter\"),i.writeClasses(),r&&i.writeAttribute(\"style\",\"height:100%\"),i.write(\">\");var s=e.getLists();if(s)for(var a=0;a<s.length;a++)s[a].sWidth=100/s.length+\"%\",s[a].bFullHeight=r,i.renderControl(s[a]);i.write(\"</div>\")},e},!0);",
	"sap/ui/ux3/Feed.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/DropdownBox\",\"sap/ui/commons/MenuButton\",\"sap/ui/commons/SearchField\",\"sap/ui/commons/ToggleButton\",\"sap/ui/core/Control\",\"./Feeder\",\"./library\",\"./FeedRenderer\"],function(t,e,o,i,s,n,r,u,l){\"use strict\";var h=n.extend(\"sap.ui.ux3.Feed\",{metadata:{library:\"sap.ui.ux3\",properties:{feederThumbnailSrc:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:null},feederSender:{type:\"string\",group:\"Data\",defaultValue:null},live:{type:\"boolean\",group:\"Behavior\",defaultValue:!0},title:{type:\"string\",group:\"Data\",defaultValue:null}},aggregations:{filterItems:{type:\"sap.ui.core.ListItem\",multiple:!0,singularName:\"filterItem\",bindable:\"bindable\"},chunks:{type:\"sap.ui.ux3.FeedChunk\",multiple:!0,singularName:\"chunk\",bindable:\"bindable\"},toolsMenuItems:{type:\"sap.ui.commons.MenuItem\",multiple:!0,singularName:\"toolsMenuItem\",bindable:\"bindable\"}},events:{filterChange:{parameters:{newValue:{type:\"string\"}}},search:{parameters:{query:{type:\"string\"}}},chunkAdded:{parameters:{chunk:{type:\"sap.ui.ux3.FeedChunk\"}}},toolsItemSelected:{parameters:{itemId:{type:\"string\"},item:{type:\"sap.ui.unified.MenuItemBase\"}}},toggleLive:{parameters:{live:{type:\"boolean\"}}}}}});return h.prototype.init=function(){this.rb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this.data(\"sap-ui-fastnavgroup\",\"true\",!0),this.oFeeder=new r(this.getId()+\"-Feeder\",{type:sap.ui.ux3.FeederType.Medium}).setParent(this),this.oFeeder.attachEvent(\"submit\",this.handleFeederSubmit,this),this.oLiveButton=new s(this.getId()+\"-liveButton\",{text:this.rb.getText(\"FEED_LIVE\"),pressed:this.getLive(),lite:!0}).setParent(this),this.oLiveButton.attachEvent(\"press\",this.handleLiveButtonPress,this),this.oFilter=new e(this.getId()+\"-filter\").setParent(this),this.oFilter.attachEvent(\"change\",this.handleFilterChange,this),this.oSearchField=new i(this.getId()+\"-search\",{enableListSuggest:!1}).setParent(this),this.oSearchField.attachEvent(\"search\",this.handleSearchFieldSearch,this)},h.prototype.initToolsButton=function(){if(!this.oToolsButton){this.oToolsButton=new o(this.getId()+\"-toolsButton\",{tooltip:this.rb.getText(\"FEED_TOOLS\"),lite:!0,menu:new sap.ui.commons.Menu(this.getId()+\"-toolsMenu\")}).setParent(this),this.oToolsButton.attachEvent(\"itemSelected\",this.handleLtoolsButtonSelected,this);var t=sap.ui.core.theming.Parameters._getThemeImage(\"_sap_ui_ux3_Feed_ToolsIconUrl\"),e=sap.ui.core.theming.Parameters._getThemeImage(\"_sap_ui_ux3_Feed_ToolsIconHoverUrl\");t&&this.oToolsButton.setProperty(\"icon\",t,!0),e&&this.oToolsButton.setProperty(\"iconHovered\",e,!0)}},h.prototype.exit=function(){this.oFeeder&&(this.oFeeder.destroy(),delete this.oFeeder),this.oLiveButton&&(this.oLiveButton.destroy(),delete this.oLiveButton),this.oToolsButton&&(this.oToolsButton.destroy(),delete this.oToolsButton),this.oFilter&&(this.oFilter.destroy(),delete this.oFilter),this.oSearchField&&(this.oSearchField.destroy(),delete this.oSearchField),this.rb=void 0},h.prototype.handleFeederSubmit=function(t){var e=new Date,o=String(e),i=new sap.ui.ux3.FeedChunk(this.getId()+\"-new-\"+this.getChunks().length,{text:t.getParameter(\"text\"),commentChunk:!1,deletionAllowed:!0,timestamp:o,sender:this.getFeederSender(),thumbnailSrc:this.getFeederThumbnailSrc()});this.insertChunk(i,0),this.fireChunkAdded({chunk:i})},h.prototype.handleLiveButtonPress=function(t){var e=t.getParameter(\"pressed\");this.setProperty(\"live\",e,!0),this.fireToggleLive({live:e})},h.prototype.handleLtoolsButtonSelected=function(t){this.fireToolsItemSelected(t.mParameters)},h.prototype.handleFilterChange=function(t){this.fireFilterChange(t.mParameters)},h.prototype.handleSearchFieldSearch=function(t){this.fireSearch(t.mParameters)},h.prototype.setFeederThumbnailSrc=function(t){return this.setProperty(\"feederThumbnailSrc\",t,!0),this.oFeeder.setThumbnailSrc(t),this},h.prototype.setLive=function(t){return this.setProperty(\"live\",t,!0),this.oLiveButton.setPressed(t),this},h.prototype.getToolsMenuItems=function(){if(this.oToolsButton)return this.oToolsButton.getMenu().getItems()},h.prototype.insertToolsMenuItem=function(t,e){return this.initToolsButton(),this.oToolsButton.getMenu().insertItem(t,e),this},h.prototype.addToolsMenuItem=function(t){return this.initToolsButton(),this.oToolsButton.getMenu().addItem(t),this},h.prototype.removeToolsMenuItem=function(t){if(this.oToolsButton)return this.oToolsButton.getMenu().removeItem(t)},h.prototype.removeAllToolsMenuItems=function(){if(this.oToolsButton)return this.oToolsButton.getMenu().removeAllItems()},h.prototype.indexOfToolsMenuItem=function(t){if(this.oToolsButton)return this.oToolsButton.getMenu().indexOfItem(t)},h.prototype.destroyToolsMenuItems=function(){return this.oToolsButton&&this.oToolsButton.getMenu().destroyItems(),this},h.prototype.bindToolsMenuItems=function(t,e,o,i){return this.initToolsButton(),this.oToolsButton.getMenu().bindItems(t,e,o,i),this},h.prototype.unbindToolsMenuItems=function(){return this.oToolsButton&&this.oToolsButton.getMenu().unbindItems(),this},h.prototype.getFilterItems=function(){return this.oFilter.getItems()},h.prototype.insertFilterItem=function(t,e){return this.oFilter.insertItem(t,e),this},h.prototype.addFilterItem=function(t){return this.oFilter.addItem(t),this},h.prototype.removeFilterItem=function(t){return this.oFilter.removeItem(t)},h.prototype.removeAllFilterItems=function(){return this.oFilter.removeAllItems()},h.prototype.indexOfFilterItem=function(t){return this.oFilter.indexOfItem(t)},h.prototype.destroyFilterItems=function(){return this.oFilter.destroyItems(),this},h.prototype.bindFilterItems=function(t,e,o,i){return this.oFilter.bindItems(t,e,o,i),this},h.prototype.unbindFilterItems=function(){return this.oFilter.unbindItems(),this},h},!0);",
	"sap/ui/ux3/FeedChunk.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/MenuButton\",\"sap/ui/core/Control\",\"sap/ui/core/theming/Parameters\",\"./Feeder\",\"./library\",\"./FeedChunkRenderer\"],function(e,t,o,n,i,s,r){\"use strict\";var a=o.extend(\"sap.ui.ux3.FeedChunk\",{metadata:{library:\"sap.ui.ux3\",properties:{thumbnailSrc:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:null},text:{type:\"string\",group:\"Data\",defaultValue:null},sender:{type:\"string\",group:\"Data\",defaultValue:null},timestamp:{type:\"string\",group:\"Data\",defaultValue:null},deletionAllowed:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},commentChunk:{type:\"boolean\",group:\"Appearance\",defaultValue:!1,deprecated:!0},feederThumbnailSrc:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:null},feederSender:{type:\"string\",group:\"Data\",defaultValue:null},flagged:{type:\"boolean\",group:\"Data\",defaultValue:!1},favorite:{type:\"boolean\",group:\"Data\",defaultValue:null},shared:{type:\"boolean\",group:\"Data\",defaultValue:!1},enableFlag:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},enableShare:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},enableComment:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},enableInspect:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},enableFavorite:{type:\"boolean\",group:\"Appearance\",defaultValue:!0}},aggregations:{comments:{type:\"sap.ui.ux3.FeedChunk\",multiple:!0,singularName:\"comment\",bindable:\"bindable\"},actionMenuItems:{type:\"sap.ui.commons.MenuItem\",multiple:!0,singularName:\"actionMenuItem\",bindable:\"bindable\"}},events:{deleted:{},commentAdded:{parameters:{comment:{type:\"sap.ui.ux3.FeedChunk\"}}},toggleFlagged:{parameters:{flagged:{type:\"boolean\"}}},senderClicked:{},referenceClicked:{parameters:{text:{type:\"string\"}}},toggleFavorite:{parameters:{favorite:{type:\"boolean\"}}},inspect:{},toggleShared:{parameters:{shareed:{type:\"boolean\"}}},actionItemSelected:{parameters:{itemId:{type:\"string\"},item:{type:\"sap.ui.unified.MenuItemBase\"}}}}}});return a.prototype.init=function(){this.maxComments=2,this.allComments=!1,this.rb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this.expanded=!1},a.prototype.initCommentFeeder=function(){this.oCommentFeeder||(this.oCommentFeeder=new i(this.getId()+\"-CommentFeeder\",{type:sap.ui.ux3.FeederType.Comment}).setParent(this),this.oCommentFeeder.attachEvent(\"submit\",this.handleCommentFeederSubmit,this),this.showCommentFeeder=!0)},a.prototype.initToolsButton=function(){if(!this.oToolsButton){this.oToolsButton=new t(this.getId()+\"-toolsButton\",{tooltip:this.rb.getText(\"FEED_TOOLS\"),lite:!0,menu:new sap.ui.commons.Menu(this.getId()+\"-toolsMenu\")}).setParent(this),this.oToolsButton.attachEvent(\"itemSelected\",this.handleToolsButtonSelected,this);var e=n._getThemeImage(\"_sap_ui_ux3_Feed_ToolsIconUrl\"),o=n._getThemeImage(\"_sap_ui_ux3_Feed_ToolsIconHoverUrl\");e&&this.oToolsButton.setProperty(\"icon\",e,!0),o&&this.oToolsButton.setProperty(\"iconHovered\",o,!0)}},a.prototype.exit=function(){this.oCommentFeeder&&(this.oCommentFeeder.destroy(),delete this.oCommentFeeder),this.oToolsButton&&(this.oToolsButton.destroy(),delete this.oToolsButton),this.rb=void 0,this.showCommentFeeder=void 0,this.expanded=void 0,this.oText=void 0,this.oHCMMenuButton&&(this.oHCMMenuButton.destroy(),delete this.oHCMMenuButton)},a.prototype.onAfterRendering=function(){if(this.oText=this.$().children(\".sapUiFeedChunkText\").get(0),this.oText.clientHeight<this.oText.scrollHeight){var t=this.$().children(\".sapUiFeedChunkByline\").get(0);e(t).append(sap.ui.ux3.FeedChunkRenderer.renderExpander(this)),this.expanded&&e(this.oText).css(\"height\",\"auto\")}},a.prototype.onclick=function(t){var o=t.target.getAttribute(\"ID\");if(o)switch(o){case this.getId()+\"-delete\":this.fireDeleted();break;case this.getId()+\"-sender\":case this.getId()+\"-thumb\":this.fireSenderClicked();break;case this.getId()+\"-exp\":var n=\"\";this.expanded?(e(this.oText).css(\"height\",\"\"),n=this.rb.getText(\"FEED_EXPAND\"),this.expanded=!1):(e(this.oText).css(\"height\",\"auto\"),n=this.rb.getText(\"FEED_COLLAPSE\"),this.expanded=!0),e.sap.byId(o).attr(\"title\",n).toggleClass(\"sapUiFeedChunkExpand sapUiFeedChunkCollapse\");break;case this.getId()+\"-all\":this.showAllComments();break;case this.getId()+\"-ActComment\":this.showCommentFeeder||(this.initCommentFeeder(),this.rerender());break;case this.getId()+\"-ActFlag\":this.setFlagged(!this.getFlagged()),this.fireToggleFlagged({flagged:this.getFlagged()});break;case this.getId()+\"-ActFavorite\":this.setFavorite(!this.getFavorite()),this.fireToggleFavorite({favorite:this.getFavorite()});break;case this.getId()+\"-ActInspect\":this.fireInspect();break;case this.getId()+\"-ActShare\":this.setShared(!this.getShared()),this.fireToggleShared({shared:this.getShared()});break;default:-1!=o.search(this.getId()+\"-Ref\")&&this.fireReferenceClicked({text:e(t.target).text()})}t.preventDefault(),t.stopPropagation()},a.prototype.showAllComments=function(){this.allComments=!this.allComments;var t=e.sap.byId(this.getId()+\" > section\");if(t.length>0){var o=sap.ui.getCore().createRenderManager();this.getRenderer().renderComments(o,this),o.flush(t[0]),o.destroy()}},a.prototype.handleCommentFeederSubmit=function(e){var t=new Date,o=String(t),n=new a(this.getId()+\"-new-\"+this.getComments().length,{text:e.getParameter(\"text\"),commentChunk:!0,deletionAllowed:!0,timestamp:o,sender:this.getFeederSender(),thumbnailSrc:this.getFeederThumbnailSrc()});this.addComment(n),this.fireCommentAdded({comment:n})},a.prototype.handleToolsButtonSelected=function(e){e.getParameter(\"itemId\")==this.getId()+\"-actDelete\"?this.fireDeleted():this.fireActionItemSelected(e.mParameters)},a.prototype.insertComment=function(e,t){return this.insertAggregation(\"comments\",e,t),this.initCommentFeeder(),this},a.prototype.addComment=function(e){return this.addAggregation(\"comments\",e),this.initCommentFeeder(),this},a.prototype.setDeletionAllowed=function(e){return e==this.getDeletionAllowed()?this:(this.setProperty(\"deletionAllowed\",e),e?(this.initToolsButton(),this.oToolsButton.getMenu().insertItem(new sap.ui.commons.MenuItem(this.getId()+\"-actDelete\",{text:this.rb.getText(\"FEED_DELETE\")}),0)):this.oToolsButton&&this.oToolsButton.getMenu().removeItem(this.getId()+\"-actDelete\"),this)},a.prototype.getActionMenuItems=function(){if(this.oToolsButton){var e=this.oToolsButton.getMenu().getItems();return e.length>0&&e[0].getId()==this.getId()+\"-actDelete\"&&e.shift(),e}},a.prototype.insertActionMenuItem=function(e,t){this.initToolsButton();var o=this.oToolsButton.getMenu().getItems();return o.length>0&&o[0].getId()==this.getId()+\"-actDelete\"&&t++,this.oToolsButton.getMenu().insertItem(e,t),this},a.prototype.addActionMenuItem=function(e){return this.initToolsButton(),this.oToolsButton.getMenu().addItem(e),this},a.prototype.removeActionMenuItem=function(e){if(this.oToolsButton)return this.oToolsButton.getMenu().removeItem(e)},a.prototype.removeAllActionMenuItems=function(){if(this.oToolsButton){var e=this.oToolsButton.getMenu().getItems();if(e.length>0&&e[0].getId()==this.getId()+\"-actDelete\"){e.shift();for(var t=0;t<e.length;t++)this.oToolsButton.getMenu().removeItem(e[t]);return e}return this.oToolsButton.getMenu().removeAllItems()}},a.prototype.indexOfActionMenuItem=function(e){if(this.oToolsButton){var t=this.oToolsButton.getMenu().indexOfItem(e),o=this.oToolsButton.getMenu().getItems();return o.length>0&&o[0].getId()==this.getId()+\"-actDelete\"&&t--,t}},a.prototype.destroyActionMenuItems=function(){if(this.oToolsButton){var e=this.oToolsButton.getMenu().getItems();e.length>0&&e[0].getId()==this.getId()+\"-actDelete\"?this.removeAllActionMenuItems():this.oToolsButton.getMenu().destroyItems()}return this},a.prototype.bindActionMenuItems=function(e,t,o,n){return this.initToolsButton(),this.oToolsButton.getMenu().bindItems(e,t,o,n),this},a.prototype.unbindActionMenuItems=function(){return this.oToolsButton&&this.oToolsButton.getMenu().unbindItems(),this},a.prototype.getFeederThumbnailSrc=function(){var e=this.getProperty(\"feederThumbnailSrc\");if(!e||\"\"==e){var t=this.getParent();t&&(t instanceof sap.ui.ux3.Feed||t instanceof a)&&(e=t.getFeederThumbnailSrc())}return e},a.prototype.getFeederSender=function(){var e=this.getProperty(\"feederSender\");if(!e||\"\"==e){var t=this.getParent();t&&(t instanceof sap.ui.ux3.Feed||t instanceof a)&&(e=t.getFeederSender())}return e},a.prototype.initHCMMenuButton=function(){this.oHCMMenuButton||(this.oHCMMenuButton=new t(this.getId()+\"-HCMMenu\",{lite:!0}).setParent(this),this.oHCMMenuButton.attachEvent(\"itemSelected\",this.handleHCMMenuButtonSelected,this))},a.prototype.setHCMMenu=function(e){return this.initHCMMenuButton(),this.oHCMMenuButton.setMenu(e),this},a.prototype.handleHCMMenuButtonSelected=function(e){this.fireEvent(\"HCMMenuItemSelected\",e.mParameters)},a},!0);",
	"sap/ui/ux3/FeedChunkRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){var r=e,i=t;i.getParent()instanceof sap.ui.ux3.FeedChunk?i.bComment=!0:i.bComment=!1;var a=i.getId();r.write(\"<ARTICLE\"),r.writeControlData(i),r.addClass(\"sapUiFeedChunk\"),i.bComment&&r.addClass(\"sapUiFeedChunkComment\"),r.writeClasses(),r.write(\">\"),r.write(\"<img id=\"+a+\"-thumb\");var s=i.getThumbnailSrc();s||(s=sap.ui.core.theming.Parameters._getThemeImage(\"_sap_ui_ux3_FeedChunk_PersonPlaceholder\")),r.writeAttributeEscaped(\"src\",s),r.writeAttributeEscaped(\"alt\",i.getSender()),r.writeClasses(),r.write(\">\"),r.write('<DIV class= \"sapUiFeedChunkText\" >'),r.write(\"<a id=\"+a+\"-sender \"),r.writeAttribute(\"href\",\"#\"),r.write(\">\"),r.writeEscaped(i.getSender()),r.write(\"</a> \"),i.oHCMMenuButton&&r.renderControl(i.oHCMMenuButton),this.renderText(r,i),r.write(\"</DIV>\"),i.bComment||(r.write('<UL class= \"sapUiFeedChunkStatusIcons\" >'),i.getFlagged()&&r.write('<LI class= \"sapUiFeedChunkFlagged\" title=\"'+i.rb.getText(\"FEED_FLAGGED\")+'\" >&#9873</LI>'),i.getFavorite()&&r.write('<LI class= \"sapUiFeedChunkFavorite\" title=\"'+i.rb.getText(\"FEED_FAVORITE\")+'\" >&#9733</LI>'),i.getShared()&&r.write('<LI class= \"sapUiFeedChunkShared\" title=\"'+i.rb.getText(\"FEED_SHARED\")+'\" >&#8635</LI>'),r.write(\"</UL>\")),r.write('<SPAN class= \"sapUiFeedChunkByline\" >'),r.writeEscaped(i.getTimestamp()),r.write(\"</SPAN>\"),i.bComment||(i.oToolsButton&&r.renderControl(i.oToolsButton),i.getEnableShare()&&r.write('<BUTTON type = \"button\" id='+a+'-ActShare class= \"sapUiFeedChunkAct sapUiFeedChunkActShare\" title=\"'+i.rb.getText(\"FEED_ACT_SHARE\")+'\" >&#8635</BUTTON>'),i.getEnableInspect()&&r.write('<BUTTON type = \"button\" id='+a+'-ActInspect class= \"sapUiFeedChunkAct sapUiFeedChunkActInspect\" title=\"'+i.rb.getText(\"FEED_ACT_INSPECT\")+'\" >i</BUTTON>'),i.getEnableFavorite()&&r.write('<BUTTON type = \"button\" id='+a+'-ActFavorite class= \"sapUiFeedChunkAct sapUiFeedChunkActFavorite\" title=\"'+i.rb.getText(\"FEED_ACT_FAVORITE\")+'\" >&#9733</BUTTON>'),i.getEnableFlag()&&r.write('<BUTTON type = \"button\" id='+a+'-ActFlag class= \"sapUiFeedChunkAct sapUiFeedChunkActFlag\" title=\"'+i.rb.getText(\"FEED_ACT_FLAG\")+'\" >&#9873</BUTTON>'),i.getEnableComment()&&r.write('<BUTTON type = \"button\" id='+a+'-ActComment class= \"sapUiFeedChunkAct sapUiFeedChunkActComment\" title=\"'+i.rb.getText(\"FEED_ACT_COMMENT\")+'\" >C</BUTTON>')),i.getDeletionAllowed()&&i.bComment&&r.write('<BUTTON type = \"button\" id='+a+'-delete class= \"sapUiFeedChunkDel\" title=\"'+i.rb.getText(\"FEED_DELETE\")+'\" >X</BUTTON>'),(i.getComments().length>0||i.showCommentFeeder)&&(r.write(\"<SECTION>\"),this.renderComments(r,i),r.write(\"</SECTION>\")),r.write(\"</ARTICLE>\")},t.renderText=function(t,r){var i=r.getText(),a=0,s=0;do{s=i.search(/\\s/);var n=\"\",d=\"\";s<0?d=i:(d=i.slice(0,s),n=i.slice(s,s+1),i=i.slice(s+1)),/^@/.test(d)?(t.write(\"<a id=\"+r.getId()+\"-Ref\"+a),t.writeAttribute(\"href\",\"#\"),t.write(\">\"),t.writeEscaped(d,!0),t.write(\"</a>\",n),a++):/^(https?|ftp):\\/\\//i.test(d)&&e.sap.validateUrl(d)?(t.write(\"<a\"),t.writeAttribute(\"href\",e.sap.encodeHTML(d)),t.write(\">\"),t.writeEscaped(d,!0),t.write(\"</a>\",n)):/^(www\\.)/i.test(d)&&e.sap.validateUrl(\"http://\"+d)?(t.write(\"<a\"),t.writeAttribute(\"href\",e.sap.encodeHTML(\"http://\"+d)),t.write(\">\"),t.writeEscaped(d,!0),t.write(\"</a>\",n)):/^[\\w\\.=-]+@[\\w\\.-]+\\.[\\w]{2,5}$/.test(d)?(t.write(\"<a\"),t.writeAttribute(\"href\",\"mailto:\"+e.sap.encodeHTML(d)),t.write(\">\"),t.writeEscaped(d,!0),t.write(\"</a>\",n)):t.writeEscaped(d+n,!0)}while(s>=0)},t.renderComments=function(e,t){var r=t.getComments(),i=r.length;e.write('<HEADER class= \"sapUiFeedChunkComments\" >'),t.rb&&(e.write(t.rb.getText(\"FEED_NO_COMMENTS\",[i])),i>t.maxComments&&(e.write(\"<a id=\"+t.getId()+\"-all \"),e.writeAttribute(\"href\",\"#\"),e.write(\">\"),t.allComments?e.write(t.rb.getText(\"FEED_MAX_COMMENTS\")):e.write(t.rb.getText(\"FEED_ALL_COMMENTS\")),e.write(\"</a>\"))),e.write(\"</HEADER>\");var a=i;!t.allComments&&t.maxComments<a&&(a=t.maxComments);for(var s=0;s<a;s++)e.renderControl(r[i-a+s]);t.oCommentFeeder&&e.renderControl(t.oCommentFeeder)},t.renderExpander=function(e){return e.expanded?\"<button id= '\"+e.getId()+\"-exp' class='sapUiFeedChunkCollapse' title='\"+e.rb.getText(\"FEED_COLLAPS\")+\"'>&#9660</button>\":\"<button id= '\"+e.getId()+\"-exp' class='sapUiFeedChunkExpand' title='\"+e.rb.getText(\"FEED_EXPAND\")+\"'>&#9660</button>\"},t},!0);",
	"sap/ui/ux3/Feeder.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/Button\",\"sap/ui/core/Control\",\"sap/ui/core/theming/Parameters\",\"./library\",\"./FeederRenderer\"],function(e,t,n,o,i,r){\"use strict\";var s=n.extend(\"sap.ui.ux3.Feeder\",{metadata:{library:\"sap.ui.ux3\",properties:{thumbnailSrc:{type:\"sap.ui.core.URI\",group:\"Data\",defaultValue:null},text:{type:\"string\",group:\"Data\",defaultValue:null},type:{type:\"sap.ui.ux3.FeederType\",group:\"Appearance\",defaultValue:sap.ui.ux3.FeederType.Large},placeholderText:{type:\"string\",group:\"Appearance\",defaultValue:null}},events:{submit:{parameters:{text:{type:\"string\"}}}}}});return s.prototype.init=function(){this.rb=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this.oSendButton=new t(this.getId()+\"-send\",{style:sap.ui.commons.ButtonStyle.Emph,icon:\"sap-icon://feeder-arrow\"}).setParent(this),this.oSendButton.attachEvent(\"press\",this.handleSendButtonPress,this)},s.prototype.initSendButton=function(){\"\"==this.getText()&&this.oSendButton.setProperty(\"enabled\",!1,!0)},s.prototype.exit=function(){this.rb=void 0,this.oInput=void 0,this.oSendButton&&(this.oSendButton.destroy(),delete this.oSendButton)},s.prototype.onAfterRendering=function(){this.oInput=this.$(\"input\")},s.prototype.onclick=function(e){switch(e.target.getAttribute(\"ID\")){case this.getId()+\"-send\":case this.getId()+\"-input\":}},s.prototype.onfocusin=function(e){this.oInput.find(\".sapUiFeederEmptyText\").remove()},s.prototype.onfocusout=function(e){var t=this.oInput.text();\"\"==t&&(this.oInput.empty(),this.oInput.append(sap.ui.ux3.FeederRenderer.getEmptyTextInfo(this))),this.setProperty(\"text\",t,!0)},s.prototype.getFocusDomRef=function(){return this.getDomRef(\"input\")},s.prototype.onkeyup=function(e){\"\"==this.oInput.text()?this.oSendButton.setEnabled(!1):this.oSendButton.setEnabled(!0)},s.prototype.handleSendButtonPress=function(e){var t=this.getMultilineText(this.oInput);this.setProperty(\"text\",t,!0),this.fireSubmit({text:t}),this.setText(\"\")},s.prototype.getMultilineText=function(t){function n(t){for(var o,i=\"\",r=0;r<t.length;r++){if(o=t[r],3!==o.nodeType&&4!==o.nodeType||(sap.ui.Device.browser.internet_explorer||sap.ui.Device.browser.edge)&&\" \"===o.nodeValue||(i+=o.nodeValue.replace(/\\n/g,\"\")),\"DIV\"===o.nodeName||\"P\"===o.nodeName||\"BR\"===o.nodeName&&!sap.ui.Device.browser.webkit){if(\"BR\"===o.nodeName&&sap.ui.Device.browser.firefox&&r===t.length-1&&\"_moz\"===e(o).attr(\"type\"))continue;(sap.ui.Device.browser.internet_explorer||sap.ui.Device.browser.edge)&&\"\"===i||(sap.ui.Device.browser.firefox||sap.ui.Device.browser.webkit)&&\"\"===i&&\"P\"===o.nodeName||sap.ui.Device.browser.webkit&&\"P\"===o.nodeName&&o.textContent.match(/^(\\n)*$/)||(i+=\"\\n\")}8!==o.nodeType&&(i+=n(o.childNodes))}return i}return n(t.get(0).childNodes)},s.prototype.getThumbnailSrc=function(){var e=this.getProperty(\"thumbnailSrc\");if(!e||\"\"==e){var t=this.getParent();t&&(t instanceof sap.ui.ux3.Feed||t instanceof sap.ui.ux3.FeedChunk)&&(e=t.getFeederThumbnailSrc())}return e},s.prototype.onpaste=function(t){sap.ui.Device.browser.firefox&&e.sap.delayedCall(10,this,\"onAfterPaste\")},s.prototype.onAfterPaste=function(){for(var t=this.oInput.get(0).childNodes,n=0;n<t.length;n++){var o=t[n];\"PRE\"==o.nodeName&&e(o).css(\"overflow\",\"hidden\")}},s},!0);",
	"sap/ui/ux3/FeederRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){var r=e,a=t;switch(r.write(\"<DIV\"),r.writeControlData(a),r.addClass(\"sapUiFeeder\"),a.getType()){case sap.ui.ux3.FeederType.Medium:r.addClass(\"sapUiFeederMedium\");break;case sap.ui.ux3.FeederType.Comment:r.addClass(\"sapUiFeederComment\");break;default:r.addClass(\"sapUiFeederLarge\")}r.writeClasses(),r.write(\">\"),r.write(\"<img id=\"+a.getId()+\"-thumb\");var s=a.getThumbnailSrc();s||(s=sap.ui.core.theming.Parameters._getThemeImage(\"_sap_ui_ux3_Feeder_PersonPlaceholder\")),r.writeAttributeEscaped(\"src\",s),r.writeClasses(),r.write(\">\"),r.write(\"<DIV id=\"+a.getId()+'-input contenteditable=\"true\" class=\"sapUiFeederInput\" >'),\"\"==a.getText()?r.write(this.getEmptyTextInfo(a)):r.writeEscaped(a.getText(),!0),r.write(\"</DIV>\"),a.initSendButton(),r.renderControl(a.oSendButton),r.write(\"</DIV>\")},t.getEmptyTextInfo=function(t){return\"<span class='sapUiFeederEmptyText'>\"+e.sap.encodeHTML(t.getPlaceholderText()||t.rb.getText(\"FEED_EMPTY_FEEDER\"))+\"</span>\"},t},!0);",
	"sap/ui/ux3/FeedRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([],function(){\"use strict\";var e={};return e.render=function(e,r){var t=e,o=r;t.write(\"<DIV\"),t.writeControlData(o),t.addClass(\"sapUiFeed\"),t.writeClasses(),t.write(\">\"),t.renderControl(o.oFeeder),t.write(\"<HEADER class=sapUiFeedTitle ><H4>\");var i=o.getTitle();i&&\"\"!=i||(i=o.rb.getText(\"FEED_TITLE\")),t.writeEscaped(i),o.oToolsButton&&t.renderControl(o.oToolsButton),t.renderControl(o.oLiveButton),t.write(\"</H4>\"),t.write('<DIV class=\"sapUiFeedToolbar\" >'),t.renderControl(o.oFilter),t.renderControl(o.oSearchField),t.write(\"</DIV>\"),t.write(\"</HEADER>\"),t.write(\"<SECTION>\");for(var n=0;n<o.getChunks().length;n++){var s=o.getChunks()[n];t.renderControl(s)}t.write(\"</SECTION>\"),t.write(\"</DIV>\")},e},!0);",
	"sap/ui/ux3/library.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/library\",\"sap/ui/commons/library\"],function(a){\"use strict\";return sap.ui.getCore().initLibrary({name:\"sap.ui.ux3\",version:\"904001.3.0.20231215124400_f0htmcm94p\",dependencies:[\"sap.ui.core\",\"sap.ui.commons\"],types:[\"sap.ui.ux3.ActionBarSocialActions\",\"sap.ui.ux3.ExactOrder\",\"sap.ui.ux3.FeederType\",\"sap.ui.ux3.FollowActionState\",\"sap.ui.ux3.NotificationBarStatus\",\"sap.ui.ux3.ShellDesignType\",\"sap.ui.ux3.ShellHeaderType\",\"sap.ui.ux3.ThingViewerHeaderType\",\"sap.ui.ux3.VisibleItemCountMode\"],interfaces:[\"sap.ui.ux3.DataSetView\"],controls:[\"sap.ui.ux3.ActionBar\",\"sap.ui.ux3.CollectionInspector\",\"sap.ui.ux3.DataSet\",\"sap.ui.ux3.DataSetSimpleView\",\"sap.ui.ux3.Exact\",\"sap.ui.ux3.ExactArea\",\"sap.ui.ux3.ExactBrowser\",\"sap.ui.ux3.ExactList\",\"sap.ui.ux3.FacetFilter\",\"sap.ui.ux3.FacetFilterList\",\"sap.ui.ux3.Feed\",\"sap.ui.ux3.FeedChunk\",\"sap.ui.ux3.Feeder\",\"sap.ui.ux3.NavigationBar\",\"sap.ui.ux3.NotificationBar\",\"sap.ui.ux3.Overlay\",\"sap.ui.ux3.OverlayContainer\",\"sap.ui.ux3.OverlayDialog\",\"sap.ui.ux3.QuickView\",\"sap.ui.ux3.Shell\",\"sap.ui.ux3.ThingInspector\",\"sap.ui.ux3.ThingViewer\",\"sap.ui.ux3.ToolPopup\"],elements:[\"sap.ui.ux3.Collection\",\"sap.ui.ux3.DataSetItem\",\"sap.ui.ux3.ExactAttribute\",\"sap.ui.ux3.NavigationItem\",\"sap.ui.ux3.Notifier\",\"sap.ui.ux3.ThingAction\",\"sap.ui.ux3.ThingGroup\"]}),sap.ui.ux3.ActionBarSocialActions={Update:\"Update\",Follow:\"Follow\",Flag:\"Flag\",Favorite:\"Favorite\",Open:\"Open\"},sap.ui.ux3.ExactOrder={Select:\"Select\",Fixed:\"Fixed\"},sap.ui.ux3.FeederType={Large:\"Large\",Medium:\"Medium\",Comment:\"Comment\"},sap.ui.ux3.FollowActionState={Follow:\"Follow\",Hold:\"Hold\",Default:\"Default\"},sap.ui.ux3.NotificationBarStatus={Default:\"Default\",Min:\"Min\",Max:\"Max\",None:\"None\"},sap.ui.ux3.ShellDesignType={Standard:\"Standard\",Light:\"Light\",Crystal:\"Crystal\"},sap.ui.ux3.ShellHeaderType={Standard:\"Standard\",BrandOnly:\"BrandOnly\",NoNavigation:\"NoNavigation\",SlimNavigation:\"SlimNavigation\"},sap.ui.ux3.ThingViewerHeaderType={Standard:\"Standard\",Horizontal:\"Horizontal\"},sap.ui.ux3.VisibleItemCountMode={Fixed:\"Fixed\",Auto:\"Auto\"},sap.ui.ux3});",
	"sap/ui/ux3/NavigationBar.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/delegate/ItemNavigation\",\"./library\",\"./NavigationBarRenderer\",\"jquery.sap.dom\"],function(t,e,i,o,r){\"use strict\";var s=e.extend(\"sap.ui.ux3.NavigationBar\",{metadata:{library:\"sap.ui.ux3\",properties:{toplevelVariant:{type:\"boolean\",group:\"Misc\",defaultValue:!1},overflowItemsToUpperCase:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}},defaultAggregation:\"items\",aggregations:{items:{type:\"sap.ui.ux3.NavigationItem\",multiple:!0,singularName:\"item\"},overflowMenu:{type:\"sap.ui.commons.Menu\",multiple:!1,visibility:\"hidden\"}},associations:{selectedItem:{type:\"sap.ui.ux3.NavigationItem\",multiple:!1},associatedItems:{type:\"sap.ui.ux3.NavigationItem\",multiple:!0,singularName:\"associatedItem\"}},events:{select:{allowPreventDefault:!0,parameters:{itemId:{type:\"string\"},item:{type:\"sap.ui.ux3.NavigationItem\"}}}}}});return s.SCROLL_STEP=250,s.prototype.init=function(){this._bPreviousScrollForward=!1,this._bPreviousScrollBack=!1,this._iLastArrowPos=-100,this._bRtl=sap.ui.getCore().getConfiguration().getRTL(),this.allowTextSelection(!1),this.startScrollX=0,this.startTouchX=0;var e=this;if(this._oItemNavigation=(new i).setCycling(!1),this.addDelegate(this._oItemNavigation),this.data(\"sap-ui-fastnavgroup\",\"true\",!0),\"ON\"===t.sap.touchEventMode){var o=function(t){t.preventDefault(),e._iInertiaIntervalId&&window.clearInterval(e._iInertiaIntervalId),e.startScrollX=e.getDomRef(\"list\").scrollLeft,e.startTouchX=t.touches[0].pageX,e._bTouchNotMoved=!0,e._lastMoveTime=(new Date).getTime()},r=function(t){var i=t.touches[0].pageX-e.startTouchX,o=e.getDomRef(\"list\"),r=o.scrollLeft,s=e.startScrollX-i;o.scrollLeft=s,e._bTouchNotMoved=!1;var a=(new Date).getTime()-e._lastMoveTime;e._lastMoveTime=(new Date).getTime(),a>0&&(e._velocity=(s-r)/a),t.preventDefault()},s=function(t){if(!1===e._bTouchNotMoved){t.preventDefault();var i=e.getDomRef(\"list\"),o=Math.abs(e._velocity/10);e._iInertiaIntervalId=window.setInterval(function(){e._velocity=.8*e._velocity;var t=50*e._velocity;i.scrollLeft=i.scrollLeft+t,Math.abs(e._velocity)<o&&(window.clearInterval(e._iInertiaIntervalId),e._iInertiaIntervalId=void 0)},50)}else!0===e._bTouchNotMoved&&(e.onclick(t),t.preventDefault());e._bTouchNotMoved=void 0,e._lastMoveTime=void 0};this.ontouchstart=o,this.ontouchend=s,this.ontouchmove=r}},s.prototype.exit=function(){this._oItemNavigation&&(this.removeDelegate(this._oItemNavigation),this._oItemNavigation.destroy(),delete this._oItemNavigation),this._checkOverflowIntervalId&&(t.sap.clearIntervalCall(this._checkOverflowIntervalId),this._checkOverflowIntervalId=null)},s.prototype.onBeforeRendering=function(){this._checkOverflowIntervalId&&(t.sap.clearIntervalCall(this._checkOverflowIntervalId),this._checkOverflowIntervalId=null),this._iSoredScrollPosition=this.$(\"list\").scrollLeft(),sap.ui.Device.browser.firefox?this.$().unbind(\"DOMMouseScroll\",this._handleScroll):this.$().unbind(\"mousewheel\",this._handleScroll);var e=this.getDomRef(\"arrow\");this._iLastArrowPos=e?parseInt(this._bRtl?e.style.right:e.style.left,10):-100},s.prototype.invalidate=function(t){t instanceof sap.ui.ux3.NavigationItem&&(this._menuInvalid=!0),e.prototype.invalidate.apply(this,arguments)},s.prototype._calculatePositions=function(){this._bPreviousScrollForward=!1,this._bPreviousScrollBack=!1,this._checkOverflow(this._getListDomRef(),this.getDomRef(\"ofb\"),this.getDomRef(\"off\"))},s.prototype.onThemeChanged=function(){this.getDomRef()&&this._calculatePositions()},s.prototype.onAfterRendering=function(){var e=this.getDomRef(),i=this._getListDomRef(),o=this.getDomRef(\"ofb\"),r=this.getDomRef(\"off\");this._checkOverflowIntervalId=t.sap.intervalCall(350,this,\"_checkOverflow\",[i,o,r]),sap.ui.Device.browser.firefox?t(e).bind(\"DOMMouseScroll\",t.proxy(this._handleScroll,this)):t(e).bind(\"mousewheel\",t.proxy(this._handleScroll,this)),this._calculatePositions(),this._updateItemNavigation();var s=this.$();s.on(\"scroll\",function(){s.children().scrollTop(0),s.scrollTop(0)}),this._iSoredScrollPosition&&this.$(\"list\").scrollLeft(this._iSoredScrollPosition)},s.prototype._getListDomRef=function(){return t(\"#\"+this.getId()).find(\"ul\")[0]},s.prototype._updateItemNavigation=function(){var e=this.getDomRef();if(e){var i=-1,o=this.getSelectedItem(),r=t(e).children().children(\"li\").children().not(\".sapUiUx3NavBarDummyItem\");r.each(function(t,e){e.id==o&&(i=t)}),this._oItemNavigation.setRootDomRef(e),this._oItemNavigation.setItemDomRefs(r.toArray()),this._oItemNavigation.setSelectedIndex(i)}},s.prototype.onsapspace=function(t){this._handleActivation(t)},s.prototype.onclick=function(t){this._handleActivation(t)},s.prototype.setOverflowItemsToUpperCase=function(t){return this._getOverflowMenu().toggleStyleClass(\"sapUiUx3NavBarUpperCaseText\",t),this.setProperty(\"overflowItemsToUpperCase\",t)},s.prototype._handleActivation=function(t){var e=t.target.id;if(\"ed\"===sap.ui.Device.browser.name&&(e=t.srcControl.getId()),e){var i=this.getId();t.preventDefault(),this._isBackwardArrowPressed(t)?this._calculateBackwardScrollStep(t,-s.SCROLL_STEP,500):this._isForwardArrowPressed(t)?this._calculateForwardScrollStep(t,s.SCROLL_STEP,500):e==i+\"-oflt\"||e==i+\"-ofl\"?this._showOverflowMenu():this._itemPressed(t)}},s.prototype._isBackwardArrowPressed=function(t){var e=this.getId();if(t.target.id==e+\"-ofb\")return!0},s.prototype._calculateBackwardScrollStep=function(t,e,i){this._scroll(e,i)},s.prototype._isForwardArrowPressed=function(t){var e=this.getId();if(t.target.id==e+\"-off\")return!0},s.prototype._calculateForwardScrollStep=function(t,e,i){this._scroll(e,i)},s.prototype._itemPressed=function(t){var e=t.target.id,i=sap.ui.getCore().byId(e);i&&e!=this.getSelectedItem()&&sap.ui.getCore().byId(e)instanceof sap.ui.ux3.NavigationItem&&this.fireSelect({item:i,itemId:e})&&(this.setAssociation(\"selectedItem\",i,!0),this._updateSelection(e))},s.prototype._getOverflowMenu=function(){var t=this.getAggregation(\"overflowMenu\");if(!t||this._menuInvalid){t?t.destroyAggregation(\"items\",!0):t=new sap.ui.commons.Menu;for(var e=this._getCurrentItems(),i=this,o=this.getSelectedItem(),r=0;r<e.length;++r){var s=e[r],a=new sap.ui.commons.MenuItem(s.getId()+\"-overflowItem\",{text:s.getText(),visible:s.getVisible(),icon:o==s.getId()?\"sap-icon://accept\":null,select:function(t){return function(e){i._handleActivation({target:{id:t.getId()},preventDefault:function(){}})}}(s)});t.addAggregation(\"items\",a,!0)}this.setAggregation(\"overflowMenu\",t,!0),this._menuInvalid=!1}return t},s.prototype._getCurrentItems=function(){var t=this.getItems();if(t.length<1){t=this.getAssociatedItems();for(var e=sap.ui.getCore(),i=0;i<t.length;++i)t[i]=e.byId(t[i])}return t},s.prototype._showOverflowMenu=function(){var t=this._getOverflowMenu(),e=this.$(\"ofl\").get(0);t.open(!0,e,sap.ui.core.Popup.Dock.EndTop,sap.ui.core.Popup.Dock.CenterCenter,e)},s.prototype._updateSelection=function(e){this._menuInvalid=!0;var i=t.sap.byId(e),o=this;i.attr(\"tabindex\",\"0\").attr(\"aria-checked\",\"true\"),i.parent().addClass(\"sapUiUx3NavBarItemSel\"),i.parent().parent().children().each(function(){var i=o.firstChild;i&&i.id!=e&&-1==i.className.indexOf(\"Dummy\")&&(t(i).attr(\"tabindex\",\"-1\"),t(i).parent().removeClass(\"sapUiUx3NavBarItemSel\"),t(i).attr(\"aria-checked\",\"false\"))});var r=i.parent().index();r>0&&r--,this._oItemNavigation.setSelectedIndex(r);var a=this.$(\"arrow\"),n=a.outerWidth(),l=s._getArrowTargetPos(e,n,this._bRtl);a.stop();var c=this._bRtl?{right:l+\"px\"}:{left:l+\"px\"};a.animate(c,500,\"linear\"),window.setTimeout(function(){l=s._getArrowTargetPos(e,n,o._bRtl),a.stop();var i=o._bRtl?{right:l+\"px\"}:{left:l+\"px\"};a.animate(i,200,\"linear\",function(){var i=t.sap.domById(e);o._scrollItemIntoView(i)})},300)},s.prototype._scrollItemIntoView=function(e){if(e){var i,o=t(e.parentNode),r=o.parent(),s=sap.ui.getCore().getConfiguration().getRTL(),a=o.index()-1;if(0==a)i=s?r[0].scrollWidth-r.innerWidth()+20:0;else if(a==o.siblings().length-2)i=s?0:r[0].scrollWidth-r.innerWidth()+20;else{var n=o.position().left,l=s?r.scrollLeftRTL():r.scrollLeft();if(n<0)i=l+n;else{var c=r.innerWidth()-(n+o.outerWidth(!0));c<0&&(i=l-c,i=Math.min(i,l+n))}}this._scrollItemIntoViewWithAnimation(e,i)}},s.prototype._scrollItemIntoViewWithAnimation=function(e,i){var o=t(e.parentNode),r=o.parent(),s=sap.ui.getCore().getConfiguration().getRTL();void 0!==i&&(s&&(i=t.sap.denormalizeScrollLeftRTL(i,r.get(0))),r.stop(!0,!0).animate({scrollLeft:i}))},s._getArrowTargetPos=function(e,i,o){var r=t.sap.byId(e);if(r.length>0){var s=r.outerWidth(),a=Math.round(r[0].offsetLeft+s/2-i/2);return o?r.parent().parent().innerWidth()-a-i:a}return-100},s.prototype._handleScroll=function(t){if(\"DOMMouseScroll\"==t.type){var e=40*t.originalEvent.detail;this._scroll(e,50)}else{var e=-t.originalEvent.wheelDelta;this._scroll(e,50)}t.preventDefault()},s.prototype._scroll=function(t,e){var i=this._getListDomRef(),o=i.scrollLeft;!sap.ui.Device.browser.internet_explorer&&\"ed\"!==sap.ui.Device.browser.name&&this._bRtl&&(t=-t);var r=o+t;this._scrollPosition(r,e)},s.prototype._scrollPosition=function(e,i){var o=this._getListDomRef();t(o).stop(!0,!0).animate({scrollLeft:e},i)},s.prototype._checkOverflow=function(e,i,o){if(e&&this.getDomRef()&&t.sap.act.isActive()){var r=e.scrollLeft,a=!1,n=!1,l=e.scrollWidth,c=e.clientWidth,h=function(){return sap.ui.Device.os.macintosh&&sap.ui.Device.browser.chrome}()?5:0;if(1==Math.abs(l-c)&&(l=c),this._bRtl){var u=t(e);this._isForwardScrollArrowEnableInRTL(u,h)&&(n=!0),this._isBackwardScrollArrowEnableInRTL(u,h)&&(a=!0)}else this._isBackwardScrollArrowEnable(r,h)&&(a=!0),this._isForwardScrollArrowEnable(e,h)&&(n=!0);n==this._bPreviousScrollForward&&a==this._bPreviousScrollBack||(this._bPreviousScrollForward=n,this._bPreviousScrollBack=a,this.$().toggleClass(\"sapUiUx3NavBarScrollBack\",a).toggleClass(\"sapUiUx3NavBarScrollForward\",n),s._bMenuLoaded||!a&&!n||(s._bMenuLoaded=!0,t.sap.require(\"sap.ui.commons.Menu\"))),this._setArrow()}},s.prototype._isBackwardScrollArrowEnable=function(t,e){return t>e},s.prototype._isBackwardScrollArrowEnableInRTL=function(t,e){return t.scrollRightRTL()>e},s.prototype._isForwardScrollArrowEnable=function(t,e){var i=t.scrollLeft,o=t.scrollWidth,r=t.clientWidth;return o>r&&o-(i+r)>e},s.prototype._isForwardScrollArrowEnableInRTL=function(t,e){return t.scrollLeftRTL()>e},s.prototype._setArrow=function(){var t=sap.ui.getCore().byId(this.getSelectedItem());if(t){var e=this.$(\"arrow\"),i=e.outerWidth(),o=s._getArrowTargetPos(t.getId(),i,this._bRtl)+\"px\";this._bRtl?e[0].style.right!=o&&(e[0].style.right=o):e[0].style.left!=o&&(e[0].style.left=o)}},s.prototype.setSelectedItem=function(t){if(this.setAssociation(\"selectedItem\",t,!0),this.getDomRef()){var e=t&&\"string\"!=typeof t?t.getId():t;this._updateSelection(e)}},s.prototype.addItem=function(t){return this._menuInvalid=!0,this.addAggregation(\"items\",t)},s.prototype.destroyItems=function(){return this._menuInvalid=!0,this.destroyAggregation(\"items\")},s.prototype.insertItem=function(t,e){return this._menuInvalid=!0,this.insertAggregation(\"items\",t,e)},s.prototype.removeItem=function(t){return this._menuInvalid=!0,this.removeAggregation(\"items\",t)},s.prototype.removeAllItems=function(){return this._menuInvalid=!0,this.removeAllAggregation(\"items\")},s.prototype.addAssociatedItem=function(t){return this._menuInvalid=!0,this.addAssociation(\"associatedItems\",t)},s.prototype.removeAssociatedItem=function(t){return this._menuInvalid=!0,this.removeAssociation(\"associatedItems\",t)},s.prototype.removeAllAssociatedItems=function(){return this._menuInvalid=!0,this.removeAllAssociation(\"associatedItems\")},s.prototype.setAssociatedItems=function(e){t.sap.assert(t.isArray(e),\"aItems must be an array\");var i=this.getDomRef(\"list\");this.removeAllAssociation(\"associatedItems\",!0);for(var o=0;o<e.length;o++)this.addAssociation(\"associatedItems\",e[o],!0);if(i){var r=t(i).find(\":focus\"),s=r.length>0?r.attr(\"id\"):null;if(arguments.length>1&&\"boolean\"==typeof arguments[1])this._iLastArrowPos=-100;else{var a=this.getDomRef(\"arrow\");this._iLastArrowPos=parseInt(this._bRtl?a.style.right:a.style.left,10)}i.innerHTML=\"\";var n=sap.ui.getCore().createRenderManager();sap.ui.ux3.NavigationBarRenderer.renderItems(n,this),n.flush(i,!0),n.destroy();var l;s&&(l=t.sap.domById(s))&&t.sap.focus(l),this._updateSelection(this.getSelectedItem()),this._updateItemNavigation()}return this},s.prototype.isSelectedItemValid=function(){var t=this.getSelectedItem();if(!t)return!1;var e=this.getItems();if(e&&0!=e.length){for(var i=0;i<e.length;i++)if(e[i].getId()==t)return!0}else{e=this.getAssociatedItems();for(var i=0;i<e.length;i++)if(e[i]==t)return!0}return!1},s},!0);",
	"sap/ui/ux3/NavigationBarRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var a={};return a.render=function(e,t){var r=e,i=t.getId();r.addClass(\"sapUiUx3NavBar\").addClass(\"sapUiUx3NavBarUpperCaseText\"),t.getToplevelVariant()&&r.addClass(\"sapUiUx3NavBarToplevel\"),r.write(\"<nav\"),r.writeControlData(t),r.writeClasses(),r.write(\"role='navigation'>\"),r.write(\"<ul id='\"+i+\"-list' role='menubar' class='sapUiUx3NavBarList'\"),r.addStyle(\"white-space\",\"nowrap\"),r.writeStyles(),r.write(\">\"),a.renderItems(r,t),r.write(\"</ul>\"),r.write(\"<a id='\"+i+\"-ofb' role='presentation' class='sapUiUx3NavBarBack' href='#'></a>\"),r.write(\"<a id='\"+i+\"-off' role='presentation' class='sapUiUx3NavBarForward' href='#'></a>\"),r.write(\"<a id='\"+i+\"-ofl' role='presentation' class='sapUiUx3NavBarOverflowBtn' href='#'>\"),r.writeIcon(\"sap-icon://overflow\",[],{id:i+\"-oflt\"}),r.write(\"</a>\"),r.write(\"</nav>\")},a.renderItems=function(a,t){var r=t.getItems(),i=!1;r&&0!=r.length||(r=t.getAssociatedItems(),i=!0);var s=r.length;a.write(\"<li\"),a.addStyle(\"display\",\"inline-block\"),a.writeStyles(),a.write(\">\"),a.write(\"<a id='\"+t.getId()+\"-dummyItem' class='sapUiUx3NavBarDummyItem sapUiUx3NavBarItem'>&nbsp;</a></li>\");for(var l=t.getSelectedItem(),o=0;o<s;o++){var n=i?sap.ui.getCore().byId(r[o]):r[o];if(n.getVisible()){var w=n.getId(),d=w==l;a.write(\"<li\"),a.addStyle(\"display\",\"inline-block\"),a.writeStyles(),d&&a.write(\" class='sapUiUx3NavBarItemSel'\"),a.write(\"><a \"),a.writeElementData(n),a.writeAttributeEscaped(\"href\",n.getHref()||\"#\"),a.write(\" aria-setsize='\"+s+\"' aria-posinset='\"+(o+1)+\"' role='menuitemradio' class='sapUiUx3NavBarItem'\"),d&&a.write(\" tabindex='0'\"),a.write(\" aria-checked='\"+(d?\"true\":\"false\")+\"'\");var p=n.getTooltip_AsString();p&&a.write(\" title='\"+e.sap.encodeHTML(p)+\"'\"),a.write(\">\"),a.write(e.sap.encodeHTML(n.getText())),a.write(\"</a></li>\")}}var v;v=t._bRtl?\"right:\"+t._iLastArrowPos:\"left:\"+t._iLastArrowPos,a.write(\"<span id='\"+t.getId()+\"-arrow' style='\"+v+\"px;\"),a.write(\"' class='sapUiUx3NavBarArrow'></span>\")},a},!0);",
	"sap/ui/ux3/NavigationItem.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Item\",\"./library\"],function(e,a,u){\"use strict\";return a.extend(\"sap.ui.ux3.NavigationItem\",{metadata:{library:\"sap.ui.ux3\",properties:{visible:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},href:{type:\"sap.ui.core.URI\",group:\"Behavior\",defaultValue:null}},defaultAggregation:\"subItems\",aggregations:{subItems:{type:\"sap.ui.ux3.NavigationItem\",multiple:!0,singularName:\"subItem\"}}}})},!0);",
	"sap/ui/ux3/NotificationBar.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/delegate/ItemNavigation\",\"sap/ui/core/theming/Parameters\",\"./library\",\"./NotificationBarRenderer\"],function(e,t,i,s,a,r){\"use strict\";var o=t.extend(\"sap.ui.ux3.NotificationBar\",{metadata:{library:\"sap.ui.ux3\",properties:{visibleStatus:{type:\"sap.ui.ux3.NotificationBarStatus\",group:\"Misc\",defaultValue:sap.ui.ux3.NotificationBarStatus.Default},resizeEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},alwaysShowToggler:{type:\"boolean\",defaultValue:!1,since:\"1.24.5\"}},aggregations:{messageNotifier:{type:\"sap.ui.core.Element\",multiple:!1},notifiers:{type:\"sap.ui.core.Element\",multiple:!0,singularName:\"notifier\"}},events:{display:{parameters:{show:{type:\"boolean\"}}},resize:{parameters:{status:{type:\"sap.ui.ux3.NotificationBarStatus\"}}}}}});return t.extend(\"sap.ui.ux3.NotificationBar.NotifierView\",{renderMessages:function(e){e.write(\"<div\"),e.writeAttribute(\"id\",this.getId()+\"-content\"),e.addClass(\"sapUiNotifierContent\"),e.writeClasses(),e.write(\">\");for(var t=this.getMessages(),i=t.length-1,s=!0;i>=0;i--){!s||0==i&&t.length>1?(e.write(\"<div\"),e.addClass(\"sapUiNotificationBarCltSep\"),e.writeClasses(),e.write(\">\"),e.write(\"</div>\")):s=!1;var a=t[i];a._message&&a._message.getReadOnly()&&a.addStyleClass(\"sapUiNotifierMessageReadOnly\"),e.renderControl(a)}e.write(\"</div>\")},metadata:{properties:{title:\"string\",visibleItems:\"int\",renderMode:{type:\"string\",defaultValue:\"callout\"}},aggregations:{messages:\"sap.ui.ux3.NotificationBar.MessageView\"}},init:function(){this._oResBundle=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\")},exit:function(){this._renderedControl&&delete this._renderedControl,delete this._oResBundle},getTitle:function(){var e=this.getProperty(\"title\"),t=this.getMessages().length;if(t>0){e=this._oResBundle.getText(\"NOTIBAR_NOTIFIER_VIEW_TITLE\",[e,t])}return e},renderer:function(e,t){e.write(\"<div\"),e.addClass(\"sapUiNotifierContainer\"),e.writeControlData(t),e.writeClasses(),e.write(\">\"),e.write(\"<div\"),e.writeAttribute(\"id\",t.getId()+\"-title\"),e.addClass(\"sapUiNotifierTitle\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(t.getTitle()),e.write(\"</div>\"),t.getMessages().length>0&&t.renderMessages(e),e.write(\"</div>\")},onAfterRendering:function(){var t=this.$(\"content\"),i=t.children(\".sapUiNotifierMessage\"),s=i.length,a=this.getVisibleItems();s>a&&e.sap.delayedCall(0,this,this._fnAfterRenderingCallback,[i,t,a])},_fnAfterRenderingCallback:function(t,i,s){var a=s-1,r=0;t.each(function(){if(r===s)return void i.css(\"max-height\",a);a+=e(this).outerHeight(),r++})}}),t.extend(\"sap.ui.ux3.NotificationBar.MessageView\",{metadata:{properties:{text:\"string\",timestamp:\"string\",icon:\"sap.ui.core.URI\"}},renderer:function(e,t){var i=t.getId();e.write(\"<div\"),e.writeControlData(t),e.addClass(\"sapUiNotifierMessage\"),e.writeClasses(),e.writeAttribute(\"tabindex\",\"0\"),e.write(\">\"),t.getIcon()&&(e.write(\"<div\"),e.writeAttribute(\"id\",i+\"-icon\"),e.addClass(\"sapUiNotifierMessageIcon\"),e.writeClasses(),e.write(\">\"),e.write(\"<img\"),e.writeAttributeEscaped(\"src\",t.getIcon()),e.write(\">\"),e.write(\"</div>\")),e.write(\"<div\"),e.writeAttribute(\"id\",i+\"-text\"),e.addClass(\"sapUiNotifierMessageText\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(t.getText()),e.write(\"</div>\"),e.write(\"<div\"),e.writeAttribute(\"id\",i+\"-timestamp\"),e.addClass(\"sapUiNotifierMessageTimestamp\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(t.getTimestamp()),e.write(\"</div>\"),e.write(\"</div>\")},onclick:function(e){if(!this._message.getReadOnly()){var t=this._message.getParent();t.fireMessageSelected({message:this._message,notifier:t})}},onsapselect:function(e){this.onclick(e)},exit:function(e){this._message&&delete this._message}}),function(){var t=function(e){var t=e.hasItems(),i=e.getVisibleStatus();return!(!t||\"None\"!==i)||(!t&&\"None\"!==i||!t&&\"Min\"!==i)},a=function(e,t){var i=t.getMessages().concat([]);if(i.length>0){i.sort(sap.ui.core.Message.compareByType);var s=i.length-1;e._sSeverestMessageLevel=i[s].getLevel()}},r=function(e){var i=e.getParameter(\"callout\");switch(e.getParameter(\"type\")){case\"added\":case\"removed\":var s=e.getParameter(\"notifier\");if(this.getMessageNotifier()&&this.getMessageNotifier().getId()===s.getId()&&a(this,this.getMessageNotifier()),t(this)){var r=this.hasItems();this.fireDisplay({show:r})}else if(this.invalidate(),\"removed\"===e.getParameter(\"type\")&&i.getContent().length>0)for(var g,l=i.getContent()[0],u=e.getParameter(\"message\"),h=l.getMessages(),f=0;f<h.length;f++)if(g=h[f],u.getId()===g._message.getId()){g.destroy(),i.rerender(),i.adjustPosition();break}break;case\"openCallout\":i.destroyContent();var s=e.getParameter(\"notifier\");s.destroyAggregation(\"views\",!0);var d=s.getId(),c=this.getMessageNotifier();c&&d===c.getId()?d+=\"-messageNotifierView\":d+=\"-messageView\";var p=new o.NotifierView(d,{title:s.getTitle(),visibleItems:this._visibleItems});s._bEnableMessageSelect&&p.addStyleClass(\"sapUiNotifierSelectable\");for(var v=s.getMessages(),f=0;f<v.length;f++){var m=n(v[f],s,this);p.addMessage(m)}s.addAggregation(\"views\",p,!0),i.addContent(p)}};o.HOVER_ITEM_HEIGHT=16,o.prototype.init=function(){this._oItemNavigation=new i,this._oItemNavigation.setCycling(!0),this.addDelegate(this._oItemNavigation),this._iCalloutWidth=parseInt(250,10),this._iCalloutHeight=parseInt(200,10),this._visibleItems=5,this._eventListener=e.proxy(r,this),this._oResBundle=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),this._togglerPosition=\"50%\",this._gapMessageArea=\"5\",this._sSeverestMessageLevel=sap.ui.core.MessageType.None,e(window).bind(\"resize\",e.proxy(m,this)),this._proxyEnableMessageSelect=e.proxy(u,this),this.data(\"sap-ui-fastnavgroup\",\"true\",!0),this.setAlwaysShowToggler(!1)},o.prototype.exit=function(){if(this.removeDelegate(this._oItemNavigation),this._oItemNavigation.destroy(),delete this._oItemNavigation,delete this._iCalloutWidth,delete this._iCalloutHeight,delete this._visibleItems,delete this._eventListener,this.getMessageNotifier()){var t=this.getMessageNotifier();t._oMessageArea.destroy(),delete t._oMessageArea}delete this._resizeFrom,delete this._resizeTo,delete this._oResBundle,delete this._formerVisibleStatus,delete this._togglerPosition,delete this._gapMessageArea,delete this._isHovered,delete this._togglerClicked,delete this._sSeverestMessageLevel,e(window).unbind(\"resize\",m),delete this._proxyEnableMessageSelect};var n=function(e,t,i){var s=new o.MessageView(t.getId()+\"-messageView-\"+e.getId(),{text:e.getText(),timestamp:e.getTimestamp()});return s._message=e,\"messageNotifier\"==t.sParentAggregationName?i.getVisibleStatus()==sap.ui.ux3.NotificationBarStatus.Max?s.setIcon(e.getIcon()||e.getDefaultIcon(\"32x32\")):s.setIcon(e.getIcon()||e.getDefaultIcon()):s.setIcon(e.getIcon()),s},g=function(e,t){t.attachEvent(\"_childControlCalling\",e._eventListener,e)},l=function(e,t){t.detachEvent(\"_childControlCalling\",e._eventListener,e)};o.prototype.addNotifier=function(e){if(e){var t=this.getVisibleStatus()==sap.ui.ux3.NotificationBarStatus.None;this.addAggregation(\"notifiers\",e,t),g(this,e)}return this},o.prototype.insertNotifier=function(e,t){return e&&(this.insertAggregation(\"notifiers\",e,t),g(this,e)),this},o.prototype.removeNotifier=function(e){var t=this.removeAggregation(\"notifiers\",e);return l(this,t),t},o.prototype.removeAllNotifiers=function(){for(var e=this.removeAllAggregation(\"notifiers\"),t=0;t<e.length;t++){var i=e[t];l(this,i)}return e},o.prototype.destroyNotifiers=function(){for(var e=this.getNotifiers(),t=0;t<e.length;t++){var i=e[t];l(this,i)}return this.destroyAggregation(\"notifiers\"),this};var u=function(e){var t=this.getMessageNotifier();t&&t.getId()===e.getParameter(\"notifier\").getId()&&t.invalidate()};o.prototype.setMessageNotifier=function(e){var t=this.getMessageNotifier();return t&&(t._oMessageArea.destroy(),delete t._oMessageArea,t.detachEvent(\"_enableMessageSelect\",this._proxyEnableMessageSelect),l(this,t)),this.setAggregation(\"messageNotifier\",e),e&&(e._oMessageArea=new o.MessageView(this.getId()+\"-inplaceMessage\"),e._oMessageArea.setParent(e),e.attachEvent(\"_enableMessageSelect\",this._proxyEnableMessageSelect),g(this,e)),this},o.prototype.destroyMessageNotifier=function(e){var t=this.getMessageNotifier();return t&&(t._oMessageArea.destroy(),delete t._oMessageArea,t.detachEvent(\"_enableMessageSelect\",this._proxyEnableMessageSelect),l(this,t)),this.destroyAggregation(\"messageNotifier\"),this};var h=function(e,t){var i=e.$();switch(t){case sap.ui.ux3.NotificationBarStatus.Min:i.addClass(\"sapUiNotificationBarMinimized\");break;case sap.ui.ux3.NotificationBarStatus.Max:var s=e.getHeightOfStatus(e.getVisibleStatus());i.addClass(\"sapUiNotificationBarMaximized\"),i.css(\"height\",s);e.$(\"containers\").css(\"max-height\",s);break;case sap.ui.ux3.NotificationBarStatus.None:e._resizeTo||i.css(\"display\",\"none\");break;case sap.ui.ux3.NotificationBarStatus.Default:default:i.removeClass(\"sapUiNotificationBarMaximized\"),i.removeClass(\"sapUiNotificationBarMinimized\")}},f=function(e){if(N(e)){var t=e.getHeightOfStatus(e._resizeFrom),i=e.$();i.css(\"height\",t);var s=e.getHeightOfStatus(e._resizeTo);i.stop(!0,!0).animate({height:s},\"fast\",function(){var t=e.getVisibleStatus();if(\"None\"===t&&(i.css(\"display\",\"none\"),e.hasItems())){if(e.getMessageNotifier()){e.getMessageNotifier().$().css(\"display\",\"none\")}if(e.getNotifiers().length>0)for(var s=e.getNotifiers(),a=0;a<s.length;a++)s[a].$().css(\"display\",\"none\")}h(e,t),M(e,t)})}else{var a=e.getVisibleStatus();h(e,a)}delete e._resizeFrom,delete e._resizeTo},d=function(t){if(t.getMessageNotifier()&&t.getMessageNotifier().hasItems()){var i,s=t.getId()+\"-notifiers\",a=e.sap.byId(s);if(a.length>0){for(var r=parseInt(a.width(),10),o=a.children(),n=0;n<o.length;n++){var g=e(o[n]);g.hasClass(\"sapUiNotifier\")?r-=g.width():g.hasClass(\"sapUiNotifierSeparator\")?r-=g.width():g.hasClass(\"sapUiInPlaceMessage\")&&(i=g)}i&&(r-=t._gapMessageArea+2,i.css(\"width\",r+\"px\"))}}};o.prototype.onAfterRendering=function(){this._oItemNavigation.setRootDomRef(this.getDomRef());var t=[];if(this.getVisibleStatus()===sap.ui.ux3.NotificationBarStatus.Max){var i=this.getMessageNotifier();if(null!=i)for(var s=i.getMessages(),a=i.getId()+\"-messageNotifierView-messageView-\",r=s.length-1;r>=0;r--){var o=e.sap.domById(a+s[r].getId());o&&t.push(o)}for(var n=this.getNotifiers(),r=0;r<n.length;r++)for(var s=n[r].getMessages(),a=n[r].getId()+\"-notifierView-messageView-\",g=s.length-1;g>=0;g--){var o=e.sap.domById(a+s[g].getId());o&&t.push(o)}}else{for(var n=this.getNotifiers(),r=0;r<n.length;r++){var o=n[r].getDomRef();o&&t.push(o)}var i=this.getMessageNotifier();if(null!=i){var o=i.getDomRef();o&&t.push(o),(o=this.getDomRef(\"inplaceMessage\"))&&e(o).hasClass(\"sapUiInPlaceMessageSelectable\")&&t.push(o)}}if(this._oItemNavigation.setItemDomRefs(t),f(this),d(this),c(this,this.getMessageNotifier()),p(this),sap.ui.Device.browser.mobile){var l=this.$(\"toggler\");this.getVisibleStatus()!==sap.ui.ux3.NotificationBarStatus.None?l.css(\"display\",\"block\"):l.css(\"display\",\"none\")}};var c=function(e,t){if(t&&t.hasItems()){var i=t.$(\"counter\");i.removeClass(\"sapUiMessageInformation\"),i.removeClass(\"sapUiMessageSuccess\"),i.removeClass(\"sapUiMessageWarning\"),i.removeClass(\"sapUiMessageError\"),a(e,t);var s=e._sSeverestMessageLevel;i.addClass(\"sapUiMessage\"+s);var r=t.getMessages().length,o=\"NOTIBAR_MESSAGE_NOTIFIER_DESC_LEVEL_\"+s.toUpperCase()+(1===r?\"_SING\":\"_PL\");v(e,t,o,r)}},p=function(e){for(var t=e.getNotifiers(),i=0;i<t.length;i++){var s=t[i].getMessages().length,a=\"NOTIBAR_NOTIFIER_COUNT_TEXT_\"+(1===s?\"SING\":\"PL\");v(e,t[i],a,s)}},v=function(e,t,i,s){var a=t.$(\"description\"),r=e._oResBundle.getText(i,[s]);a.html(r)},m=function(e){d(this)},N=function(e){return!(!e._resizeFrom||!e._resizeTo||e._resizeFrom==e._resizeTo)};o.prototype.hasItems=function(){var e=this.getNotifiers();if(e.length>0)for(var t=0;t<e.length;t++){var i=e[t];if(i.hasItems())return!0}return!(!this.getMessageNotifier()||!this.getMessageNotifier().hasItems())};var M=function(e,t){var i=\"none\",s=e.$();switch(t){case sap.ui.ux3.NotificationBarStatus.Max:case sap.ui.ux3.NotificationBarStatus.None:break;case sap.ui.ux3.NotificationBarStatus.Min:s.stop().animate({height:e.getHeightOfStatus(t)},{duration:\"fast\",queue:!0}),s.addClass(\"sapUiNotificationBarMinimized\"),e.$(\"notifiers\").css(\"display\",\"none\"),i=\"block\";break;default:case sap.ui.ux3.NotificationBarStatus.Default:s.stop().animate({height:e.getHeightOfStatus(t)},{duration:\"fast\",queue:!0}),s.removeClass(\"sapUiNotificationBarMaximized\"),s.removeClass(\"sapUiNotificationBarMinimized\")}e.$(\"hoverItem\").css(\"display\",i)};o.prototype.onfocusin=function(e){this._togglerClicked&&(delete this._togglerClicked,e.stopImmediatePropagation(!0))},o.prototype.onclick=function(t){this._togglerClicked=!0,this.$().blur();var i=e(document.activeElement);_(this);var s=t.target.id,a=s.split(\"-\");if(a){var r=this.getVisibleStatus();switch(a[a.length-1]){case\"ArrowUp\":\"Min\"===r?this.setVisibleStatus(\"Default\"):this.setVisibleStatus(\"Max\");break;case\"ArrowDown\":\"Max\"===r?this.setVisibleStatus(\"Default\"):this.setVisibleStatus(\"Min\"),t.preventDefault();break;case\"BarUp\":this._formerVisibleStatus?this.setVisibleStatus(this._formerVisibleStatus):this.setVisibleStatus(\"Default\");break;case\"BarDown\":this._formerVisibleStatus=r,this.setVisibleStatus(\"Min\"),i.blur();break;default:if(i.hasClass(\"sapUiNotifier\"))i.focus();else if(this.hasItems()){var o=this.getNotifiers();if(o.length>0){var n=e(o[0]);n.focus()}else{var g=this.getMessageNotifier();g&&e(g).focus()}}}}},o.prototype.onThemeChanged=function(e){this.getDomRef()&&this.invalidate()};var _=function(e){for(var t=e.getNotifiers(),i=0;i<t.length;i++){t[i]._oCallout.close()}e.getMessageNotifier()&&e.getMessageNotifier()._oCallout.close()};o.prototype.getHeightOfStatus=function(t){var i=\"\";if(t==sap.ui.ux3.NotificationBarStatus.Min)i=\"sapUiNotificationBarHeightMinimized\";else{if(t!=sap.ui.ux3.NotificationBarStatus.Default){if(t==sap.ui.ux3.NotificationBarStatus.Max){i=\"sapUiNotificationBarHeightMaximized\",i=s.get(i);var a=i.indexOf(\"%\");if(-1!=a){var r=i.substring(0,a),o=e(window).height();o=parseInt(o/100*r,10);var n=parseInt(this.getHeightOfStatus(sap.ui.ux3.NotificationBarStatus.Default),10);o<n&&(o=n+1)}else{e.sap.log.warning(\"No valid percantage value given for maximized size. 400px is used\"),o=400}return o+\"px\"}return\"0px\"}i=\"sapUiNotificationBarHeight\"}return i=s.get(i)},o.prototype.setVisibleStatus=function(e){this._resizeFrom=this.getVisibleStatus(),this._resizeTo=e,this._resizeFrom!==this._resizeTo&&(e===sap.ui.ux3.NotificationBarStatus.None&&(_(this),this.getDomRef()?M(this,e):this.$().css({height:\"0px\",display:\"none\"})),this.setProperty(\"visibleStatus\",e),this.fireResize({status:e}))},o.prototype.setAlwaysShowToggler=function(e){sap.ui.Device.browser.mobile&&(e=!0),this.setProperty(\"alwaysShowToggler\",e,!0);var t=this.$(\"toggler\");e?t.css(\"display\",\"block\"):t.css(\"display\",\"none\")}}(),o},!0);",
	"sap/ui/ux3/NotificationBarRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Icon\"],function(e,t){\"use strict\";var i={};return function(){i.render=function(e,t){a(e,t),o(e,t),g(e,t)};var a=function(e,t){e.write(\"<div\"),e.writeControlData(t),t.getVisibleStatus()===sap.ui.ux3.NotificationBarStatus.None?t.$().length>0&&t._resizeFrom?t.$().stop().animate({height:0},\"fast\",function(){t.$().css(\"display\",\"none\"),e.addStyle(\"display\",\"none\"),e.writeAttribute(\"aria-hidden\",\"true\")}):(e.addStyle(\"display\",\"none\"),e.writeAttribute(\"aria-hidden\",\"true\")):(e.writeAttribute(\"aria-hidden\",\"false\"),e.addStyle(\"display\",\"block\")),e.writeStyles(),e.addClass(\"sapUiNotificationBar\"),t._resizeTo&&t._resizeFrom==sap.ui.ux3.NotificationBarStatus.Max&&t._resizeTo==sap.ui.ux3.NotificationBarStatus.Default&&e.addClass(\"sapUiNotificationBarMaximized\"),e.writeClasses(),e.write(\">\"),d(e,t)},s=function(e,t){var i=t.getVisibleStatus();if(\"None\"!==i){var a=t.getId()+\"-toggler\";e.write(\"<div\"),e.writeAttribute(\"id\",a),e.addClass(\"sapUiBarToggle\"),\"Min\"!==i&&e.addClass(\"sapUiBarToggleWide\"),e.writeClasses(),t.getAlwaysShowToggler()&&(e.addStyle(\"display\",\"block\"),e.writeStyles()),e.write(\">\"),r(e,t,\"ArrowUp\"),r(e,t,\"ArrowDown\"),r(e,t,\"BarUp\"),r(e,t,\"BarDown\"),e.write(\"</div>\")}else e.addStyle(\"display\",\"none\"),e.writeStyles()},r=function(e,t,i){e.write(\"<div\");var a=t.getId()+\"-\"+i;e.writeAttribute(\"id\",a);var s=t.getVisibleStatus(),r=!0,d=\"\";switch(i){case\"ArrowUp\":\"Default\"===s&&(r=!1),d=t._oResBundle.getText(\"NOTIBAR_TITLE_ENLARGE\");break;case\"ArrowDown\":\"Max\"===s&&(r=!1),d=t._oResBundle.getText(\"NOTIBAR_TITLE_MINIMIZE\");break;case\"BarUp\":\"Min\"===s&&(r=!1),d=t._oResBundle.getText(\"NOTIBAR_TITLE_BAR_UP\");break;case\"BarDown\":\"Max\"!==s&&\"Default\"!==s||(r=!1),d=t._oResBundle.getText(\"NOTIBAR_TITLE_BAR_DOWN\")}e.writeAttributeEscaped(\"title\",d),r&&e.addClass(\"sapUiBarToggleHide\"),e.addClass(\"sapUiBarToggle\"+i),e.addClass(\"sapUiBarToggleItem\"),e.writeClasses(),e.write(\">\"),e.write(\"</div>\")},d=function(t,i){t.write(\"<div\");var a=i.getId()+\"-hoverItem\";if(t.writeAttribute(\"id\",\"\"+a),\"Min\"===i.getVisibleStatus()?(t.addStyle(\"top\",\"-\"+sap.ui.ux3.NotificationBar.HOVER_ITEM_HEIGHT+\"px\"),t.addStyle(\"display\",\"block\")):t.addStyle(\"display\",\"none\"),i.getDomRef()){var s=e(i.getDomRef()),r=s.width()+\"px\";t.addStyle(\"width\",r)}t.writeStyles(),t.addClass(\"sapUiNotiHover\"),t.writeClasses(),t.write(\">\"),t.write(\"</div>\")},o=function(e,t){t.getResizeEnabled()&&s(e,t),t.hasItems()&&(t.getVisibleStatus()==sap.ui.ux3.NotificationBarStatus.Max?l(e,t):n(e,t))},l=function(e,t){var i=t.getNotifiers(),a=t.getMessageNotifier(),s=\"\";if(e.write(\"<div\"),e.writeAttribute(\"id\",t.getId()+\"-containers\"),e.addClass(\"sapUiNotifierContainers\"),e.writeClasses(),e.write(\">\"),a&&a.hasItems()){a.destroyAggregation(\"views\",!0),s=a.getId()+\"-messageNotifierView\";var r=u(s,a);a.addAggregation(\"views\",r,!0),e.renderControl(r)}if(i.length>0)for(var d=0;d<i.length;d++)if(i[d].hasItems()){i[d].destroyAggregation(\"views\",!0),s=i[d].getId()+\"-notifierView\";var o=u(s,i[d]);i[d].addAggregation(\"views\",o,!0),e.renderControl(o)}e.write(\"</div\")},n=function(e,t){var i=t.getNotifiers(),a=t.getMessageNotifier();e.write(\"<ul\"),e.writeAttribute(\"id\",t.getId()+\"-notifiers\"),e.addClass(\"sapUiNotifiers\"),e.writeClasses(),e.write(\">\");for(var s=!1,r=0;r<i.length;r++)if(i[r].hasItems()){s=!0;break}var d=!(!a||!a.hasItems());s&&p(e,i),s&&d&&(e.write(\"<li\"),e.addClass(\"sapUiNotifierSeparator\"),e.writeClasses(),e.write(\">\"),e.write(\"&nbsp;\"),e.write(\"</li>\")),d&&f(e,a,t),e.write(\"</ul>\")},g=function(e,t){e.write(\"</div>\")},w=function(e,t,i){var a=t.getId();e.write(\"<li\"),e.writeElementData(t),e.addClass(\"sapUiNotifier\"),e.writeClasses(),e.writeAttribute(\"tabindex\",\"-1\"),e.writeAttribute(\"aria-describedby\",a+\"-description>\"),e.write(\">\"),c(e,t.getIcon(),i),e.write('<div id=\"'+a+'-description\"'),e.addStyle(\"display\",\"none\"),e.writeStyles(),e.write(\">\"),e.write(\"</div>\");var s=t.getMessages().length;s>0&&(e.write('<div id=\"'+a+'-counter\" role=\"tooltip\"'),e.addClass(\"sapUiNotifierMessageCount\"),i&&e.addClass(\"sapUiMessage\"),e.writeClasses(),e.write(\">\"),s>99&&(s=\">99\"),e.write(s),e.write(\"</div>\")),e.write(\"</li>\")},u=function(e,t){var i=new sap.ui.ux3.NotificationBar.NotifierView(e,{title:t.getTitle(),renderMode:\"maximized\"});t._bEnableMessageSelect&&i.addStyleClass(\"sapUiNotifierSelectable\");for(var a=t.getMessages(),s=0;s<a.length;s++){var r=a[s],d=new sap.ui.ux3.NotificationBar.MessageView(e+\"-messageView-\"+r.getId(),{text:r.getText(),timestamp:r.getTimestamp()});d._message=r,d.setIcon(r.getIcon()||r.getDefaultIcon(\"32x32\")),i.addMessage(d)}return i},p=function(e,t){for(var i=0;i<t.length;i++)w(e,t[i],!1)},c=function(e,i,a){if(null==i||\"\"==i){var s=new t({useIconTooltip:!1});return s.addStyleClass(\"sapUiNotifierIcon\"),a?s.setSrc(\"sap-icon://alert\"):s.setSrc(\"sap-icon://notification-2\"),void e.renderControl(s)}e.write('<img alt=\"\"'),e.addClass(\"sapUiNotifierIcon\"),e.writeClasses(),e.writeAttributeEscaped(\"src\",i),e.write(\">\")},f=function(e,t,i){w(e,t,!0),v(e,t,i)},v=function(e,t,i){if(t.hasItems()){var a=t.getMessages(),s=a[a.length-1],r=t._oMessageArea;r._message=s;var d=i.getId()+\"-inplaceMessage-\"+r._message.getId();if(e.write(\"<li\"),e.writeAttribute(\"id\",d),e.addClass(\"sapUiInPlaceMessage\"),e.writeClasses(),i._gapMessageArea){var o=i._gapMessageArea+\"px\";e.addStyle(\"margin-left\",o),e.writeStyles()}e.write(\">\"),\"\"!=s.getText()&&(e.write(\"<div\"),e.writeControlData(r),e.writeAttribute(\"tabindex\",\"-1\"),e.addClass(\"sapUiNotifierMessageText\"),e.addClass(\"sapUiInPlaceMessage\"),t._bEnableMessageSelect&&!r._message.getReadOnly()&&e.addClass(\"sapUiInPlaceMessageSelectable\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(s.getText()),e.write(\"</div>\")),\"\"!=s.getTimestamp()&&(e.write(\"<div\"),e.addClass(\"sapUiNotifierMessageTimestamp\"),e.addClass(\"sapUiInPlaceMessage\"),e.writeClasses(),e.write(\">\"),e.writeEscaped(s.getTimestamp()),e.write(\"</div>\")),e.write(\"</li>\")}}}(),i},!0);",
	"sap/ui/ux3/Notifier.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/Callout\",\"sap/ui/core/Element\",\"./library\"],function(e,t,s,i){\"use strict\";var o=s.extend(\"sap.ui.ux3.Notifier\",{metadata:{library:\"sap.ui.ux3\",properties:{icon:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},title:{type:\"string\",group:\"Misc\",defaultValue:null}},aggregations:{messages:{type:\"sap.ui.core.Message\",multiple:!0,singularName:\"message\"},views:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"view\",visibility:\"hidden\"}},events:{messageSelected:{parameters:{message:{type:\"sap.ui.core.Message\"},notifier:{type:\"sap.ui.ux3.Notifier\"}}}}}});return function(){var s=function(){this.fireEvent(\"_childControlCalling\",{type:\"openCallout\",callout:this._oCallout,notifier:this})},i=function(e){e.getSource()&&e.getSource().destroyContent(),this._oCallout&&this._oCallout.$().css(\"display\",\"none\")};o.prototype.hasItems=function(){return this.getMessages().length>0},o.prototype.init=function(){this._oCallout=new t(this.getId()+\"-callout\",{beforeOpen:e.proxy(s,this),open:function(e){this.$().css({position:\"fixed\",display:\"block\"})},close:e.proxy(i,this),collision:\"none\"}),this._oCallout.addStyleClass(\"sapUiNotifierCallout\"),sap.ui.Device.browser.mobile&&this._oCallout.setOpenDelay(0),this._oCallout.setMyPosition(\"begin bottom\"),this._oCallout.setAtPosition(\"begin top\"),this._oCallout.setTip=function(){t.prototype.setTip.apply(this,arguments);var e=this.$(\"arrow\");e.css(\"bottom\",\"-24px\"),sap.ui.getCore().getConfiguration().getRTL()||e.css(\"left\",\"6px\")},this.setTooltip(this._oCallout),this.setTooltip=function(){e.sap.log.warning(\"Setting toolstips for notifiers deactivated\")},this._proxyEnableMessageSelect=e.proxy(a,this),this.attachEvent(sap.ui.base.EventProvider.M_EVENTS.EventHandlerChange,this._proxyEnableMessageSelect)};var a=function(e){\"messageSelected\"===e.getParameter(\"EventId\")&&(\"listenerAttached\"===e.getParameter(\"type\")?this._bEnableMessageSelect=!0:\"listenerDetached\"===e.getParameter(\"type\")&&(this._bEnableMessageSelect=!1),this.fireEvent(\"_enableMessageSelect\",{enabled:this._bEnableMessageSelect,notifier:this}))};o.prototype.exit=function(e){this._oCallout=void 0,this._oMessageView&&(this._oMessageView.destroy(),delete this._oMessageView),this.detachEvent(sap.ui.base.EventProvider.M_EVENTS.EventHandlerChange,this._proxyEnableMessageSelect),delete this._proxyEnableMessageSelect},o.prototype.onclick=function(e){e.preventDefault(),this.$().trigger(\"mouseover\")};var n=function(e,t,s){var i=t?t.getLevel():sap.ui.core.MessageType.None;s.fireEvent(\"_childControlCalling\",{type:e,notifier:s,level:i,message:t,callout:s._oCallout})};o.prototype.addMessage=function(e){return this.addAggregation(\"messages\",e),n(\"added\",e,this),this},o.prototype.insertMessage=function(e,t){return this.insertAggregation(\"messages\",e,t),n(\"added\",e,this),this},o.prototype.removeMessage=function(e){var t=this.removeAggregation(\"messages\",e);return t&&n(\"removed\",t,this),t},o.prototype.removeAllMessages=function(){var e=this.removeAllAggregation(\"messages\");return e.length>0&&n(\"removed\",null,this),e},o.prototype.destroyMessages=function(){var e=this.getMessages().length;return this.destroyAggregation(\"messages\"),e>0&&n(\"removed\",null,this),this}}(),o},!0);",
	"sap/ui/ux3/Overlay.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/Popup\",\"./library\",\"./OverlayRenderer\"],function(t,e,o,s,i){\"use strict\";var n=e.extend(\"sap.ui.ux3.Overlay\",{metadata:{interfaces:[\"sap.ui.core.PopupInterface\"],library:\"sap.ui.ux3\",properties:{openButtonVisible:{type:\"boolean\",group:\"Misc\",defaultValue:!0},closeButtonVisible:{type:\"boolean\",group:\"Misc\",defaultValue:!0}},events:{close:{allowPreventDefault:!0,parameters:{id:{type:\"string\"}}},closed:{allowPreventDefault:!0,parameters:{id:{type:\"string\"}}},openNew:{parameters:{id:{type:\"string\"}}},open:{parameters:{id:{type:\"string\"}}}}}});return n.prototype.init=function(){var e=this;this._oPopup=new o(this,!1,!0),this._oPopup.attachOpened(function(o){var s=t.sap.byId(e._initialFocusId)[0];!s&&e._getShell()&&e.getOpenButtonVisible()?s=t.sap.domById(e._getOpenButtonId()):!s&&e._getShell()&&e.getCloseButtonVisible()?s=t.sap.domById(e._getCloseButtonId()):s||(s=e.$(\"content\").firstFocusableDomRef()),s||(s=e.$().firstFocusableDomRef()),s&&t.sap.focus(s)}),this._oPopup.attachClosed(function(t){e.fireClosed({id:e.getId()})}),this._overridePopupEventing()},n.prototype._overridePopupEventing=function(){this._oPopup.onmousedown=function(t){}},n.prototype._getShell=function(){var e=t(\".sapUiUx3Shell\").control();return e.length>0&&!this._oShell&&(this._oShell=e.length?e[0]:null),this._oShell},n.prototype._getCloseButtonId=function(){return this.getId()+\"-close\"},n.prototype._getOpenButtonId=function(){return this.getId()+\"-openNew\"},n.prototype._initDom=function(e,o,s){var i=t(\".sapUiUx3Shell\").control();this._oShell=i.length?i[0]:null,i=this._oShell,this.$().css(\"position\",\"fixed\"),i?(this._bFocusEventsRegistered=!0,i.syncWithCanvasSize(this.getId(),!0,e,o,s),this.$(\"firstFocusDummyPaneFw\").attr(\"tabindex\",\"0\").focusin(t.proxy(i.focusFirstHdr,i)),this.$(\"firstFocusDummyPaneBw\").attr(\"tabindex\",\"0\").focusin(t.proxy(i.focusLastTool,i)),this.$(\"LastFocusDummyPane\").attr(\"tabindex\",\"0\").focusin(t.proxy(i.focusPaneStart,i))):this.$().css(\"bottom\",\"0\").css(\"top\",\"0\").css(\"left\",\"0\").css(\"right\",\"0\")},n.prototype._cleanupDom=function(){this._oShell&&this._oShell.syncWithCanvasSize(this.getId(),!1),this._bFocusEventsRegistered&&(this._bFocusEventsRegistered=!1,this.$(\"firstFocusDummyPaneFw\").removeAttr(\"tabindex\").unbind(\"focusin\"),this.$(\"firstFocusDummyPaneBw\").removeAttr(\"tabindex\").unbind(\"focusin\"),this.$(\"LastFocusDummyPane\").removeAttr(\"tabindex\").unbind(\"focusin\"))},n.prototype.onAfterRendering=function(){var e=this._oPopup.getOpenState();e!==sap.ui.core.OpenState.OPEN&&e!==sap.ui.core.OpenState.OPENING||this._initDom(t.proxy(this._setFocusFirst,this),t.proxy(this._setFocusLast,this),t.proxy(this._applyChanges,this))},n.prototype.onBeforeRendering=function(){},n.prototype.exit=function(){this.close(),this._oPopup.destroy(),this._oPopup=null,this._oShell=null},n.prototype.open=function(e){this._initialFocusId=e,this._oPopup.isOpen()||(e&&this._oPopup.setInitialFocusId(e),this._oPreviousFocus=o.getCurrentFocusInfo(),this._oPopup.open(400),this._initDom(t.proxy(this._setFocusFirst,this),t.proxy(this._setFocusLast,this),t.proxy(this._applyChanges,this)),this.fireOpen({id:this.getId()}))},n.prototype.close=function(){this._oPopup.isOpen()&&(this._oPopup.close(400),t.sap.delayedCall(400,this,\"restorePreviousFocus\"),this._cleanupDom())},n.prototype.onclick=function(t){this._handleButtonEvent(t)},n.prototype.onsapselect=function(t){this._handleButtonEvent(t)},n.prototype._handleButtonEvent=function(t){var e=t.target.id;e===this._getCloseButtonId()?this.fireClose({id:this.getId()})&&this.close():e===this._getOpenButtonId()&&this.fireOpenNew({id:this.getId()})},n.prototype._getText=function(t,e){var o,s=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\");if(s&&(o=s.getText(t)),o&&e)for(var i=0;i<e.length;i++)o=o.replace(\"{\"+i+\"}\",e[i]);return o||t},n.prototype._setFocusFirst=function(){t.sap.focus(t.sap.domById(this._getOpenButtonId()))},n.prototype._setFocusLast=function(){t.sap.focus(t.sap.domById(this._getCloseButtonId()))},n.prototype._applyChanges=function(t){return this},n.prototype.isOpen=function(){return this._oPopup.isOpen()},n.prototype.restorePreviousFocus=function(){o.applyFocusInfo(this._oPreviousFocus)},n},!0);",
	"sap/ui/ux3/OverlayContainer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./Overlay\",\"./library\",\"./OverlayContainerRenderer\"],function(t,e,s,o){\"use strict\";var i=e.extend(\"sap.ui.ux3.OverlayContainer\",{metadata:{library:\"sap.ui.ux3\",defaultAggregation:\"content\",aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"}}}});return i.prototype._setFocusLast=function(){var e=this.$(\"content\").lastFocusableDomRef();!e&&this.getCloseButtonVisible()?e=this.getDomRef(\"close\"):!e&&this.getOpenButtonVisible()&&(e=this.getDomRef(\"openNew\")),t.sap.focus(e)},i.prototype._setFocusFirst=function(){this.getOpenButtonVisible()?t.sap.focus(this.getDomRef(\"openNew\")):this.getCloseButtonVisible()?t.sap.focus(this.getDomRef(\"close\")):t.sap.focus(this.$(\"content\").firstFocusableDomRef())},i},!0);",
	"sap/ui/ux3/OverlayContainerRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Renderer\",\"./OverlayRenderer\"],function(e,n,r){\"use strict\";var a=n.extend(r);return a.renderContent=function(e,n){var r=e;r.write(\"<div role='Main' class='sapUiUx3OCContent' id='\"+n.getId()+\"-content'>\");for(var a=n.getContent(),t=0;t<a.length;t++){var s=a[t];r.renderControl(s)}r.write(\"</div>\")},a.addRootClasses=function(e,n){e.addClass(\"sapUiUx3OC\")},a.addOverlayClasses=function(e,n){e.addClass(\"sapUiUx3OCOverlay\")},a},!0);",
	"sap/ui/ux3/OverlayDialog.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/IntervalTrigger\",\"./Overlay\",\"./library\",\"./OverlayDialogRenderer\"],function(t,e,i,s,o){\"use strict\";var n=i.extend(\"sap.ui.ux3.OverlayDialog\",{metadata:{library:\"sap.ui.ux3\",properties:{width:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:\"auto\"},height:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:\"auto\"}},aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"}}}});return n.prototype.init=function(){i.prototype.init.apply(this),this.setProperty(\"openButtonVisible\",!1),n.Trigger=new e(300)},n.prototype._setFocusLast=function(){var e=this.$(\"content\").lastFocusableDomRef();!e&&this.getCloseButtonVisible()&&(e=this.getDomRef(\"close\")),t.sap.focus(e)},n.prototype._setFocusFirst=function(){this.getCloseButtonVisible()?t.sap.focus(this.getDomRef(\"close\")):t.sap.focus(this.$(\"content\").firstFocusableDomRef())},n.prototype.setOpenButtonVisible=function(e){t.sap.log.warning(\"OverlayDialog does not support an openButton.\")},n.prototype.setWidth=function(t){return\"auto\"!=t&&\"inherit\"!=t||(t=\"auto\"),this.setProperty(\"width\",t)},n.prototype.setHeight=function(t){return\"auto\"!=t&&\"inherit\"!=t||(t=\"auto\"),this.setProperty(\"height\",t)},n.prototype.onBeforeRendering=function(){i.prototype.onBeforeRendering.apply(this,arguments),this._cleanup()},n.prototype.onAfterRendering=function(){i.prototype.onAfterRendering.apply(this,arguments),n.Trigger.addListener(this._checkChange,this)},n.prototype._cleanup=function(){n.Trigger.removeListener(this._checkChange,this),this.contentWidth=null,this.contentHeight=null,this.overlayWidth=null,this.overlayHeight=null},n.prototype.exit=function(){this._cleanup(),i.prototype.exit.apply(this,arguments)},n.prototype._checkChange=function(){if(this.getDomRef()){var t=this.$(\"content\"),e=this.$(),i=\"auto\"===this.getWidth(),s=\"auto\"===this.getHeight(),o=i?Math.round(e.width()/2):t.width(),n=s?Math.round(e.height()/2):t.height(),h=e.width(),r=e.height();if(o!=this.contentWidth||n!=this.contentHeight||h!=this.overlayWidth||r!=this.overlayHeight){t.css(\"left\",\"0\").css(\"right\",\"auto\").css(\"top\",\"0\").css(\"bottom\",\"auto\").css(\"width\",this.getWidth()).css(\"height\",this.getHeight()),this.contentWidth=o,this.contentHeight=n,this.overlayWidth=h,this.overlayHeight=r;var a=this.$(\"close\");this.contentWidth<this.overlayWidth?(t.css(\"left\",\"50%\"),t.css(\"right\",\"auto\"),t.css(\"margin-left\",Math.round(-1*this.contentWidth/2)+\"px\"),t.css(\"width\",s?this.contentWidth:this.getWidth()),a.css(\"right\",\"50%\"),a.css(\"margin-right\",Math.round(-1*this.contentWidth/2-10)+\"px\")):(t.css(\"left\",\"0\"),t.css(\"right\",\"10px\"),t.css(\"margin-left\",\"0\"),t.css(\"width\",\"auto\"),a.css(\"right\",\"0\"),a.css(\"margin-right\",\"0\")),this.contentHeight<this.overlayHeight-30?(t.css(\"top\",\"50%\"),t.css(\"bottom\",\"auto\"),t.css(\"margin-top\",Math.round(-1*this.contentHeight/2)+\"px\"),t.css(\"height\",s?this.contentHeight:this.getHeight()),a.css(\"top\",\"50%\"),a.css(\"margin-top\",Math.round(-1*this.contentHeight/2-10)+\"px\")):(t.css(\"top\",\"10px\"),t.css(\"bottom\",\"30px\"),t.css(\"margin-top\",\"0\"),t.css(\"height\",\"auto\"),a.css(\"top\",\"0\"),a.css(\"margin-top\",\"0\"))}}},n},!0);",
	"sap/ui/ux3/OverlayDialogRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Renderer\",\"./OverlayRenderer\"],function(e,n,r){\"use strict\";var a=n.extend(r);return a.renderContent=function(e,n){var r=e;r.write(\"<div role='Main' class='sapUiUx3ODContent' id='\"+n.getId()+\"-content'>\");for(var a=n.getContent(),t=0;t<a.length;t++){var s=a[t];r.renderControl(s)}r.write(\"</div>\")},a.addRootClasses=function(e,n){e.addClass(\"sapUiUx3OD\")},a.addOverlayClasses=function(e,n){e.addClass(\"sapUiUx3ODOverlay\")},a},!0);",
	"sap/ui/ux3/OverlayRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var a={};return a.render=function(e,a){var s=e;s.write(\"<div\"),s.writeControlData(a),s.addClass(\"sapUiUx3Overlay\"),this.addRootClasses&&this.addRootClasses(s,a),s.writeClasses(),s.write(\">\"),s.write(\"<div role='presentation'\"),s.addClass(\"sapUiUx3OverlayOverlay\"),this.addOverlayClasses&&this.addOverlayClasses(s,a),s.writeClasses(),s.write(\">\"),s.write(\"</div>\"),s.write(\"<span class='sapUiUx3OverlayFocusDummyPane' id='\"+a.getId()+\"-firstFocusDummyPaneFw'></span>\"),s.write(\"<span class='sapUiUx3OverlayFocusDummyPane' id='\"+a.getId()+\"-firstFocusDummyPaneBw'></span>\"),a.getOpenButtonVisible()&&s.write('<a role=\"button\" aria-disabled=\"false\" class=\\'sapUiUx3OverlayOpenButton\\' id=\\''+a.getId()+'-openNew\\' tabindex=\"0\" title=\"'+a._getText(\"OVERLAY_OPEN_BUTTON_TOOLTIP\")+'\">'+a._getText(\"OVERLAY_OPEN_BUTTON_TEXT\")+\"</a>\"),a.getCloseButtonVisible()&&s.write('<a role=\"button\" aria-disabled=\"false\" class=\\'sapUiUx3OverlayCloseButton\\' id=\\''+a.getId()+\"-close' tabindex=\\\"0\\\" aria-label='\"+a._getText(\"OVERLAY_CLOSE_BUTTON_TOOLTIP\")+\"'></a>\"),this.renderContent&&this.renderContent(s,a),s.write(\"<span class='sapUiUx3OverlayFocusDummyPane' id='\"+a.getId()+\"-LastFocusDummyPane'></span>\"),s.write(\"</div>\")},a},!0);",
	"sap/ui/ux3/QuickView.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/CalloutBase\",\"sap/ui/core/delegate/ItemNavigation\",\"./ActionBar\",\"./library\",\"./QuickViewRenderer\"],function(t,e,i,o,n,a){\"use strict\";var r=e.extend(\"sap.ui.ux3.QuickView\",{metadata:{library:\"sap.ui.ux3\",properties:{type:{type:\"string\",group:\"Misc\",defaultValue:null},firstTitle:{type:\"string\",group:\"Misc\",defaultValue:null},firstTitleHref:{type:\"string\",group:\"Misc\",defaultValue:null},secondTitle:{type:\"string\",group:\"Misc\",defaultValue:null},icon:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},width:{type:\"sap.ui.core.CSSSize\",group:\"Dimension\",defaultValue:null},showActionBar:{type:\"boolean\",group:\"Misc\",defaultValue:!0},followState:{type:\"sap.ui.ux3.FollowActionState\",group:\"Misc\",defaultValue:sap.ui.ux3.FollowActionState.Default},flagState:{type:\"boolean\",group:\"Misc\",defaultValue:!1},favoriteState:{type:\"boolean\",group:\"Misc\",defaultValue:!1},favoriteActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},updateActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},followActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},flagActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},openActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0}},aggregations:{content:{type:\"sap.ui.core.Element\",multiple:!0,singularName:\"content\"},actions:{type:\"sap.ui.ux3.ThingAction\",multiple:!0,singularName:\"action\"},actionBar:{type:\"sap.ui.ux3.ActionBar\",multiple:!1}},events:{actionSelected:{parameters:{id:{type:\"string\"},action:{type:\"sap.ui.ux3.ThingAction\"},newState:{type:\"string\"}}},feedSubmit:{parameters:{text:{type:\"string\"}}},navigate:{allowPreventDefault:!0,parameters:{href:{type:\"string\"}}}}}});return r.prototype.init=function(){function i(t){var e=t.getParameters();this.fireActionSelected(e)}function n(t){var e=t.getParameters();this.fireFeedSubmit(e)}var a;e.prototype.init.call(this),this.getActionBar()||(a=new o,a.attachActionSelected(t.proxy(i,this)),a.attachFeedSubmit(t.proxy(n,this)),this.setAggregation(\"actionBar\",a,!0))},r.prototype.onmouseover=function(e){var i=this._getPopup();if(i.isOpen()&&i.getContent()==this)return void(this.sCloseNowTimeout&&(t.sap.clearDelayedCall(this.sCloseNowTimeout),this.sCloseNowTimeout=null));sap.ui.core.TooltipBase.prototype.onmouseover.call(this,e)},r.prototype.onAfterRendering=function(){var t=this.getDomRef(),e=[],o=this.$(\"title\");e.push(o),o=this.$(\"link\"),o.length||(o=this.$(\"name\")),o.length&&(e.push(o),o=this.$(\"descr\"),o.length&&e.push(o),this.oItemNavigation||(this.oItemNavigation=new i(null,null,!1),this.addDelegate(this.oItemNavigation)),this.oItemNavigation.setRootDomRef(t),this.oItemNavigation.setItemDomRefs(e),this.oItemNavigation.setCycling(!1),this.oItemNavigation.setSelectedIndex(1),this.oItemNavigation.setPageSize(e.length))},r.prototype.onclick=function(t){var e=t.target;e&&e.hasAttribute(\"href\")&&(this.fireEvent(\"navigate\",{href:e.href},!0,!1)||t.preventDefault())},r.prototype.exit=function(){this.oItemNavigation&&(this.removeDelegate(this.oItemNavigation),this.oItemNavigation.destroy(),delete this.oItemNavigation)},r.prototype.insertAction=function(t,e){return this.getActionBar()&&this.getActionBar().insertBusinessAction(t,e),this},r.prototype.addAction=function(t){return this.getActionBar()&&this.getActionBar().addBusinessAction(t),this},r.prototype.removeAction=function(t){return this.getActionBar()&&this.getActionBar().removeBusinessAction(t),this},r.prototype.removeAllActions=function(){return this.getActionBar()&&this.getActionBar().removeAllBusinessActions(),this},r.prototype.getActions=function(){return this.getActionBar()&&this.getActionBar().getBusinessActions(),this},r.prototype.destroyActions=function(){return this.getActionBar()&&this.getActionBar().destroyBusinessActions(),this},r.prototype.setFollowState=function(t){return this.getActionBar()&&this.getActionBar().setFollowState(t),this},r.prototype.getFollowState=function(){var t=null;return this.getActionBar()&&(t=this.getActionBar().getFollowState()),t},r.prototype.setFlagState=function(t){return this.getActionBar()&&this.getActionBar().setFlagState(t),this},r.prototype.getFlagState=function(){var t=null;return this.getActionBar()&&(t=this.getActionBar().getFlagState()),t},r.prototype.setFavoriteState=function(t){return this.getActionBar()&&this.getActionBar().setFavoriteState(t),this},r.prototype.getFavoriteState=function(){var t=null;return this.getActionBar()&&(t=this.getActionBar().getFavoriteState()),t},r.prototype.setFavoriteActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowFavorite(t),this},r.prototype.getFavoriteActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowFavorite()),t},r.prototype.setFlagActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowFlag(t),this},r.prototype.getFlagActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowFlag()),t},r.prototype.setUpdateActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowUpdate(t),this},r.prototype.getUpdateActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowUpdate()),t},r.prototype.setFollowActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowFollow(t),this},r.prototype.getFollowActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowFollow()),t},r.prototype.setOpenActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowOpen(t),this},r.prototype.getOpenActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowOpen()),t},r.prototype.setIcon=function(t){return this.setProperty(\"icon\",t),this.getActionBar()&&this.getActionBar().setThingIconURI(t),this},r.prototype.setActionBar=function(t){return this.setAggregation(\"actionBar\",t,!0),this.getIcon()&&this.getActionBar()&&this.getActionBar().setThingIconURI(this.getIcon()),this},r},!0);",
	"sap/ui/ux3/QuickViewRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/CalloutBaseRenderer\",\"sap/ui/core/Renderer\",\"sap/ui/core/IconPool\"],function(t,e,i,r){\"use strict\";var a=i.extend(e);return a.renderContent=function(t,e){var i,a=t,s=sap.ui.getCore().getConfiguration().getAccessibility(),n=e.getType(),d=e.getFirstTitle(),o=e.getFirstTitleHref(),w=e.getIcon(),l=e.getSecondTitle(),c=e.getWidth(),u=e.getId(),p=e.getTooltip_AsString();a.write(\"<div\"),p&&a.writeAttributeEscaped(\"title\",p),s&&(a.writeAttribute(\"role\",\"dialog\"),a.writeAttribute(\"aria-labelledby\",u+\"-title\")),a.addClass(\"sapUiUx3QV\"),a.writeClasses(),c&&(a.addStyle(\"width\",c),a.writeStyles()),a.write(\">\"),a.write(\"<div\"),a.writeAttribute(\"id\",u+\"-title\"),a.writeAttribute(\"tabindex\",\"-1\"),a.addClass(\"sapUiUx3QVHeader\"),a.writeClasses(),a.write(\">\"),a.writeEscaped(n),a.write(\"</div>\"),(w||d||l)&&(a.write(\"<div\"),s&&a.writeAttribute(\"role\",\"heading\"),a.addClass(\"sapUiUx3QVHeading\"),a.writeClasses(),a.write(\">\"),w&&(r.isIconURI(w)&&(i={title:d,tabindex:\"-1\"}),a.writeIcon(w,\"sapUiUx3QVIcon\",i)),a.write(\"<span\"),a.writeAttribute(\"id\",u+\"-name\"),s&&l&&a.writeAttribute(\"aria-describedby\",u+\"-descr\"),a.addClass(\"sapUiUx3QVTitle1\"),a.writeClasses(),a.write(\">\"),o&&(a.write(\"<a\"),a.writeAttribute(\"id\",u+\"-link\"),a.writeAttributeEscaped(\"href\",o),a.writeAttribute(\"tabindex\",\"-1\"),a.write(\">\")),a.writeEscaped(d||\"\"),o&&a.write(\"</a>\"),a.write(\"</span>\"),l&&(a.write(\"<br><span\"),a.writeAttribute(\"id\",u+\"-descr\"),a.writeAttribute(\"tabindex\",\"-1\"),a.addClass(\"sapUiUx3QVTitle2\"),a.writeClasses(),a.write(\">\"),a.writeEscaped(l),a.write(\"</span>\")),a.write(\"</div>\")),a.write('<div id=\"'+u+'-content\">'),this.renderBody(a,e),a.write(\"</div>\"),a.write(\"</div>\"),e.getShowActionBar()&&e.getActionBar()&&a.renderControl(e.getActionBar())},a.renderBody=function(t,e){for(var i=e.getContent(),r=0;r<i.length;r++){if(t.write('<div class=\"sapUiUx3QVBody\">'),i[r]instanceof sap.ui.core.Control)t.renderControl(i[r]);else if(i[r].getContent&&\"function\"==typeof i[r].getContent)for(var a=i[r].getContent(),s=0;s<a.length;s++)a[s]instanceof sap.ui.core.Control&&t.renderControl(a[s]);t.write(\"</div>\")}},a},!0);",
	"sap/ui/ux3/Shell.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/commons/Menu\",\"sap/ui/core/Control\",\"sap/ui/core/theming/Parameters\",\"./library\",\"./ShellRenderer\"],function(e,t,s,a,o,i){\"use strict\";var n=s.extend(\"sap.ui.ux3.Shell\",{metadata:{library:\"sap.ui.ux3\",properties:{appTitle:{type:\"string\",group:\"Misc\",defaultValue:null},appIcon:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},appIconTooltip:{type:\"string\",group:\"Misc\",defaultValue:null},showLogoutButton:{type:\"boolean\",group:\"Misc\",defaultValue:!0},logoutButtonTooltip:{type:\"string\",group:\"Accessibility\",defaultValue:null},showSearchTool:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showInspectorTool:{type:\"boolean\",group:\"Misc\",defaultValue:!1,deprecated:!0},showFeederTool:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showTools:{type:\"boolean\",group:\"Misc\",defaultValue:!0},showPane:{type:\"boolean\",group:\"Misc\",defaultValue:!0},headerType:{type:\"sap.ui.ux3.ShellHeaderType\",group:\"Misc\",defaultValue:sap.ui.ux3.ShellHeaderType.Standard},designType:{type:\"sap.ui.ux3.ShellDesignType\",group:\"Misc\",defaultValue:sap.ui.ux3.ShellDesignType.Standard},paneWidth:{type:\"int\",group:\"Misc\",defaultValue:250},applyContentPadding:{type:\"boolean\",group:\"Appearance\",defaultValue:!0},fullHeightContent:{type:\"boolean\",group:\"Appearance\",defaultValue:!1},allowOverlayHeaderAccess:{type:\"boolean\",group:\"Appearance\",defaultValue:!1}},defaultAggregation:\"content\",aggregations:{worksetItems:{type:\"sap.ui.ux3.NavigationItem\",multiple:!0,singularName:\"worksetItem\"},paneBarItems:{type:\"sap.ui.core.Item\",multiple:!0,singularName:\"paneBarItem\"},paneContent:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"paneContent\"},content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"},toolPopups:{type:\"sap.ui.ux3.ToolPopup\",multiple:!0,singularName:\"toolPopup\"},headerItems:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"headerItem\"},notificationBar:{type:\"sap.ui.ux3.NotificationBar\",multiple:!1},_paneOverflowMenu:{type:\"sap.ui.commons.Menu\",multiple:!1,visibility:\"hidden\"}},associations:{selectedWorksetItem:{type:\"sap.ui.ux3.NavigationItem\",multiple:!1}},events:{worksetItemSelected:{allowPreventDefault:!0,parameters:{id:{type:\"string\"},item:{type:\"sap.ui.ux3.NavigationItem\"},key:{type:\"string\"}}},paneBarItemSelected:{parameters:{id:{type:\"string\"},item:{type:\"sap.ui.core.Item\"},key:{type:\"string\"}}},logout:{},search:{},feedSubmit:{},paneClosed:{parameters:{id:{type:\"string\"}}}}}});return n.WSI_MENU_DELAY=200,n.WSI_OVERFLOW_SCROLL_STEP=250,n.TOOL_PREFIX=\"-tool-\",n.FIRST_RENDERING=!0,n.SIDE_BAR_BASE_WIDTH=null,n.PANE_OVERFLOW_BUTTON_HEIGHT=null,n.prototype.init=function(){this._iOpenPaneIndex=-1,this._sOpenWsiId=null,this._bPreviousScrollRight=!1,this._bPreviousScrollLeft=!1,this._sSelectedWorksetId=null,this._sSelectedFacetId=null,this._aSyncRefStack=[],this._mSyncRefs={},this._oWorksetBar=new sap.ui.ux3.NavigationBar(this.getId()+\"-wsBar\",{toplevelVariant:!0,select:[this._handleWorksetBarSelect,this]}).setParent(this),this._oFacetBar=new sap.ui.ux3.NavigationBar(this.getId()+\"-facetBar\",{select:[this._handleFacetBarSelect,this]}).setParent(this),this.setAggregation(\"_paneOverflowMenu\",new t);var e=this;this._checkResizeClosure=function(){e._checkResize()},this.currentToolPaletteWidth=0,this._updateThemeVariables()},n.prototype.exit=function(){this._oWorksetBar&&(this._oWorksetBar.destroy(),delete this._oWorksetBar),this._oFacetBar&&(this._oFacetBar.destroy(),delete this._oFacetBar),this._oSearchField=null,e(window).unbind(\"resize\",this._checkResizeClosure)},n.prototype.onBeforeRendering=function(){if(this._beforeRenderingToolPalette(),this.$(\"focusDummyPane\").unbind(\"focusin\"),window.FileReader){this.$(\"hdr\").unbind(\"dragover\",this._handleDragover).unbind(\"dragend\",this._handleDragend).unbind(\"drop\",this._handleDrop);this.$(\"bgImg\").unbind(\"dragover\",e.proxy(this._handleDragover)).unbind(\"dragend\",this._handleDragend).unbind(\"drop\",this._handleDrop)}},n.prototype.onAfterRendering=function(){if(this._afterRenderingToolPalette(),this._topSyncRefId&&this._mSyncRefs[this._topSyncRefId].focusLast&&this.$(\"focusDummyPane\").focusin(this._mSyncRefs[this._topSyncRefId].focusLast),window.FileReader){this.$(\"hdr\").bind(\"dragover\",e.proxy(this._handleDragover,this)).bind(\"dragend\",e.proxy(this._handleDragend,this)).bind(\"drop\",e.proxy(this._handleDrop,this));this.$(\"bgImg\").bind(\"dragover\",e.proxy(this._handleDragover,this)).bind(\"dragend\",e.proxy(this._handleDragend,this)).bind(\"drop\",e.proxy(this._handleDrop,this))}var t=this._oFacetBar.getAssociatedItems().length>0;this.$(\"facetBar\").css(\"display\",t?\"block\":\"none\"),this._adaptContentHeight(),this._bRtl=sap.ui.getCore().getConfiguration().getRTL(),this._getPersonalization().hasChanges()&&this._getPersonalization().applySettings(this._getPersonalization().oSettings),this._oPaneItemNavigation||(this._oPaneItemNavigation=(new sap.ui.core.delegate.ItemNavigation).setCycling(!1),this.addDelegate(this._oPaneItemNavigation));var s=this.$(\"paneBarEntries\");this._updatePaneBarItemNavigation(s),this._setNotifyVisibility(),n.FIRST_RENDERING&&e(window).bind(\"resize\",this._checkResizeClosure),this._checkResize(),n.FIRST_RENDERING=!1,sap.ui.Device.browser.firefox&&17==sap.ui.Device.browser.version&&e.sap.delayedCall(500,this,this._checkResize)},n.prototype._updateThemeVariables=function(){n.SIDE_BAR_BASE_WIDTH=parseInt(a.get(\"sapUiUx3ShellSideBarBaseWidth\"),10),n.PANE_OVERFLOW_BUTTON_HEIGHT=parseInt(a.get(\"sapUiUx3ShellPaneOverflowButtonHeight\"),10),n.PANE_OVERFLOW_BUTTON_MAX_HEIGHT=n.PANE_OVERFLOW_BUTTON_HEIGHT},n.prototype._checkResize=function(){this.getDomRef()&&(e.sap.clearDelayedCall(this._checkResizeDelayId),this._checkResizeDelayId=e.sap.delayedCall(100,this,function(){this._rerenderPaneBarItems(),this._checkToolPaletteSize()}))},n.prototype._checkToolPaletteSize=function(t){if(this.getDomRef()){void 0===t&&(t=!this.getShowTools());var s=this.$(\"tp\"),a=1,o=9999999,i=0,r=!0;t&&(a=0,r=!1);do{var p=a*n.SIDE_BAR_BASE_WIDTH,l=Math.floor(p/2),h=Math.floor(p/4),d=this._bRtl?\"right\":\"left\";this.$(\"canvas\").css(d,p+\"px\"),this.$(\"canvasBackground\").css(d,p+\"px\"),this.$(\"wBar\").css(\"margin-\"+d,p+\"px\");var c={};c[d]=p+\"px\",this.$(\"notify\").css(c),s.css(\"width\",p+\"px\");var c={};if(c.width=l+\"px\",c[\"margin-\"+d]=h+\"px\",this.$(\"tp-separator\").css(c),!r)break;if(sap.ui.core.RenderManager.forceRepaint(s[0]),(i=s.children().last()[0].offsetTop)>=o)a--,r=!1;else if(o=i,++a>10){e.sap.log.error(\"The ToolPalette is growing too much, this must be a bug.\");break}}while(i>s.height());this.currentToolPaletteWidth=this.getShowTools()?p:0,this._updateOverlaysOnToolPaletteChange()}},n.prototype._updateOverlaysOnToolPaletteChange=function(){var e=this._getSyncRefs();this._bRtl?e.css(\"right\",this.currentToolPaletteWidth+\"px\"):e.css(\"left\",this.currentToolPaletteWidth+\"px\")},n.prototype._updatePaneBarItemNavigation=function(e){this._oPaneItemNavigation.setRootDomRef(e[0]);var t=e.children().toArray();this._oPaneItemNavigation.setItemDomRefs(t),this._oPaneItemNavigation.getFocusedIndex()>t.length&&this._oPaneItemNavigation.setFocusedIndex(-1),this._checkPaneBarOverflow(e)},n.prototype._checkPaneBarOverflow=function(t){e.sap.clearDelayedCall(this._checkPaneBarOverflowDelayId),this._checkPaneBarOverflowDelayId=e.sap.delayedCall(200,this,function(){this._delayedCheckPaneBarOverflow(t)})},n.prototype._delayedCheckPaneBarOverflow=function(t){if(t||(t=this.$(\"paneBarEntries\")),0==t.length)return void this._checkPaneBarOverflow();var s=t.parent().height()-(this._bRtl?t.innerHeight():0),a=0,o=t.children();o.css(\"display\",\"inline-block\");for(var i=!1,n=o.length,r=n-1;r>=0;--r){var p=o[r];a=this._bRtl?0-p.offsetLeft:p.offsetLeft+p.offsetWidth;var l=a<s;e(p).css(\"display\",l?\"inline-block\":\"none\"),sap.ui.getCore().byId(p.id+\"-overflow\").setVisible(!l),l||(i=!0)}var h=this.$(\"paneBarOverflowButton\");i?h.css(\"display\",\"block\"):(h.css(\"display\",\"none\"),sap.ui.Device.browser.firefox&&17==sap.ui.Device.browser.version&&sap.ui.core.RenderManager.forceRepaint(document.getElementsByTagName(\"body\")[0])),this._changeOverflowButton()&&this._checkPaneBarOverflow()},n.prototype._adaptOverflowButtonHeight=function(){var e=this.$(\"paneBarOverflowButton\"),t=this.$(\"paneBarOverflowWrapper\"),s=this.$(\"paneBarOverflowText\"),a=this.$(\"paneBarRight\");s.css(\"width\",\"\");var o=n.PANE_OVERFLOW_BUTTON_HEIGHT,i=s[0].scrollWidth+5;return i>n.PANE_OVERFLOW_BUTTON_MAX_HEIGHT?n.PANE_OVERFLOW_BUTTON_HEIGHT=n.PANE_OVERFLOW_BUTTON_MAX_HEIGHT:n.PANE_OVERFLOW_BUTTON_HEIGHT=i,e.css(\"height\",n.PANE_OVERFLOW_BUTTON_HEIGHT),t.css(\"width\",n.PANE_OVERFLOW_BUTTON_HEIGHT),s.css(\"width\",\"100%\"),a.css(\"padding-bottom\",n.PANE_OVERFLOW_BUTTON_HEIGHT+\"px\"),o!=n.PANE_OVERFLOW_BUTTON_HEIGHT},n.prototype._changeOverflowButton=function(){var e=null;this._sOpenPaneId&&(e=sap.ui.getCore().byId(this._sOpenPaneId+\"-overflow\"));var t=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\").getText(\"SHELL_MORE_BUTTON\"),s=!1;e&&e.getVisible()&&(t=e.getText(),s=!0),t=t.toUpperCase();var a=this.$(\"paneBarOverflowText\");return a.text(t),a.attr(\"title\",t),a.toggleClass(\"sapUiUx3ShellPaneEntrySelected\",s),this._adaptOverflowButtonHeight()},n.prototype._getPaneOverflowMenu=function(){return this.getAggregation(\"_paneOverflowMenu\")},n.prototype.getFocusInfo=function(){try{var e=document.activeElement;return e?{sFocusId:e.id,oFocusedElement:e}:{}}catch(e){return{}}},n.prototype.applyFocusInfo=function(t){var s=e.sap.domById(t.sFocusId)||t.oFocusedElement;e.sap.focus(s)},n._updateToolIcon=function(t){if(t&&t.firstChild){var s,a=e(t),o=t.id.substr(t.id.indexOf(n.TOOL_PREFIX)+6),i=sap.ui.getCore().byId(o);s=a.is(\".sapUiUx3ShellToolSelected\")?i.getIconSelected():a.is(\".sapUiUx3ShellToolHover\")?i.getIconHover():i.getIcon(),t.firstChild.src=s}},n.prototype.onclick=function(e){this.onUserActivation(e)},n.prototype.onsapspace=function(e){this.onUserActivation(e)},n.prototype.onsapenter=function(e){this.onUserActivation(e)},n.prototype.onUserActivation=function(e){var t=e.target.id,s=e.target.parentNode,a=this.getId();if(e.target.className&&e.target.className.indexOf&&e.target.className.indexOf(\"sapUiUx3ShellHeader-logout\")>-1)this.fireLogout();else if(s&&s.parentNode&&s.parentNode.className&&s.parentNode.className.indexOf&&s.parentNode.className.indexOf(\"sapUiUx3ShellToolPaletteArea\")>-1)this._handleToolItemClick(t);else if(s&&s.parentNode&&s.parentNode.parentNode&&s.parentNode.parentNode.className&&s.parentNode.parentNode.className.indexOf&&s.parentNode.parentNode.className.indexOf(\"sapUiUx3ShellToolPaletteArea\")>-1)this._handleToolItemClick(s.id);else if(t===a+\"-paneBarOverflowText\"){var o=this.$(\"paneBarOverflowButton\")[0];this._getPaneOverflowMenu().open(!0,o,(this._bRtl?\"left\":\"right\")+\" bottom\",\"center center\",o)}else t&&s&&s.className&&s.className.indexOf&&s.className.indexOf(\"sapUiUx3ShellPaneEntries\")>-1&&this._handlePaneBarItemClick(t)},n.prototype._handleWorksetBarSelect=function(e){this._handleWorksetItemClick(e.getParameter(\"item\"))||e.preventDefault()},n.prototype._handleFacetBarSelect=function(e){this._handleWorksetItemClick(e.getParameter(\"item\"))||e.preventDefault()},n.prototype._handleWorksetItemClick=function(e){var t=e.getParent(),s=e.getId(),a=s,o=!0;if(t instanceof n){if(s!=this._sSelectedWorksetId){var i=e.getSubItems();if(i.length>0&&(a=i[0].getId()),o=this._fireWorksetItemSelected(a)){this._sSelectedWorksetId=s,i.length>0?(this._sSelectedFacetId=i[0].getId(),s=this._sSelectedFacetId):this._sSelectedFacetId=null;var i=e.getSubItems();this._oFacetBar.setAssociatedItems(i,!0);var r=this.$(\"facetBar\"),p=this._calcFacetBarHeight(r);i.length>0?(this._oFacetBar.isSelectedItemValid()||(this._oFacetBar.setSelectedItem(i[0]),this._sSelectedFacetId=i[0].getId()),r.slideDown(),this._adaptContentHeight(null,!0,p)):(this._oFacetBar.setSelectedItem(null),r.slideUp(),this._adaptContentHeight(null,!0,p))}}}else s!=this._sSelectedFacetId&&(o=this._fireWorksetItemSelected(a))&&(this._sSelectedFacetId=s);return o},n.prototype._fireWorksetItemSelected=function(e){var t=sap.ui.getCore().byId(e),s=t?t.getKey():null,a=this.fireWorksetItemSelected({id:e,item:t,key:s});return a&&this.setAssociation(\"selectedWorksetItem\",e,!0),a},n.prototype._closeCurrentToolPopup=function(){var t;if(this._oOpenToolPopup){if(t=this._oOpenToolPopup.getId(),e.sap.byId(this.getId()+n.TOOL_PREFIX+this._oOpenToolPopup.getId()).removeClass(\"sapUiUx3ShellToolSelected\").attr(\"aria-pressed\",\"false\"),t===this.getId()+\"-feederTool\"){var s=sap.ui.getCore().byId(this.getId()+\"-feeder\");s.setText(\"\"),s.rerender()}this._oOpenToolPopup.close(),this._oOpenToolPopup=null}return t},n.prototype._handleToolItemClick=function(t){var s,a=this._closeCurrentToolPopup(),o=t.substr(t.indexOf(n.TOOL_PREFIX)+6);if((s=o==this.getId()+\"-searchTool\"?this._getSearchTool():o==this.getId()+\"-feederTool\"?this._getFeederTool():sap.ui.getCore().byId(o))&&s.getId()!=a){this._oOpenToolPopup=s,s.setPosition(sap.ui.core.Popup.Dock.BeginTop,sap.ui.core.Popup.Dock.EndTop,e.sap.domById(t),\"13 -6\",\"fit\"),s.open(),e.sap.byId(t).addClass(\"sapUiUx3ShellToolSelected\").attr(\"aria-pressed\",\"true\"),n._updateToolIcon(e.sap.domById(t));var i=this,r=function(a){s.detachClosed(r),i._oOpenToolPopup&&i._oOpenToolPopup.getId()===a.getParameter(\"id\")&&i._closeCurrentToolPopup(),e.sap.byId(t).removeClass(\"sapUiUx3ShellToolSelected\"),n._updateToolIcon(e.sap.domById(t))};s.attachClosed(r)}else s.getId()==a&&n._updateToolIcon(e.sap.domById(t))},n.prototype._hasDarkDesign=function(){return this.getDesignType()!==sap.ui.ux3.ShellDesignType.Light&&this.getDesignType()!==sap.ui.ux3.ShellDesignType.Crystal},n.prototype._getSearchTool=function(){if(!this._oSearchPopup){var e=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\");this._oSearchPopup=new sap.ui.ux3.ToolPopup(this.getId()+\"-searchTool\",{tooltip:e.getText(\"SHELL_SEARCH\")}).addStyleClass(\"sapUiUx3TP-search\");var t=this._hasDarkDesign();this._oSearchPopup.setInverted(t);var s=this,a=new sap.ui.commons.SearchField(this.getId()+\"-searchField\",{enableListSuggest:!1,search:function(e){s.fireSearch({text:e.getParameter(\"query\")})}}),o=new sap.ui.commons.Label({text:e.getText(\"SHELL_SEARCH_LABEL\")+\":\"}).setLabelFor(a);this._oSearchPopup.addContent(o).addContent(a),this._oSearchPopup.attachOpen(function(){window.setTimeout(function(){a.focus()},100)}),this._oSearchField=a}return this._oSearchPopup},n.prototype.getSearchField=function(){return this._oSearchField||this._getSearchTool(),this._oSearchField},n.prototype._getFeederTool=function(){if(!this._oFeederPopup){var e=this,t=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\");this._oFeederPopup=new sap.ui.ux3.ToolPopup(this.getId()+\"-feederTool\",{tooltip:t.getText(\"SHELL_FEEDER\")}).addStyleClass(\"sapUiUx3TP-feeder\");var s=this._hasDarkDesign();this._oFeederPopup.setInverted(s);var a=new sap.ui.ux3.Feeder(this.getId()+\"-feeder\",{type:sap.ui.ux3.FeederType.Medium,submit:function(t){e.fireFeedSubmit({text:t.getParameter(\"text\")}),a.setText(\"\"),a.rerender(),e._oFeederPopup.close()}});this._oFeederPopup.setInitialFocus(this.getId()+\"-feeder\"),this._oFeederPopup.attachClose(function(){a.setText(\"\")}),this._oFeederPopup.addContent(a)}return this._oFeederPopup},n.prototype.openPane=function(t){var s=this;e.sap.assert(\"string\"==typeof t,\"sPaneId must be given as string\");var a=sap.ui.getCore().byId(t);if(a&&t!=this._sOpenPaneId&&this.getShowPane()){var o;o=a?\"\"==a.getKey()?null:a.getKey():null,this.firePaneBarItemSelected({id:t,item:a,key:o});var i=e.sap.byId(t);i.siblings().removeClass(\"sapUiUx3ShellPaneEntrySelected\"),i.addClass(\"sapUiUx3ShellPaneEntrySelected\"),this._sOpenPaneId?e.sap.byId(this.getId()+\"-pb_\"+this._sOpenPaneId).removeClass(\"sapUiUx3ShellPaneEntrySelected\"):this._openPane(function(){s.focusPaneStart()}),this._sOpenPaneId=t}return this},n.prototype.closePane=function(){return this._closePane(),this},n.prototype.isPaneOpen=function(){return null!=this._sOpenPaneId},n.prototype._handlePaneBarItemClick=function(e){e===this._sOpenPaneId?this.closePane():this.openPane(e),this._checkPaneBarOverflow()},function(){n._SHELL_OFFSET_RIGHT=0,n.prototype._closePane=function(t){if(!this._sOpenPaneId)return void(t&&t());var s=this._sOpenPaneId,a=this,o=this.getId(),i=this.getShowPane()?e.sap.byId(o+\"-paneBarRight\").outerWidth()+n._SHELL_OFFSET_RIGHT:n._SHELL_OFFSET_RIGHT,r={};r[this._bRtl?\"left\":\"right\"]=i+\"px\";var p={};p[this._bRtl?\"marginLeft\":\"marginRight\"]=i-n._SHELL_OFFSET_RIGHT+\"px\",e.sap.byId(o+\"-content\").css(\"overflow-x\",\"hidden\"),e.sap.byId(o+\"-canvas\").stop().animate(r),e.sap.byId(o+\"-notify\").stop().animate(r),this._getSyncRefs().stop(!1,!0).animate(r),e.sap.byId(o+\"-wBar\").stop().animate(p),e.sap.byId(o+\"-paneBar\").removeClass(\"sapUiUx3ShellPaneBarOpened\").addClass(\"sapUiUx3ShellPaneBarClose\"),e.sap.byId(o+\"-canvasBackground\").removeClass(\"sapUiUx3ShellCanvasBackgroundOpen\").addClass(\"sapUiUx3ShellCanvasBackgroundClosed\").stop().animate(r,function(){e.sap.byId(o+\"-paneBar\").removeClass(\"sapUiUx3ShellPaneBarOpen\"),e.sap.byId(o+\"-content\").css(\"overflow-x\",\"\"),t&&t(),a.firePaneClosed({id:s})}),e.sap.byId(this._sOpenPaneId).removeClass(\"sapUiUx3ShellPaneEntrySelected\"),this._sOpenPaneId=null},n.prototype._openPane=function(t){var s=this.getId(),a=this.getPaneWidth(),o=e.sap.byId(s+\"-paneBarRight\").outerWidth();e.sap.byId(s+\"-content\").css(\"overflow-x\",\"hidden\"),this._bRtl?(e.sap.byId(s+\"-paneBar\").removeClass(\"sapUiUx3ShellPaneBarClose\").addClass(\"sapUiUx3ShellPaneBarOpen\"),e.sap.byId(s+\"-wBar\").stop().animate({marginLeft:a+o+\"px\"}),e.sap.byId(s+\"-canvas\").stop().animate({left:a+o+n._SHELL_OFFSET_RIGHT+\"px\"}),e.sap.byId(s+\"-notify\").stop().animate({left:a+o+n._SHELL_OFFSET_RIGHT+\"px\"}),this._getSyncRefs().stop(!1,!0).animate({left:a+o+n._SHELL_OFFSET_RIGHT+\"px\"}),e.sap.byId(s+\"-canvasBackground\").stop().animate({left:a+o+n._SHELL_OFFSET_RIGHT+\"px\"},function(){e.sap.byId(s+\"-content\").css(\"overflow-x\",\"\"),e.sap.byId(s+\"-canvasBackground\").removeClass(\"sapUiUx3ShellCanvasBackgroundClosed\").addClass(\"sapUiUx3ShellCanvasBackgroundOpen\"),e.sap.byId(s+\"-paneBar\").addClass(\"sapUiUx3ShellPaneBarOpened\"),t&&t()})):(e.sap.byId(s+\"-paneBar\").removeClass(\"sapUiUx3ShellPaneBarClose\").addClass(\"sapUiUx3ShellPaneBarOpen\"),e.sap.byId(s+\"-wBar\").stop().animate({marginRight:a+o+\"px\"}),e.sap.byId(s+\"-canvas\").stop().animate({right:a+o+n._SHELL_OFFSET_RIGHT+\"px\"}),e.sap.byId(s+\"-notify\").stop().animate({right:a+o+n._SHELL_OFFSET_RIGHT+\"px\"}),this._getSyncRefs().stop(!1,!0).animate({right:a+o+n._SHELL_OFFSET_RIGHT+\"px\"}),e.sap.byId(s+\"-canvasBackground\").stop().animate({right:a+o+n._SHELL_OFFSET_RIGHT+\"px\"},function(){e.sap.byId(s+\"-content\").css(\"overflow-x\",\"\"),e.sap.byId(s+\"-canvasBackground\").removeClass(\"sapUiUx3ShellCanvasBackgroundClosed\").addClass(\"sapUiUx3ShellCanvasBackgroundOpen\"),e.sap.byId(s+\"-paneBar\").addClass(\"sapUiUx3ShellPaneBarOpened\"),t&&t()}))},n.prototype.setPaneWidth=function(t){if(\"number\"==typeof t&&t>0){if(t=Math.max(t,50),this.getDomRef()){var s=this.getId();e.sap.byId(s+\"-paneContent\").css(\"width\",t+\"px\"),e.sap.byId(s+\"-paneBar\").css(\"width\",t+n.SIDE_BAR_BASE_WIDTH+\"px\"),this._sOpenPaneId&&(this._bRtl?(e.sap.byId(s+\"-wBar\").css(\"marginLeft\",t+n.SIDE_BAR_BASE_WIDTH+\"px\"),e.sap.byId(s+\"-canvas\").css(\"left\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\"),e.sap.byId(s+\"-notify\").css(\"left\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\"),this._getSyncRefs().css(\"left\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\"),e.sap.byId(s+\"-canvasBackground\").css(\"left\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\")):(e.sap.byId(s+\"-wBar\").css(\"marginRight\",t+n.SIDE_BAR_BASE_WIDTH+\"px\"),e.sap.byId(s+\"-canvas\").css(\"right\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\"),e.sap.byId(s+\"-notify\").css(\"right\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\"),this._getSyncRefs().css(\"right\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\"),e.sap.byId(s+\"-canvasBackground\").css(\"right\",t+n.SIDE_BAR_BASE_WIDTH+n._SHELL_OFFSET_RIGHT+\"px\")))}this.setProperty(\"paneWidth\",t,!0)}return this},n.prototype.setOffsetRight=function(t,s,a){t<0&&(t=0),t>600&&(t=600),n._SHELL_OFFSET_RIGHT=t;var o=t+\"px\",i=this.getId(),r=this._bRtl?{left:o}:{right:o};e.sap.byId(i+\"-hdr\").stop().animate(r),e.sap.byId(i+\"-hdrImg\").stop().animate(r),e.sap.byId(i+\"-bg\").stop().animate(r,function(){s&&s()}),e.sap.byId(i+\"-bgImg\").stop().animate(r),e.sap.byId(i+\"-wBar\").stop().animate(r),e.sap.byId(i+\"-paneBar\").stop().animate(r),e.sap.byId(a).stop().animate({width:o}),this.$().hasClass(\"sapUiUx3ShellNoPane\")||(o=t+(this._sOpenPaneId?this.getPaneWidth():0)+n.SIDE_BAR_BASE_WIDTH+\"px\"),r=this._bRtl?{left:o}:{right:o},e.sap.byId(i+\"-notify\").stop().animate(r),this._getSyncRefs().stop(!1,!0).animate(r),e.sap.byId(i+\"-canvas\").stop().animate(r),e.sap.byId(i+\"-canvasBackground\").stop().animate(r)},n.prototype._refreshCanvasOffsetRight=function(t){var s=this.getId(),a=this._bRtl?\"left\":\"right\",o=n._SHELL_OFFSET_RIGHT;if(t){var i=e.sap.byId(s+\"-paneBarRight\").outerWidth();o=o+(this._sOpenPaneId?this.getPaneWidth():0)+i}o+=\"px\",e.sap.byId(s+\"-notify\").css(a,o),e.sap.byId(s+\"-canvas\").css(a,o),e.sap.byId(s+\"-canvasBackground\").css(a,o),this._getSyncRefs().css(a,o)},n.prototype._setNotifyVisibility=function(t){var s=this.getNotificationBar();if(s){t||(t=s.getVisibleStatus());var a=this.$(\"notify\"),o=this._topSyncRefId?e.sap.byId(this._topSyncRefId):e(null),i=o.hasClass(\"sapUiUx3TI\"),n=0,r=0;t===sap.ui.ux3.NotificationBarStatus.Min?n=10:t!==sap.ui.ux3.NotificationBarStatus.Max&&t!==sap.ui.ux3.NotificationBarStatus.Default||(n=this.getHeaderType()===sap.ui.ux3.ShellHeaderType.BrandOnly&&i?parseInt(s.getHeightOfStatus(sap.ui.ux3.NotificationBarStatus.Default),10):10,r=n),a.removeClass(\"sapUiUx3ShellNotifyTI\").removeClass(\"sapUiUx3ShellNotifyOverlay\"),this._topSyncRefId&&(this._getSyncRefs().animate({bottom:r+\"px\"},\"fast\"),r>0&&a.addClass(i?\"sapUiUx3ShellNotifyTI\":\"sapUiUx3ShellNotifyOverlay\")),t===sap.ui.ux3.NotificationBarStatus.Min?a.css(\"height\",n+\"px\").css(\"z-index\",1):a.css(\"height\",n+\"px\").css(\"z-index\",1e5),n>0&&!this.$().hasClass(\"sapUiUx3ShellNotifyVisible\")?this.$().addClass(\"sapUiUx3ShellNotifyVisible\"):0==n&&this.$().hasClass(\"sapUiUx3ShellNotifyVisible\")&&this.$().removeClass(\"sapUiUx3ShellNotifyVisible\"),this._adaptContentHeight(t)}},n.prototype.syncWithCanvasSize=function(t,s,a,o,i){var r=e.inArray(t,this._aSyncRefStack);if(s){var p={id:t,focusFirst:a,focusLast:o,applyChanges:i};r<0&&this._aSyncRefStack.push(t),this._mSyncRefs[t]=p,p.applyChanges({showOverlay:this.getHeaderType()!==sap.ui.ux3.ShellHeaderType.BrandOnly})}else r>=0&&(delete this._mSyncRefs[t],this._aSyncRefStack.splice(r,1));if(this.$(\"canvas\").removeAttr(\"aria-hidden\"),this.$(\"focusDummyTPStart\").removeAttr(\"tabindex\").unbind(\"focusin\"),this.$(\"focusDummyTPEnd\").removeAttr(\"tabindex\").unbind(\"focusin\"),this.$(\"focusDummyHdrStart\").removeAttr(\"tabindex\").unbind(\"focusin\"),this.$(\"focusDummyHdrEnd\").removeAttr(\"tabindex\").unbind(\"focusin\"),this.$(\"focusDummyPane\").removeAttr(\"tabindex\").unbind(\"focusin\"),this.$().toggleClass(\"sapUiUx3ShellBlockHeaderAccess\",!1),delete this._topSyncRefId,this._aSyncRefStack.length>0){var p=this._mSyncRefs[this._aSyncRefStack[this._aSyncRefStack.length-1]],l=this._getSyncRefs(),h=this.getDomRef(\"canvas\");l.css(this._bRtl?\"right\":\"left\",(this.getShowTools()?this.currentToolPaletteWidth:0)+\"px\");var d=n._SHELL_OFFSET_RIGHT;this.getShowPane()&&(d+=n.SIDE_BAR_BASE_WIDTH,this._sOpenPaneId&&(d+=this.getPaneWidth())),l.css(this._bRtl?\"left\":\"right\",d+\"px\"),l.css(\"top\",e.sap.domById(this.getId()+(this.getAllowOverlayHeaderAccess()?\"-hdr\":\"-hdrLine\")).offsetHeight+\"px\"),l.css(\"bottom\",\"0\"),e(h).attr(\"aria-hidden\",\"true\"),this.$(\"focusDummyTPEnd\").attr(\"tabindex\",\"0\").focusin(p.focusFirst),this.$(\"focusDummyHdrStart\").attr(\"tabindex\",\"0\").focusin(e.proxy(this.focusPaneEnd,this)),this.$(\"focusDummyHdrEnd\").attr(\"tabindex\",\"0\").focusin(e.proxy(this.focusFirstTool,this)),this.$(\"focusDummyTPStart\").attr(\"tabindex\",\"0\").focusin(e.proxy(this.focusLastHdr,this)),this.$(\"focusDummyPane\").attr(\"tabindex\",\"0\").focusin(p.focusLast),this.$().toggleClass(\"sapUiUx3ShellBlockHeaderAccess\",!this.getAllowOverlayHeaderAccess()),this._topSyncRefId=p.id}e.sap.require(\"jquery.sap.script\"),this._sUpdateNotificationZIndex&&(e.sap.clearDelayedCall(this._sUpdateNotificationZIndex),delete this._sUpdateNotificationZIndex),this._sUpdateNotificationZIndex=e.sap.delayedCall(0,this,function(){if(delete this._sUpdateNotificationZIndex,this._setNotifyVisibility(),this._oOpenToolPopup&&this._topSyncRefId){var t=e.sap.byId(this._topSyncRefId);this._oOpenToolPopup.$().css(\"z-index\",parseInt(t.css(\"z-index\"),10)+1)}})}}(),n.prototype._getSyncRefs=function(){for(var t,s=[],a=0;a<this._aSyncRefStack.length;a++)(t=e.sap.domById(this._aSyncRefStack[a]))&&s.push(t);return e(s)},n.prototype.focusFirstHdr=function(){var t=this.$(\"hdr-items\").firstFocusableDomRef();t&&this.getAllowOverlayHeaderAccess()&&this.getHeaderType()!=sap.ui.ux3.ShellHeaderType.BrandOnly?e.sap.focus(t):this.focusFirstTool()},n.prototype.focusLastHdr=function(){var t=this.$(\"hdr-items\").lastFocusableDomRef();t&&this.getAllowOverlayHeaderAccess()&&this.getHeaderType()!=sap.ui.ux3.ShellHeaderType.BrandOnly?e.sap.focus(t):this.focusPaneEnd()},n.prototype.focusFirstTool=function(){var t=this.$(\"tp\").find(\".sapUiUx3ShellTool\").first();t.length&&this.getShowTools()?e.sap.focus(t[0]):this._mSyncRefs[this._topSyncRefId].focusFirst()},n.prototype.focusLastTool=function(){var t=this.$(\"tp\").find(\".sapUiUx3ShellTool\").last();t.length&&this.getShowTools()?e.sap.focus(t[0]):this.focusPaneEnd()},n.prototype.focusPaneStart=function(){var t=this.$(\"paneBar\").firstFocusableDomRef();t?e.sap.focus(t):this.focusFirstTool()},n.prototype.focusPaneEnd=function(){var t=this.$(\"paneBar\").lastFocusableDomRef();t?e.sap.focus(t):this._mSyncRefs[this._topSyncRefId].focusLast()},n.prototype.setAppTitle=function(e){return this.setProperty(\"appTitle\",e,!0),this._rerenderHeader(),this},n.prototype.setAppIcon=function(e){return this.setProperty(\"appIcon\",e,!0),this._rerenderHeader(),this},n.prototype.setShowLogoutButton=function(e){return this.setProperty(\"showLogoutButton\",e,!0),this._rerenderHeader(),this},n.prototype.setLogoutButtonTooltip=function(e){return this.setProperty(\"logoutButtonTooltip\",e,!0),this._rerenderHeader(),this},n.prototype.insertHeaderItem=function(e,t){return sap.ui.commons&&sap.ui.commons.Button&&e instanceof sap.ui.commons.Button&&e.setStyled(!1),this.insertAggregation(\"headerItems\",e,t,!0),this._rerenderHeader(),this},n.prototype.addHeaderItem=function(e){return sap.ui.commons&&sap.ui.commons.Button&&e instanceof sap.ui.commons.Button&&e.setStyled(!1),this.addAggregation(\"headerItems\",e,!0),this._rerenderHeader(),this},n.prototype.removeHeaderItem=function(e){var t=this.removeAggregation(\"headerItems\",e,!0);return this._rerenderHeader(),t},n.prototype.removeAllHeaderItems=function(){var e=this.removeAllAggregation(\"headerItems\",!0);return this._rerenderHeader(),e},n.prototype.destroyHeaderItems=function(){return this.destroyAggregation(\"headerItems\",!0),this._rerenderHeader(),this},n.prototype.setShowSearchTool=function(e){return this.setProperty(\"showSearchTool\",e,!0),this._rerenderToolPalette(),this},n.prototype.setShowFeederTool=function(e){return this.setProperty(\"showFeederTool\",e,!0),this._rerenderToolPalette(),this},n.prototype.setHeaderType=function(t){var s=this.getHeaderType();this.setProperty(\"headerType\",t,!0),this.$().removeClass(\"sapUiUx3ShellHead\"+s).addClass(\"sapUiUx3ShellHead\"+this.getHeaderType());var a=this._getSyncRefs();a.length&&a.css(\"top\",e.sap.domById(this.getId()+(this.getAllowOverlayHeaderAccess()?\"-hdr\":\"-hdrLine\")).offsetHeight+\"px\");var o={showOverlay:t!==sap.ui.ux3.ShellHeaderType.BrandOnly};return e.each(this._mSyncRefs,function(e,t){t.applyChanges(o)}),this},n.prototype.setAllowOverlayHeaderAccess=function(t){this.setProperty(\"allowOverlayHeaderAccess\",t,!0);var s=this._getSyncRefs();return s.length&&(this.$().toggleClass(\"sapUiUx3ShellBlockHeaderAccess\",!this.getAllowOverlayHeaderAccess()),s.css(\"top\",e.sap.domById(this.getId()+(this.getAllowOverlayHeaderAccess()?\"-hdr\":\"-hdrLine\")).offsetHeight+\"px\")),this},n.prototype.setDesignType=function(e){var t=this.getDesignType();this.setProperty(\"designType\",e,!0);var s=this._hasDarkDesign();this._oSearchPopup&&this._oSearchPopup.setInverted(s),this._oFeederPopup&&this._oFeederPopup.setInverted(s);for(var a=this.getToolPopups(),o=0;o<a.length;++o)a[o].setInverted(s);return this.$().removeClass(\"sapUiUx3ShellDesign\"+t).addClass(\"sapUiUx3ShellDesign\"+e).toggleClass(\"sapUiUx3ShellDesignLight\",!s),this},n.prototype.setShowTools=function(e){return this.setProperty(\"showTools\",e,!0),e?(this.$().removeClass(\"sapUiUx3ShellNoTools\"),this._checkResize()):(this.$().addClass(\"sapUiUx3ShellNoTools\"),this._closeCurrentToolPopup(),this.$(\"tp\").attr(\"style\",\"\")),this._checkToolPaletteSize(!0),this},n.prototype.setShowPane=function(e){if(this.setProperty(\"showPane\",e,!0),e)this.$().removeClass(\"sapUiUx3ShellNoPane\"),this._refreshCanvasOffsetRight(!0),this._checkPaneBarOverflow();else{var t=this;this._closePane(function(){t._refreshCanvasOffsetRight(!1),t.$().addClass(\"sapUiUx3ShellNoPane\")})}return this},n.prototype.insertToolPopup=function(e,t){return this.insertAggregation(\"toolPopups\",e,t,!0),e.attachIconChanged(this._rerenderToolPalette,this),this._rerenderToolPalette(),this},n.prototype.addToolPopup=function(e){var t=this._hasDarkDesign();return e.setInverted(t),this.addAggregation(\"toolPopups\",e,!0),e.attachIconChanged(this._rerenderToolPalette,this),this._rerenderToolPalette(),this},n.prototype.removeToolPopup=function(e){var t=this.removeAggregation(\"toolPopups\",e,!0);return t===this._oOpenToolPopup&&this._closeCurrentToolPopup(),this._rerenderToolPalette(),t},n.prototype.removeAllToolPopups=function(){var e=this.removeAllAggregation(\"toolPopups\",!0);return this._rerenderToolPalette(),e},n.prototype.destroyToolPopups=function(){return this.destroyAggregation(\"toolPopups\",!0),this._rerenderToolPalette(),this},n.prototype.insertContent=function(e,t){return this.insertAggregation(\"content\",e,t,!0),this._rerenderContent(),this},n.prototype.addContent=function(e){return this.addAggregation(\"content\",e,!0),this._rerenderContent(),this},n.prototype.removeContent=function(e){var t=this.removeAggregation(\"content\",e,!0);return this._rerenderContent(),t},n.prototype.removeAllContent=function(){var e=this.removeAllAggregation(\"content\",!0);return this._rerenderContent(),e},n.prototype.destroyContent=function(){return this.destroyAggregation(\"content\",!0),this._rerenderContent(),this},n.prototype.addPaneBarItem=function(e){return this.addAggregation(\"paneBarItems\",e,!0),this._rerenderPaneBarItems(),this},n.prototype.insertPaneBarItem=function(e,t){return this.insertAggregation(\"paneBarItems\",e,t,!0),this._rerenderPaneBarItems(),this},n.prototype.removePaneBarItem=function(e){var t=this.removeAggregation(\"paneBarItems\",e,!0);if(t){var s=sap.ui.getCore().byId(t.getId()+\"-overflow\");s&&s.destroy()}return this._rerenderPaneBarItems(),t},n.prototype.removeAllPaneBarItems=function(){var e=this.removeAllAggregation(\"paneBarItems\",!0);return this._getPaneOverflowMenu().destroyItems(),this._rerenderPaneBarItems(),e},n.prototype.destroyPaneBarItems=function(){return this.destroyAggregation(\"paneBarItems\",!0),this._getPaneOverflowMenu().destroyItems(),this._rerenderPaneBarItems(),this},n.prototype.addWorksetItem=function(e){return this.addAggregation(\"worksetItems\",e,!0),this._rerenderWorksetItems(),this},n.prototype.insertWorksetItem=function(e,t){return this.insertAggregation(\"worksetItems\",e,t,!0),this._rerenderWorksetItems(),this},n.prototype.removeWorksetItem=function(e){var t=this.removeAggregation(\"worksetItems\",e,!0);return this._rerenderWorksetItems(),t},n.prototype.removeAllWorksetItems=function(){var e=this.removeAllAggregation(\"worksetItems\",!0)\n;return this._rerenderWorksetItems(),e},n.prototype.destroyWorksetItems=function(){return this.destroyAggregation(\"worksetItems\",!0),this._rerenderWorksetItems(),this},function(){function e(e){var t=e.getNotificationBar();t&&(e._setNotifyVisibility(sap.ui.ux3.NotificationBarStatus.None),t.setVisibleStatus=t.__orig_setVisibleStatus,t.detachDisplay(t.__fHandleNotifyDisplay),delete t.__orig_setVisibleStatus,delete t.__fHandleNotifyDisplay)}n.prototype.setNotificationBar=function(t){if(e(this),t){var s=this;t.__orig_setVisibleStatus=t.setVisibleStatus,t.setVisibleStatus=function(e){this.__orig_setVisibleStatus.apply(this,arguments),s._setNotifyVisibility()}}return this.setAggregation(\"notificationBar\",t,!0),this._rerenderNotificationArea(),t&&(t.__fHandleNotifyDisplay=function(e){var s=e?e.getParameter(\"show\"):t.hasItems();t.setVisibleStatus(s?sap.ui.ux3.NotificationBarStatus.Default:sap.ui.ux3.NotificationBarStatus.None)},t.attachDisplay(t.__fHandleNotifyDisplay),t.__fHandleNotifyDisplay()),this},n.prototype.destroyNotificationBar=function(){return e(this),this.destroyAggregation(\"notificationBar\",!0),this._rerenderNotificationArea(),this}}(),n.prototype._rerenderNotificationArea=function(){var e=this.$(\"notify\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.ShellRenderer.renderNotificationArea(t,this),t.flush(e[0],!0),t.destroy()}},n.prototype._rerenderHeader=function(){var e=this.$(\"hdr\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.ShellRenderer.renderHeader(t,this),t.flush(e[0],!0),t.destroy()}},n.prototype._rerenderToolPalette=function(){var e=this.$(\"tp\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();this._beforeRenderingToolPalette(),sap.ui.ux3.ShellRenderer.renderToolPalette(t,this),t.flush(e[0],!0),this._afterRenderingToolPalette(),t.destroy(),this._checkResize()}},n.prototype._beforeRenderingToolPalette=function(){this.$(\"tp\").find(\".sapUiUx3ShellTool\").unbind(\"mouseenter mouseleave\"),this.$(\"focusDummyTPEnd\").unbind(\"focusin\"),this.$(\"focusDummyTPStart\").unbind(\"focusin\")},n.prototype._afterRenderingToolPalette=function(){var t=this.getId()+n.TOOL_PREFIX,s=this.getToolPopups(),a=!1;if(this._oOpenToolPopup&&this._oOpenToolPopup.isOpen()&&(this.indexOfToolPopup(this._oOpenToolPopup)>=0||this._oOpenToolPopup===this._oSearchPopup||this._oOpenToolPopup===this._oFeederPopup)){this._oOpenToolPopup.setPosition(sap.ui.core.Popup.Dock.BeginTop,sap.ui.core.Popup.Dock.EndTop,e.sap.domById(t+this._oOpenToolPopup.getId()),\"13 -6\",\"fit\");var o=e.sap.domById(t+this._oOpenToolPopup.getId());e(o).toggleClass(\"sapUiUx3ShellToolSelected\",!0),n._updateToolIcon(o),a=!0}!a&&this._oOpenToolPopup&&this._closeCurrentToolPopup();for(var i=0;i<s.length;i++){var r=s[i];r instanceof sap.ui.ux3.ToolPopup&&e.sap.byId(t+r.getId()).hover(function(t){e(this).toggleClass(\"sapUiUx3ShellToolHover\",\"mouseenter\"===t.type),n._updateToolIcon(this)})}this._topSyncRefId&&this._mSyncRefs[this._topSyncRefId].focusFirst&&this.$(\"focusDummyTPEnd\").attr(\"tabindex\",\"0\").focusin(this._mSyncRefs[this._topSyncRefId].focusFirst),this._aSyncRefStack.length>0&&this.$(\"focusDummyTPStart\").attr(\"tabindex\",\"0\").focusin(e.proxy(this.focusLastHdr,this))},n.prototype._rerenderContent=function(e){var t=this.$(\"content\");if(t.length>0){for(var s=this.getContent(),a=sap.ui.getCore().createRenderManager(),o=0;o<s.length;o++)a.renderControl(s[o]);a.flush(t[0],e),a.destroy()}},n.prototype._rerenderPane=function(e){var t=this.$(\"paneContent\");if(t.length>0){for(var s=this.getPaneContent(),a=sap.ui.getCore().createRenderManager(),o=0;o<s.length;o++)a.renderControl(s[o]);a.flush(t[0],e),a.destroy()}},n.prototype._rerenderPaneBarItems=function(){var e=this.$(\"paneBar\").find(\".sapUiUx3ShellPaneEntries\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.ShellRenderer.renderPaneBarItems(t,this),t.flush(e[0]),t.destroy(),this._updatePaneBarItemNavigation(e)}for(var s=this,a=this._getPaneOverflowMenu(),o=this.getPaneBarItems(),i=function(e){var t={overflowItem:e.getParameter(\"item\"),target:{id:e.getParameter(\"id\").replace(/-overflow$/,\"\"),parentNode:{className:\"sapUiUx3ShellPaneEntries\"}}};s.onUserActivation(t)},n=0;n<o.length;++n){var r=o[n].getId()+\"-overflow\";if(!sap.ui.getCore().byId(r)){var p=new sap.ui.commons.MenuItem(r,{text:o[n].getText(),visible:!1,select:i});a.addItem(p)}}this._checkPaneBarOverflow(e)},n.prototype._rerenderWorksetItems=function(){if(this.$(\"wBar\").length>0){sap.ui.ux3.ShellRenderer.renderWorksetItems(null,this),sap.ui.ux3.ShellRenderer.renderFacetBar(null,this);var e=this._oFacetBar.getAssociatedItems();this._oFacetBar.$().css(\"display\",e&&e.length>0?\"block\":\"none\"),this._adaptContentHeight()}},n.prototype.forceInvalidation=s.prototype.invalidate,n.prototype.invalidate=function(e){if(e)if(e instanceof sap.ui.ux3.NavigationItem){if(this._oWorksetBar&&this._oFacetBar){this._oWorksetBar.setAssociatedItems(this.getWorksetItems());var t=this.getSelectedWorksetItem();if(t){var s,a=sap.ui.getCore().byId(t);a&&a.getParent()instanceof sap.ui.ux3.NavigationItem?this._oFacetBar.setAssociatedItems(a.getParent().getSubItems()):a&&(s=a.getSubItems())&&s&&s.length>0&&this._oFacetBar.setAssociatedItems(s),s=this._oFacetBar.getAssociatedItems(),this._oFacetBar.$().css(\"display\",s&&s.length>0?\"block\":\"none\"),this._adaptContentHeight()}}}else e instanceof sap.ui.core.Item&&e.getParent()==this?this.forceInvalidation():e instanceof sap.ui.ux3.ToolPopup?this._rerenderToolPalette():this.indexOfHeaderItem(e)>=0&&this._rerenderHeader();else this.forceInvalidation()},n.prototype._setParent=s.prototype.setParent,n.prototype.setParent=function(e,t,s){this._setParent(e,t,s),this.forceInvalidation()},n.prototype.setContent=function(t,a){e.sap.assert(null===t||t instanceof s||e.isArray(t)&&(!(t.length>0)||t[0]instanceof s),\"vContent must be a control or array of controls or null\"),e.sap.assert(void 0===a||!0===a||!1===a,\"bDestruct must be true, false, or undefined\");var o=[],i=this.$(\"content\"),n=!1;if(a?this.destroyAggregation(\"content\",!0):(o=this.removeAllAggregation(\"content\",!0),i.length>0&&(sap.ui.core.RenderManager.preserveContent(i[0]),n=!0,i.empty())),t instanceof s)this.addAggregation(\"content\",t,!0);else if(t&&\"object\"==typeof t&&t.length)for(var r=0;r<t.length;r++)this.addAggregation(\"content\",t[r],!0);return this._rerenderContent(n),o},n.prototype.setPaneContent=function(t,a){e.sap.assert(t instanceof s||e.isArray(t)&&(!(t.length>0)||t[0]instanceof s),\"vContent must be a control or array of controls\"),e.sap.assert(void 0===a||!0===a||!1===a,\"bDestruct must be true, false, or undefined\");var o=[],i=this.$(\"paneContent\"),n=!1;if(a?this.destroyAggregation(\"paneContent\",!0):(o=this.removeAllAggregation(\"paneContent\",!0),i.length>0&&(sap.ui.core.RenderManager.preserveContent(i[0]),n=!0,i.empty())),t instanceof s)this.addAggregation(\"paneContent\",t,!0);else if(t&&\"object\"==typeof t&&t.length)for(var r=0;r<t.length;r++)this.addAggregation(\"paneContent\",t[r],!0);return this._rerenderPane(n),o},n.prototype.getSelectedWorksetItem=function(){return this.getAssociation(\"selectedWorksetItem\")},n.prototype.setSelectedWorksetItem=function(e){var t=this.getSelectedWorksetItem();this.setAssociation(\"selectedWorksetItem\",e,!0);var s=this.getSelectedWorksetItem();if(t!=s){var a=sap.ui.getCore().byId(s);if(!a)throw new Error(\"WorksetItem with ID \"+s+\" cannot be found.\");this._sSelectedWorksetId=s,this._sSelectedFacetId=null;var o=a.getSubItems();if(o.length>0&&(a=o[0]),a&&a.getParent()instanceof sap.ui.ux3.NavigationItem){var i=a.getParent();if(this._sSelectedWorksetId=i.getId(),this._sSelectedFacetId=a.getId(),this._oWorksetBar.setSelectedItem(i),this._oFacetBar.setAssociatedItems(i.getSubItems()),this._oFacetBar.setSelectedItem(a),this.getDomRef()){var n=this.$(\"facetBar\"),r=this._calcFacetBarHeight(n);n.slideDown(),this._adaptContentHeight(null,!0,r)}}else if(a&&(this._oWorksetBar.setSelectedItem(a),this._oFacetBar.setAssociatedItems([]),this._oFacetBar.setSelectedItem(null),this.getDomRef())){var n=this.$(\"facetBar\"),r=this._calcFacetBarHeight(n);n.slideUp(),this._adaptContentHeight(null,!0,r)}}return this},n.prototype.setApplyContentPadding=function(e){this.setProperty(\"applyContentPadding\",e,!0),this.$().toggleClass(\"sapUiUx3ShellNoContentPadding\",!e),this._adaptContentHeight()},n.prototype.setFullHeightContent=function(e){this.setProperty(\"fullHeightContent\",e,!0),this.$().toggleClass(\"sapUiUx3ShellFullHeightContent\",e),this._adaptContentHeight()},n.prototype._calcFacetBarHeight=function(e){if(void 0===this._iFacetBarHeight&&(this._iFacetBarHeight=0),e||(e=this.$(\"facetBar\")),e.length>0){var t=this.$(\"facetBar\").outerHeight(!0);this._iFacetBarHeight=Math.max(this._iFacetBarHeight,t)}return this._iFacetBarHeight},n.prototype._adaptContentHeight=function(e,t,s){if(this.getDomRef()){var a=this.$(\"content\"),o=this.$(\"canvas\");if(this.getFullHeightContent()){var i=this.getApplyContentPadding(),n=i?parseInt(o.css(\"paddingTop\"),10):0,r=i?parseInt(o.css(\"paddingLeft\"),10):0,p=i?parseInt(o.css(\"paddingRight\"),10):0,l=s||this._calcFacetBarHeight(),h=n+(this._oFacetBar.getAssociatedItems().length>0?l:0)+\"px\";t?a.stop().animate({top:h}):a.stop().css(\"top\",h);var d=this.getNotificationBar();if(d&&!e&&(e=d.getVisibleStatus()),e===sap.ui.ux3.NotificationBarStatus.Default||e===sap.ui.ux3.NotificationBarStatus.Max)a.css(\"bottom\",d.getHeightOfStatus(sap.ui.ux3.NotificationBarStatus.Default));else{var c=i?parseInt(o.css(\"paddingBottom\"),10):0;d&&e===sap.ui.ux3.NotificationBarStatus.Min&&(c+=sap.ui.ux3.NotificationBar.HOVER_ITEM_HEIGHT),a.css(\"bottom\",c+\"px\")}a.css(this._bRtl?\"right\":\"left\",r+\"px\"),a.css(this._bRtl?\"left\":\"right\",p+\"px\")}else a.removeAttr(\"style\");sap.ui.Device.browser.webkit&&sap.ui.core.RenderManager.forceRepaint(this.getId()+\"-canvas\")}},n.prototype._handleDragover=function(t){var s=t.target.id;if(!this._dragOverBlinking){var a=e.sap.byId(s);a.css(\"opacity\",\"0.5\"),this._dragOverBlinking=!0;var o=this;window.setTimeout(function(){a.css(\"opacity\",\"1\"),window.setTimeout(function(){o._dragOverBlinking=null},300)},300)}return!1},n.prototype._handleDragend=function(e){return!1},n.prototype._handleDrop=function(t){var s=t.target.id;t.preventDefault();var a=t.originalEvent,o=a.dataTransfer.files[0];if(o){var i=new window.FileReader;i.onload=e.proxy(function(e){var t=e.target.result;s==this.getId()+\"-bgImg\"?this._getPersonalization()._handleBackgroundImageChange(t,!0):s==this.getId()+\"-hdr\"?this._getPersonalization()._handleHeaderImageChange(t,!0):s==this.getId()+\"-logoImg\"&&this._getPersonalization()._handleLogoImageChange(t,!0),i=null},this),i.readAsDataURL(o)}},n.prototype._getPersonalization=function(){return this.oPersonalization||(e.sap.require(\"sap.ui.ux3.ShellPersonalization\"),this.oPersonalization=new sap.ui.ux3.ShellPersonalization(this)),this.oPersonalization},n.prototype.openPersonalizationDialog=function(){this._getPersonalization().openDialog()},n.prototype.initializePersonalization=function(e){this._getPersonalization().initializeSettings(e)},n.prototype.onThemeChanged=function(e){if(this._iFacetBarHeight=void 0,this.getDomRef()){var t=\"\";this.getAppIcon()||(t=a._getThemeImage(\"sapUiUx3ShellApplicationImageURL\",!0),this.$(\"logoImg\").attr(\"src\",t)),t=a._getThemeImage(\"sapUiUx3ShellHeaderImageURL\",!0),this.$(\"hdrImg\").attr(\"src\",t),t=a._getThemeImage(\"sapUiUx3ShellBackgroundImageURL\",!0),this.$(\"bgImg\").attr(\"src\",t),this.$(\"facetBar\").stop(!0,!0),this._adaptContentHeight(),this._updateThemeVariables(),this._checkResize()}},n},!0);",
	"sap/ui/ux3/ShellColorPicker.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/EventProvider\",\"sap/ui/commons/Button\",\"sap/ui/core/Popup\"],function(e,t,o,i){\"use strict\";var s=t.extend(\"sap.ui.ux3.ShellColorPicker\",{constructor:function(e){t.apply(this),this.id=e}});return s.M_EVENTS={liveChange:\"liveChange\"},s.prototype.attachLiveChange=function(e,t){this.attachEvent(s.M_EVENTS.liveChange,e,t)},s.prototype.detachLiveChange=function(e,t){this.detachEvent(s.M_EVENTS.liveChange,e,t)},s.prototype.fireLiveChange=function(e){var t={cssColor:s.hslToCss(e)};this.fireEvent(s.M_EVENTS.liveChange,t)},s.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen()},s.prototype.open=function(t,s,r,n,a,h,l){if(!this.oPopup||!this.oPopup.isOpen()){this.oSlider=new sap.ui.commons.Slider({width:\"225px\",liveChange:[this.handleSlider,this]}),this.oOkBtn=new o({text:\"OK\",press:[this.handleOk,this]}),this.oCancelBtn=new o({text:\"Cancel\",press:[this.handleCancel,this]}),this.oInitialColor=t,this.oCurrentColor=e.extend({},this.oInitialColor),this.oSlider.setValue(this.oCurrentColor.l);var d=sap.ui.getCore().createRenderManager(),u=document.createElement(\"div\"),p=sap.ui.getCore().getStaticAreaRef();p.appendChild(u),this.renderHtml(d),d.flush(u),d.destroy,this.oPopup=new i(u.firstChild,!1,!0,!0).attachClosed(this.handleClose,this),this.oPopup.setAutoCloseAreas([u.firstChild]),this.oPopup.open(s,r,n,a,h,l),p.removeChild(u),u=null,e.sap.byId(this.id).bind(\"mousedown\",e.proxy(this.handleGeneralMouseDown,this)),e.sap.byId(this.id+\"-img\").bind(\"mousedown\",e.proxy(this.handleMouseDown,this)),e.sap.byId(this.id+\"-marker\").bind(\"mousedown\",e.proxy(this.handleMouseDown,this)),this._imgOffset=e.sap.byId(this.id+\"-img\").offset(),this.adaptSliderBar(this.oCurrentColor),this.markColorOnImage(this.oCurrentColor),this.adaptPreview(this.oCurrentColor)}},s.parseCssRgbString=function(t){t=e.trim(t.replace(/rgb\\(/,\"\").replace(/\\)/,\"\"));var o=t.split(\",\"),i={r:parseInt(o[0],10),g:parseInt(o[1],10),b:parseInt(o[2],10)};return s.rgbToHsl(i)},s.prototype.renderHtml=function(e){e.write(\"<div id='\"+this.id+\"' class='sapUiUx3ShellColorPicker'>\"),e.write(\"<img id='\"+this.id+\"-img' src='\"+sap.ui.resource(\"sap.ui.ux3\",\"img/colors-h.png\")+\"'>\"),e.renderControl(this.oSlider),e.write(\"<div id='\"+this.id+\"-grad' class='sapUiUx3ShellColorPickerGradient'></div>\"),e.write(\"<div id='\"+this.id+\"-marker' class='sapUiUx3ShellColorPickerMarker'></div>\"),e.write(\"<div id='\"+this.id+\"-preview' class='sapUiUx3ShellColorPickerPreview'></div>\"),e.renderControl(this.oOkBtn),e.renderControl(this.oCancelBtn),e.write(\"</div>\")},s.prototype.markColorOnImage=function(t){var o=225*t.h,i=75*(1-t.s);e.sap.byId(this.id+\"-marker\").css(\"left\",o+10).css(\"top\",i+10)},s.prototype.markColorOnSlider=function(e){this.oSlider.setValue(e.l)},s.prototype.adaptSliderBar=function(t){var o=\"\",i=e.extend({},t);i.l=50;var r=s.hslToCss(i);sap.ui.Device.browser.firefox?o=\"-moz-linear-gradient(left, black, \"+r+\", white)\":sap.ui.Device.browser.webkit&&(o=\"-webkit-gradient(linear, left center, right center, from(#000), color-stop(0.5, \"+r+\"), to(#FFF))\"),e.sap.byId(this.id+\"-grad\").css(\"background-image\",o)},s.prototype.adaptPreview=function(t){e.sap.byId(this.id+\"-preview\").css(\"background-color\",s.hslToCss(t))},s.prototype.handleSlider=function(e){var t=e.getParameter(\"value\");this.oCurrentColor.l=t,this.adaptPreview(this.oCurrentColor),this.fireLiveChange(this.oCurrentColor)},s.prototype.handleGeneralMouseDown=function(e){e.preventDefault()},s.prototype.handleMouseDown=function(t){this.handleMousePos(t),t.preventDefault(),e(document).bind(\"mousemove\",e.proxy(this.handleMousePos,this)).bind(\"mouseup\",e.proxy(this.handleMouseUp,this))},s.prototype.handleMouseUp=function(t){this.handleMousePos(t),e(document).unbind(\"mousemove\",this.handleMousePos).unbind(\"mouseup\",this.handleMouseUp)},s.prototype.handleMousePos=function(e){var t=e.pageX-this._imgOffset.left,o=e.pageY-this._imgOffset.top;t=Math.min(Math.max(t,0),225),o=Math.min(Math.max(o,0),75);var i=t/225,s=1-o/75;this.oCurrentColor.h=i,this.oCurrentColor.s=s,this.adaptSliderBar(this.oCurrentColor),this.markColorOnImage(this.oCurrentColor),this.adaptPreview(this.oCurrentColor),this.fireLiveChange(this.oCurrentColor)},s.prototype.handleOk=function(){this.fireLiveChange(this.oCurrentColor),this.oPopup.close()},s.prototype.handleCancel=function(){this.fireLiveChange(this.oInitialColor),this.oPopup.close()},s.prototype.handleClose=function(){e.sap.byId(this.id+\"-img\").unbind(\"mousedown\",this.handleMouseDown),e.sap.byId(this.id+\"-marker\").unbind(\"mousedown\",this.handleMouseDown),e(document).unbind(\"mousemove\",this.handleMousePos).unbind(\"mouseup\",this.handleMouseUp),e.sap.byId(this.id).unbind(\"mousedown\",this.handleGeneralMouseDown),this.oSlider.destroy(),this.oSlider=null,this.oOkBtn.destroy(),this.oOkBtn=null,this.oCancelBtn.destroy(),this.oCancelBtn=null;var t=e.sap.domById(this.id);t.parentNode.removeChild(t),this.oPopup.destroy(),this.oPopup=null},s.rgbToHsl=function(e){var t,o,i=e.r/255,s=e.g/255,r=e.b/255,n=Math.max(i,s,r),a=Math.min(i,s,r),h=(n+a)/2;if(n==a)t=o=0;else{var l=n-a;switch(o=h>.5?l/(2-n-a):l/(n+a),n){case i:t=(s-r)/l+(s<r?6:0);break;case s:t=(r-i)/l+2;break;case r:t=(i-s)/l+4}t/=6}return{h:t,s:o,l:100*h}},s.hslToRgb=function(e){var t,o,i,r=e.l/100;if(0==e.s)t=o=i=r;else{var n=r<.5?r*(1+e.s):r+e.s-r*e.s,a=2*r-n;t=s.hueToRgb(a,n,e.h+1/3),o=s.hueToRgb(a,n,e.h),i=s.hueToRgb(a,n,e.h-1/3)}return[255*t,255*o,255*i]},s.hueToRgb=function(e,t,o){return o<0&&(o+=1),o>1&&(o-=1),o<1/6?e+6*(t-e)*o:o<.5?t:o<2/3?e+(t-e)*(2/3-o)*6:e},s.hslToCss=function(e){var t=s.hslToRgb(e);return\"rgb(\"+Math.round(t[0])+\",\"+Math.round(t[1])+\",\"+Math.round(t[2])+\")\"},s},!0);",
	"sap/ui/ux3/ShellPersonalization.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/base/EventProvider\",\"sap/ui/commons/Button\",\"sap/ui/commons/Dialog\"],function(e,t,i,o){\"use strict\";var n=t.extend(\"sap.ui.ux3.ShellPersonalization\",{constructor:function(e){t.apply(this),this.shell=e,this.oSettings={}}});return n.prototype.initializeSettings=function(t){this.oSettings=e.extend({},t),this.shell.getDomRef()&&this.applySettings(t)},n.M_EVENTS={personalizationChange:\"personalizationChange\"},n.prototype.attachPersonalizationChange=function(e,t){this.attachEvent(n.M_EVENTS.personalizationChange,e,t)},n.prototype.detachPersonalizationChange=function(e,t){this.detachEvent(n.M_EVENTS.personalizationChange,e,t)},n.prototype.firePersonalizationChange=function(e){this.fireEvent(n.M_EVENTS.personalizationChange,e)},n.ORIGINAL_SETTINGS={bByDStyle:!1,sBgColor:\"rgb(17,17,17)\",sBgCssImg:null,sBgImgSrc:null,sBgImgPos:\"tile\",fBgImgOpacity:1,fSidebarOpacity:1,sLineColor:\"rgb(239,170,0)\",sLogoImageSrc:null,sLogoAlign:\"left\",bUseLogoSize:!1},n.TRANSPARENT_1x1=sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\"),n.IMAGE_FOLDER_PATH=e.sap.getModulePath(\"sap.ui.ux3.themes.\"+sap.ui.getCore().getConfiguration().getTheme(),\"/img/shell/\"),n.getOriginalSettings=function(){if(!n._bOriginalSettingsInitialized){n._bOriginalSettingsInitialized=!0,e.sap.require(\"sap.ui.core.theming.Parameters\");var t=sap.ui.core.theming.Parameters.get(),i=t[\"sap.ui.ux3.Shell:sapUiUx3ShellGradientTop\"],o=t[\"sap.ui.ux3.Shell:sapUiUx3ShellGradientBottom\"];sap.ui.Device.browser.firefox?n.ORIGINAL_SETTINGS.sBgCssImg=\"-moz-linear-gradient(top, \"+i+\" 0, \"+o+\" 108px, \"+o+\")\":sap.ui.Device.browser.internet_explorer?9==sap.ui.Device.browser.version?n.ORIGINAL_SETTINGS.sBgCssImg=\"url(\"+n.IMAGE_FOLDER_PATH+\"Workset_bg.png)\":n.ORIGINAL_SETTINGS.sBgCssImg=\"-ms-linear-gradient(top, \"+i+\" 0, \"+o+\" 108px, \"+o+\")\":sap.ui.Device.browser.webkit&&(n.ORIGINAL_SETTINGS.sBgCssImg=\"-webkit-linear-gradient(top, \"+i+\" 0, \"+o+\" 108px, \"+o+\")\")}return n.ORIGINAL_SETTINGS},n.prototype.hasChanges=function(){var e=0;for(var t in this.oSettings)e++;return e>0},n.prototype.applySettings=function(t){var i=e.extend({},n.getOriginalSettings());i=e.extend(i,t),this.applyByDStyle(i.bByDStyle),this.applyBgColor(i.sBgColor),this.applyBgImage(i.sBgCssImg,i.sBgImgSrc),this.applyBgImageOpacity(i.fBgImgOpacity),i.sHeaderImageSrc?this.applyHeaderImage(i.sHeaderImageSrc):this.shell.getDomRef(\"hdr\").style.backgroundImage=\"\",this.applySidebarOpacity(i.fSidebarOpacity),this.applyBgColor(i.sBgColor),this.applyLineColor(i.sLineColor),this.applyLogoImage(i.sLogoImageSrc),this.applyLogoAlign(i.sLogoAlign),this.applyUseLogoSize(i.bUseLogoSize)},n.prototype.openDialog=function(){this.oDialog&&this._getDialog().isOpen()||(this.oTransientSettings=e.extend({},this.oSettings),this._getDialog().open(),this._bindDragAndDrop(\"bg\"),this._bindDragAndDrop(\"hdr\"),this._bindDragAndDrop(\"logo\"))},n.prototype.getTransientSettingsWithDefaults=function(){return e.extend(e.extend({},n.getOriginalSettings()),this.oTransientSettings)},n.prototype._bindDragAndDrop=function(t){if(window.FileReader){var i=this.shell.getId()+\"-p13n_\";e.sap.byId(i+t+\"ImageImg\").bind(\"dragover\",e.proxy(this._handleDragover,this)).bind(\"dragend\",e.proxy(this._handleDragend,this)).bind(\"drop\",e.proxy(this._handleDrop,this)),e.sap.byId(i+t+\"ImageHolder\").bind(\"dragover\",e.proxy(this._handleDragover,this)).bind(\"dragend\",e.proxy(this._handleDragend,this)).bind(\"drop\",e.proxy(this._handleDrop,this))}},n.prototype._unbindDragAndDrop=function(t){if(window.FileReader){var i=this.shell.getId()+\"-p13n_\";e.sap.byId(i+\"hdrImageImg\").unbind(\"dragover\",this._handleDragover).unbind(\"dragend\",this._handleDragend).unbind(\"drop\",this._handleDrop),e.sap.byId(i+\"hdrImageHolder\").unbind(\"dragover\",this._handleDragover).unbind(\"dragend\",this._handleDragend).unbind(\"drop\",this._handleDrop)}},n.prototype._getDialog=function(){if(!this.oDialog){e.sap.require(\"sap.ui.ux3.ShellColorPicker\");var t=this.shell.getId()+\"-p13n_\",i=e.extend(e.extend({},n.getOriginalSettings()),this.oSettings),o=sap.ui.commons,s=this,a=new o.Dialog({title:\"Shell Personalization\",width:\"544px\",height:\"560px\",showCloseButton:!1,resizable:!1,closed:[function(){this._unbindDragAndDrop(\"bg\"),this._unbindDragAndDrop(\"hdr\"),this._unbindDragAndDrop(\"logo\"),this.oTransientSettings=null},this]}).addStyleClass(\"sapUiUx3ShellP13n\"),r=new o.TabStrip({width:\"100%\",height:\"100%\",select:e.proxy(function(t){var i=sap.ui.getCore().byId(t.getParameter(\"id\"));if(i){var o=t.getParameter(\"index\");i.setSelectedIndex(o);var n=this;0==o?(window.setTimeout(function(){n.shell.$(\"bgColor\").css(\"background-color\",n.getTransientSettingsWithDefaults().sBgColor)},1),window.setTimeout(e.proxy(function(){this._bindDragAndDrop(\"bg\")},this),0)):1==o?(window.setTimeout(function(){n.shell.$(\"lineColor\").css(\"background-color\",n.getTransientSettingsWithDefaults().sLineColor)},1),window.setTimeout(e.proxy(function(){this._bindDragAndDrop(\"hdr\")},this),0)):2==o&&window.setTimeout(e.proxy(function(){this._bindDragAndDrop(\"logo\")},this),0)}},this)});this.oBgImgHtml=new sap.ui.core.HTML(t+\"bgImageHolder\",{preferDOM:!0,content:\"<div id='\"+t+\"bgImageHolder' class='sapUiUx3ShellP13nImgHolder'><img id='\"+t+\"bgImageImg' src='\"+(this.oTransientSettings.sBackgroundImageSrc?e.sap.encodeHTML(this.oTransientSettings.sBackgroundImageSrc):sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\"))+\"'></div>\"}),this.oBgImgOpacitySlider=new o.Slider({value:void 0!==this.oTransientSettings.fBgImgOpacity?100-100*this.oTransientSettings.fBgImgOpacity:100-100*n.getOriginalSettings().fBgImgOpacity,liveChange:e.proxy(this._handleBgImageOpacitySliderChange,this)}),this.oSidebarOpacitySlider=new o.Slider({value:void 0!==this.oTransientSettings.fSidebarOpacity?100-100*this.oTransientSettings.fSidebarOpacity:100-100*n.getOriginalSettings().fSidebarOpacity,liveChange:e.proxy(this._handleSidebarOpacitySliderChange,this)}),this.oBgColorPicker=new sap.ui.ux3.ShellColorPicker(t+\"bgColorPicker\"),this.oBgColorPicker.attachLiveChange(function(e){s._handleBgColorChange(e)});var g=new o.Button({text:\"Change...\"}),s=this;g.attachPress(function(){s.oBgColorPicker.isOpen()||s.oBgColorPicker.open(sap.ui.ux3.ShellColorPicker.parseCssRgbString(s.getTransientSettingsWithDefaults().sBgColor),sap.ui.core.Popup.Dock.BeginTop,sap.ui.core.Popup.Dock.BeginBottom,s.shell.getDomRef(\"bgColor\"))}),this.oBgPreviewHtml=new sap.ui.core.HTML({preferDom:!0,content:\"<div id='\"+this.shell.getId()+\"-bgColor' style='background-color:\"+e.sap.encodeHTML(i.sBgColor)+\"' class='sapUiUx3ShellColorPickerPreview'></div>\"});var l=(new sap.ui.commons.Tab).setText(\"Background\").addContent(new o.layout.MatrixLayout({layoutFixed:!1}).createRow(new o.Label({text:\"Background Image:\"}),this.oBgImgHtml).createRow(new o.Label({text:\"Image Transparency:\"}),this.oBgImgOpacitySlider).createRow(new o.Label({text:\"Background Color:\"}),(new o.layout.MatrixLayoutCell).addContent(this.oBgPreviewHtml).addContent(g)).createRow(null).createRow(new o.Label({text:\"Sidebar Transparency:\"}),this.oSidebarOpacitySlider));r.addTab(l),this.oByDStyleCb=new o.CheckBox({text:\"ByDesign-style Header Bar\",checked:this.oTransientSettings.bByDStyle,change:e.proxy(this._handleByDStyleChange,this)}),this.oHdrImgHtml=new sap.ui.core.HTML(t+\"hdrImageHolder\",{preferDOM:!0,content:\"<div id='\"+t+\"hdrImageHolder' class='sapUiUx3ShellP13nImgHolder'><img id='\"+t+\"hdrImageImg' src='\"+(this.oTransientSettings.sHeaderImageSrc?e.sap.encodeHTML(this.oTransientSettings.sHeaderImageSrc):sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\"))+\"'></div>\"}),this.oLineColorPicker=new sap.ui.ux3.ShellColorPicker(t+\"lineColorPicker\"),this.oLineColorPicker.attachLiveChange(function(e){s._handleLineColorChange(e)});var h=new o.Button({text:\"Change...\"}),s=this;h.attachPress(function(){s.oLineColorPicker.isOpen()||s.oLineColorPicker.open(sap.ui.ux3.ShellColorPicker.parseCssRgbString(s.getTransientSettingsWithDefaults().sLineColor),sap.ui.core.Popup.Dock.BeginTop,sap.ui.core.Popup.Dock.BeginBottom,s.shell.getDomRef(\"lineColor\"))}),this.oLinePreviewHtml=new sap.ui.core.HTML({preferDom:!0,content:\"<div id='\"+this.shell.getId()+\"-lineColor' style='background-color:\"+e.sap.encodeHTML(i.sLineColor)+\"' class='sapUiUx3ShellColorPickerPreview'></div>\"});var d=(new sap.ui.commons.Tab).setText(\"Header Bar\").addContent(new o.layout.MatrixLayout({layoutFixed:!1}).createRow(new o.Label({text:\"Line Color (ByD-style only):\"}),(new o.layout.MatrixLayoutCell).addContent(this.oLinePreviewHtml).addContent(h)).createRow(null).createRow(new o.Label({text:\"Header Image:\"}),this.oHdrImgHtml));r.addTab(d),this.oLogoImgHtml=new sap.ui.core.HTML(t+\"logoImageHolder\",{preferDOM:!0,content:\"<div id='\"+t+\"logoImageHolder' class='sapUiUx3ShellP13nImgHolder'><img id='\"+t+\"logoImageImg' src='\"+(this.oTransientSettings.sLogoImageSrc?e.sap.encodeHTML(this.oTransientSettings.sLogoImageSrc):sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\"))+\"'></div>\"}),this.oLogoRbg=(new o.RadioButtonGroup).addItem(new sap.ui.core.Item({text:\"Left\",key:\"left\"})).addItem(new sap.ui.core.Item({text:\"Center\",key:\"center\"})).attachSelect(this._handleLogoAlignChange,this),this.oUseLogoSizeCb=new o.CheckBox({text:\"Use original image size\",checked:this.oTransientSettings.bUseLogoSize,change:e.proxy(this._handleUseLogoSizeChange,this)});var p=(new sap.ui.commons.Tab).setText(\"Logo\").addContent(new o.layout.MatrixLayout({layoutFixed:!1}).createRow(new o.Label({text:\"Logo Image:\"}),this.oLogoImgHtml).createRow(new o.Label({text:\"Position:\"}),this.oLogoRbg).createRow(this.oUseLogoSizeCb));r.addTab(p),a.addContent(r);var s=this;a.addButton(new o.Button({text:\"Reset All\",press:function(){s.applySettings(e.extend({},n.getOriginalSettings())),s.oSettings={},s.oTransientSettings={},s.updateDialog(),s._bindDragAndDrop(\"bg\"),s._bindDragAndDrop(\"hdr\"),s._bindDragAndDrop(\"logo\"),s.firePersonalizationChange({settings:{}})}})),a.addButton(new o.Button({text:\"OK\",press:function(){s.oSettings=e.extend({},s.oTransientSettings),s.firePersonalizationChange({settings:s.oSettings}),a.close()}})),a.addButton(new o.Button({text:\"Cancel\",press:function(){a.close()}})),this.oDialog=a}return this.oDialog},n.prototype.updateDialog=function(){var t=e.extend({},n.getOriginalSettings());t=e.extend(t,this.oSettings);var i=this.shell.getId()+\"-p13n_\";this.oBgImgHtml.setContent(\"<div id='\"+i+\"bgImageHolder' class='sapUiUx3ShellP13nImgHolder'><img id='\"+i+\"bgImageImg' src='\"+(t.sBackgroundImageSrc?e.sap.encodeHTML(t.sBackgroundImageSrc):sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\"))+\"'></div>\"),this.oBgImgOpacitySlider.setValue(100-100*t.fBgImgOpacity),this.oSidebarOpacitySlider.setValue(100-100*t.fSidebarOpacity),this.oByDStyleCb.setChecked(t.bByDStyle),this.oHdrImgHtml.setContent(\"<div id='\"+i+\"hdrImageHolder' class='sapUiUx3ShellP13nImgHolder'><img id='\"+i+\"hdrImageImg' src='\"+(t.sHeaderImageSrc?e.sap.encodeHTML(t.sHeaderImageSrc):sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\"))+\"'></div>\"),this.oLogoRbg.setSelectedIndex(\"center\"==t.sLogoAlign?1:0),this.oUseLogoSizeCb.setChecked(t.bUseLogoSize),this.oLogoImgHtml.setContent(\"<div id='\"+i+\"logoImageHolder' class='sapUiUx3ShellP13nImgHolder'><img id='\"+i+\"logoImageImg' src='\"+(t.sLogoImageSrc?e.sap.encodeHTML(t.sLogoImageSrc):sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\"))+\"'></div>\")},n.prototype._handleByDStyleChange=function(e){var t=e.getParameter(\"checked\");this.oTransientSettings.bByDStyle=t,this.applyByDStyle(t)},n.prototype.applyByDStyle=function(e){this.shell.$().toggleClass(\"sapUiUx3ShellByD\",e)},n.prototype._handleBgColorChange=function(e){var t=e.getParameter(\"cssColor\");this.oTransientSettings.sBgColor=t,this.applyBgColor(t)},n.prototype.applyBgColor=function(e){this.shell.$(\"bg\").css(\"background-color\",e),this.shell.$(\"bgColor\").css(\"background-color\",e)},n.prototype._handleBackgroundImageChange=function(e,t){t?(this.oSettings.sBgCssImg=\"url(\"+e+\")\",this.oSettings.sBgImgSrc=null,this.applyBgImage(this.oSettings.sBgCssImg,this.oSettings.sBgImgSrc),this.firePersonalizationChange({settings:this.oSettings})):(this.oTransientSettings.sBgCssImg=\"url(\"+e+\")\",this.oTransientSettings.sBgImgSrc=null,this.applyBgImage(this.oTransientSettings.sBgCssImg,this.oTransientSettings.sBgImgSrc))},n.prototype.applyBgImage=function(e,t){e=e||\"\",t=t||n.TRANSPARENT_1x1;var i=this.shell.getDomRef(\"bgImg\");i.style.backgroundImage=e,i.src=t},n.prototype._handleHeaderImageChange=function(e,t){t?(this.oSettings.sHeaderImageSrc=e,this.firePersonalizationChange({settings:this.oSettings})):this.oTransientSettings.sHeaderImageSrc=e,this.applyHeaderImage(e)},n.prototype.applyHeaderImage=function(e){this.shell.$(\"hdr\").css(\"background-image\",\"url(\"+e+\")\"),this.oDialog&&this.oDialog.isOpen()&&this.shell.$(\"p13n_hdrImageImg\").attr(\"src\",e)},n.prototype._handleLineColorChange=function(e){var t=e.getParameter(\"cssColor\");this.oTransientSettings.sLineColor=t,this.applyLineColor(t)},n.prototype.applyLineColor=function(e){this.shell.$(\"hdr\").find(\"hr\").css(\"background-color\",e),this.shell.$(\"lineColor\").css(\"background-color\",e)},n.prototype._handleBgImageOpacitySliderChange=function(e){var t=(100-e.getParameter(\"value\"))/100;this.oTransientSettings.fBgImgOpacity=t,this.applyBgImageOpacity(t)},n.prototype.applyBgImageOpacity=function(e){this.shell.$(\"bgImg\").css(\"opacity\",e)},n.prototype._handleSidebarOpacitySliderChange=function(e){var t=(100-e.getParameter(\"value\"))/100;this.oTransientSettings.fSidebarOpacity=t,this.applySidebarOpacity(t)},n.prototype.applySidebarOpacity=function(e){this.shell.$(\"tp\").css(\"opacity\",e),this.shell.$(\"paneBar\").children(\":nth-child(2)\").css(\"opacity\",e)},n.prototype._handleLogoImageChange=function(e,t){t?(this.oSettings.sLogoImageSrc=e,this.firePersonalizationChange({settings:this.oSettings})):this.oTransientSettings.sLogoImageSrc=e,this.applyLogoImage(e)},n.prototype.applyLogoImage=function(e){e||(e=this.shell.getAppIcon())||(e=n.TRANSPARENT_1x1),this.shell.$(\"logoImg\").attr(\"src\",e),this.shell.$(\"p13n_logoImageImg\").attr(\"src\",e)},n.prototype._handleLogoAlignChange=function(e){var t=e.getParameter(\"selectedIndex\"),i=[\"left\",\"center\"][t];this.oTransientSettings.sLogoAlign=i,this.applyLogoAlign(i)},n.prototype.applyLogoAlign=function(e){var t=e;sap.ui.getCore().getConfiguration().getRTL()&&\"right\"==t&&(t=\"left\"),this.shell.$(\"hdr\").css(\"text-align\",t)},n.prototype._handleUseLogoSizeChange=function(e){var t=e.getParameter(\"checked\");this.oTransientSettings.bUseLogoSize=t,this.applyUseLogoSize(t)},n.prototype.applyUseLogoSize=function(e){this.shell.$(\"hdr\").toggleClass(\"sapUiUx3ShellHeaderFlex\",e),this.shell.$(\"hdrImg\").toggleClass(\"sapUiUx3ShellHeaderImgFlex\",e)},n.prototype._handleDragover=function(t){var i=t.target.id;if(!this._dragOverBlinking){var o=e.sap.byId(i);o.css(\"opacity\",\"0.5\"),this._dragOverBlinking=!0;var n=this;window.setTimeout(function(){o.css(\"opacity\",\"1\"),window.setTimeout(function(){n._dragOverBlinking=null},250)},250)}return!1},n.prototype._handleDragend=function(e){return!1},n.prototype._handleDrop=function(t){var i=t.target.id;t.preventDefault();var o=t.originalEvent,n=o.dataTransfer.files[0];if(n){var s=new window.FileReader;s.onload=e.proxy(function(e){var t=e.target.result;i==this.shell.getId()+\"-p13n_bgImageImg\"||i==this.shell.getId()+\"-p13n_bgImageHolder\"?this._handleBackgroundImageChange(t):i==this.shell.getId()+\"-p13n_hdrImageImg\"||i==this.shell.getId()+\"-p13n_hdrImageHolder\"?this._handleHeaderImageChange(t):i!=this.shell.getId()+\"-p13n_logoImageImg\"&&i!=this.shell.getId()+\"-p13n_logoImageHolder\"||this._handleLogoImageChange(t),s=null},this),s.readAsDataURL(n)}},n},!0);",
	"sap/ui/ux3/ShellRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/IconPool\"],function(e,t){\"use strict\";var a={};return a.render=function(e,t){var i=e,r=t.isPaneOpen(),s=t.getPaneWidth()+sap.ui.ux3.Shell.SIDE_BAR_BASE_WIDTH,l=sap.ui.getCore().getConfiguration().getRTL(),o=t.getId();sap.ui.ux3.Shell.FIRST_RENDERING&&(document.body.style.margin=\"0\"),i.write(\"<div\"),i.writeControlData(t),i.addClass(\"sapUiUx3Shell\"),i.addClass(\"sapUiUx3ShellHead\"+t.getHeaderType()),i.addClass(\"sapUiUx3ShellDesign\"+t.getDesignType()),t._hasDarkDesign()||i.addClass(\"sapUiUx3ShellDesignLight\"),t.getFullHeightContent()&&i.addClass(\"sapUiUx3ShellFullHeightContent\"),t.getApplyContentPadding()||i.addClass(\"sapUiUx3ShellNoContentPadding\"),t.getShowTools()||i.addClass(\"sapUiUx3ShellNoTools\"),t.getShowPane()||i.addClass(\"sapUiUx3ShellNoPane\"),t._topSyncRefId&&!t.getAllowOverlayHeaderAccess()&&i.addClass(\"sapUiUx3ShellBlockHeaderAccess\"),i.writeClasses(),i.write(\">\"),i.write(\"<img id='\"+o+\"-hdrImg' class='sapUiUx3ShellHeaderImg' src='\");var n=sap.ui.core.theming.Parameters._getThemeImage(\"sapUiUx3ShellHeaderImageURL\",!0);i.writeEscaped(n),i.write(\"'>\"),i.write(\"<header id='\"+o+\"-hdr' class='sapUiUx3ShellHeader' role='banner'>\");var d=t._topSyncRefId?\" tabindex='0'\":\"\";i.write(\"<span class='sapUiUx3ShellFocusDummy' id='\"+o+\"-focusDummyHdrStart'\"+d+\"></span>\"),a.renderHeader(i,t),i.write(\"<span class='sapUiUx3ShellFocusDummy' id='\"+o+\"-focusDummyHdrEnd'\"+d+\"></span>\"),i.write(\"</header>\"),i.write(\"<div id='\",o,\"-bg' class='sapUiUx3ShellBg'></div>\"),i.write(\"<img id='\",o,\"-bgImg' class='sapUiUx3ShellBgImg' src='\"),n=sap.ui.core.theming.Parameters._getThemeImage(\"sapUiUx3ShellBackgroundImageURL\",!0),i.writeEscaped(n),i.write(\"'>\");var p=r?\" style='margin-\"+(l?\"left\":\"right\")+\":\"+(s+22)+\"px'\":\"\";i.write(\"<div id='\",o,\"-wBar'\"+p+\" class='sapUiUx3ShellWorksetBar'>\"),a.renderWorksetItems(i,t),i.write(\"</div>\"),i.write(\"<section id='\"+o+\"-tp' class='sapUiUx3ShellToolPaletteArea' role='complementary' data-sap-ui-fastnavgroup='true'>\"),a.renderToolPalette(i,t),i.write(\"</section>\");var c=r?\" style='\"+(l?\"left\":\"right\")+\":\"+s+\"px'\":\"\";i.write(\"<div class='sapUiUx3ShellCanvas'\"+c+\" id='\"+o+\"-canvas'>\"),a.renderFacetBar(i,t),i.write(\"<article class='sapUiUx3ShellContent' id='\"+o+\"-content' role='main' data-sap-ui-fastnavgroup='true'>\");for(var g=t.getContent(),U=0;U<g.length;U++)i.renderControl(g[U]);i.write(\"</article><div class='sapUiUx3ShellNotifySpace'></div></div>\");var d=t._topSyncRefId?\" tabindex='0'\":\"\";i.write(\"<span class='sapUiUx3ShellFocusDummy' id='\"+o+\"-focusDummyPane'\"+d+\"></span>\"),i.write(\"<aside id='\"+o+\"-paneBar' class='sapUiUx3ShellPaneBar \"+(r?\" sapUiUx3ShellPaneBarOpen sapUiUx3ShellPaneBarOpened\":\" sapUiUx3ShellPaneBarClose\")+\"' role='complementary' style='width:\"+s+\"px;'>\"),i.write(\"<section id='\"+o+\"-paneContent' style='width:\"+t.getPaneWidth()+\"px;' class='sapUiUx3ShellPaneBarContent' role='tabpanel'>\");for(var u=t.getPaneContent(),U=0;U<u.length;U++)i.renderControl(u[U]);i.write(\"</section>\"),i.write(\"<div id='\"+o+\"-paneBarRight' class='sapUiUx3ShellPaneBarRight' data-sap-ui-fastnavgroup='true'>\"),i.write(\"<ul id='\"+o+\"-paneBarEntries' class='sapUiUx3ShellPaneEntries' role='tablist'>\"),a.renderPaneBarItems(i,t),i.write(\"</ul>\"),i.write(\"<div id='\"+o+\"-paneBarOverflowButton' class='sapUiUx3ShellPaneOverflowButton'\"),i.addStyle(\"display\",\"none;\"),i.writeStyles(),i.write(\">\"),i.write(\"<div id='\"+o+\"-paneBarOverflowWrapper' class='sapUiUx3ShellPaneOverflowWrapper'>\"),i.write(\"<span id='\"+o+\"-paneBarOverflowText' class='sapUiUx3ShellPaneOverflowText sapUiUx3ShellPaneEntry'>\"),i.write(sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\").getText(\"SHELL_MORE_BUTTON\")),i.write(\"</span>\"),i.write(\"</div>\"),i.write(\"</div>\"),i.write(\"</div>\"),i.write(\"</aside>\"),i.write(\"<div class='sapUiUx3ShellCanvasBackground \"+(r?\"sapUiUx3ShellCanvasBackgroundOpen\":\"sapUiUx3ShellCanvasBackgroundClosed\")+\"' id='\"+o+\"-canvasBackground'\"+c+\">\"),i.write(\"<div class='sapUiUx3ShellCanvasBackgroundRight'></div>\"),i.write(\"</div>\"),i.write(\"<div id='\"+o+\"-notify' class='sapUiUx3ShellNotify'>\"),a.renderNotificationArea(i,t),i.write(\"</div>\"),i.write(\"</div>\")},a.renderHeader=function(t,a){var i=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),r=a.getAppIcon();t.write(\"<hr id='\"+a.getId()+\"-hdrLine'>\"),t.write(\"<span id='\"+a.getId()+\"-hdr-items' class='sapUiUx3ShellHeaderTitleRight'>\");for(var s=a.getHeaderItems(),l=0;l<s.length;l++)s[l]instanceof sap.ui.commons.MenuButton&&s[l].getMenu()&&s[l].getMenu().addStyleClass(\"sapUiMnuTop\",!0),t.renderControl(s[l]),(l<s.length-1||a.getShowLogoutButton())&&t.write(\"<span class='sapUiUx3ShellHeaderSep'></span>\");if(a.getShowLogoutButton()&&(t.write(\"<a id='\"+a.getId()+\"-logout' title='\"),t.write(a.getLogoutButtonTooltip()?e.sap.encodeHTML(a.getLogoutButtonTooltip()):i.getText(\"SHELL_LOGOUT\")),t.write(\"' tabindex='0' role='button' class='sapUiUx3ShellHeaderButton sapUiUx3ShellHeader-logout'></a>\")),t.write(\"</span>\"),t.write(\"<span class='sapUiUx3ShellHeaderTitleLeft' \"),t.writeAttributeEscaped(\"title\",a.getAppTitle()),t.write(\">\"),t.write(\"<img id='\"+a.getId()+\"-logoImg' src='\"),r)t.writeEscaped(a.getAppIcon());else{var o=sap.ui.core.theming.Parameters._getThemeImage(\"sapUiUx3ShellApplicationImageURL\",!0);t.writeEscaped(o)}t.write(\"'\");var n=a.getAppIconTooltip()||i.getText(\"SHELL_LOGO\");t.writeAttributeEscaped(\"alt\",n),t.writeAttributeEscaped(\"title\",n),t.write(\">\"),t.write(\"<span>\"),t.writeEscaped(a.getAppTitle()),t.write(\"</span>\"),t.write(\"</span>\")},a.renderToolPalette=function(e,a){var i=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),r=a.getId(),s=a._topSyncRefId?\" tabindex='0'\":\"\";e.write(\"<span class='sapUiUx3ShellFocusDummy' id='\"+a.getId()+\"-focusDummyTPStart'\"+s+\"></span>\");var l=i.getText(\"SHELL_TOOLPANE_GENERIC\"),o=!1,n=!0,d=\"\";a.getShowSearchTool()&&(o=!0,d+=\"<a id='\"+r+sap.ui.ux3.Shell.TOOL_PREFIX+r+\"-searchTool' title='\"+i.getText(\"SHELL_SEARCH\")+\"' class='sapUiUx3ShellTool sapUiUx3ShellTool-search' tabindex='0' role='button' aria-pressed='false'></a>\",n?n=!1:l+=\",\",l+=\" \"+i.getText(\"SHELL_SEARCH\")),a.getShowFeederTool()&&(o=!0,d+=\"<a id='\"+r+sap.ui.ux3.Shell.TOOL_PREFIX+r+\"-feederTool' title='\"+i.getText(\"SHELL_FEEDER\")+\"' class='sapUiUx3ShellTool sapUiUx3ShellTool-feeder' tabindex='0' role='button' aria-pressed='false'></a>\",n?n=!1:l+=\",\",l+=\" \"+i.getText(\"SHELL_FEEDER\")),o&&(e.write(\"<div role='toolbar'aria-describedby='\"+r+\"-genericToolsDescr'>\"),e.write(\"<span id='\"+r+\"-genericToolsDescr' style='display:none;'>\"+l+\"</span>\"),e.write(d+\"</div>\"));var p=a.getToolPopups();if(o&&p.length>0&&e.write(\"<hr id='\"+r+\"-tp-separator' class='sapUiUx3ShellToolSep'>\"),p.length>0){e.write(\"<div role='toolbar' aria-describedby='\"+r+\"-appToolsDescr'>\"),e.write(\"<span id='\"+r+\"-appToolsDescr' style='display:none;'>\"+i.getText(\"SHELL_TOOLPANE_APP\")+\"</span>\");for(var c=0;c<p.length;c++){var g=p[c];if(g instanceof sap.ui.core.SeparatorItem)e.write(\"<hr class='sapUiUx3ShellToolSep'>\");else{e.write(\"<a id='\"+r+\"-tool-\"+g.getId()+\"' class='sapUiUx3ShellTool'\");var U=g.getTooltip_AsString();U||(U=g.getTitle()),U&&(e.write(\" title='\"),e.writeEscaped(U),e.write(\"' \")),e.write(\" tabindex='0' role='button' aria-pressed='false'>\");var u=g.getIcon();t.isIconURI(u)?e.writeIcon(u,[\"sapUiUx3ShellToolFontIcon\"],{title:null,\"aria-label\":null}):(e.write(\"<img src='\"),e.writeEscaped(u),e.write(\"' alt='' role='presentation'>\")),e.write(\"</a>\")}}e.write(\"</div>\")}e.write(\"<span class='sapUiUx3ShellFocusDummy' id='\"+a.getId()+\"-focusDummyTPEnd'\"+s+\"></span>\")},a.renderPaneBarItems=function(e,t){for(var a=t.getId(),i=t.getPaneBarItems(),r=i.length,s=0;s<r;s++){var l=i[s],o=l.getId();e.write(\"<li\"),e.writeElementData(l),e.write(\" role='tab' aria-controls='\"+a+\"-paneContent' aria-setsize='\"+r+\"' aria-posinset='\"+(s+1)+\"' tabindex='-1' class='sapUiUx3ShellPaneEntry\"),t._sOpenPaneId===o&&e.write(\" sapUiUx3ShellPaneEntrySelected\"),e.write(\"'\"),l.getTooltip_AsString()&&e.writeAttributeEscaped(\"title\",l.getTooltip_AsString()),e.write(\">\"),e.writeEscaped(l.getText().toUpperCase()),e.write(\"</li>\")}},a.renderNotificationArea=function(e,t){e.write(\"<div class='sapUiUx3ShellNotifyBG'></div>\"),t.getNotificationBar()&&e.renderControl(t.getNotificationBar())},a.renderWorksetItems=function(e,t){var a=t.getWorksetItems();t._oWorksetBar.setAssociatedItems(a),!t._oWorksetBar.isSelectedItemValid()&&a.length>0&&(t.setAssociation(\"selectedWorksetItem\",a[0],!0),t._oWorksetBar.setSelectedItem(a[0])),e&&e.renderControl(t._oWorksetBar)},a.renderFacetBar=function(e,t){var a=sap.ui.getCore().byId(t.getSelectedWorksetItem());if(a){var i=a.getParent();i&&i instanceof sap.ui.ux3.NavigationItem&&(a=i);var r=a.getSubItems();t._oFacetBar.setAssociatedItems(r),!t._oFacetBar.isSelectedItemValid()&&r.length>0&&t._oFacetBar.setSelectedItem(r[0])}e&&e.renderControl(t._oFacetBar)},a},!0);",
	"sap/ui/ux3/ThingAction.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\"],function(t,e){\"use strict\";var i=e.extend(\"sap.ui.ux3.ThingAction\",{metadata:{library:\"sap.ui.ux3\",properties:{text:{type:\"string\",group:\"Misc\",defaultValue:null},enabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0}},events:{select:{parameters:{id:{type:\"string\"},action:{type:\"sap.ui.ux3.ThingAction\"}}}}}});return i.prototype.onclick=function(t){this.fireSelect({id:this.getId(),action:this})},i.prototype.onsapselect=function(t){this.fireSelect({id:this.getId(),action:this})},i},!0);",
	"sap/ui/ux3/ThingGroup.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Element\",\"./library\"],function(e,t){\"use strict\";return t.extend(\"sap.ui.ux3.ThingGroup\",{metadata:{library:\"sap.ui.ux3\",properties:{title:{type:\"string\",group:\"Misc\",defaultValue:null},colspan:{type:\"boolean\",group:\"Misc\",defaultValue:!1}},defaultAggregation:\"content\",aggregations:{content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"},actions:{type:\"sap.ui.ux3.ThingGroup\",multiple:!0,singularName:\"action\"}}}})},!0);",
	"sap/ui/ux3/ThingInspector.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"./ActionBar\",\"./Overlay\",\"./ThingViewer\",\"./ThingInspectorRenderer\",\"./library\"],function(t,e,i,o,n){\"use strict\";var r=i.extend(\"sap.ui.ux3.ThingInspector\",{metadata:{library:\"sap.ui.ux3\",properties:{firstTitle:{type:\"string\",group:\"Misc\",defaultValue:null},type:{type:\"string\",group:\"Misc\",defaultValue:null},icon:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},secondTitle:{type:\"string\",group:\"Misc\",defaultValue:null},followState:{type:\"sap.ui.ux3.FollowActionState\",group:\"Misc\",defaultValue:sap.ui.ux3.FollowActionState.Default},flagState:{type:\"boolean\",group:\"Misc\",defaultValue:!1},favoriteState:{type:\"boolean\",group:\"Misc\",defaultValue:!1},favoriteActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},updateActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},followActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},flagActionEnabled:{type:\"boolean\",group:\"Misc\",defaultValue:!0},headerType:{type:\"sap.ui.ux3.ThingViewerHeaderType\",group:\"Misc\",defaultValue:sap.ui.ux3.ThingViewerHeaderType.Standard}},aggregations:{actions:{type:\"sap.ui.ux3.ThingAction\",multiple:!0,singularName:\"action\"},headerContent:{type:\"sap.ui.ux3.ThingGroup\",multiple:!0,singularName:\"headerContent\"},facets:{type:\"sap.ui.ux3.NavigationItem\",multiple:!0,singularName:\"facet\"},facetContent:{type:\"sap.ui.ux3.ThingGroup\",multiple:!0,singularName:\"facetContent\"},actionBar:{type:\"sap.ui.ux3.ActionBar\",multiple:!1},thingViewer:{type:\"sap.ui.ux3.ThingViewer\",multiple:!1,visibility:\"hidden\"}},associations:{selectedFacet:{type:\"sap.ui.ux3.NavigationItem\",multiple:!1}},events:{actionSelected:{parameters:{id:{type:\"string\"},action:{type:\"sap.ui.ux3.ThingAction\"}}},facetSelected:{allowPreventDefault:!0,parameters:{id:{type:\"string\"},item:{type:\"sap.ui.ux3.NavigationItem\"},key:{type:\"string\"}}},feedSubmit:{parameters:{text:{type:\"string\"}}}}}});return function(){r.prototype.init=function(){var t,n=this;i.prototype.init.apply(this),this._oThingViewer=new o(this.getId()+\"-thingViewer\"),this.setAggregation(\"thingViewer\",this._oThingViewer),this._oThingViewer.attachFacetSelected(function(t){var e=t.getParameters().item;n.fireFacetSelected({id:e.getId(),key:e.getKey(),item:e})?n.setSelectedFacet(e):t.preventDefault()}),this._oSocialActions={},null==this.getActionBar()&&(t=new e(this.getId()+\"-actionBar\"),t.setShowOpen(!1),t.setAlwaysShowMoreMenu(!1),t.setDividerWidth(\"252px\"),t.attachActionSelected(function(t){var e,i=t.getParameters().id,o=t.getParameters().action;-1!==i.indexOf(sap.ui.ux3.ActionBarSocialActions.Favorite)||-1!==i.indexOf(sap.ui.ux3.ActionBarSocialActions.Follow)||-1!==i.indexOf(sap.ui.ux3.ActionBarSocialActions.Flag)?(n._oSocialActions[i]?e=n._oSocialActions[i]:(e=new sap.ui.ux3.ThingAction({id:n.getId()+\"-\"+i.toLowerCase(),text:o.text,enabled:o.enabled}),n._oSocialActions[i]=e),n.fireActionSelected({id:i.toLowerCase(),action:e})):n.fireActionSelected({id:t.getParameters().id,action:t.getParameters().action})}),t.attachFeedSubmit(function(t){n.fireFeedSubmit({text:t.getParameters().text})}),this.setActionBar(t))},r.prototype.onAfterRendering=function(){i.prototype.onAfterRendering.apply(this,arguments);var t=this._getShell();this._bShell=!!t,t||this._applyChanges({showOverlay:!1})},r.prototype.onBeforeRendering=function(){i.prototype.onBeforeRendering.apply(this,arguments)},r.prototype.exit=function(){this._oThingViewer.exit(arguments),this._oThingViewer.destroy(),this._oThingViewer=null,i.prototype.exit.apply(this,arguments)},r.prototype.open=function(t){this.getDomRef()&&this.rerender(),i.prototype.open.apply(this,arguments),this._selectDefault()},r.prototype._getNavBar=function(){return this._oThingViewer._oNavBar},r.prototype._selectDefault=function(){this._oThingViewer._selectDefault()},r.prototype._equalColumns=function(){this._oThingViewer._equalColumns()},r.prototype._setTriggerValue=function(){this._oThingViewer._setTriggerValue()},r.prototype._setFocusLast=function(){var e=this.$(\"thingViewer-toolbar\").lastFocusableDomRef();!e&&this.getCloseButtonVisible()&&this.$(\"close\").is(\":sapFocusable\")?e=this.getDomRef(\"close\"):!e&&this.getOpenButtonVisible()&&this.$(\"openNew\").is(\":sapFocusable\")&&(e=this.getDomRef(\"openNew\")),t.sap.focus(e)},r.prototype._setFocusFirst=function(){this.getOpenButtonVisible()&&this.$(\"openNew\").is(\":sapFocusable\")?t.sap.focus(this.getDomRef(\"openNew\")):this.getCloseButtonVisible()&&this.$(\"close\").is(\":sapFocusable\")?t.sap.focus(this.getDomRef(\"close\")):t.sap.focus(this.$(\"thingViewer-content\").firstFocusableDomRef())},r.prototype.insertAction=function(t,e){return this.getActionBar()&&this.getActionBar().insertBusinessAction(t,e),this},r.prototype.addAction=function(t){return this.getActionBar()&&this.getActionBar().addBusinessAction(t),this},r.prototype.removeAction=function(t){var e;return this.getActionBar()&&(e=this.getActionBar().removeBusinessAction(t)),e},r.prototype.removeAllActions=function(){var t;return this.getActionBar()&&(t=this.getActionBar().removeAllBusinessActions()),t},r.prototype.getActions=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getBusinessActions()),t},r.prototype.destroyActions=function(){return this.getActionBar()&&this.getActionBar().destroyBusinessActions(),this},r.prototype.indexOfAction=function(t){var e=-1;return this.getActionBar()&&(e=this.getActionBar().indexOfBusinessAction(t)),e},r.prototype.getFacets=function(){return this._oThingViewer.getFacets()},r.prototype.insertFacet=function(t,e){return this._oThingViewer.insertFacet(t,e),this},r.prototype.addFacet=function(t){return this._oThingViewer.addFacet(t),this},r.prototype.removeFacet=function(t){return this._oThingViewer.removeFacet(t)},r.prototype.removeAllFacets=function(){return this._oThingViewer.removeAllFacets()},r.prototype.destroyFacets=function(){return this._oThingViewer.destroyFacets(),this},r.prototype.indexOfFacet=function(t){return this._oThingViewer.indexOfFacet(t)},r.prototype.setFollowState=function(t){return this.getActionBar()&&this.getActionBar().setFollowState(t),this},r.prototype.getFollowState=function(){var t=null;return this.getActionBar()&&(t=this.getActionBar().getFollowState()),t},r.prototype.setFlagState=function(t){return this.getActionBar()&&this.getActionBar().setFlagState(t),this},r.prototype.getFlagState=function(){var t=null;return this.getActionBar()&&(t=this.getActionBar().getFlagState()),t},r.prototype.setFavoriteState=function(t){return this.getActionBar()&&this.getActionBar().setFavoriteState(t),this},r.prototype.getFavoriteState=function(){var t=null;return this.getActionBar()&&(t=this.getActionBar().getFavoriteState()),t},r.prototype.setIcon=function(t){return this._oThingViewer.setIcon(t),this.getActionBar()&&this.getActionBar().setThingIconURI(t),this},r.prototype.getIcon=function(){return this._oThingViewer.getIcon()},r.prototype.setType=function(t){return this._oThingViewer.setType(t),this},r.prototype.getType=function(){return this._oThingViewer.getType()},r.prototype.insertFacetContent=function(t,e){return this._oThingViewer.insertFacetContent(t,e),this},r.prototype.addFacetContent=function(t){return this._oThingViewer.addFacetContent(t),this},r.prototype.removeFacetContent=function(t){return this._oThingViewer.removeFacetContent(t)},r.prototype.removeAllFacetContent=function(){return this._oThingViewer.removeAllFacetContent()},r.prototype.destroyFacetContent=function(){return this._oThingViewer.destroyFacetContent(),this},r.prototype.getFacetContent=function(){return this._oThingViewer.getFacetContent()},r.prototype.indexOfFacetContent=function(t){return this._oThingViewer.indexOfFacetContent(t)},r.prototype.setActionBar=function(t){return this._oThingViewer.setActionBar(t),this},r.prototype.getActionBar=function(){return this._oThingViewer.getActionBar()},r.prototype.destroyActionBar=function(){this._oThingViewer.destroyActionBar()},r.prototype.insertHeaderContent=function(t,e){return this._oThingViewer.insertHeaderContent(t,e),this},r.prototype.addHeaderContent=function(t){return this._oThingViewer.addHeaderContent(t),this},r.prototype.getHeaderContent=function(){return this._oThingViewer.getHeaderContent()},r.prototype.removeHeaderContent=function(t){return this._oThingViewer.removeHeaderContent(t)},r.prototype.removeAllHeaderContent=function(){return this._oThingViewer.removeAllHeaderContent()},r.prototype.destroyHeaderContent=function(){return this._oThingViewer.destroyHeaderContent(),this},r.prototype.indexOfHeaderContent=function(t){return this._oThingViewer.indexOfHeaderContent(t)},r.prototype.setSelectedFacet=function(t){this._oThingViewer.setSelectedFacet(t)},r.prototype.getSelectedFacet=function(t){return this._oThingViewer.getSelectedFacet()},r.prototype.setFavoriteActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowFavorite(t),this},r.prototype.getFavoriteActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowFavorite()),t},r.prototype.setFlagActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowFlag(t),this},r.prototype.getFlagActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowFlag()),t},r.prototype.setUpdateActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowUpdate(t),this},r.prototype.getUpdateActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowUpdate()),t},r.prototype.setFollowActionEnabled=function(t){return this.getActionBar()&&this.getActionBar().setShowFollow(t),this},r.prototype.getFollowActionEnabled=function(){var t;return this.getActionBar()&&(t=this.getActionBar().getShowFollow()),t},r.prototype.setFirstTitle=function(t){this._oThingViewer.setTitle(t)},r.prototype.getFirstTitle=function(){return this._oThingViewer.getTitle()},r.prototype.setSecondTitle=function(t){this._oThingViewer.setSubtitle(t)},r.prototype.getSecondTitle=function(){return this._oThingViewer.getSubtitle()},r.prototype.setHeaderType=function(t){return this._oThingViewer.setHeaderType(t),this},r.prototype.getHeaderType=function(){return this._oThingViewer.getHeaderType()},r.prototype._applyChanges=function(t){return this.oChanges=t,t.showOverlay?this.$().removeClass(\"sapUiUx3TINoFrame\"):this.$().addClass(\"sapUiUx3TINoFrame\"),this}}(),r},!0);",
	"sap/ui/ux3/ThingInspectorRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Renderer\",\"./OverlayRenderer\"],function(e,n,r){\"use strict\";var a=n.extend(r);return a.renderContent=function(e,n){var r=e;r.write(\"<div role='Main' class='sapUiUx3TIContent' id='\"+n.getId()+\"-content'>\"),r.renderControl(n._oThingViewer),r.write(\"</div>\")},a.addRootClasses=function(e,n){e.addClass(\"sapUiUx3TI\")},a.addOverlayClasses=function(e,n){e.addClass(\"sapUiUx3TIOverlay\")},a},!0);",
	"sap/ui/ux3/ThingViewer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"./ThingViewerRenderer\",\"./library\"],function(e,t,r){\"use strict\";var i=t.extend(\"sap.ui.ux3.ThingViewer\",{metadata:{library:\"sap.ui.ux3\",properties:{title:{type:\"string\",group:\"Misc\",defaultValue:null},type:{type:\"string\",group:\"Misc\",defaultValue:null},icon:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},subtitle:{type:\"string\",group:\"Misc\",defaultValue:null},width:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:\"100%\"},height:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:\"100%\"},headerType:{type:\"sap.ui.ux3.ThingViewerHeaderType\",group:\"Misc\",defaultValue:sap.ui.ux3.ThingViewerHeaderType.Standard}},aggregations:{headerContent:{type:\"sap.ui.ux3.ThingGroup\",multiple:!0,singularName:\"headerContent\"},facets:{type:\"sap.ui.ux3.NavigationItem\",multiple:!0,singularName:\"facet\"},facetContent:{type:\"sap.ui.ux3.ThingGroup\",multiple:!0,singularName:\"facetContent\"},actionBar:{type:\"sap.ui.ux3.ActionBar\",multiple:!1},navBar:{type:\"sap.ui.ux3.NavigationBar\",multiple:!1,visibility:\"hidden\"}},associations:{selectedFacet:{type:\"sap.ui.ux3.NavigationItem\",multiple:!1}},events:{facetSelected:{allowPreventDefault:!0,parameters:{id:{type:\"string\"},item:{type:\"sap.ui.ux3.NavigationItem\"},key:{type:\"string\"}}}}}});return function(){i.prototype.init=function(){var e=this;this._oNavBar=new sap.ui.ux3.NavigationBar,this.setAggregation(\"navBar\",this._oNavBar),this._oNavBar.attachSelect(function(t){var r=t.getParameters().item;e.fireFacetSelected({id:r.getId(),key:r.getKey(),item:r})?e.setSelectedFacet(r):t.preventDefault()})},i.prototype.onAfterRendering=function(){this._resize=!1,this.getActionBar()&&this._adjustStyles(),this.$().find(\".sapUiUx3TVFacetContent\").length<=0||(this._resizeListenerId=sap.ui.core.ResizeHandler.register(this.$().find(\".sapUiUx3TVFacetContent\")[0],e.proxy(this._onresize,this)),this._setTriggerValue(),this._setHeaderPosition(),this._onresize())},i.prototype.onBeforeRendering=function(){this._resizeListenerId&&(sap.ui.core.ResizeHandler.deregister(this._resizeListenerId),this._resizeListenerId=null)},i.prototype._setHeaderPosition=function(){if(this.getHeaderType()===sap.ui.ux3.ThingViewerHeaderType.Standard){var e=this.$().find(\".sapUiUx3TVHeaderContainerIdentifier\");this.$().find(\".sapUiUx3TVHeaderGroupScrollContainer\").css(\"top\",e.outerHeight())}},i.prototype._onresize=function(t){var r;if(t&&(r=e(t.target).width()),r||(r=e(this.$().find(\".sapUiUx3TVFacetContent\")[0]).width()),r<this._triggerValue&&0==this._resize){for(var i=this.$().find(\".sapUiUx3TVFacetThingGroup\"),n=0;n<i.length;n++)e(i[n]).animate({width:\"100%\"},\"fast\");this._resize=!0}else if(r>this._triggerValue&&1==this._resize){for(var i=this.$().find(\".sapUiUx3TVFacetThingGroup\"),n=0;n<i.length;n++)e(i[n]).animate({width:\"50%\"},\"fast\");this._resize=!1}if(this.getActionBar()){var a=this.getActionBar().getActionBarMinWidth(),s=a;this._bShell&&(a+=36,s=a+60),this.$().find(\".sapUiUx3TV\").css(\"min-width\",s+\"px\"),this.$().find(\".sapUiUx3TVContent\").css(\"min-width\",a+\"px\")}},i.prototype.exit=function(){this._oNavBar.destroy(),this._resizeListenerId&&(sap.ui.core.ResizeHandler.deregister(this._resizeListenerId),this._resizeListenerId=null)},i.prototype._getNavBar=function(){return this._oNavBar},i.prototype._selectDefault=function(){var e=this._oNavBar.getItems();if(e.length&&!this._oNavBar.getSelectedItem()){this.getSelectedFacet()||this.setSelectedFacet(e[0]);var t=this._oNavBar.getSelectedItem(),r=sap.ui.getCore().byId(t);this.fireFacetSelected({id:r.getId(),key:r.getKey(),item:r})}},i.prototype._equalColumns=function(){var e=this.$().find(\".sapUiUx3TVHeader\"),t=this.$().find(\".sapUiUx3TVFacets\"),r=this.$().find(\".sapUiUx3TVContentScrollContainer\"),i=r.get(0).scrollHeight;t.height(i),e.height(i)},i.prototype._rerenderHeader=function(){var e=this.$(\"header\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.ThingViewerRenderer.renderHeader(t,this),t.flush(e[0]),t.destroy()}},i.prototype._rerenderHeaderContent=function(){var e=this.$(\"headerContent\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.ThingViewerRenderer.renderHeaderContent(t,this),t.flush(e[0]),t.destroy()}},i.prototype._rerenderToolbar=function(){var e=this.$(\"toolbar\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.ThingViewerRenderer.renderToolbar(t,this),t.flush(e[0]),t.destroy()}},i.prototype._rerenderFacetContent=function(){var e=this.$(\"facetContent\");if(e.length>0){var t=sap.ui.getCore().createRenderManager();sap.ui.ux3.ThingViewerRenderer.renderFacetContent(t,this),t.flush(e[0]),t.destroy(),this._resize=!1,this._setTriggerValue(),this._onresize()}},i.prototype._setTriggerValue=function(){var t,r;this.$(\"facetContent\").length>0&&(t=this.$().find(\".sapUiUx3TVFacetThingGroup\"),(r=e(t[0]).css(\"min-width\"))&&(this._triggerValue=2*parseInt(r,10)))},i.prototype.getFacets=function(){return this._oNavBar.getItems()},i.prototype.insertFacet=function(e,t){return this._oNavBar.insertItem(e,t),this},i.prototype.addFacet=function(e){return this._oNavBar.addItem(e),this},i.prototype.removeFacet=function(e){return this._oNavBar.removeItem(e)},i.prototype.removeAllFacets=function(){return this._oNavBar.removeAllItems()},i.prototype.destroyFacets=function(){return this._oNavBar.destroyItems(),this},i.prototype.setIcon=function(e){return this.setProperty(\"icon\",e),this.getActionBar()&&this.getActionBar().setThingIconURI(e),this._rerenderHeader(),this},i.prototype.insertFacetContent=function(e,t){return this.insertAggregation(\"facetContent\",e,t,!0),this._rerenderFacetContent(),this},i.prototype.addFacetContent=function(e){return this.addAggregation(\"facetContent\",e,!0),this._rerenderFacetContent(),this},i.prototype.removeFacetContent=function(e){var t=this.removeAggregation(\"facetContent\",e,!0);return this._rerenderFacetContent(),t},i.prototype.removeAllFacetContent=function(){var e=this.removeAllAggregation(\"facetContent\",!0);return this._rerenderFacetContent(),e},i.prototype.destroyFacetContent=function(){return this.destroyAggregation(\"facetContent\",!0),this._rerenderFacetContent(),this},i.prototype.insertHeaderContent=function(e,t){return this.insertAggregation(\"headerContent\",e,t,!0),this._rerenderHeaderContent(),this},i.prototype.addHeaderContent=function(e){return this.addAggregation(\"headerContent\",e,!0),this._rerenderHeaderContent(),this},i.prototype.removeHeaderContent=function(e){var t=this.removeAggregation(\"headerContent\",e,!0);return this._rerenderHeaderContent(),t},i.prototype.removeAllHeaderContent=function(){var e=this.removeAllAggregation(\"headerContent\",!0);return this._rerenderHeaderContent(),e},i.prototype.destroyHeaderContent=function(){return this.destroyAggregation(\"headerContent\",!0),this._rerenderHeaderContent(),this},i.prototype.setSelectedFacet=function(e){var t=this.getSelectedFacet();this.setAssociation(\"selectedFacet\",e,!0);var r=this.getSelectedFacet();t!=r&&this._oNavBar.setSelectedItem(r)},i.prototype.setTitle=function(e){this.setProperty(\"title\",e,!0),this._rerenderHeader()},i.prototype.setSubtitle=function(e){this.setProperty(\"subtitle\",e,!0),this._rerenderHeader()},i.prototype.setActionBar=function(e){return this.setAggregation(\"actionBar\",e,!0),this.getIcon()&&this.getActionBar()&&this.getActionBar().setThingIconURI(this.getIcon()),this._rerenderToolbar(),this._adjustStyles(),this},i.prototype._adjustStyles=function(){var e=this.$().find(\".sapUiUx3TVHeader\"),t=this.$().find(\".sapUiUx3TVFacets\");e.length>0&&(e.addClass(\"sapUiUx3TVActionBar\"),e.removeClass(\"sapUiUx3TVNoActionBar\")),t.length>0&&(t.addClass(\"sapUiUx3TVActionBar\"),t.removeClass(\"sapUiUx3TVNoActionBar\"))}}(),i},!0);",
	"sap/ui/ux3/ThingViewerRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(e){\"use strict\";var t={};return t.render=function(e,t){var i=e;i.write(\"<div\"),i.writeControlData(t),i.writeAttributeEscaped(\"style\",\"width:\"+t.getWidth()+\"; height:\"+t.getHeight()),i.addClass(\"sapUiUx3TV\"),i.writeClasses(),i.write(\">\"),this.renderContent(i,t),i.write(\"</div>\")},t.renderContent=function(e,t){var i=e,r=t.getHeaderType();i.write(\"<div role='Main' class='sapUiUx3TVContent' id='\"+t.getId()+\"-content'>\"),i.write(\"<div class='sapUiUx3TVHeader sapUiUx3TVNoActionBar\"),t.getHeaderType()===sap.ui.ux3.ThingViewerHeaderType.Standard?i.write(\"'>\"):i.write(\" sapUiUx3TVhorizontal'>\"),i.write(\"<div class='sapUiUx3TVHeaderContainerIdentifier'>\"),i.write(\"<span role='heading' aria-level='1' class='sapUiUx3TVIdentifier'\"),i.writeAttributeEscaped(\"title\",t.getType()),i.write(\">\"),i.writeEscaped(t.getType()),i.write(\"</span>\"),i.write(\"</div>\"),r===sap.ui.ux3.ThingViewerHeaderType.Standard?(i.write(\"<div class='sapUiUx3TVHeaderGroupScrollContainer'>\"),i.write(\"<div id='\"+t.getId()+\"-header' class='sapUiUx3TVHeaderContainer'>\"),this.renderHeader(i,t),i.write(\"</div>\")):(i.write(\"<div id='\"+t.getId()+\"-header' class='sapUiUx3TVHeaderContainer'>\"),this.renderHeader(i,t),i.write(\"</div>\"),i.write(\"<div class='sapUiUx3TVHeaderGroupScrollContainer sapUiUx3TVhorizontal'>\")),i.write(\"<div id='\"+t.getId()+\"-headerContent'\"),r===sap.ui.ux3.ThingViewerHeaderType.Standard?i.write(\">\"):i.write(\"style='height:100%; white-space:nowrap'>\"),this.renderHeaderContent(i,t),i.write(\"</div>\"),i.write(\"</div>\"),i.write(\"</div>\"),i.write(\"<div class='sapUiUx3TVFacets sapUiUx3TVNoActionBar\"),r===sap.ui.ux3.ThingViewerHeaderType.Standard?i.write(\"'>\"):i.write(\" sapUiUx3TVhorizontal'>\"),i.write(\"<div role='Navigation' class='sapUiUx3TVFacetBar'>\"),i.renderControl(t._getNavBar()),i.write(\"</div>\"),i.write(\"<div id='\"+t.getId()+\"-facetContent' class='sapUiUx3TVFacetContent sapUiBodyBackground'>\"),this.renderFacetContent(i,t),i.write(\"</div>\"),i.write(\"</div>\"),this.renderToolbar(i,t),i.write(\"</div>\")},t.addRootClasses=function(e,t){e.addClass(\"sapUiUx3TV\")},t.addOverlayClasses=function(e,t){e.addClass(\"sapUiUx3TVOverlay\")},t.renderHeader=function(e,t){var i=e;i.write(\"<div class='sapUiUx3TVIconBar'>\"),i.writeIcon(t.getIcon(),[\"sapUiUx3TVIcon\"],{role:\"presentation\",id:t.getId()+\"-swatch\",title:null}),i.write(\"<div class='sapUiUx3TVTitle'>\"),i.write(\"<span role='heading' aria-level='2' class='sapUiUx3TVTitleFirst'\"),i.writeAttributeEscaped(\"title\",t.getTitle()),i.write(\">\"),i.writeEscaped(t.getTitle()),i.write(\"</span><br>\"),i.write(\"</div><div class='sapUiUx3TVTitle'>\"),i.write(\"<span role='heading' aria-level='3' class='sapUiUx3TVTitleSecond'\"),i.writeAttributeEscaped(\"title\",t.getSubtitle()),i.write(\">\"),i.writeEscaped(t.getSubtitle()),i.write(\"</span>\"),i.write(\"</div>\"),i.write(\"</div>\")},t.renderToolbar=function(e,t){t.getActionBar()&&(e.write(\"<div id='\"+t.getId()+\"-toolbar' class='sapUiUx3TVToolbar'>\"),e.renderControl(t.getActionBar()),e.write(\"</div>\"))},t.renderHeaderContent=function(e,t){for(var i=t.getHeaderContent(),r=t.getHeaderType(),a=0;a<i.length;a++){var n=i[a];r===sap.ui.ux3.ThingViewerHeaderType.Standard&&e.write(\"<hr class='sapUiUx3TVHRWhite'>\"),e.write(\"<div class='sapUiUx3TVHeaderContainer\"),r===sap.ui.ux3.ThingViewerHeaderType.Standard?e.write(\"' role='form'>\"):e.write(\" sapUiUx3TVhorizontal' role='form'>\"),n.getTitle()&&(e.write(\"<div class='sapUiUx3TVHeaderGroupTitle'\"),e.writeAttributeEscaped(\"title\",n.getTooltip_AsString()?n.getTooltip_AsString():n.getTitle()),e.write(\"><span role='heading' aria-level='4'>\"),e.writeEscaped(n.getTitle()),e.write(\"</span>\"),e.write(\"</div>\")),e.write(\"<div class='sapUiUx3TVHeaderGroupContent'>\");for(var s=n.getContent(),d=0;d<s.length;d++){var o=s[d];e.renderControl(o)}e.write(\"</div>\"),e.write(\"</div>\")}},t.renderFacetContent=function(e,t){var i=t.getFacetContent(),r=!0;1==i.length&&(r=!1);for(var a=0;a<i.length;a++){var n=i[a];n.getColspan()?e.write(\"<div class='sapUiUx3TVFacetThingGroupSpan' role='form'>\"):e.write(\"<div class='sapUiUx3TVFacetThingGroup' role='form'>\"),r&&(e.write(\"<div class='sapUiUx3TVFacetThingGroupContentTitle'\"),e.writeAttributeEscaped(\"title\",n.getTooltip_AsString()?n.getTooltip_AsString():n.getTitle()),e.write(\"><span role='heading'>\"),e.writeEscaped(n.getTitle()),e.write(\"</span></div>\")),e.write(\"<div class='sapUiUx3TVFacetThingGroupContent'>\");for(var s=n.getContent(),d=0;d<s.length;d++)e.renderControl(s[d]);e.write(\"</div></div>\")}},t},!0);",
	"sap/ui/ux3/ToolPopup.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\",\"sap/ui/core/Control\",\"sap/ui/core/IconPool\",\"sap/ui/core/Popup\",\"sap/ui/core/theming/Parameters\",\"sap/ui/core/RenderManager\",\"./library\",\"./ToolPopupRenderer\"],function(t,e,o,i,s,r,n,p){\"use strict\";var a=e.extend(\"sap.ui.ux3.ToolPopup\",{metadata:{interfaces:[\"sap.ui.core.PopupInterface\"],library:\"sap.ui.ux3\",properties:{title:{type:\"string\",group:\"Misc\",defaultValue:null},icon:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},iconHover:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},iconSelected:{type:\"sap.ui.core.URI\",group:\"Misc\",defaultValue:null},modal:{type:\"boolean\",group:\"Behavior\",defaultValue:!1},inverted:{type:\"boolean\",group:\"Misc\",defaultValue:!0},autoClose:{type:\"boolean\",group:\"Misc\",defaultValue:!1},maxHeight:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:null},maxWidth:{type:\"sap.ui.core.CSSSize\",group:\"Misc\",defaultValue:null},openDuration:{type:\"int\",group:\"Misc\",defaultValue:400},closeDuration:{type:\"int\",group:\"Misc\",defaultValue:400}},defaultAggregation:\"content\",aggregations:{buttons:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"button\"},content:{type:\"sap.ui.core.Control\",multiple:!0,singularName:\"content\"}},associations:{initialFocus:{type:\"sap.ui.core.Control\",multiple:!1},opener:{type:\"sap.ui.core.Control\",multiple:!1},defaultButton:{type:\"sap.ui.core.Control\",multiple:!1}},events:{open:{},close:{allowPreventDefault:!0},enter:{parameters:{originalEvent:{type:\"object\"},originalSrcControl:{type:\"sap.ui.core.Control\"}}},iconChanged:{},closed:{},opened:{}}}});return a.ARROW_LEFT=new RegExp(/my:(left|begin)([-+]\\d*\\%?)?\\|[a-z]+([-+]\\d*\\%?)? at:(right|end)\\|[a-z]+/),a.ARROW_RIGHT=new RegExp(/my:(right|end)([-+]\\d*\\%?)?\\|[a-z]+([-+]\\d*\\%?)? at:(left|begin)\\|[a-z]+/),a.ARROW_UP=new RegExp(/my:[a-z]+([-+]\\d*\\%?)?\\|top([-+]\\d*\\%?)? at:[a-z]+\\|bottom/),a.ARROW_DOWN=new RegExp(/my:[a-z]+([-+]\\d*\\%?)?\\|bottom([-+]\\d*\\%?)? at:[a-z]+\\|top/),function(){function e(t,e){var o,i;if(!e)return null;for(o=sap.ui.getCore().byId(e);!o&&o!==t;){if(!e||!document.getElementById(e))return null;i=document.getElementById(e).parentNode,e=i.id,o=sap.ui.getCore().byId(e)}return o}a.prototype.init=function(){this.oPopup=null,this._bPositionSet=!1,this._mParameters={},this._mParameters.that=this,this._mParameters.firstFocusable=this.getId()+\"-firstFocusable\",this._mParameters.lastFocusable=this.getId()+\"-lastFocusable\",this._bFocusSet=!1,this._proxyOpened=t.proxy(u,this),this._proxyClosed=t.proxy(g,this),this._proxyFixSize=t.proxy(p,this),this._proxyOnResize=t.proxy(f,this),l(this)},a.prototype.exit=function(){this.oPopup&&(this.oPopup.detachOpened(this._proxyOpened),this.oPopup.detachClosed(this._proxyClosed),this.oPopup.destroy(),delete this.oPopup),delete this._bPositionSet,delete this._mParameters,delete this._bFocusSet,delete this._bPreventRestoreFocus,delete this._proxyOpened,delete this._proxyClosed,delete this._bRTL,delete this._sArrowDir,delete this._oArrowIcon,delete this._bThemeInverted,delete this._sInitialFocusId};var o=function(e){var o=e;return t.sap.assert(!!o,\"No ToolPopup instance given for _fnGetInitialFocus\"),o._bFocusSet?o._sInitialFocusId=o.oPopup._sInitialFocusId:n(o),o._sInitialFocusId},n=function(e){for(var o,i,s=e,r=[s._mParameters.firstFocusable,s._mParameters.lastFocusable],n=t(\":sapTabbable\",s.$()).get(),p=0;p<n.length;p++)if(-1===r.indexOf(n[p].id)){o=n[p];break}if(i=t(o).control(),i[0]){o=i[0].getFocusDomRef()||o}else o=t.sap.domById(r[0]);o&&(t.sap.focus(o),s._sInitialFocusId=o.id)};a.prototype.getFocusDomRef=function(){var t,i=e(this,this._sInitialFocusId);return i||(this._bFocusSet=!1,t=o(this),i=e(this,t)),i?i.getDomRef():this.getDomRef()},a.prototype.onfocusin=function(e){this._mParameters.event=e,this._mParameters.$FocusablesContent=t(\":sapTabbable\",this.$(\"content\")),this._mParameters.$FocusablesFooter=t(\":sapTabbable\",this.$(\"buttons\")),this.oPopup.focusTabChain(this._mParameters)};var p=function(){var e=this.$(),o=0,i=this.getMaxHeight(),s=i?parseInt(i,10):0,r=this.getMaxWidth();if(r){var n=parseInt(r,10),p=e.css(\"border-left-width\"),a=parseInt(p,10),u=e.css(\"border-right-width\"),h=parseInt(u,10),l=e.css(\"padding-left\"),c=parseInt(l,10),g=e.css(\"padding-right\");n-=a+c+parseInt(g,10)+h,e.css(\"max-width\",n+\"px\")}else e.css(\"max-width\",\"\");var f=e.css(\"padding-top\"),P=parseInt(f,10),_=e.css(\"padding-bottom\"),y=parseInt(_,10),I=e.css(\"border-top-width\"),b=parseInt(I,10),m=e.css(\"border-bottom-width\"),w=parseInt(m,10),v=P+y+b+w,x=t(document).scrollTop(),A=e.rect(),R=A.top-x+e.outerHeight(!0),C=t(window).height(),O=R>C&&0===s,T=0;if(O){var F=t.sap.byId(this.getOpener()),U=F.rect(),D=U.top-x+F.outerHeight(!0),S=this.oPopup._getPositionOffset();if(R>D&&S.length>0&&(T=Math.abs(parseInt(S[1],10)),R-T<C)){O=!1;var H=\"Offset of \"+T+\" pushes ToolPopup out of the window\";t.sap.log.warning(H,\"\",\"sap.ui.ux3.ToolPopup\")}s=s||C-A.top}if(e.toggleClass(\"sapUiUx3TPLargeContent\",O),s||O){e.css(\"max-height\",s+\"px\");var z=this.$(\"title\"),W=this.$(\"title-separator\"),M=this.$(\"buttons\"),B=this.$(\"buttons-separator\");o=s>0?s:C-A.top-y-T,o-=v,o-=z.outerHeight(!0),o-=W.outerHeight(!0),o-=B.outerHeight(!0),o-=M.length>0?M.outerHeight(!0):0,o=parseInt(o,10);var L=this.$(\"content\");L.css(\"max-height\",o+\"px\"),L.toggleClass(\"sapUiUx3TPLargeContent\",!0)}d(this)},u=function(){if(this._proxyFixSize(),!this._sInitialFocusId){var e=o(this);if(e!==sap.ui.getCore().getCurrentFocusedControlId()){t.sap.byId(e).focus()}}this._sResizeID||(this._sResizeID=sap.ui.core.ResizeHandler.register(this.$(\"content\")[0],this._proxyOnResize)),this.fireOpened()};a.prototype.isOpen=function(){return this.oPopup&&(\"OPENING\"==this.oPopup.getOpenState()||\"OPEN\"==this.oPopup.getOpenState())},a.prototype.willBeClosed=function(){var t=this.oPopup&&this.oPopup.getOpenState();return t!==sap.ui.core.OpenState.OPENING&&t!==sap.ui.core.OpenState.OPEN},a.prototype.open=function(e,o){this._my=e,this._at=o,this._sArrowDir=c(this);var s=null;if(this.sOffset=\"\",I(this),!this._bPositionSet){var r=0,n=0;if(this._my||(this._my=i.Dock.BeginTop),this._at||(this._at=i.Dock.EndTop),s=t.sap.domById(this.getOpener())){switch(this._sArrowDir){case\"Up\":r=0,n=this.iArrowWidth;break;case\"Down\":r=0,n=-this.iArrowWidth;break;case\"Right\":r=-this.iArrowWidth;break;default:case\"Left\":r=this.iArrowWidth}r=parseInt(r,10),n=parseInt(n,10),this.sOffset=r+\" \"+n,this.setPosition(this._my,this._at,s,this.sOffset,\"none\")}else this.setPosition(i.Dock.BeginTop,i.Dock.BeginTop,window,\"0 0\",\"fit\"),t.sap.log.warning(\"No opener set. Using a default position for Popup\",\"\",\"sap.ui.ux3.ToolPopup\");this._bPositionSet=!1}this._ensurePopup();var p=this.getAutoClose(),a=this.getModal();return p&&a&&(t.sap.log.warning(\"A modal & autoclose ToolPopup will not work properly. Therefore 'autoclose' will be deactived!\"),p=!1),this.oPopup.setAutoClose(p),this.oPopup.setModal(a),this._oPreviousFocus=i.getCurrentFocusInfo(),this.fireOpen(),h(this),this.oPopup.open(this.getOpenDuration(),this._my,this._at,s,this.sOffset,\"\",!0),d(this),this};var h=function(e){if(!e.getOpener()){var o=\"\";e.oPopup&&(o=e.oPopup._oPosition.of instanceof sap.ui.core.Element?e.oPopup._oPosition.of.getId():e.oPopup._oPosition.of.length>0?e.oPopup._oPosition.of[0].id:e.oPopup._oPosition.of.id),\"\"!==o?e.setAssociation(\"opener\",o,!0):t.sap.log.error(\"Neither an opener was set properly nor a corresponding one can be distinguished\",\"\",\"sap.ui.ux3.ToolPopup\")}},l=function(t){var e=\"sapUiUx3ToolPopupArrowWidth\";t.sArrowWidth=s.get(e),t.iArrowWidth=parseInt(t.sArrowWidth,10),e=\"sapUiUx3ToolPopupArrowHeight\",t.sArrowHeight=s.get(e),t.iArrowHeight=parseInt(t.sArrowHeight,10),e=\"sapUiUx3ToolPopupArrowRightMarginCorrection\",t.sArrowPadding=s.get(e),t.iArrowPadding=parseInt(t.sArrowPadding,10),e=\"sapUiUx3ToolPopupArrowRightMarginCorrectionInverted\",t.sArrowPaddingInverted=s.get(e),t.iArrowPaddingInverted=parseInt(t.sArrowPaddingInverted,10)},c=function(e){var o=\"Left\",i=e._my,s=e._at;if(!i&&e.oPopup&&(i=e.oPopup._oPosition.my),!s&&e.oPopup&&(s=e.oPopup._oPosition.at),e._bHorizontalArrow=!1,i&&s){var r=i.split(\" \"),n=s.split(\" \"),p=\"my:\"+r[0]+\"|\"+r[1];if(p+=\" at:\"+n[0]+\"|\"+n[1],a.ARROW_LEFT.exec(p)?(e._bHorizontalArrow=!0,o=\"Left\"):a.ARROW_RIGHT.exec(p)?(e._bHorizontalArrow=!0,o=\"Right\"):a.ARROW_UP.exec(p)?o=\"Up\":a.ARROW_DOWN.exec(p)&&(o=\"Down\"),e.getDomRef()&&e.isOpen()){var u=e.$(),h=u.rect(),l=t.sap.byId(e.getOpener()),c=l.rect();if(c)if(e._bHorizontalArrow){var d=h.left+u.outerWidth(!0)+e.iArrowWidth,g=c.left+l.outerWidth(!0);o=d<=g?\"Right\":\"Left\"}else{var f=h.top+u.outerHeight(!0)+e.iArrowWidth,P=c.top+l.outerHeight(!0);o=f<=P?\"Down\":\"Up\"}}}return o},d=function(e){var o,i=\"\",s=0,r=0,n=e.iArrowHeight/2,p=sap.ui.getCore().getConfiguration().getRTL(),a=e.$().rect(),u=t.sap.byId(e.getOpener()),h=u.rect(),l=0,d=e.$(\"arrow\");if(e.getDomRef()){e._sArrowDir=c(e),o=e._sArrowDir,p&&(\"Right\"===e._sArrowDir?o=\"Left\":\"Left\"===e._sArrowDir&&(o=\"Right\")),h||t.sap.log.warning(\"Opener wasn't set properly. Therefore arrow will be at a default position\",\"\",\"sap.ui.ux3.ToolPopup\"),!e._my&&e.oPopup&&(e._my=e.oPopup._oPosition.my),e._bHorizontalArrow?(i=\"top\",h&&(l=parseInt(e.$().css(\"border-top-width\"),10)||0,r=parseInt(h.top-l-a.top,10),s=Math.round(r+h.height/2-n),s=s+n>a.height?s-e.iArrowHeight:s)):(i=\"left\",h&&(p?(i=\"right\",l=parseInt(e.$().css(\"border-right-width\"),10)||0,r=parseInt(a.left+a.width-h.left-h.width-l,10)):(l=parseInt(e.$().css(\"border-left-width\"),10)||0,r=parseInt(h.left-a.left-l,10)),s=Math.round(r+h.width/2-n),s=s+n>a.width?s-e.iArrowHeight:s)),h||(s=e.iArrowHeight);var g=\"\";if(g=d.hasClass(\"sapUiUx3TPNewArrow\")?\"sapUiUx3TPNewArrow sapUiUx3TPNewArrow\":e.isInverted()?\"sapUiUx3TPArrow sapUiTPInverted sapUiUx3TPArrow\":\"sapUiUx3TPArrow sapUiUx3TPArrow\",d.attr(\"class\",g+o),\"Right\"===o){var f=a.width;e.isInverted()?f+=e.iArrowPaddingInverted:f+=e.iArrowPadding,p?d.css(\"right\",f+\"px\"):d.css(\"left\",f+\"px\")}else d.css({left:\"\",right:\"\"});s=parseInt(s,10),s=s<-l?-l:s,d.css(i,s+\"px\")}};a.prototype.onsapescape=function(){this.fireClose()&&this.close()};var g=function(t){this._bPreventRestoreFocus||i.applyFocusInfo(this._oPreviousFocus),this.getDomRef()&&(r.preserveContent(this.getDomRef()),this.$().remove()),this.fireClosed()};a.prototype.close=function(t){return this.oPopup&&this.oPopup.isOpen()&&(this._sResizeID&&(sap.ui.core.ResizeHandler.deregister(this._sResizeID),delete this._sResizeID),this.oPopup.close(this.getCloseDuration()),this._bPreventRestoreFocus=t),this},a.prototype.getEnabled=function(){var t=this.oPopup?this.oPopup.getOpenState():sap.ui.core.OpenState.CLOSED;return t===sap.ui.core.OpenState.OPENING||t===sap.ui.core.OpenState.OPEN},a.prototype.onsapenter=function(e){var o=this.getDefaultButton(),i=sap.ui.getCore().byId(o);if(o&&i&&t.contains(this.getDomRef(),i.getDomRef())&&i instanceof sap.ui.commons.Button){var s=i.$();s.click(),s.focus()}e.preventDefault(),e.stopPropagation()},a.prototype.onBeforeRendering=function(){var t=this.getInitialFocus()||this._sInitialFocusId,e=this.getDefaultButton();this._bFocusSet=!0,t?this.oPopup.setInitialFocusId(t):e?this.oPopup.setInitialFocusId(e):this._bFocusSet=!1,this._bRTL=sap.ui.getCore().getConfiguration().getRTL()},a.prototype._ensurePopup=function(){if(!this.oPopup){this.oPopup=new i(this,!1,!0,!1),this.oPopup.attachOpened(this._proxyOpened),this.oPopup.attachClosed(this._proxyClosed);var e=this;this.oPopup._applyPosition=function(){i.prototype._applyPosition.apply(e.oPopup,arguments);var o=e.oPopup._oLastPosition.of;if(o){var s=t.sap.byId(o.id);e._bPositionSet&&(s.hasClass(\"sapUiUx3ShellTool\")||(e._my=e.oPopup._oLastPosition.my,e._at=e.oPopup._oLastPosition.at)),d(e)}else e.oPopup.close()}}return this.oPopup};var f=function(){this.getContent().length&&(this._proxyFixSize(),this.oPopup._applyPosition(this.oPopup._oLastPosition))};a.prototype.setPosition=function(){return this._ensurePopup(),this.oPopup.setPosition.apply(this.oPopup,arguments),this._bPositionSet=!0,h(this),this};var P=function(t,e){var o=t;\"content\"===e?_(o):\"buttons\"===e&&y(o),o._proxyFixSize(),o.oPopup._applyPosition(o.oPopup._oLastPosition)},_=function(t){var e=t.getDomRef(\"content\");e.innerHTML=\"\";for(var o=t.getContent(),i=sap.ui.getCore().createRenderManager(),s=0;s<o.length;s++)i.renderControl(o[s]);i.flush(e,!0),i.destroy()},y=function(e){var o=e.getDomRef(\"buttons\"),i=e.getDomRef(\"buttons-separator\"),s=e.getButtons();if(0===s.length)t(o).addClass(\"sapUiUx3TPButtonRowHidden\"),t(i).addClass(\"sapUiUx3TPButtonRowHidden\");else{t(o).removeClass(\"sapUiUx3TPButtonRowHidden\"),t(i).removeClass(\"sapUiUx3TPButtonRowHidden\"),o.innerHTML=\"\";for(var r=sap.ui.getCore().createRenderManager(),n=0;n<s.length;n++)r.renderControl(s[n]);r.flush(o,!0),r.destroy()}};a.prototype.addContent=function(t){return this.addAggregation(\"content\",t,!0),this.isOpen()&&P(this,\"content\"),this},a.prototype.insertContent=function(t,e){return this.insertAggregation(\"content\",t,e,!0),this.isOpen()&&P(this,\"content\"),this},a.prototype.removeContent=function(t){return this.removeAggregation(\"content\",t,!0),this.isOpen()&&P(this,\"content\"),this},a.prototype.addButton=function(t){return this.addAggregation(\"buttons\",t,!0),this.isOpen()&&P(this,\"buttons\"),this},a.prototype.insertButton=function(t,e){return this.insertAggregation(\"buttons\",t,e,!0),this.isOpen()&&P(this,\"buttons\"),this},a.prototype.removeButton=function(t){return this.removeAggregation(\"button\",t,!0),this.isOpen()&&P(this,\"buttons\"),this};var I=function(t){var e=\"sapUiUx3ToolPopupInverted\";e=s.get(e),t._bThemeInverted=\"true\"===e};a.prototype.onThemeChanged=function(){I(this)},a.prototype.isInverted=function(){return I(this),this.getInverted()&&this._bThemeInverted},a.prototype.setAutoCloseAreas=function(t){return this._ensurePopup(),this.oPopup.setAutoCloseAreas(t)},a.prototype.addFocusableArea=function(e){if(this._ensurePopup(),\"string\"==typeof e)return this.oPopup._addFocusableArea(\"channelId\",\"eventId\",{id:e}),this;t.sap.log.error(\"Wrong type of focusable area ID - string expected\",\"\",\"sap.ui.ux3.ToolPopup\")},a.prototype.removeFocusableArea=function(e){if(this._ensurePopup(),\"string\"==typeof e)return this.oPopup._removeFocusableArea(\"channelId\",\"eventId\",{id:e}),this;t.sap.log.error(\"Wrong type of focusable area ID - string expected\",\"\",\"sap.ui.ux3.ToolPopup\")}}(),a.prototype.setIcon=function(t){return this.setProperty(\"icon\",t,!0),this.fireIconChanged(),this},a.prototype.setIconHover=function(t){return this.setProperty(\"iconHover\",t,!0),this.fireIconChanged(),this},a.prototype.setIconSelected=function(t){return this.setProperty(\"iconSelected\",t,!0),this.fireIconChanged(),this},a.prototype.getIconSelected=function(){return this.getProperty(\"iconSelected\")||this.getProperty(\"iconHover\")},a.prototype.setMaxWidth=function(e){/[0-9]+px/.test(e)?this.setProperty(\"maxWidth\",e):t.sap.log.error(\"Only values in pixels are possible\",\"\",\"sap.ui.ux3.ToolPopup\")},a},!0);",
	"sap/ui/ux3/ToolPopupRenderer.js": "/*!\n * UI development toolkit for HTML5 (OpenUI5)\n * (c) Copyright 2009-2023 SAP SE or an SAP affiliate company.\n * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.\n */\nsap.ui.define([\"jquery.sap.global\"],function(i){\"use strict\";var e={};return e.render=function(i,e){var t=sap.ui.getCore().getLibraryResourceBundle(\"sap.ui.ux3\"),s=e.getId(),a=e.getContent(),r=e.getButtons(),d=e.getTitle(),n=sap.ui.resource(\"sap.ui.core\",\"themes/base/img/1x1.gif\");if(i.write(\"<div\"),i.writeControlData(e),i.addClass(\"sapUiUx3TP\"),\"\"===d&&i.addClass(\"sapUiUx3TPNoTitle\"),0===r.length&&i.addClass(\"sapUiUx3TPNoButtons\"),e.isInverted()&&(i.addClass(\"sapUiTPInverted\"),i.addClass(\"sapUiInverted-CTX\")),i.writeClasses(),i.write(\" aria-labelledby='\",s,\"-title \",s,\"-acc' role='dialog'\"),i.writeAttribute(\"tabindex\",\"-1\"),i.write(\">\"),i.write(\"<div id='\"+s+\"-arrow' class='sapUiUx3TPArrow sapUiUx3TPArrowLeft'><div class='sapUiUx3TPArrowBorder'></div></div>\"),i.write(\"<span style='display:none;' id='\",s,\"-acc'>\"),i.writeEscaped(t.getText(\"DIALOG_CLOSE_HELP\")),i.write(\"</span>\"),i.write('<span id=\"'+s+'-firstFocusable\" tabindex=\"0\" class=\"sapUiUxTPFocus\">'),i.write('<img src=\"'+n+'\">'),i.write(\"</span>\"),d&&\"\"!==d.length)i.write('<div class=\"sapUiUx3TPTitle\" id=\"'+s+'-title\">'),i.write('<span class=\"sapUiUx3TPTitleText\">'),i.writeEscaped(d),i.write(\"</span>\"),i.write(\"</div>\"),i.write('<div class=\"sapUiUx3TPTitleSep\" id=\"'+s+'-title-separator\"></div>');else{var l=e.getTooltip_AsString();l&&(i.write(\"<h1 id='\"+s+\"-title' style='display:none;'>\"),i.writeEscaped(l),i.write(\"</h1>\"))}i.write('<div id=\"'+s+'-content\"'),i.addClass(\"sapUiUx3TPContent\"),i.writeClasses(),i.write(\">\");for(var o=0;o<a.length;o++)i.renderControl(a[o]);if(i.write(\"</div>\"),r.length>0){i.write('<div class=\"sapUiUx3TPButtonsSep\" id=\"'+s+'-buttons-separator\"></div>'),i.write('<div class=\"sapUiUx3TPBtnRow\" id=\"'+s+'-buttons\">');for(var o=0;o<r.length;o++)i.renderControl(r[o].addStyleClass(\"sapUiUx3TPBtn\"))}else i.write('<div class=\"sapUiUx3TPButtonsSep sapUiUx3TPButtonRowHidden\" id=\"'+s+'-buttons-separator\"></div>'),i.write('<div class=\"sapUiUx3TPBtnRow sapUiUx3TPButtonRowHidden\" id=\"'+s+'-buttons\">');i.write(\"</div>\"),i.write('<span id=\"'+s+'-lastFocusable\" tabindex=\"0\" class=\"sapUiUxTPFocus\">'),i.write('<img src=\"'+n+'\">'),i.write(\"</span>\"),i.write(\"</div>\")},e},!0);",
	"sap/ui/ux3/manifest.json": "{\"_version\":\"1.9.0\",\"sap.app\":{\"_version\":\"1.2.0\",\"id\":\"sap.ui.ux3\",\"type\":\"library\",\"applicationVersion\":{\"version\":\"9.4.0-0\"},\"title\":\"The OpenUI5-based library, sap.ui.ux3.\"},\"sap.ui5\":{\"_version\":\"1.1.0\",\"dependencies\":{\"libs\":{\"sap.ui.core\":{},\"sap.ui.commons\":{}}},\"library\":{\"i18n\":\"messagebundle.properties\"}}}"
}, "sap/ui/ux3/library-preload");